#!/bin/bash
# Script destiné à remettre les droits en place 
# Equipe Sambaedu - Licence GPL
# Version 12-2020

usage()
{
	echo "script permettant la remise en place des droits" 
	echo "usage: $0 -u -s -p -w -h"
	echo "       -u :  Remise en place des droits des homes"
	echo "       -s :  Remise en place des droits des /var/sambaedu"
	echo "       -p :  Remise en place des droits sur /var/lib/samba/printers"
	echo "       -w :  Remise en place des droits sur wpkg"
	echo "       -h :  cette aide"
	exit $1
}

if [ $# -eq "0" ]  # Script appele sans argument?
then
  echo "option incorrecte"
  usage 1 
fi

if [ $# -gt "1" ]  # Script appele avec >1 argument?
then
  echo "Un seul argument accepté à la fois"
  usage 1 
fi

while getopts "uspwh" cmd
do
    source /usr/share/sambaedu/includes/utils.inc.sh
	case $cmd in
	u) correct_home
	;;
	s) correct_var_sambaedu
	;;
	p) correct_printers
	;;
	w) correct_wpkg
	;;
	h) usage 0 ;;
	\?) echo "bad option!"
	usage 1 ;;
	*) echo "bad option!"
	usage 1 ;;
	esac
done
exit 0
