<?php

/**
 * Ajoute une liste d'utilisateurs à une classe ou une équipe
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: add_list_users_group.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include_once "ldap.inc.php";
include "ihm.inc.php";

echo "<h1>Annuaire</h1>";

$cn = $_POST['cn'] ?? $_GET['cn'] ?? '';
$new_cns = $_POST['new_cns'] ?? "";
$add_list_users_group = $_POST['add_list_users_group'] ?? "";
$err = "0";

if (have_right($config, SE_USER_ADMIN)) {

    $filter = "8_" . $cn;
    echo aff_trailer("$filter");
    if (! $add_list_users_group) {
        $people_new_members = array();
        echo "<H4>Ajouter des membres au groupe : $cn</H4>\n";
        // cas d'un groupe de type Equipe
        if (preg_match("#Equipe_#", $cn)) {
            // Recherche de la liste des cn des membres de ce groupe
            $cns_act = search_ad($config, "*", "memberof", $cn);
            // Reherche de la liste des professeurs
            $cns_profs = search_ad($config, "*", "memberof", "Profs");
            // Constitution d'un tableau excluant les membres actuels

            foreach ($cns_profs as $key => $value) {
                if (! in_array($value, $cns_act))
                    array_push($people_new_members, $value);
            }
        } elseif (preg_match("#Classe_#", $cn)) {
            // Recherche de la liste des Eleves
            $tous_cns_eleves = search_ad($config, "*", "memberof", "Eleves");
            // Recherche de la liste des Eleves appartenant a une classe
            // $list_classes = list_classes($config, "*");
            $classes = search_ad($config, "*", "classe");
            $list_classes = array();
            foreach ($classes as $val) {
                array_push($list_classes, $val["cn"]);
            }
            $cns_eleves = array();
            foreach ($list_classes as $key => $value) {
                $cn_of_classe = search_ad($config, "*", "memberof", $value);
                $cns_eleves = array_merge($cn_of_classe, $cns_eleves);
            }
            // Recherche des Eleves qui ne sont pas affectes a une classe
            foreach ($tous_cns_eleves as $key => $value) {
                if (! in_array($value, $cns_eleves))
                    array_push($people_new_members, $value);
            }
            usort($people_new_members, "cmp_nom");
        }

        // Affichage de la liste dans une boite de selection
        if (count($people_new_members) > 15)
            $size = 15;
        else
            $size = count($people_new_members);
        if (count($people_new_members) > 0) {
            $form = "<form action=\"add_list_users_group.php\" method=\"post\">\n";
            $form .= "<p>Sélectionnez les membres à ajouter au groupe :</p>\n";
            $form .= "<p><select size=\"" . $size . "\" name=\"new_cns[]\" multiple=\"multiple\">\n";
            echo $form;
            for ($loop = 0; $loop < count($people_new_members); $loop ++) {
                echo "<option value='" . $people_new_members[$loop]["cn"] . "'>" . $people_new_members[$loop]["fullname"];
            }
            $form = "</select></p>\n";
            $form .= "<input type=\"hidden\" name=\"cn\" value=\"$cn\">\n";
            $form .= "<input type=\"hidden\" name=\"add_list_users_group\" value=\"true\">\n";
            $form .= "<input type=\"reset\" value=\"Réinitialiser la sélection\">\n";
            $form .= "<input type=\"submit\" value=\"Valider\">\n";
            $form .= "</form>\n";
            echo $form;
        } else {
            echo "<font color=\"orange\">Vous ne pouvez pas ajouter d'élèves car il n'existe plus d'élèves non affectés à des classes !!</font><BR>";
        }
    } else {
        // Ajout des membres au groupe
        $dn = filter_group($config, "(CN=$cn)")[0]['dn'];
        echo "<H4>Ajout des membres au groupe : <A href=\"group.php?filter=$dn\">$cn</A></H4>\n";
        for ($loop = 0; $loop < count($new_cns); $loop ++) {
            $nomComplet = search_ad($config, $new_cns[$loop], "user");
            echo "Ajout de l'utilisateur&nbsp;" . $nomComplet[0]["fullname"] . "&nbsp;";
            if (groupaddmember($config, $new_cns[$loop], $cn . $config['suffix']) == 1) {
                echo "<strong>Réussi</strong><BR>";
            } else {
                echo "</strong><font color=\"orange\">Échec</font></strong><BR>";
                $err ++;
            }
        }
    }
} else {
    echo "<div class=error_msg>Cette application, nécessite les droits d'administrateur du serveur SambaEdu !</div>";
}

$html = "";
admin_footer_html($html);
echo $html;
?>