<?php

/**

 * Ajoute des utilisateurs dans l'annuaire
 * @Version
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 */

/**
 *
 * @Repertoire: annu
 * file: add_user.php
 */
require "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
require_once "ldap.inc.php";
require_once "functions.inc.php";
require_once ("samba-tool.inc.php");

require_once ("ent.inc.php");
// HTMLPurifier
// require_once ("traitement_data.inc.php");

require "ihm.inc.php";

echo "<h1>" . "Annuaire" . "</h1>\n";

@session_start();

echo aff_trailer("7");

if (! isset($_SESSION['comptes_crees'])) {
    $_SESSION['comptes_crees'] = array(
        array()
    ); // un sous-tableau par compte ; le deuxième tavbleau est, dans l'ordre nom, prenom, classe (?? en fait, non) (ou 'prof'), cn, password
    array_splice($_SESSION['comptes_crees'], 0, 1);
}
$etabs = list_etabs($config);
$etabs[0] = "Domaine entier";
if (count($etabs) > 1) {
    if (! isset($_POST['uai']) && ! isset($config['etab_ou'])) {
        $choix = "<SELECT NAME=\"uai\" SIZE=\"1\" onchange=submit()>";
        $etab = 0;
        foreach ($etabs as $e) {
            $choix .= "<option value=\"" . $e . "\"";
            if ($etab == $e) {
                $choix .= " selected";
            }
            $choix .= ">" . etab_to_name($config, $e) . "\n";
            $choix .= "</option>";
        }
        $choix .= "</SELECT>\n";
    } else {
        $etab = $_POST['uai'] ?? $config['etab_ou'];
        $choix = etab_to_name($config, $etab);
    }
} else {
    $choix = $config['etab_name'] ?? "";
    $etab = 0;
}
$users = cache_fetch('ent');
$nom = $_POST['nom'] ?? $_GET['nom'] ?? $users[0]['ent']['lastName'] ?? "";
$prenom = $_POST['prenom'] ?? $_GET['prenom'] ?? $users[0]['ent']['firstName'] ?? "";
$naissance = $_POST['naissance'] ?? $_GET['naissance'] ?? $users[0]['ent']['birthDate'] ?? "";
$password = $_POST['userpw'] ?? $_GET['userpw'] ?? $users[0]['ent']['code'] ?? "";
$sexe = $_POST['sexe'] ?? $_GET['sexe'] ?? $users[0]['ent']['sex'] ?? "";
$categorie = $_POST['categorie'] ?? $_GET['categorie'] ?? map_profil($users[0]['ent']['type'], "manuel", true) ?? "Administratifs";
$originallogin = $_POST['login'] ?? $_GET['login'] ?? $users[0]['ent']['login'] ?? "";
$id = $_POST['id'] ?? $_GET['id'] ?? $users[0]['ent']['id Pronote'] ?? "";
$classes = $_POST['classes'] ?? $users[0]['ent']['allClasses'] ?? [];
$add_user = isset($_POST['add_user']) ? $_POST['add_user'] : "";
$fonction = $_POST['fonction'] ?? $users[0]['ent']['fonction'] ?? "";
$config['pwdPolicy'] = $config['pwdPolicy'] ?? 0;
$rules = get_password_rule($config);
$length = $rules['min-pwd-length'];
$new_etab = $_POST['new_etab'] ?? $users[0]['ent']['structure'] ?? $etab;
if ($rules['complexity'] == "on")
    $complexity = true;
else
    $complexity = false;

if (have_right($config, SE_USER_ADMIN)) {
    // Ajout d'un utilisateur
    if ((! isset($_POST['add_user'])) || (! $nom || ! $prenom) || // absence de nom ou de prenom
    ($password && ! verifPwd($password, $length, $complexity)[0]) || // mot de passe invalide
    ($password && $password != ensure_ascii($password)) || // mot de passe invalide
    ($naissance && ! verifDateNaissance($naissance)) || // date de naissance invalide
    ($categorie == "Administratifs" && empty($fonction)) || // Fonction obligatoire
    ($categorie == "Eleves" && empty($classes)) || // classe obligatoire
    ($categorie == "Profs" && empty($classes) && empty($fonction)) || // classe obligatoire ou fonction obligatoire
    (($naissance && verifDateNaissance($naissance)) && ($password && ! verifPwd($password, $length, $complexity)[0]))) // date de naissance mais password invalide
                                                                                                                        // || ($userpwd && !verifPwd($userpwd) ) // password invalide
    {
        echo "<form autocomplete=\"off\" name=\"auth\" action=\"add_user.php\" method=\"post\">
        <table border=\"0\"><tr>
        <td style='width:30%;'>Etablissement de rattachement</td>
        <td>";
        $etabs = list_etabs($config);
        if (count($etabs) > 1 && empty($config['etab_ou'])) {
            array_unshift($etabs, 0);
            $choix = "<SELECT NAME=\"new_etab\" SIZE=\"1\" onchange=submit()>";
            foreach ($etabs as $e) {
                $choix .= "<option value=\"" . $e . "\"";
                if ($new_etab == $e) {
                    $choix .= " selected";
                }
                $choix .= ">" . etab_to_name($config, $e) . "\n";
                $choix .= "</option>";
            }
            $choix .= "</SELECT>\n";
            echo $choix;
        } else {
            echo etab_to_name($config, $new_etab);
            echo "<input type=hidden name=new_etab value=" . $new_etab . ">";
        }
        echo "</td>
        </tr>
        <tr>
            <td>";
        echo "Catégorie</td>
                <td colspan=\"2\" valign=\"top\"><select name=\"categorie\" onchange=\"submit()\">";
        if (($new_etab == 0 && count($etabs) < 2) || $new_etab != 0) {
            echo "<option value=\"Eleves\"";
            if ($categorie == "Eleves")
                echo "SELECTED";
            echo ">" . "Elèves" . "</option>\n";
            echo "<option value=\"Profs\"";
            if ($categorie == "Profs")
                echo "SELECTED";
            echo ">" . "Profs" . "</option>\n";
        }
        echo "<option value=\"Administratifs\"";
        if ($categorie == "Administratifs")
            echo "SELECTED";
        echo ">" . "Administratifs" . "</option>\n
            </select></td>
            </tr>";
        if ($categorie != "Eleves") {
            echo " <tr>
          <td><u>Fonction</u> :&nbsp;</td>
          <td>
            <select name=\"fonction\">\n";
            $old_config = $config;
            $config = get_config($config, true, true);
            $list_fonctions_all = search_ad($config, "*", "groupe", $config['dn']['groups'], [], "base");
            $config = $old_config;
            # Construction du tableau sans les groupes déja attribués
            $list_fonctions = array();
            if ($categorie == "Administratifs") {
                $motif = "/Direction|Secretariat|Medical|VieScol|Agent|AED|Tech/";
            } else {
                $motif = "/Documentaliste|AESH/";
            }
            foreach ($list_fonctions_all as $value) {
                if (preg_match($motif, $value['cn'])) {
                    array_push($list_fonctions, $value['cn']);
                }
            }
            asort($list_fonctions);
            array_unshift($list_fonctions, "");

            foreach ($list_fonctions as $f) {
                echo "<option value='" . $f . "'";
                echo ">" . $f;
            }
            echo "        </select>
        </td>
        </tr>";
        }

        if ($categorie == "Profs" || $categorie == "Eleves") {
            echo "<tr>
                <td>Classe (obligatoire pour les Elèves et les Profs)</td>
                <td colspan=\"2\" valign=\"top\"><select name=\"classes[]\"";
            if ($categorie == "Profs") {
                echo " multiple";
            }
            echo ">";
            $old_config = $config;
            $config = get_config($config, true, $new_etab);
            $liste = list_classes_etab_fast($config);
            $config = $old_config;
            foreach ($liste as $classe) {
                echo "<option value=\"" . $classe . "\">" . $classe . "</option>";
            }
            echo "</select></td>
            </tr>";
        }

        ?>
<tbody>
    <tr>
        <td><?php echo "Nom :"; ?></td>
        <td colspan="2" valign="top"><input autocomplete="new-nom"
            type="text" name="nom" value="<?php echo $nom ?>" size="20"></td>
    </tr>
    <tr>
        <td><?php echo "Prénom :"; ?></td>
        <td colspan="2" valign="top"><input autocomplete="new-prenom"
            type="text" name="prenom" value="<?php echo $prenom ?>"
            size="20"></td>

    </tr>
    <tr>
        <td><?php echo "Suggestion de login :"; ?></td>
        <td colspan="2" valign="top"><input autocomplete="new-login"
            type="text" name="login"
            value="<?php echo $originallogin ?>" size="20"></td>

    </tr>
    <tr>
        <td><?php echo "Date de naissance :"; ?></td>
        <td><input autocomplete="new-naissance" type="text"
            name="naissance" value="<?php echo $naissance ?>" size="8"></td>
        <td><font color="#FF9900">
                    &nbsp;<?php echo "(YYYYMMDD) Ce champ est optionnel. Il ne sert qu'à faciliter la mise en correspondance avec une base ENT et Pronote."; ?>
                </font></td>
    </tr>
    <tr>
        <td><?php echo "Mot de passe :"; ?></td>
        <td><input autocomplete="new-userpw" type="password" value=""
            name="userpw" size='13' maxlength='13'></td>
        <td><font color="#FF9900">
                    &nbsp;<?php echo "Ce champ est optionnel."; ?>
                </font></td>
    </tr>
    <tr>
        <td colspan="3" valign="top">
        <?php
        echo '<blockquote><font color="#FF9900">';
        echo 'Si le champ mot de passe est laissé vide, un mot de passe sera créé selon la politique de mot de passe par défaut qui est définie à : ' . "<br/>";
        $config['pwdPolicy'] = $config['pwdPolicy'] ?? 0;
        switch ($config['pwdPolicy']) {
            case 0: // date de naissance
            case 1:
                echo "date de naissance (YYYYMMDD)";
                echo "<br />Si ni la date de naissance ni le mot de passe ne sont renseignées, un mot de passe aléatoire sera généré";
                break;
            case 2: // aleatoire
                echo "aléatoire ($length car.)";
                break;
            case 3: // code
                echo "code d'activation " . $config['activation_code'];
                break;
        }
        echo "</font></blockquote></td>";
        echo "          <tr>
                <td></td>
                <td></td>
                <td><input type=\"hidden\" name=\"add_user\" value=\"true\"> <input
                    type=\"submit\" value=\"Lancer la requête\"></td>
            </tr>

        </tbody>
    </table>
</form>";
        if ($add_user) {
            if ((! $nom) || (! $prenom)) {
                echo "<div class=error_msg>" . "Vous devez obligatoirement renseigner les champs : nom, prénom !" . "</div><br>\n";
            } elseif (! $naissance && ! $password && $config['pwdPolicy'] < 2) {
                echo "<div class='error_msg'>";
                echo "Vous devez obligatoirement renseigner un des deux champs mot de passe ou date de naissance.";
                echo "</div><BR>\n";
            } else {
                if ((($password) && ! verifPwd($password, $length, $complexity)[0]) || (($password) && ($password != ensure_ascii($password)))) {
                    echo "<div class='error_msg'>";
                    echo verifPwd($password, $length)[1] . "</div><BR>\n";
                }
                if (($naissance) && ! verifDateNaissance($naissance)) {
                    echo "<div class='error_msg'>";
                    echo "Le champ date de naissance doit être obligatoirement au format AnnéeMoisJour (YYYYMMDD).";
                    echo "</div><BR>\n";
                }
            }
        }
    } else {
        // mode ent
        $allClasses = [];
        foreach ($classes as $classe) {
            $allClasses[] = [
                'name' => $classe,
                'etab' => $new_etab
            ];
        }
        $ent[0] = [
            'structure' => $new_etab,
            'login' => $originallogin,
            'firstName' => $prenom,
            'lastName' => $nom,
            'birthDate' => $naissance,
            'code' => $password,
            'type' => map_profil($categorie, "manuel"),
            'fonction' => $fonction,
            'sex' => $sexe,
            'Id Pronote' => $id,
            'allClasses' => $allClasses
        ];
        $session = "add_user_" . session_id();
        $lock = apcu_fetch('ent_lock');
        if (isset($lock['lock']) && $lock['lock'] != $session) {
            echo "Une tâche d'importation de comptes est déjà en cours. Veuillez réessayer plus tard<br>";
        } else {
            apcu_add('ent_lock', [
                'lock' => $session
            ], $config['ent_timeout']);
            cache_delete('ent');
            apcu_delete('total');
            cache_delete('match');
            cache_store('ent', $ent, $config['ent_timeout']);
            match_ad_from_ent($config, 120, true, false, true);
            if (! $html = apcu_fetch('ent_html')) {
                $html = "";
            }
            $match = cache_fetch('match');
            $group = [];
            $ret = update_user_ent($config, $match, $group, $html, false, true, false, "all", $session);
            // echo $html;
            if ($ret || $ret == 0) {
                cache_delete('ent');
                echo "L'utilisateur " . " <strong>$prenom $nom</strong> " . " a été créé avec succès." . "<BR>";
                if (count($group) > 0) {
                    echo "Son identifiant est " . "<STRONG><a href='people.php?cn=" . $group[0]['ad']['cn'] . "' title=\"Modifier le compte.\">" . $group[0]['ad']["cn"] . "</a></STRONG><BR>\n";
                    echo "Son mot de passe initial est " . "<STRONG>" . $group[0]['ent']["code"] . "</STRONG><BR>\n";
                    $nouveau = array(
                        'nom' => "$nom",
                        'pre' => "$prenom",
                        'cn' => $group[0]['ad']["cn"],
                        'pwd' => $group[0]['ent']["code"]
                    );
                    $_SESSION['comptes_crees'][] = $nouveau;
                    $group['groupes'] = [];
                    update_group_ent($config, $group, $html, false, true, $session);
                    // echo $html;
                    echo "<LI><A HREF=\"add_user_group.php?cn=" . $group[0]['ad']["cn"] . "\">" . "Ajouter à des groupes..." . "</A>\n";
                    echo generate_listing($session, false);
                }

                if ((isset($_POST['create_home'])) && ($_POST['create_home'] == 'y')) {
                    echo "<p><b>Création du dossier personnel de " . $group[0]['ad']["cn"] . "</b><br />";
                    exec("sudo /usr/share/sambaedu/shares/shares.avail/mkhome.sh " . $group[0]['ad']["cn"], $ReturnValue2);
                    echo "<pre style='color:red'>";
                    foreach ($ReturnValue2 as $key => $value) {
                        echo "$value";
                    }
                    echo "</pre>\n";
                }
            } else {
                echo "<div class='error_msg'>" . "Erreur lors de la création du nouvel utilisateur" . " $prenom $nom
                                </font>," . " veuillez contacter" . "
                <a href='mailto:admin@" . $config['domain'] . "?subject=PB creation nouvel utilisateur Sambaedu'>" . "l'administrateur du système" . "</a></div><br />\n";
                echo "<p><br /></p>\n";
            }
            apcu_delete('ent_lock');
            apcu_delete('ent_count');
            cache_delete('match');
            apcu_delete('ent_html');
            cache_delete('group');
            cache_delete('ent');
        }
    }

    include ("listing.inc.php");
} else {
    echo "<div class=error_msg>" . "Cette application, nécessite les droits d'administrateur du serveur SambaEdu !" . "</div>";
}

$html = "";
admin_footer_html($html);
echo $html;
?>