<?php

/**

 * Affiche les membres de groupes sélectionnés
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: affichageleve.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include_once "ldap.inc.php";
include "ihm.inc.php";

$description = "";
$intitule = "";

echo "<h1>Annuaire</h1>";

// debug_var();
if (have_right($config, SE_USER_ADMIN)) {
    $cn = urldecode($_POST["cn"] ?? $_GET["cn"] ?? "");
    $description = ((isset($_POST["description"])) ? $_POST["description"] : "");
    $action = ((isset($_POST["action"])) ? $_POST["action"] : 1);
    $classe_gr = ((isset($_POST["classe_gr"])) ? $_POST["classe_gr"] : array());
    $equipe_gr = ((isset($_POST["equipe_gr"])) ? $_POST["equipe_gr"] : array());
    $autres_gr = ((isset($_POST["autres_gr"])) ? $_POST["autres_gr"] : array());
    $matiere_gr = ((isset($_POST["matiere_gr"])) ? $_POST["matiere_gr"] : array());
    $cours_gr = $_POST["cours_gr"] ?? array();

    echo aff_trailer("1");
    $filter = [];
    for ($loop = 0; $loop < count($classe_gr); $loop ++) {
        $filter[$loop] = $classe_gr[$loop];
    }
    $index = $loop;
    for ($loop = 0; $loop < count($equipe_gr); $loop ++) {
        $filter[$index + $loop] = $equipe_gr[$loop];
    }
    $index = $index + $loop;
    for ($loop = 0; $loop < count($autres_gr); $loop ++) {
        $filter[$index + $loop] = $autres_gr[$loop];
    }
    $index = $index + $loop;
    for ($loop = 0; $loop < count($matiere_gr); $loop ++) {
        $filter[$index + $loop] = $matiere_gr[$loop];
    }
    $index = $index + $loop;
    for ($loop = 0; $loop < count($cours_gr); $loop ++) {
        $filter[$index + $loop] = $cours_gr[$loop];
    }
    if ($action != '1') {
        // Message d'erreurs de saisie
        if ($cn == "" || $description == "") {
            echo "<div class=error_msg>Vous devez saisir un nom de groupe et une description !</div><br>\n";
            exit();
        } elseif (! verifDescription($description)) {
            echo "<div class=error_msg>Le champ description comporte des caractères interdits !</div><br>\n";
            exit();
        } elseif (! verifIntituleGrp($intitule)) {
            echo "<div class=error_msg>Le champ intitulé ne doit pas commencer ou se terminer par l'expresssion : Classe, Equipe ou Matiere !</div><br>\n";
            exit();
        } elseif ($filter == "") {
            echo "<div class=error_msg>Vous devez sélectionner au moins un groupe!</div><br>\n";
            exit();
        }

        // Verification de l'existence du groupe
        $groups = filter_group($config, "(cn=$cn)");
        if (count($groups)) {
            echo "<div class='error_msg'>Attention le groupe <font color='#0080ff'><a href='group.php?filter=$cn' style='color:#0080ff' target='_blank'>$cn</a></font> est déja présent dans la base, veuillez choisir un autre nom !</div><BR>\n";
            exit();
        } else {
            // Ajout du groupe
            $intitule = enleveaccents($intitule);
            // exec("/usr/share/se3/sbin/groupAdd.pl \"1\" $cn \"$description\"", $AllOutPut, $ReturnValue);
            if ($ReturnValue == "0") {
                echo "<div class=error_msg>Le groupe <font color='#0080ff'><a href='group.php?filter=$cn' style='color:#0080ff' target='_blank'>$cn</a></font> a été ajouté avec succès.</div><br>\n";
            } else {
                echo "<div class=error_msg>Echec, le groupe <font color='#0080ff'><a href='group.php?filter=$cn' style='color:#0080ff' target='_blank'>$cn</a></font> n'a pas été créé !\n";
                if ($ReturnValue)
                    echo "(type d'erreur : $ReturnValue),&nbsp;";
                echo "&nbsp;Veuillez contacter</div> <A HREF='mailto:admin?subject=PB creation groupe'>l'administrateur du système</A><BR>\n";
                exit();
            }
        }
    }

    if (empty($cn)) {
        echo "<p style='color:red'>Le groupe n'est pas choisi&nbsp;???</p>";
        echo "<p><a href='annu.php'>Retour à l'accueil Annuaire</a></p>";
        $html = "";
        admin_footer_html($html);
        echo $html;
        die();
    }

    echo "<B>Sélectionner les personnes à mettre dans le groupe <a href='group.php?filter=$cn' target='_blank'>$cn</a> :</B><BR>\n";
    echo "<form action=\"constitutiongroupe.php\" method=\"post\">\n";
    echo "<table border=\"0\" cellspacing=\"10\">\n";
    echo "<TR>\n";
    for ($loop = 0; $loop < count($filter); $loop ++) {
        echo "<TD>" . $filter[$loop] . "</TD>\n";
    }
    echo "</TR>\n";
    echo "<TR>\n";
    for ($filt = 0; $filt < count($filter); $filt ++) {
        $gus = array();
        echo "<td valign=\"top\">";
        $gus = search_people_group($config, $filter[$filt]);
        echo "<select name=\"eleves[]\" size=\"10\"  multiple=multiple>\n";
        for ($loop = 0; $loop < count($gus); $loop ++) {
            echo "<option value=" . $gus[$loop]["cn"] . ">" . $gus[$loop]["fullname"] . "</option>\n";
        }
        echo "</select>\n</td>\n";
    }
    echo "</TR>\n";
    echo "</table>\n";
    echo "<BR><BR>\n";
    $CREER_REP = (isset($_POST['CREER_REP']) ? $_POST['CREER_REP'] : "");
    echo "<input type=\"hidden\" name=\"cn\" value=\"" . urlencode($cn) . "\">
              <input type=\"hidden\" name=CREER_REP value=\"$CREER_REP\">
              <input type=\"submit\" value=\"valider\">
              <input type=\"reset\" value=\"Réinitialiser la sélection\">\n";
    echo "</form>\n";
} // fin is_admin
else
    echo "Vous n'avez pas les droits nécessaires pour ouvrir cette page...";
$html = "";
admin_footer_html($html);
echo $html;
?>