<?php

/** Suppression d'un groupe
 * @description Supprime un groupe dans l'annuaire
 * @Version 12/2018 - keyser
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * @file: del_group.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include_once "ldap.inc.php";
include "ihm.inc.php";

echo "<h1>Annuaire</h1>";

if (! have_right($config, SE_USER_ADMIN)) {
    echo ("Vous n'avez pas les droits suffisants pour accéder à cette fonction");
    $html = "";
    admin_footer_html($html);
    echo $html;
    die();
}

$cn = $_GET['cn'] ?? "";

if ($cn == '') {
    echo "<p style='color:red;'>ERREUR: Nom du groupe obligatoire.</p>";
    $html = "";
    admin_footer_html($html);
    echo $html;
    die();
}

echo aff_trailer("6");
$group = filter_group($config, "(cn=" . $cn . ")");
if ($cn != "Eleves" && $cn != "Profs" && $cn != "Administratifs") {
    $ReturnValue = delete_group($config, $cn);
    if ($ReturnValue) {
        echo "<strong>Le groupe $cn  a été supprimé avec succès.</strong><br>\n";
    } else {
        echo "<div class='error_msg'>Echec de la suppression de " . $cn . "</div><BR>\n";
    }
} else {
    echo "<div class=error_msg>La suppression des groups principaux (Eleves, Profs, Administratifs) n'est pas autorisée !</div>";
}

$html = "";
admin_footer_html($html);
echo $html;
?>