<?php

/**
 * Supprime un droit sur un user ou groupe
 * @Version 11/2018 - keyser
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: delete_right.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include_once "ldap.inc.php";
include "ihm.inc.php";

if (! have_right($config, SE_ADMIN)) {
    echo ("Vous n'avez pas les droits suffisants pour accéder à cette fonction");
    $html = "";
    admin_footer_html($html);
    echo $html;
    die();
}

$filtrecomp = $_POST['filtrecomp'] ?? "";
$old_rights = $_POST['old_rights'] ?? array();
$delete_right = $_POST['delete_right'] ?? "";
$right = $_POST['right'] ?? "";
$type = $_POST['type'] ?? "";
$mp = "";

echo "<h1>Annuaire</h1>\n";
echo aff_trailer("1");
// Affichage du formulaire de selection de parc
if ($right == "") {
    echo "<TABLE><TR><TD>";
    echo "<H3>Sélection du droit à retirer</H3>";
    echo "</TD><TD>";
    ?>
<u
    onmouseover="this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape<?php echo "('<b>se3_is_admin</b> Donne le droit d\'administration sur tout le système. Ce droit l\'emporte sur tous les autres.<BR><b>Annu_is_admin</b> Donne tous les droits sur l\'annuaire (Ajouter, supprimer, modifier des utilisateurs ou des groupes).<BR><b>sovajon_is_admin</b> Délégue le droit de changer les mots de passe à un professeur. Il faut que celui-ci soit professeur de la classe.<BR><b>system_is_admin</b> Donne le droit de visualiser les informations système du serveur.<BR><b>computer_is_admin</b> Permet de gérer les machines clientes (Créer ou supprimer des machines des parcs, état des machines clientes...)<BR><b>printers_is_admin</b> Gestion des files d\'impression des imprimantes.<BR><b>echange_can_administrate</b> Permet de gérer les répertoires _echanges dans les répertoires classes.<BR><b>inventaire_can_read</B> Permet de consulter l\'inventaire<BR><b>annu_can_read</b> Permet de consulter l\'annuaire. Par défaut les membres du groupe Profs ont ce droit.<BR><b>maintenance_can_write</b> Permet de déclarer une panne sur une machine dans l\'interface de maintenance.<BR><b>parc_can_view</b> Permet de voir les parcs.<BR><b>parc_can_manage</b> Permet de déléguer la gestion d\'un parc à une personne.<BR><b>smbweb_is_open</b> Donne le droit d\'accès depuis l\'interface smbwebclient du Slis ou du Lcs (optionnel).')"; ?>"><img
    name="action_image2" src="../elements/images/system-help.png"></u>
<?php
    echo "</TD></TR></TABLE>";
    $list_rights = list_rights($config, 'all');
    if (count($list_rights) > 0) {
        echo "<FORM method=\"post\">\n";
        echo "<SELECT NAME=\"right\" SIZE=\"1\">";
        for ($loop = 0; $loop < count($list_rights); $loop ++) {
            echo "<option value=" . $list_rights[$loop] . ">" . $list_rights[$loop] . "\n";
        }
        echo "</SELECT>&nbsp;&nbsp;\n";
        echo "<input type=\"submit\" value=\"Valider\">\n";
        echo "</FORM>\n";
    }
} else {
    // Affichage du formulaire de remplissagge du parc
    if (! $delete_right) {
        // Filtrage des noms
        echo "<FORM action=\"delete_right.php\" method=\"post\">\n";
        echo "<P>Lister les noms contenant :";
        echo "<INPUT TYPE=\"text\" NAME=\"filtrecomp\"\n VALUE=\"$filtrecomp\" SIZE=\"8\">";
        echo "<input type=\"hidden\" name=\"right\" value=\"$right\">\n";
        echo "<input type=\"submit\" value=\"Valider\">\n";
        echo "</FORM>\n";
        // Lecture des membres du droit
        $mp_all = list_members_right_profiles($config, $right);
        // Filtrage selon critere
        if ("$filtrecomp" == "")
            $mp = $mp_all;
        else {
            $lmloop = 0;
            for ($loop = 0; $loop < count($mp_all); $loop ++) {
                $mach = $mp_all[$loop];
                if (preg_match("/$filtrecomp/", $mach))
                    $mp[$lmloop ++] = $mach;
            }
        }
        if (count($mp) > 15)
            $size = 15;
        else
            $size = count($mp);
        // echo "<pre>". print_r(search_ad($config, "cn=Profs,ou=groups,dc=diderot,dc=org", "type"),true) . "</pre>";

        if (count($mp) > 0) {
            $form = "<form action=\"delete_right.php\" method=\"post\">\n";
            $form .= "<p>Sélectionnez les personnes ou groupes à priver du droit <b>$right</b> :</p>\n";
            $form .= "<p><select size=\"" . $size . "\" name=\"old_rights[]\" multiple=\"multiple\">\n";
            echo $form;
            foreach ($mp as $nom) {
                $cn = ldap_dn2cn($nom);
                if (type_ad($config, $nom) == "group") {
                    $type = "groupe";
                    $value = "$cn ($type)";
                } else {
                    $type = "utilisateur";
                    $value = "$cn ($type)";
                }
                echo "<option value=" . $nom . ">" . $value;
            }
            $form = "</select></p>\n";
            $form .= "<input type=\"hidden\" name=\"delete_right\" value=\"true\">\n";
            $form .= "<input type=\"hidden\" name=\"right\" value=\"$right\">\n";
            $form .= "<input type=\"hidden\" name=\"type\" value=\"$type\">\n";
            $form .= "<input type=\"reset\" value=\"Réinitialiser la sélection\">\n";
            $form .= "<input type=\"submit\" value=\"Valider\">\n";
            $form .= "</form>\n";
            echo $form;
        } else {
            $message = "Il n'y a rien à supprimer !";
            echo $message;
        }
    } else {
        // Suppression des droits
        echo "<H3>Modification du droit <U>$right</U></H3>";
        // var_dump($old_rights);
        echo "<P>Vous avez sélectionné " . count($old_rights) . " droit(s)<BR>\n";
        for ($loop = 0; $loop < count($old_rights); $loop ++) {
            $pers = $old_rights[$loop];
            $cn = ldap_dn2cn($pers);
            echo "Suppression de $cn du droit <U>$right</U><BR>";
            remove_right_profile($config, $cn, $right);
            if ($right == SE_COMPUTER_ADMIN) {
                $cmd = "net rpc rights revoke -U " . $config['ldap_admin_name'] . "%" . $config['ldap_admin_passwd'] . " '" . $config['samba_domain'] . "\\" . $cn . "' SeMachineAccountPrivilege";
                system("$cmd");
                echo "<BR>";
                echo "<b>Suppression du droit d'intégrer les machines au domaine</b>";
            }
            echo "<BR>";
        }
    }
}

$html = "";
admin_footer_html($html);
echo $html;
?>