<?php

/**

 * Affiche les membres d'un groupe
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: group.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include "ihm.inc.php";
include "wallpaper.inc.php";
include "shortcuts.inc.php";

echo "<h1>Annuaire</h1>";
$login = $config['login'];
$filter = $_GET['filter'] ?? $_POST['filter'] ?? '';
$filter = urldecode($filter);
$filter_cn = ldap_dn2cn($filter);
// $etab = $_GET['etab'] ?? $_POST['etab'] ?? 0;
echo aff_trailer("8_" . $filter);
if ($filter == '') {
    echo "<div class=error_msg>Paramètre absent !</div>";
    $html = "";
    admin_footer_html($html);
    echo $html;
    exit();
}
// recherche des membres du groupe
if (preg_match("/(eleves|profs|administratifs)/i", $filter)) {
    $config = get_config($config, true, true);
    // $group = search_ad($config, $filter, "group", $config['dn']['groups']);
} else {
    // $group = search_ad($config, $filter, "group", "OU=" . $etab . "," . $config['dn']['groups']);
}
$group = search_ad($config, $filter, "dn");
if (count($group) == 0) {
    echo "<div class=error_msg>le groupe n'existe pas</div>";
    $html = "";
    admin_footer_html($html);
    echo $html;
    exit();
}

$config = get_config($config, true, $_SESSION['etab']);
$people = search_people_group($config, $filter);

// tableau de profs
$lesprofs = search_people_group($config, "CN=Profs," . $config['dn']['Profs']);
$list_prof_grp = array();
foreach ($lesprofs as $key => $value) {
    $list_prof_grp[$key] = $value["cn"];
}

// tableau des PP si Equipe
if (preg_match("/Equipe/", $filter)) {
    $people2 = search_people_group($config, $filter);
    // on crée un tableau des PP de la classe
    $liste_pp = list_pp($config, $filter);
    $list_pp_grp = array();
    foreach ($liste_pp as $key => $value) {
        $cn = str_getcsv($value, ",");
        parse_str($cn[0], $output);
        $list_pp_grp[$key] = $output["CN"];
    }
}
// teste les droits
$admin_annu = have_right($config, SE_USER_ADMIN);
$can_read_annu = have_right($config, SE_USER_READ);
$admin_sovajon = have_right($config, SE_USER_PASSWORD_INIT | SE_USER_READ | SE_USER_MODIFY);
$admin_se = have_right($config, SE_ADMIN);

// Affiche les membres du groupe
$etab = 0;
if (count($people)) {
    $intitule = strtr($filter_cn, "_", " ");
    $etab = $group[0]["etab"];
    if ($etab != $_SESSION['etab']) {
        echo " etablissement : " . etab_to_name($config, $etab) . "  ";
    }

    $description = $group[0]["description"] ?? "";
    echo "<U>Groupe</U> : $intitule <font size=\"-2\">" . $description . "</font><BR>\n";
    echo "Il y a " . count($people) . " membre";
    if (count($people) > 1)
        echo "s";
    echo " dans ce groupe<BR>\n";
    foreach ($people as $p) {
        if (isset($p['dn'])) {

            if (in_array($p["cn"], $list_prof_grp)) {
                echo "<img src=\"images/gender_teacher.gif\" alt=\"Professeur\" width=18 height=18 hspace=1 border=0>\n";
            } else {
                if (isset($p["sexe"]) && $p["sexe"] == "F") {
                    echo "<img src=\"images/gender_girl.gif\" alt=\"El&egrave;ve\" width=14 height=14 hspace=3 border=0>\n";
                } else {
                    echo "<img src=\"images/gender_boy.gif\" alt=\"El&egrave;ve\" width=14 height=14 hspace=3 border=0>\n";
                }
            }

            // Si on a pas les droits on n'a pas de lien
            if ($admin_annu || $can_read_annu) {
                echo "<A href=\"people.php?cn=" . $p["cn"] . "\">" . $p["fullname"] . "</A>";
            } else {
                // si on a les droits sovajon_is_admin on vérifie si on a la classe ou si les droits étendus du groupe prof sont activés
                $cn_eleve = $p["cn"];
                if (is_my_eleve($config, $login, $cn_eleve) and $admin_sovajon) {
                    echo "<A href=\"people.php?cn=" . $p["cn"] . "\">" . $p["prenom"] . " " . $p["name"] . "</A>";
                } else {
                    echo $p["prenom"] . " " . $p["name"];
                }
            }
            $etab_prof = $p["etab"];
            $fonction = ldap_dn2cn(ldap_dn2oudn($p['dn']));
            if (! in_array($fonction, [
                "Eleves",
                "Profs",
                "Administratifs"
            ])) {
                foreach ($p['memberof'] as $g) {
                    if (preg_match("/CN=" . $fonction . ",/i", $g)) {
                        break;
                    }
                }
                echo " fonction : <A href=\"group.php?filter=" . $g . "\">" . $fonction . "</A> ,";
            }
            if ($etab_prof != $etab) {
                echo " etablissement de rattachement : " . etab_to_name($config, $etab_prof) . "  ";
            }

            if (preg_match("/Equipe/", $filter) && in_array($p["cn"], $list_pp_grp)) {
                echo "<strong><font size=\"-2\" color=\"#ff8f00\">&nbsp;&nbsp;(professeur principal)</font></strong>";
                $owner = $p["cn"];
            }

            echo "<BR>\n";
        }
    }
} else {
    echo " <STRONG>Pas de membres</STRONG>  dans le groupe $filter.<BR>";
}

//
// Affichage menu admin (se3_is_admin et Annu_is_admin)
// Pour les groupes sauf pour les groupes Eleves Profs Administratifs
//

if (($admin_annu) && ($group[0]["cn"] != "Eleves" && $group[0]["cn"] != "Profs" && $group[0]["cn"] != "Administratifs")) {
    echo "<br><ul style=\"color: red;\">\n";

    // Affichage du menu "Ajouter des membres" si le groupe est de type Equipe_ ou Classe
    if (preg_match("/Equipe_/", $group[0]["cn"]) || preg_match("/Classe_/", $group[0]["cn"])) {
        echo "<li><a href=\"add_list_users_group.php?cn=" . urlencode($group[0]["samaccountname"]) . "\">Ajouter des membres</a></li>\n";
    }

    // keyser ajout MC Marques
    // Affichage du menu "Ajouter des membres" si le groupe n'est de type Equipe_ ou Classe
    // pour ajouter dans un sous-groupe
    if (! preg_match("/Equipe_/", $group[0]["samaccountname"]) && ! preg_match("/Classe_/", $group[0]["samaccountname"])) {
        echo "<li><a href=\"aj_ssgroup.php?cn=" . urlencode($group[0]["samaccountname"]) . "\">Ajouter des membres</a></li>\n";
    }
    // fin ajout
    // Lien pour supprimer des membres
    if (count($people)) {
        echo "<li><a href=\"del_user_group.php?cn=" . urlencode($group[0]["samaccountname"]) . "\">Enlever des membres</a></li>\n";
    }

    // Lien pour supprimer le groupe
    echo "<li><a href=\"del_group.php?cn=" . urlencode($group[0]["samaccountname"]) . "\" onclick= \"return getconfirm();\">Supprimer ce groupe</a></li>\n";

    // Lien pour modifier la description du groupe
    echo "<li><a href=\"mod_group_descrip.php?cn=" . urlencode($group[0]["samaccountname"]) . "\">Modifier la description de ce groupe</a></li>\n";
    // Affiche un listing du groupe
    echo "<li><a href=\"grouplist.php?filter=" . $filter . "\" target='_new'>Afficher un listing du groupe</a></li>\n";

    // Affichage menu gestion des droits
    // si la personne est admin uniquement
    if ($admin_se) {
        // Affichage du menu "Deleguer un droit a un groupe"
        echo "<li><a href=\"manage_rights.php?cn=" . $filter . "\">Gérer les droits de ce groupe</a></li>\n";
        echo "<li><a href=\"../printers/add_printer.php?parc=" . $filter . "\">Ajouter une imprimante pour ce groupe</a></li>\n";
        echo "<li><a href=\"../printers/delete_printer.php?parc=" . $filter . "\">Supprimer une imprimante pour ce groupe</a></li>\n";
        echo "<li>Définir un fond d'écran</li>\n";
        echo "<FORM method=\"post\" action=\"group.php\" enctype=\"multipart/form-data\">\n";
        echo "<input type=hidden name=filter value=\"$filter\">";
        echo upload_wallpaper($config, "/etc/sambaedu/applications/wallpaper/wallpaper@" . $group[0]['cn'] . ".jpg");
        echo "</FORM>";
        echo "<li>Raccourcis</li>\n";
        echo "<FORM method=\"post\" action=\"group.php\" enctype=\"multipart/form-data\">\n";
        echo "<input type=hidden name=filter value=\"$filter\">";
        echo list_shortcuts($config, ldap_dn2cn($filter));
        echo "</FORM>";
    } // Fin Affichage menu droits
    echo "</ul>\n";
} elseif ($admin_se) {
    // Affichage du menu "Deleguer un droit a un groupe"
    echo "<br><ul style=\"color: red;\">\n";
    // echo "<li><a href=\"pop_group.php?filter='" . $filter . "'\">Envoyer un Pop Up à ce groupe") . "</a></li>\n";
    echo "<li><a href=\"manage_rights.php?cn=" . $filter . "\">Gérer les droits de ce groupe</a></li>\n";
    echo "<li><a href=\"grouplist.php?filter=" . $filter . "\" target='_new'>Afficher un listing du groupe</a></li>\n";
    echo "<li><a href=\"../printers/add_printer.php?parc=" . $filter . "\">Ajouter une imprimante pour ce groupe</a></li>\n";
    echo "<li><a href=\"../printers/delete_printer.php?parc=" . $filter . "\">Supprimer une imprimante pour ce groupe</a></li>\n";
    echo "<li>Définir un fond d'écran</li>\n";
    echo "<FORM method=\"post\" action=\"group.php\" enctype=\"multipart/form-data\">\n";
    echo "<input type=hidden name=filter value=\"$filter\">";
    echo upload_wallpaper($config, "/etc/sambaedu/applications/wallpaper/wallpaper@" . $group[0]['cn'] . ".jpg");
    echo "</FORM>";
    echo "<li>Raccourcis</li>\n";
    echo "<FORM method=\"post\" action=\"group.php\" enctype=\"multipart/form-data\">\n";
    echo list_shortcuts($config, ldap_dn2cn($filter));
    echo "<input type=hidden name=filter value=\"$filter\">";
    echo "</FORM>";
    echo "</ul>\n";
}

// Si le groupe est classe
$equipe = preg_replace("/^CN=(Classe_|Cours_)/i", "CN=Equipe_", $filter);

if (! $admin_annu) {
    if ($admin_sovajon) {

        // Affiche un listing du groupe si on a une Classe
        // que pour les eleves

        if (preg_match("/^(Classe_|Cours_)/i", "$filter")) {
            echo "<li><a href=\"grouplist.php?filter=" . $filter . "\" target='_new'>Afficher un listing du groupe</a></li>\n";
        }
        echo "</ul>\n";
    } elseif ($can_read_annu) {}
}

// Affichage de l'equipe pedagogique associee a la classe

if (preg_match("/^CN=(Classe_|Cours_)/", $filter)) {
    $equipe = preg_replace("/^CN=(Classe_|Cours_)/", "CN=Equipe_", $filter);
    $equipe_cn = ldap_dn2cn($equipe);
    $people2 = search_people_group($config, $equipe);
    // on crée un tableau des PP de la classe
    $liste_pp = list_pp($config, $filter);
    $list_pp_grp = array();
    foreach ($liste_pp as $key => $value) {
        $cn = str_getcsv($value, ",");
        parse_str($cn[0], $output);
        $list_pp_grp[$key] = $output["CN"];
    }

    if (count($people2)) {
        // affichage des resultats
        echo "<BR><U>Professeurs de la classe</U> : <a href=\"group.php?filter=$equipe\">$equipe_cn</A><BR>\n";
        foreach ($people2 as $p) {
            if (! empty($p["cn"])) {
                if (in_array($p["cn"], $list_prof_grp)) {
                    echo "<img src=\"images/gender_teacher.gif\" alt=\"Professeur\" width=18 height=18 hspace=1 border=0>\n";
                } else {
                    if (isset($p["sexe"]) && $p["sexe"] == "F") {
                        echo "<img src=\"images/gender_girl.gif\" alt=\"El&egrave;ve\" width=14 height=14 hspace=3 border=0>\n";
                    } else {
                        echo "<img src=\"images/gender_boy.gif\" alt=\"El&egrave;ve\" width=14 height=14 hspace=3 border=0>\n";
                    }
                }

                // On a un lien sur les profs uniquement si on est annu_can_read ou Annu_is_admin
                if (($admin_annu) || ($can_read_annu)) {
                    echo "<A href=\"people.php?cn=" . $p["cn"] . "\">" . $p["fullname"] . "</A>";
                } else {
                    echo $p["fullname"];
                }
                $etab_prof = $p["etab"];
                if ($etab_prof != $etab) {
                    echo " etablissement de rattachement : " . etab_to_name($config, $etab_prof) . "  ";
                }

                if (in_array($p["cn"], $list_pp_grp)) {
                    echo "<strong><font size=\"-2\" color=\"#ff8f00\">&nbsp;&nbsp;(professeur principal)</font></strong>";
                    $owner = $p["cn"];
                }
                echo "<BR>\n";
            }
        }
    }
}

// Affichage du rebond sur la classe associee a une equipe pedagogique

if (preg_match("/^Equipe_/", $filter)) {
    $filter2 = preg_replace("/^CN=Equipe_/", "CN=Classe_", $filter);
    $people2 = search_people_group($config, $filter2);
    if (count($people2)) {
        // affichage des resultats
        echo "<BR>Il y a " . count($people2) . " élèves dans la <a href=\"group.php?filter=$filter2\">" . ldap_dn2cn($filter2) . "</A> associée à cette équipe.\n";
        echo "<BR>\n";
    }
}

$html = "";
admin_footer_html($html);
echo $html;
?>