<?php

/**

 * Page permettant de creer des listes pour en faire un export de l'annuaire
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: grouplist.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include_once "ldap.inc.php";
include "ihm.inc.php";

require_once ("ent.inc.php");

$filter = $_GET['filter'] ?? '';

if ((have_right($config, SE_USER_ADMIN)) || (have_right($config, SE_USER_PASSWORD_INIT | SE_USER_READ | SE_USER_MODIFY))) {

    if (preg_match("/(eleves|profs|administratifs|Direction|Secretariat|AED|VieScol|Agent)/i", $filter)) {
        $config = get_config($config, true, true);
    }
    $group = search_ad($config, $filter, "dn", $config['dn']['groups']);
    $config = get_config($config, true);
    $people = search_ad($config, "*", "memberof", $filter, [
        'pwdlastset'
    ]);

    // tableau de profs
    $lesprofs = search_ad($config, "*", "memberof", "Profs");
    $list_prof_grp = array();
    foreach ($lesprofs as $key => $value) {
        $list_prof_grp[$key] = $value["cn"];
    }

    if (count($people)) {
        // affichage des r?sultats
        // Nettoyage des _ dans l'intitul? du groupe
        $intitule = strtr($filter, "_", " ");
        echo "<H1><U>Groupe</U> : $intitule <font size=\"-2\">" . $group[0]["description"] . "</font></H1>\n";
        echo "<TABLE border=1 cellspacing = 1 cellpadding = 2><thead>
        <tr>
        <th>Nom</th>
        <th>login</th>
        <th>Activé</th><th>code d'activation</th></thead>
        <tbody>\n";
        sync_ent($config);
        $ent = cache_fetch('ent');
        $list = [];

        $complexite = get_password_rule($config)['complexity'];
        if ($complexite == "on") {
            $complexite_mdp = "-#ENT#";
        } else {
            $complexite_mdp = "";
        }

        for ($loop = 0; $loop < count($people); $loop ++) {
            // $groupes = $people[$loop]["memberof"];
            // foreach ($groupes as $groupe) {
            // if ($groupe == $group[0]['dn']) {

            if ($people[$loop]['pwdlastset'] == 0) {
                $actif = "<img src=\"../elements/images/disabled.png\" alt=\"non activé\" width=18 height=18 hspace=1 border=0>";
                if ($ent) {
                    $code = $ent[array_search($people[$loop]["cn"], array_column($ent, "login"))]['code'] ?? "";
                    if (! empty($code)) {
                        $code .= $complexite_mdp;
                    }
                } else {
                    reinit_passwd($config, $people[$loop], $list, false, true, true);
                    $code = end($list)['pwd'];
                }
            } else {
                $actif = "<img src=\"../elements/images/enabled.png\" alt=\"activé\" width=18 height=18 hspace=1 border=0>";
                $code = "";
            }

            echo "<TR><TD>\n";
            if (in_array($people[$loop]["cn"], $list_prof_grp)) {
                echo "<img src=\"images/gender_teacher.gif\" alt=\"Professeur\" width=18 height=18 hspace=1 border=0>\n";
            } else {
                if (isset($people[$loop]["sexe"]) && $people[$loop]["sexe"] == "F") {
                    echo "<img src=\"images/gender_girl.gif\" alt=\"El&egrave;ve\" width=14 height=14 hspace=3 border=0>\n";
                } else {
                    echo "<img src=\"images/gender_boy.gif\" alt=\"El&egrave;ve\" width=14 height=14 hspace=3 border=0>\n";
                }
            }
            // preg_match("/([0-9]{8})/", $people[$loop]["gecos"], $naiss);
            echo $people[$loop]["fullname"] . "</TD><TD>" . $people[$loop]["cn"] . "</TD><TD>" . $actif . "</TD><TD>" . $code . "</TD>\n";

            echo "</TR>\n";
            // }
            // }
        }
        echo "</tbody></table>\n";
        // generation du csv
        // $contenu_fichier = "login;lastName;firstName;allClasses;activated;code\n";

        // foreach ($list as $user) {
        // $contenu_fichier .= $user['cn'] . ";" . $user['nom'] . ";" . $user['pre'] . ";" . $user['cla'] . ";" . $user['change'] . ";" . $user['pwd'] . "\n";
        // }
        // $nom_fic = ldap_dn2cn($filter) . ".csv";

        // file_put_contents("/var/www/sambaedu/tmp/" . $nom_fic, $contenu_fichier);
        // echo "export OK : <a href=../tmp/" . $nom_fic . "> Télécharger...</a><br>\n";

        echo "<p>Générer un <a href='grouplist_csv.php?filter=$filter' target='blank'>export CSV du groupe</a></p>\n";
    } else {
        echo " <STRONG>Pas de membres </STRONG>  dans le groupe $filter.<BR>";
    }
} else {
    echo "<div class=error_msg>Erreur : vous ne disposez pas des droits suffisants !</div>";
}
$html = "";
admin_footer_html($html);
echo $html;

?>