<?php

/**

 * Liste les groupes
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: grouplist_csv.php
 */
// ====================================
// Portion de code correspondant a la partie entete.inc.php sans l'affichage HTML
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
require_once ("ent.inc.php");
include "ihm.inc.php";
$filter = $_GET['filter'];
if ((have_right($config, SE_USER_ADMIN)) || (have_right($config, SE_USER_PASSWORD_INIT | SE_USER_READ | SE_USER_MODIFY))) {

    if (preg_match("/(eleves|profs|administratifs)/i", $filter)) {
        $config = get_config($config, true, true);
    }
    $config = get_config($config, true);
    $people = search_ad($config, "*", "memberof", $filter);

    if (count($people)) {

        sync_ent($config);
        $ent = cache_fetch('ent');

        $complexite = get_password_rule($config)['complexity'];
        if ($complexite == "on") {
            $complexite_mdp = "-#ENT#";
        } else {
            $complexite_mdp = "";
        }

        // $contenu_fichier='';
        $contenu_fichier = "login;originalLogin;fullName;lastName;firstName;externalId;email;allClasses;activated;code\n";

        for ($loop = 0; $loop < count($people); $loop ++) {
            // preg_match("/([0-9]{8})/",$people[$loop]["gecos"],$naiss);
            $groupes = $people[$loop]["memberof"];
            // foreach ($groupes as $groupe) {
            // if ($groupe == $group[0]['dn']) {
            $list = [];
            foreach ($groupes as $classe) {
                if (preg_match("/CN=(Classe|Equipe)_(.*),/iU", $classe, $m)) {
                    $list[] = $m[2];
                }
            }
            $list = implode(',', $list);
            if ($people[$loop]['pwdlastset'] == 0) {
                $actif = 0;
            } else {
                $actif = 1;
            }
            if ($ent) {
                $code = $ent[array_search($people[$loop]["cn"], array_column($ent, "login"))]['code'] ?? "";
                if (! empty($code)) {
                    $code .= $complexite_mdp;
                }
            } elseif ($config['pwdPolicy'] < 2) {
                $code = $people[$loop]["date"] ?? "";
            } elseif ($config['pwdPolicy'] > 2) {
                $code = $config['activation_code'];
            } else {
                $code = "";
            }

            $originallogin = explode("@", $people[$loop]['userprincipalname'])[0];
            $contenu_fichier .= $people[$loop]["cn"] . ";" . $originallogin . ";" . $people[$loop]["fullname"] . ";" . $people[$loop]["nom"] . ";" . $people[$loop]["prenom"] . ";" . to_guid($people[$loop]["objectguid"]) . ";" . $people[$loop]["email"] . ";" . $list . ";" . $actif . ";" . $code . "\n";
            // }
            // }
        }
        $nom_fic = ldap_dn2cn($filter) . ".csv";
        header('Content-Type: text/x-csv');
        header('Content-Disposition: attachment; filename="' . $nom_fic . '"');
        header('Pragma: no-cache');

        echo $contenu_fichier;
    } else {
        echo " <STRONG>Pas de membres</STRONG> dans le groupe $filter.<BR>";
        $html = "";
        admin_footer_html($html);
        echo $html;
    }
}
?>