<?php

/**
 * Affiche les groupes de l'AD correspondant au filtre passé en post
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Version $Id: groups_list.php 05-11-2018 keyser $
 * @Note: Ce fichier doit etre appele par un form
 * @Licence Distribue sous la licence GPL
 */
/**
 *
 * @Repertoire: annu
 * file: groups_list.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include_once "ldap.inc.php";
include "ihm.inc.php";

$group = isset($_POST['group']) ? $_POST['group'] : "";
$priority_group = isset($_POST['priority_group']) ? $_POST['priority_group'] : "";

if (! isset($_POST['group'])) {
    die('Erreur : ce script ne peut être appelé directement!');
}

// var_dump($priority_group);
// var_dump($group);

echo "<h1>Annuaire</h1>\n";

if ((have_right($config, SE_USER_ADMIN)) || (have_right($config, SE_USER_READ)) || (have_right($config, SE_ADMIN))) {
    echo aff_trailer("3");

    if (! $group) {
        $filter = "(cn=*)";
    } else {
        if ($priority_group == "contient") {
            $filter = "(cn=*$group*)";
        } elseif ($priority_group == "commence") {
            $filter = "(|(cn=Classe_$group*)(cn=Cours_$group*)(cn=Equipe_$group*)(cn=Matiere_$group*)(cn=$group*))";
        } else {
            // $priority_group == "finit"
            $filter = "(|(cn=Classe_*$group)(cn=Cours_*$group)(cn=Equipe_*$group)(cn=Matiere_*$group)(cn=*$group))";
        }
    }

    // Remplacement *** ou ** par *
    $filter = preg_replace("/\*\*\*/", "*", $filter);
    $filter = preg_replace("/\*\*/", "*", $filter);
    // var_dump($filter);
    # $TimeStamp_0=microtime();
    $groups = filter_group($config, $filter);
    // affichage de la liste des groupes trouves
    if (count($groups)) {
        if (count($groups) == 1) {
            echo "<p><STRONG>" . count($groups) . "</STRONG> groupe répond à ces critères de recherche</p>\n";
        } else {
            echo "<p><STRONG>" . count($groups) . "</STRONG> groupes répondent à ces critères de recherche</p>\n";
        }
        echo "<UL>\n";
        $etab_ou = $_SESSION['etab'];
        for ($loop = 0; $loop < count($groups); $loop ++) {
            echo "<LI><A href=\"group.php?filter=" . urlencode($groups[$loop]["dn"]) . "\">";
            echo "<STRONG>" . $groups[$loop]["cn"] . "</STRONG>";
            if (ldap_dn2uai($groups[$loop]["dn"]) != $etab_ou && ldap_dn2uai($groups[$loop]["dn"]) != 0) {
                echo " " . etab_to_name($config, ldap_dn2uai($groups[$loop]["dn"]));
            }
            $description = $groups[$loop]["description"] ?? "";
            echo "</A> <font size=\"-2\">" . $description . "</font></LI>\n";
            if ((have_right($config, SE_USER_ADMIN)) || (have_right($config, SE_ADMIN))) {
                echo "<a href=\"manage_rights.php?cn=" . $groups[$loop]["dn"] . "\">Gérer les droits de ce groupe</a>\n";
            }
        }
        echo "</UL>\n";
    } else {
        echo "<STRONG>Pas de résultats</STRONG> correspondant aux critères sélectionnés.<BR>";
    }
} else {
    die("Vous n'avez pas les droits suffisants pour accéder à cette fonction</BODY></HTML>");
}

$html = "";
admin_footer_html($html);
echo $html;
?>