<?php
/**
 * affiche le statut des action à distance en cours
 * @Projet SambaEdu
 * @auteurs denis bonnenfant
 * @Licence Distribue selon les termes de la licence GPL
 *
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include "ihm.inc.php";
require_once ("ldap.inc.php");
require_once ("fonc_outils.inc.php");
require_once ("fonc_parc.inc.php");
require_once 'ent.inc.php';
require "pronote.inc.php";
require "partages.inc.php";

$end = false;
$force = false;
$ad_cns = $_POST['ad'] ?? $_GET['ad'] ?? array();
$files = $_FILES;
$global = $_POST['global'] ?? false;
$action = $_POST['action'] ?? $_GET['action'] ?? "match_groups";
$form = $_POST['form'] ?? $_GET['form'] ?? "match";
$session = $_POST['lock'] ?? "";

if (have_right($config, SE_USER_ADMIN)) {
    echo "<h1>Assistant d'importation des comptes ENT</h1><br>\n";
    // echo refresh_page($page);
    $page = "import_ent.php#end";
    echo "<FORM name=\"ent\" enctype=\"multipart/form-data\" action=\"" . $page . "\" method=\"post\">\n";
    if (empty($session)) {
        // nouvel import
        $session = session_id();
    }
    $lock = apcu_fetch('ent_lock');
    if (empty($lock) || $action == "nouveau_force") {
        if ($action == "nouveau_force") {
            echo "Suppression du verrou.<br>";
        }
        $session = session_id();
        $lock['lock'] = $session;
        apcu_add('ent_lock', $lock, $config['ent_timeout']);
    }
    if ($lock['lock'] != $session) {
        echo "session : " . $session . " lock :  " . $lock['lock'] . "<br>";
        echo "Un import est déjà en cours, ou a été interrompu avant d'être fini. Vous pouvez recommencer plus tard, ou forcer une nouvelle importation.<br>\n";
        echo "<input type=\"hidden\" name=\"lock\" value=\"" . $session . "\">";
        echo form_ent_next("nouveau_force");
    } else {
        apcu_add('ent_lock', [
            'lock' => $session
        ], $config['ent_timeout']);
        echo "<input type=\"hidden\" name=\"lock\" value=\"" . $session . "\">";
        if ($action == "nouveau_force") {
            $force = true;
            cache_delete('ent');
        }
        if ($action == "nouveau" || $action == "nouveau_force") {
            apcu_delete('ent_html');
            cache_delete('ent');
            cache_delete('match');
            cache_delete('group');
            apcu_delete('ent_lock');
            cache_delete('group');
            cache_delete('members');
            cache_delete('match');
            apcu_delete('total');
            cache_delete('ad_users');
            cache_delete('new');
            apcu_delete('n_new');
            apcu_delete('listing');
            echo "Le moteur d'import choisit automatiquement l'étape suivante,
pour un import « classique » il suffit donc de valider les étapes obligatoires jusqu'à arriver à
 ce que l'étape suivante soit « 8 - Appliquer les changements », valider, et attendre les rechargements de la page jusqu'à la fin du traitement.<br>";
            echo "Certaines étapes sont cependant alors sautées, il est donc parfois souhaitable de changer manuellement l'étape suivante.<br>\n";
            echo "Par exemple :<ul>
<li>Pour importer des utilisateurs qui n'ont pas de classes dans le fichier d'origine, il est nécessaire d'effectuer les étapes suivantes :
<ul><li>2 -Mise en correspondance automatique, Valider</li>
<li>Choisir l'étape 3 - Correspondances par groupes ou 3 -Correspondances globales, Valider.</li>
<li>Dans le tableau, cliquer sur Créer...</li>
<li>7 - Valider.</li>
<li>8 - Appliquer les changements, Valider.</li></ul>
</li>\n";
            echo "<li>Pour supprimer des utilisateurs existants dans l'AD mais qui ne seraient plus présent sur l'ENT suite à leur départ de l'établissement, il est nécessaire d'effectuer les étapes suivantes :
<ul><li>2 - Mise en correspondance auto, Valider.</li>
<li>Choisir l'étape 6 - Mettre des utilisateurs à la corbeille ou 6 - Mettre tous les utilisateurs (la différence étant la liste de ceux présélectionnés) : dans le tableau cocher les utilisateurs à supprimer, ou décocher ceux à garder.</li>
<li>7 - Valider</li>
<li>8 - Appliquer les changements, Valider.</li></ul>
</li>\n";
            echo "<li>Pour renommer des utilisateurs, procéder de la même façon.</li>
</ul>\n";

            switch ($config['ent_type']) {
                case "csv":
                case "xml":
                case "kosmos":
                    echo upload_ent($config, $files, $config['ent_type']);
                    echo form_ent_next("read_file");
                    break;
                // case "pronote":
                // echo sync_pronote($config);
                // echo match_ad($config, true);
                // echo form_ent_next("match_groups");
                // break;
                default:
                    echo sync_ent($config, $force);
                    if (! empty($config['ent_sync_cours'])) {
                        echo sync_ent_groups($config);
                    }
                // echo match_ad($config, true);
                // echo form_ent_next("match");
            }
        } elseif ($action == "sync_groups" && ! empty($config['ent_sync_cours'])) {
            echo sync_ent_groups($config);
            echo form_ent_next("match");
        } elseif ($action == "match") {
            $end = match_ad_from_ent($config, 20, true);
            echo apcu_fetch('ent_html');
            if ($end) {
                echo form_ent_next("commit");
            } else {
                echo form_ent_next("match");
            }
            // } elseif ($action == "merge_pronote") {
            // echo sync_pronote($config, true);
            // echo merge_pronote($config);
            // echo form_ent_next("match_groups");
            // } elseif ($action == "read_file") {
            // echo upload_ent($config, $files, $config['ent_type']);
            // echo match_ad($config, true);
            // echo form_ent_next("commit");
        } elseif ($action == "match_groups") {
            echo @form_map_users($config, false);
            echo form_ent_next("apply");
        } elseif ($action == "match_global") {
            echo @form_map_users($config, true);
            echo form_ent_next("apply");
        } elseif ($action == "rename") {
            echo @form_rename_users($config, false);
            echo form_ent_next("apply");
        } elseif ($action == "rename_global") {
            echo @form_rename_users($config, true);
            echo form_ent_next("apply");
        } elseif (preg_match("/trash_(.*)/", $action, $m)) {
            echo @form_trash_users($config, $m[1]);
            echo form_ent_next("apply");
        } elseif ($action == "password") {
            echo @form_reinit_password($config, false);
            echo form_ent_next("apply");
        } elseif ($action == "apply") {
            if (count($ad_cns) > 0) {
                if ($form == "match") {
                    echo match_ent_users($config, $ad_cns);
                } elseif ($form == "rename") {
                    echo rename_ent_users($config, $ad_cns);
                } elseif ($form == "trash") {
                    echo trash_ad_users($config, $ad_cns);
                } elseif ($form == "password") {
                    echo reinit_all_passwords($config, $ad_cns);
                }
                echo form_ent_next("apply");
            } else {
                echo "Aucun changement supplémentaire à faire.<br>";
                echo form_ent_next("commit");
            }
        } elseif ($action == "commit") {

            $end = update_ad_from_ent($config, 10, true);
            echo apcu_fetch('ent_html');
            $ent_count = apcu_fetch('ent_count');
            if ($ent_count > 0) {
                echo apcu_fetch('ent_type') . " : " . $ent_count . " comptes restant à traiter...<br>";
            }
            if ($end) {
                apcu_delete('ent_lock');
                $headers = 'MIME-Version: 1.0' . "\n";
                $headers .= 'Content-type: text/html; charset=utf-8' . "\n";
                mail("root", "[" . $config['se4fs_name'] . "] Fin d'import ENT manuel", "<b>Début d'import :</b><br>\n" . apcu_fetch('ent_html'), $headers);
                apcu_delete('ent_html');
                echo form_ent_next("nouveau_force");
            } else {
                echo form_ent_next("commit");
            }
        }
        echo "</form>";
        echo "<a id=\"end\"></a>";
        if ($end && $action == "commit") {
            echo generate_listing();
            // echo "<b> Importation terminée </b>";
            batch_write();
            apcu_delete('ent_lock');
            cache_delete('ent');
            cache_delete('match');
            // effacement du cache ldap
            apcu_delete(new APCUIterator('#^search_#'));
            apcu_delete("ldap_cache_invalid");
        } elseif (! $end && ($action == "commit" || $action == "match")) {
            echo "<script type=\"text/javascript\">";
            // $html .= "document.forms[\"ent\"].submit()";
            echo "var wait = setTimeout(document.ent.submit(), 29000)";
            echo "</script>";
        }
    }
}
$html = "";
admin_footer_html($html);
echo $html;
?>
