<?php
/**
 * import de fichiers csv
 * @Projet SambaEdu
 * @auteurs denis bonnenfant
 * @Licence Distribue selon les termes de la licence GPL
 *
 *
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include "ihm.inc.php";
require_once ("ldap.inc.php");
require_once ("fonc_outils.inc.php");
require_once ("fonc_parc.inc.php");
require_once 'ent.inc.php';
require "pronote.inc.php";
require "partages.inc.php";
require "gpei.inc.php";
require "sites.inc.php";

$end = false;
$force = false;
$ad_cns = $_POST['ad'] ?? $_GET['ad'] ?? array();
$files = $_FILES;
$action = $_POST['action'] ?? $_GET['action'] ?? "match_groups";
$form = $_POST['form'] ?? $_GET['form'] ?? "match";
$session = $_POST['lock'] ?? "";
$config['etab_ou'] = $_SESSION['etab_ou'] ?? $config['etab_ou'] ?? 0;
if (have_right($config, SE_USER_ADMIN)) {
    echo "<h1>Importation Fichiers GPEI</h1><br>\n";
    // echo refresh_page($page);
    $page = "import_gpei.php#end";
    echo "<FORM name=\"ent\" enctype=\"multipart/form-data\" action=\"" . $page . "\" method=\"post\">\n";
    if (empty($session)) {
        // nouvel import
        $session = session_id();
    }
    $ent['ent_type'] = "gpei";
    if (count($ent) == 0) {
        echo form_config_ent($config, $ent, true);
        echo form_ent_next("nouveau");
        echo "</form>";
    } else {

        $file_type = $_POST['file_type'] ?? $ent['ent_type'];
        echo "<input type=\"hidden\" name=\"file_type\" value=\"" . $file_type . "\">";
        echo "<input type=\"hidden\" name=\"ent[ent_type]\" value=\"" . $file_type . "\">";
        $lock = apcu_fetch('ent_lock');
        if (empty($lock) || $action == "nouveau_force") {
            echo "Suppression du verrou.<br>";
            $session = session_id();
            $lock['lock'] = $session;
            apcu_store('ent_lock', $lock);
        }
        if ($lock['lock'] != $session) {
            echo "session : " . $session . " lock :  " . $lock['lock'] . "<br>";
            echo "Un import est déjà en cours, ou a été interrompu avant d'être fini. Vous pouvez recommencer plus tard, ou forcer une nouvelle importation.<br>\n";
            echo "<input type=\"hidden\" name=\"lock\" value=\"" . $session . "\">";
            echo form_ent_next("nouveau_force");
        } else {
            apcu_add('ent_lock', [
                'lock' => $session
            ]);
            echo "<input type=\"hidden\" name=\"lock\" value=\"" . $session . "\">";
            if ($action == "nouveau_force") {
                $force = true;
                cache_delete('ent');
            }
            if ($action == "nouveau" || $action == "nouveau_force") {
                apcu_delete('ent_html');
                cache_delete('ent');
                cache_delete('match');
                cache_delete('group');
                apcu_delete('ent_lock');
                cache_delete('group');
                cache_delete('match');
                cache_delete('members');
                apcu_delete('total');
                cache_delete('ad_users');
                cache_delete('new');
                apcu_delete('n_new');
                apcu_delete('listing');
                switch ($file_type) {
                    case "csv":
                    case "csv_pronote":
                    case "xml":
                    case "kosmos":
                    case "pronote":
                        echo upload_ent($config, $files, $file_type);
                        echo form_ent_next("read_file");
                        break;
                    default:
                        echo upload_ent($config, $files, $file_type);
                        echo form_ent_next("read_file");
                }
                if ($config['etab_ou'] == 0) {
                    echo "<h2>Import pour tous les établissements : </h2>
Attention cet import peut être très long !<br>";
                }
            } elseif ($action == "read_file") {
                echo upload_ent($config, $files, $file_type);
                echo form_ent_next("match");
            } elseif ($action == "match") {
                $end = match_ad_from_ent($config, 27, true);
                echo apcu_fetch('ent_html');
                if ($end) {
                    // apcu_delete('ent_html');
                    echo form_ent_next("commit");
                } else {
                    echo form_ent_next("match");
                }
            } elseif ($action == "match_groups") {
                echo @form_map_users($config, false);
                echo form_ent_next("apply");
            } elseif ($action == "match_global") {
                echo @form_map_users($config, true);
                echo form_ent_next("apply");
            } elseif ($action == "rename") {
                echo @form_rename_users($config, false);
                echo form_ent_next("apply");
            } elseif ($action == "rename_global") {
                echo @form_rename_users($config, true);
                echo form_ent_next("apply");
            } elseif (preg_match("/trash_(.*)/", $action, $m)) {
                echo @form_trash_users($config, $m[1]);
                echo form_ent_next("apply");
            } elseif ($action == "apply") {
                if (count($ad_cns) > 0) {
                    if ($form == "match") {
                        echo match_ent_users($config, $ad_cns);
                    } elseif ($form == "rename") {
                        echo rename_ent_users($config, $ad_cns);
                    } elseif ($form == "trash") {
                        echo trash_ad_users($config, $ad_cns);
                    }
                    echo form_ent_next("apply");
                } else {
                    echo "Aucun changement supplémentaire à faire.<br>";
                    echo form_ent_next("commit");
                }
            } elseif ($action == "commit") {
                $end = update_ad_from_ent($config, 45, true);
                echo apcu_fetch('ent_html');
                echo apcu_fetch('ent_type') . " : " . apcu_fetch('ent_count') . " comptes restant à traiter...<br>";
                if ($end) {
                    apcu_delete('ent_lock');
                    $headers = 'MIME-Version: 1.0' . "\n";
                    $headers .= 'Content-type: text/html; charset=utf-8' . "\n";
                    mail("root", "[" . $config['se4fs_name'] . "] Fin d'import CSV manuel", "<b>Début d'import :</b><p>" . apcu_fetch('ent_html') . "<b>Fin d'import</b>", $headers);
                    apcu_delete('ent_html');
                    echo form_ent_next("nouveau_force");
                } else {
                    echo form_ent_next("commit");
                }
            }
        }
        echo "</form>";
        echo "<a id=\"end\"></a>";
        if ($end && $action == "commit") {
            echo generate_listing("listing");
            echo "<b> Importation terminée </b>";
            batch_write();
            apcu_delete('ent_lock');
            cache_delete('ent');
            cache_delete('match');
            cache_delete('matieres');
            cache_delete('ad_users');
            // effacement du cache ldap
            apcu_delete(new APCUIterator('#^search_#'));
            apcu_delete("ldap_cache_invalid");
        } elseif (! $end && ($action == "commit" || $action == "match")) {
            echo "<script type=\"text/javascript\">";
            // $html .= "document.forms[\"ent\"].submit()";
            echo "var wait = setTimeout(document.ent.submit(), 29000)";
            echo "</script>";
        }
    }
}
$html = "";
admin_footer_html($html);
echo $html;
?>
