<?php
/**
 * import de fichiers csv
 * @Projet SambaEdu
 * @auteurs denis bonnenfant
 * @Licence Distribue selon les termes de la licence GPL
 *
 *
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include "ihm.inc.php";
require_once ("ldap.inc.php");
require_once ("fonc_outils.inc.php");
require_once ("fonc_parc.inc.php");
require_once 'ent.inc.php';
require "pronote.inc.php";
require "partages.inc.php";

$end = false;
$force = false;
$ad_cns = $_POST['ad'] ?? $_GET['ad'] ?? array();
$files = $_FILES;
$action = $_POST['action'] ?? $_GET['action'] ?? "match_groups";
$form = $_POST['form'] ?? $_GET['form'] ?? "match";
$session = $_POST['lock'] ?? "";
$manu = true;

if (have_right($config, SE_USER_ADMIN)) {
    echo "<h1>Assistant d'importation des comptes à partir de fichiers CSV, JSON ou XML</h1><br>\n";
    // echo refresh_page($page);
    $page = "import_csv.php#end";
    echo "<form name=\"ent\" enctype=\"multipart/form-data\" action=\"" . $page . "\" method=\"post\">\n";
    if (empty($session)) {
        // nouvel import
        $session = session_id();
    }
    $ent = $_POST['ent'] ?? array();
    if (count($ent) == 0) {
        echo "Le moteur d'import choisit automatiquement l'étape suivante, pour un import « classique » il suffit donc de valider les étapes obligatoires jusqu'à arriver à ce que l'étape suivante soit « 8 - Appliquer les changements », valider, et attendre les rechargements de la page jusqu'à la fin du traitement.<br>";
        echo "Certaines étapes sont cependant alors sautées, il est donc parfois souhaitable de changer manuellement l'étape suivante.<br>\n";
        echo "Par exemple :<br>– Pour importer des utilisateurs qui n'ont pas de classe dans le fichier d'origine, il est nécessaire de sélectionner « Créer... » dans le tableau de l'étape « 3 - Correspondances globales » (les étapes sont alors : 1 Valider ⇒ 2 Valider ⇒ changement d'étape suivante pour : 3 Valider ⇒ dans le tableau Créer... puis Valider ⇒ 7 Valider ⇒ 8 Valider).<br>\n";
        echo "– Pour supprimer des utilisateurs existants dans l'AD mais qui ne seraient plus dans le fichier d'origine suite à leur départ de l'établissement, il est nécessaire de passer par l'étape « 6 - Mettre des utilisateurs à la corbeille / Mettre tous les utilisateurs à la corbeille » (les étapes sont alors : 1 Valider ⇒ 2 Valider ⇒ changement d'étape suivante pour : 6 Valider ⇒ dans le tableau choisir les utilisateurs à supprimer puis Valider ⇒ 7 Valider ⇒ 8 Valider).<br>\n<br>\n";
        echo form_config_ent($config, $ent, true);
        echo "<br><label for='remove'>Activer la suppression des anciennes affectations et utilisateurs (via l'étape 6) ?</label>";
        echo "<input name='remove' id='remove' type='checkbox' value='true'/><br>\n";
        echo form_ent_next("nouveau");
        echo "</form>";
    } else {
        $file_type = $_POST['file_type'] ?? "csv_group";
        echo "<input type=\"hidden\" name=\"file_type\" value=\"" . $file_type . "\">";
        echo "<input type=\"hidden\" name=\"ent[ent_type]\" value=\"" . $file_type . "\">";
        $asm = false;
        if (! isset($_POST['remove']) && ! isset($_GET['remove'])) {
            switch ($file_type) {
                case "csv_pronote":
                    $remove = false;
                    break;
                case "csv_pronote_CAS":
                    $remove = false;
                    $asm = true;
                    break;
                case "csv_group":
                    $remove = false;
                    $update_mode = "group";
                    break;
                case "json":
                    $remove = true;
                    break;
                default:
                    $remove = false;
            }
        } else {
            $remove = $_POST['remove'] ?? $_GET['remove'];
        }
        if ($remove) {
            echo "<input type=\"hidden\" name=\"remove\" value=\"true\">";
        } else {
            echo "<input type=\"hidden\" name=\"remove\" value=\"false\">";
        }
        $lock = apcu_fetch('ent_lock');
        if (empty($lock) || $action == "nouveau_force") {
            echo "Suppression du verrou.<br>";
            $session = session_id();
            $lock['lock'] = $session;
            apcu_add('ent_lock', $lock, $config['ent_timeout']);
        }
        if ($lock['lock'] != $session) {
            echo "session : " . $session . " lock :  " . $lock['lock'] . "<br>";
            echo "Un import est déjà en cours, ou a été interrompu avant d'être fini. Vous pouvez recommencer plus tard, ou forcer une nouvelle importation.<br>\n";
            echo "<input type=\"hidden\" name=\"lock\" value=\"" . $session . "\">";
            echo form_ent_next("nouveau_force");
        } else {
            apcu_add('ent_lock', [
                'lock' => $session
            ], $config['ent_timeout']);
            echo "<input type=\"hidden\" name=\"lock\" value=\"" . $session . "\">";
            if ($action == "nouveau_force") {
                cache_delete('ent');
                $force = true;
            }
            if ($action == "nouveau" || $action == "nouveau_force") {
                apcu_delete('ent_html');
                cache_delete('ent');
                cache_delete('match');
                cache_delete('group');
                apcu_delete('ent_lock');
                cache_delete('group');
                cache_delete('members');
                cache_delete('match');
                apcu_delete('total');
                cache_delete('ad_users');
                cache_delete('new');
                apcu_delete('n_new');
                apcu_delete('listing');
                switch ($file_type) {
                    case "csv":
                    case "json":
                    case "csv_pronote":
                    case "xml":
                    case "kosmos":
                    case "pronote":
                    default:
                        echo upload_ent($config, $files, $file_type, $manu);
                        echo form_ent_next("read_file");
                }
            } elseif ($action == "read_file") {
                echo upload_ent($config, $files, $file_type, $manu);
                echo form_ent_next("match");
            } elseif ($action == "match") {
                $end = match_ad_from_ent($config, 20, true, $asm, $manu);
                echo apcu_fetch('ent_html');
                if ($end) {
                    echo form_ent_next("commit");
                } else {
                    echo form_ent_next("match");
                }
            } elseif ($action == "match_groups") {
                echo @form_map_users($config, false);
                echo form_ent_next("apply");
            } elseif ($action == "match_global") {
                echo @form_map_users($config, true);
                echo form_ent_next("apply");
            } elseif ($action == "rename") {
                echo @form_rename_users($config, false);
                echo form_ent_next("apply");
            } elseif ($action == "rename_global") {
                echo @form_rename_users($config, true);
                echo form_ent_next("apply");
            } elseif ($action == "trash") {
                echo @form_trash_users($config, false);
                echo form_ent_next("apply");
            } elseif ($action == "trash_all") {
                echo @form_trash_users($config, true);
                echo form_ent_next("apply");
            } elseif ($action == "apply") {
                if (count($ad_cns) > 0) {
                    if ($form == "match") {
                        echo match_ent_users($config, $ad_cns);
                    } elseif ($form == "rename") {
                        echo rename_ent_users($config, $ad_cns);
                    } elseif ($form == "trash") {
                        echo trash_ad_users($config, $ad_cns);
                    }
                    echo form_ent_next("apply");
                } else {
                    echo "Aucun changement supplémentaire à faire.<br>";
                    echo form_ent_next("commit");
                }
            } elseif ($action == "commit") {
                $end = update_ad_from_ent($config, 10, false, false, false, "group");
                echo apcu_fetch('ent_html');
                echo apcu_fetch('ent_type') . " : " . apcu_fetch('ent_count') . " comptes restant à traiter...<br>";
                if ($end) {
                    apcu_delete('ent_lock');
                    $headers = 'MIME-Version: 1.0' . "\n";
                    $headers .= 'Content-type: text/html; charset=utf-8' . "\n";
                    mail("root", "[" . $config['se4fs_name'] . "] Fin d'import CSV manuel", "<b>Début d'import :</b><p>" . apcu_fetch('ent_html') . "<b>Fin d'import</b>", $headers);
                    apcu_delete('ent_html');
                    echo form_ent_next("nouveau_force");
                } else {
                    echo form_ent_next("commit");
                }
            }
        }
        echo "</form>";
        echo "<a id=\"end\"></a>";
        if ($end && $action == "commit") {
            echo generate_listing();
            echo "<b> Importation terminée </b>";
            batch_write();
            apcu_delete('ent_lock');
            cache_delete('ent');
            cache_delete('match');
        } elseif (! $end && ($action == "commit" || $action == "match")) {
            echo "<script type=\"text/javascript\">";
            // $html .= "document.forms[\"ent\"].submit()";
            echo "var wait = setTimeout(document.ent.submit(), 29000)";
            echo "</script>";
        }
    }
}
$html = "";
admin_footer_html($html);
echo $html;
?>
