<?php
/**

 * import de fichiers siecle

 * @Projet SambaEdu

 * @auteurs denis bonnenfant, Tom Ricci

 * @Licence Distribue selon les termes de la licence GPL
 * 
 * 
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include "ihm.inc.php";
require_once ("ldap.inc.php");
require_once ("fonc_outils.inc.php");
require_once ("fonc_parc.inc.php");
require_once 'ent.inc.php';
require "pronote.inc.php";
require "partages.inc.php";

$files = $_FILES;
$time = time();
$date_sortie = $_POST['date_sortie'] ?? $_GET['date_sortie'] ?? false;
$import_groupes = $_POST['import_groupes'] ?? $_GET['import_groupes'] ?? false;

if (have_right($config, SE_USER_ADMIN)) {
    echo "<h1>Assistant d'importation des comptes depuis SIECLE</h1><br>\n";
    $page = "import_siecle.php#end";
    echo "<form name=\"ent\" enctype=\"multipart/form-data\" action=\"" . $page . "\" method=\"post\">\n";
    if (isset($files['siecle'])) {
        if (array_key_exists('name', $files['siecle'])) {
            echo "Le fichier " . $files['siecle']['name'] . " a été chargé.<br>";
        } else {
            echo "<p style='color:red;'><b>ERREUR:</b> Aucun fichier n'a été; fourni !</p>\n";
            die();
        }

        $tmp_eleves_file = $files['siecle']['tmp_name'];
        $eleves_file = $files['siecle']['name'];
        $size_eleves_file = $files['siecle']['size'] / 1024;

        if (empty($tmp_eleves_file)) {
            echo "<p>L'upload du fichier <span style='color:red;'>$eleves_file</span> a semble-t-il échoué.</p>";

            $upload_max_filesize = ini_get('upload_max_filesize');
            $post_max_size = ini_get('post_max_size');

            echo "<p>Il se peut que le fichier fourni ait été trop volumineux.<br />PHP est actuellement paramétré avec:<br />\n";
            echo "</p>\n";
            echo "<blockquote>\n";
            echo "<span style='color:blue;'>upload_max_filesize</span>=<span style='color:green;'>" . $upload_max_filesize . "</span><br />\n";
            echo "<span style='color:blue;'>post_max_size</span>=<span style='color:green;'>" . $post_max_size . "</span><br />\n";
            echo "</blockquote>\n";
            echo "<p>\n";
            echo "Si ces valeurs sont insuffisantes pour vos fichiers XML, il est possible de modifier les valeurs limites dans <span style='color:green;'>/etc/php/" . substr(phpversion(), 0, 3) . "/fpm/pool.d/sambaedu.conf</span>\n";
            echo "</p>\n";
            die();
        }
        $dossier_tmp_import_comptes = sys_get_temp_dir();
        $dest_file = $dossier_tmp_import_comptes . "/" . $eleves_file;
        if (file_exists($dest_file)) {
            unlink($dest_file);
        }
        if (! is_uploaded_file($tmp_eleves_file)) {
            echo "<p style='color:red'>Impossible d'importer le fichier.</p><br>\n";
            die();
        }
        if (! move_uploaded_file("$tmp_eleves_file", "$dest_file")) {
            echo "<p style='color:red'>Impossible de copier le fichier.</p>\n";
            die();
        }
        echo "Fichier de " . $size_eleves_file . " ko correctement importé.<br>\n";

        // Si jamais un fichier non dézippé est fourni
        $extension_fichier_emis = strtolower(strrchr($eleves_file, "."));
        if ($extension_fichier_emis == ".zip") {
            if (! extension_loaded('zip')) {
                echo "Erreur, le module zip manque.";
                die();
            }
            $dossier_tmp_import_comptes = $dossier_tmp_import_comptes . "/" . hash("sha256", rand());
            mkdir($dossier_tmp_import_comptes);
            $zip = new ZipArchive();
            if ($zip->open($dest_file) === TRUE) {
                $zip->extractTo($dossier_tmp_import_comptes);
            } else {
                echo "<p style='color:red'>Echec de l'extraction de l'archive ZIP.</p>\n";
                die();
            }
            $zip->close();
            $files = scandir($dossier_tmp_import_comptes);
            $import_files = array();
            foreach ($files as $file) {
                if (preg_match("/.*\.xml$/", $file) == 1) {
                    $import_files[] = $dossier_tmp_import_comptes . "/" . $file;
                }
            }
        } else {
            $import_files[] = $dest_file;
        }

        libxml_use_internal_errors(true);
        $eleves = array();
        foreach ($import_files as $file) {
            $eleves_xml = simplexml_load_file($file);
            $objet_eleves = ($eleves_xml->DONNEES->ELEVES);

            foreach ($objet_eleves->children() as $eleve) {
                $id = false;
                foreach ($eleve->attributes() as $key => $value) {
                    if (strtoupper($key) == 'ELEVE_ID') {
                        $id = trim($value);
                        break;
                    } elseif (strtoupper($key) == 'ELENOET') {
                        $id = trim($value);
                        break;
                    } else {
                        echo "Eleve sans ELEVE_ID ou ELENOET dans DONNEES->ELEVES";
                    }
                }
                if ($id) {
                    $eleves[$id] = array(
                        "Id" => "",
                        "Identifiant SIECLE" => $id,
                        "Type" => "ELEVE",
                        "Nom" => "",
                        "Prénom" => "",
                        "Classes" => "",
                        "Groupes" => "",
                        "Date de naissance" => "",
                        "Sexe" => "",
                        "Date de sortie" => ""
                    );
                    foreach ($eleve->children() as $key => $value) {
                        switch (strtoupper($key)) {
                            case "ID_ELEVE_ETAB":
                                $eleves[$id]['Id'] = trim($value);
                                break;
                            case "NOM_DE_FAMILLE":
                                $eleves[$id]['Nom'] = trim($value);
                                break;
                            case "PRENOM":
                                $eleves[$id]['Prénom'] = trim($value);
                                break;
                            case "CODE_SEXE":
                                $eleves[$id]['Sexe'] = trim($value);
                                break;
                            case "DATE_NAISS":
                                $eleves[$id]['Date de naissance'] = map_birthdate(trim($value), "siecle");
                                break;
                            case "DATE_SORTIE":
                                $eleves[$id]['Date de sortie'] = strtotime(trim($value)) ?? $time;
                                break;
                            default:
                            // do nothing
                        }
                    }
                }
            }
            $objet_structures = ($eleves_xml->DONNEES->STRUCTURES);
            foreach ($objet_structures->children() as $structures_eleve) {
                $id = false;
                foreach ($structures_eleve->attributes() as $key => $value) {
                    if (strtoupper($key) == 'ELEVE_ID') {
                        $id = trim($value);
                        break;
                    } elseif (strtoupper($key) == 'ELENOET') {
                        $id = trim($value);
                        break;
                    } else {
                        echo "Eleve sans ELEVE_ID ou ELENOET dans DONNEES->STRUCTURES";
                    }
                }
                if ($id) {
                    foreach ($structures_eleve->children() as $structure) {
                        foreach ($structure->children() as $key => $value) {
                            switch (strtoupper($key)) {
                                case "CODE_STRUCTURE":
                                    $siblings = $structure->children()->xpath("preceding-sibling::* | following-sibling::*");
                                    foreach ($siblings as $sibling) {
                                        if (strtoupper($sibling->getName()) == "TYPE_STRUCTURE") {
                                            switch (strtoupper($sibling[0])) {
                                                case "D":
                                                    if ($eleves[$id]['Classes'] == "") {
                                                        $eleves[$id]['Classes'] = trim($value);
                                                    } else {
                                                        $eleves[$id]['Classes'] .= ", " . trim($value);
                                                    }
                                                    break 3;
                                                case "G":
                                                    if ($import_groupes) {
                                                        if ($eleves[$id]['Groupes'] == "") {
                                                            $eleves[$id]['Groupes'] = trim($value);
                                                        } else {
                                                            $eleves[$id]['Groupes'] .= ", " . trim($value);
                                                        }
                                                    }
                                                    break 3;
                                                default:
                                                // do nothing
                                            }
                                        }
                                    }
                                default:
                                // do nothing
                            }
                        }
                    }
                    $eleves[$id]['Classes'] = trim($eleves[$id]['Classes']);
                    $eleves[$id]['Groupes'] = trim($eleves[$id]['Groupes']);
                }
            }
        }
        /*
         * echo "<pre>";
         * print_r($eleves);
         * echo "</pre>";
         */
        if ($date_sortie) {
            foreach ($eleves as $id => $value) {
                if (! empty($eleves[$id]['Date de sortie']) && $eleves[$id]['Date de sortie'] < strtotime($date_sortie)) {
                    unset($eleves[$id]);
                }
            }
        }
        echo count($eleves) . " élèves traités.";
        $dossier_tmp_import_comptes = sys_get_temp_dir();
        $file_name = "siecle_eleves.csv";
        $dest_file = $dossier_tmp_import_comptes . "/" . $file_name;
        $fp = fopen($dest_file, 'w');
        $delimiter = ';';
        $enclosure = '"';
        $keys = array(
            0 => "Id",
            1 => "Identifiant SIECLE",
            2 => "Type",
            3 => "Nom",
            4 => "Prénom",
            5 => "Classes",
            6 => "Groupes",
            7 => "Date de naissance",
            8 => "Sexe"
        );
        fputcsv($fp, $keys, $delimiter, $enclosure);
        foreach ($eleves as $line) {
            fputcsv($fp, $line, $delimiter, $enclosure);
        }
        fclose($fp);
        echo "</form>";

        $page = "import_csv.php#end";
        echo "<form name=\"ent\" enctype=\"multipart/form-data\" action=\"" . $page . "\" method=\"post\">\n";
        apcu_delete('ent_html');
        cache_delete('group');
        cache_delete('match');
        cache_delete('members');
        cache_delete('ad_users');
        cache_delete('new');
        cache_delete('ent');
        $temp = tempnam(sys_get_temp_dir(), "php");
        file_put_contents($temp, file_get_contents($dest_file));
        $file_type = "csv_siecle";
        $files = array(
            "csv_ent" => array(
                "name" => $file_name,
                "type" => "text/csv",
                "tmp_name" => $temp,
                "size" => filesize($dest_file)
            )
        );
        echo "<input type=\"hidden\" name=\"ent[ent_type]\" value=\"" . $file_type . "\">";
        echo upload_ent($config, $files, $file_type);
        echo "<br><label for='remove'>Activer la suppression des anciennes affectations ainsi que la suppression des anciens utilisateurs via l'étape 6 ?</label>";
        echo "<input name='remove' id='remove' type='checkbox' value='true'/><br>\n";
        echo form_ent_next("match");
        // echo "<input id=\"end\" type=\"submit\" value=\"Valider\">";
        echo "</form>";
    } else {
        echo "<p>Fichier XML <i>ElevesSansAdresses</i> (éventuellement dans une archive zip) récupéré sur SIECLE :</p>";
        echo "<input title=\"chemin du fichier\" size=\"100\" name=\"siecle\" type=\"file\">";
        echo "<br><label for='import_groupes'>Importer les groupes (en plus des classes) :</label>";
        echo "<input name='import_groupes' id='import_groupes' type='checkbox' value='true'/>\n";
        echo "<br><label for='date_sortie'>Retirer les élèves partis en fonction de la valeur de DATE_SORTIE dans le XML ? Indiquer alors la date de bascule d'année (laisser tel quel sinon) :</label>";
        echo "<input name='date_sortie' id='date_sortie' type='date' value=''/><br>\n";
        echo "<input type=\"submit\" value=\"Valider\">";
        echo "</form>";
    }
}
$html = "";
admin_footer_html($html);
echo $html;
?>
