<?php
/**

 * import de fichiers siecle

 * @Projet SambaEdu

 * @auteurs denis bonnenfant, Tom Ricci

 * @Licence Distribue selon les termes de la licence GPL
 *
 *
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include "ihm.inc.php";
require_once ("ldap.inc.php");
require_once ("fonc_outils.inc.php");
require_once ("fonc_parc.inc.php");
require_once 'ent.inc.php';
require "pronote.inc.php";
require "partages.inc.php";

$files = $_FILES;

if (have_right($config, SE_USER_ADMIN)) {
    echo "<h1>Assistant d'importation des comptes depuis STS</h1><br>\n";
    $page = "import_sts.php#end";
    echo "<form name=\"ent\" enctype=\"multipart/form-data\" action=\"" . $page . "\" method=\"post\">\n";
    if (isset($files['sts'])) {
        if (array_key_exists('name', $files['sts'])) {
            echo "Le fichier " . $files['sts']['name'] . " a été chargé.<br>";
        } else {
            echo "<p style='color:red;'><b>ERREUR:</b> Aucun fichier n'a été; fourni !</p>\n";
            die();
        }

        $tmp_sts_file = $files['sts']['tmp_name'];
        $sts_file = $files['sts']['name'];
        $size_users_file = $files['sts']['size'] / 1024;

        if (empty($tmp_sts_file)) {
            echo "<p>L'upload du fichier <span style='color:red;'>$sts_file</span> a semble-t-il échoué.</p>";

            $upload_max_filesize = ini_get('upload_max_filesize');
            $post_max_size = ini_get('post_max_size');

            echo "<p>Il se peut que le fichier fourni ait été trop volumineux.<br />PHP est actuellement paramétré avec:<br />\n";
            echo "</p>\n";
            echo "<blockquote>\n";
            echo "<span style='color:blue;'>upload_max_filesize</span>=<span style='color:green;'>" . $upload_max_filesize . "</span><br />\n";
            echo "<span style='color:blue;'>post_max_size</span>=<span style='color:green;'>" . $post_max_size . "</span><br />\n";
            echo "</blockquote>\n";
            echo "<p>\n";
            echo "Si ces valeurs sont insuffisantes pour vos fichiers XML, il est possible de modifier les valeurs limites dans <span style='color:green;'>/etc/php/" . substr(phpversion(), 0, 3) . "/fpm/pool.d/sambaedu.conf</span>\n";
            echo "</p>\n";
            die();
        }
        $dossier_tmp_import_comptes = sys_get_temp_dir();
        $dest_file = $dossier_tmp_import_comptes . "/" . $sts_file;
        if (file_exists($dest_file)) {
            unlink($dest_file);
        }
        if (! is_uploaded_file($tmp_sts_file)) {
            echo "<p style='color:red'>Impossible d'importer le fichier.</p><br>\n";
            die();
        }
        if (! move_uploaded_file("$tmp_sts_file", "$dest_file")) {
            echo "<p style='color:red'>Impossible de copier le fichier.</p>\n";
            die();
        }
        echo "Fichier de " . $size_users_file . " ko correctement importé.<br>\n";

        // Si jamais un fichier non dézippé est fourni
        $extension_fichier_emis = strtolower(strrchr($sts_file, "."));
        if ($extension_fichier_emis == ".zip") {
            if (! extension_loaded('zip')) {
                echo "Erreur, le module zip manque.";
                die();
            }
            $dossier_tmp_import_comptes = $dossier_tmp_import_comptes . "/" . hash("sha256", rand());
            mkdir($dossier_tmp_import_comptes);
            $zip = new ZipArchive();
            if ($zip->open($dest_file) === TRUE) {
                $zip->extractTo($dossier_tmp_import_comptes);
            } else {
                echo "<p style='color:red'>Echec de l'extraction de l'archive ZIP.</p>\n";
                die();
            }
            $zip->close();
            $files = scandir($dossier_tmp_import_comptes);
            $import_files = array();
            foreach ($files as $file) {
                if (preg_match("/.*\.xml$/", $file) == 1) {
                    $import_files[] = $dossier_tmp_import_comptes . "/" . $file;
                }
            }
        } else {
            $import_files[] = $dest_file;
        }

        libxml_use_internal_errors(true);
        $users = array();
        foreach ($import_files as $file) {
            $users_xml = simplexml_load_file($file);
            $objet_users = ($users_xml->DONNEES->INDIVIDUS);
            foreach ($objet_users->children() as $user) {
                $id = 0;
                foreach ($user->attributes() as $key => $value) {
                    if (strtoupper($key) == 'ID') {
                        $id = trim($value);
                        break;
                    } else {
                        echo "Utilisateur sans ID dans DONNEES->INDIVIDUS";
                        die();
                    }
                }
                $users[$id] = array(
                    "Id" => $id,
                    "Type" => "",
                    "Nom" => "",
                    "Prénom" => "",
                    "Classes" => "",
                    "Date de naissance" => "",
                    "Sexe" => ""
                );
                foreach ($user->children() as $key => $value) {
                    switch (strtoupper($key)) {
                        case "FONCTION":
                            $users[$id]['Type'] = trim($value);
                            break;
                        case "NOM_USAGE":
                            $users[$id]['Nom'] = trim($value);
                            break;
                        case "PRENOM":
                            $users[$id]['Prénom'] = trim($value);
                            break;
                        case "SEXE":
                            $users[$id]['Sexe'] = trim($value);
                            break;
                        case "DATE_NAISSANCE":
                            $users[$id]['Date de naissance'] = map_birthdate(trim($value), "sts");
                            break;
                        default:
                        // do nothing
                    }
                }
            }
            $objet_structures = ($users_xml->DONNEES->STRUCTURE->DIVISIONS);
            foreach ($objet_structures->children() as $division) {
                $classe = false;
                foreach ($division->attributes() as $key => $value) {
                    if (strtoupper($key) == 'CODE') {
                        $classe = trim($value);
                    } else {
                        echo "Division sans CODE dans DONNEES->STRUCTURE->DIVISIONS";
                        // die();
                    }
                }
                if ($classe) {
                    foreach ($division->SERVICES->children() as $service) {
                        foreach ($service->ENSEIGNANTS->children() as $enseignant) {
                            foreach ($enseignant->attributes() as $key => $value) {
                                $id = false;
                                switch (strtoupper($key)) {
                                    case "ID":
                                        $id = trim($value);
                                        break;
                                    default:
                                    // do nothing
                                }
                                if ($id) {
                                    if ($users[$id]['Classes'] == "") {
                                        $users[$id]['Classes'] = trim($classe);
                                    } else {
                                        $users[$id]['Classes'] .= ", " . trim($classe);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        /*
         * echo "<pre>";
         * print_r($users);
         * echo "</pre>";
         */
        echo count($users) . " utilisateurs traités.";
        $dossier_tmp_import_comptes = sys_get_temp_dir();
        $file_name = "sts_emp.csv";
        $dest_file = $dossier_tmp_import_comptes . "/" . $file_name;
        $fp = fopen($dest_file, 'w');
        $delimiter = ';';
        $enclosure = '"';
        fputcsv($fp, array_keys($users[array_keys($users)[0]]), $delimiter, $enclosure);
        foreach ($users as $line) {
            fputcsv($fp, $line, $delimiter, $enclosure);
        }
        fclose($fp);
        echo "</form>";

        $page = "import_csv.php#end";
        echo "<form name=\"ent\" enctype=\"multipart/form-data\" action=\"" . $page . "\" method=\"post\">\n";
        apcu_delete('ent_html');
        cache_delete('group');
        cache_delete('match');
        cache_delete('members');
        cache_delete('ad_users');
        cache_delete('new');
        cache_delete('ent');
        $temp = tempnam(sys_get_temp_dir(), "php");
        file_put_contents($temp, file_get_contents($dest_file));
        $file_type = "csv_sts";
        $files = array(
            "csv_ent" => array(
                "name" => $file_name,
                "type" => "text/csv",
                "tmp_name" => $temp,
                "size" => filesize($dest_file)
            )
        );
        $html = "";
        echo "<input type=\"hidden\" name=\"ent[ent_type]\" value=\"" . $file_type . "\">";
        echo upload_ent($config, $files, $file_type);
        echo "<br><label for='remove'>Activer la suppression des anciennes affectations ainsi que la suppression des anciens utilisateurs via l'étape 6 ?</label>";
        echo "<input name='remove' id='remove' type='checkbox' value='true'/><br>\n";
        echo form_ent_next("match");
        // echo "<input id=\"end\" type=\"submit\" value=\"Valider\">";
        echo "</form>";
    } else {
        echo "<p>Fichier XML STS <i>sts_emp_UAI_ANNEE.xml</i> (éventuellement dans une archive zip) :</p>";
        echo "<input title=\"chemin du fichier\" size=\"100\" name=\"sts\" type=\"file\">";
        echo "<input type=\"submit\" value=\"Valider\">";
        echo "</form>";
    }
}
$html = "";
admin_footer_html($html);
echo $html;
?>