<?php

/**

 * Gestion des comptes orphelins
 * @Projet SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: ldap_cleaner.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
require_once "ldap.inc.php";

require_once "partages.inc.php";
include "ihm.inc.php";

if (! have_right($config, SE_ADMIN))
    die("Vous n'avez pas les droits suffisants pour accéder à cette fonction</BODY></HTML>");

$DEBUG = FALSE;

function draw_table_result($msg_cat, $type1, $type2 = "", $type3 = "", $mode = "")
{
    $html = "<table style='margin-left: 200px; text-align: left; width: 450px;' border='1' cellpadding='1' cellspacing='1'>\n";
    $html .= "<tbody>\n";
    $html .= "<tr>\n";
    $html .= "<td style='text-align: center; width: 300px; height: 20px; ' colspan='1' rowspan='2'>Utilisateur</td>\n";
    $html .= "<td style='text-align: center; width: 150px; height: 20px; ' colspan='3' rowspan='1'>$msg_cat</td>\n";
    $html .= "</tr>\n";
    $html .= "<tr>\n";
    if ($mode == '') {
        $html .= "<td style='text-align: center; width: 50px; height: 20px; '>$type1</td>\n";
        $html .= "<td style='text-align: center; width: 50px; height: 20px;'>$type2</td>\n";
        $html .= "<td style='text-align: center; width: 50px;  height: 20px;'>$type3</td>\n";
    } else {
        $html .= "<td style='text-align: center; width: 50px; height: 20px; '>$type1<br />";
        $html .= "<a href='#' onclick=\"coche('1');return false;\"><img src='../elements/images/enabled.png' border='0' /></a>";
        $html .= " / ";
        $html .= "<a href='#' onclick=\"decoche('1');return false;\"><img src='../elements/images/disabled.png' border='0' /></a>";
        $html .= "</td>\n";

        $html .= "<td style='text-align: center; width: 50px; height: 20px; '>$type2<br />";
        $html .= "<a href='#' onclick=\"coche('2');return false;\"><img src='../elements/images/enabled.png' border='0' /></a>";
        $html .= " / ";
        $html .= "<a href='#' onclick=\"decoche('2');return false;\"><img src='../elements/images/disabled.png' border='0' /></a>";
        $html .= "</td>\n";

        $html .= "<td style='text-align: center; width: 50px; height: 20px; '>$type3<br />";
        $html .= "<a href='#' onclick=\"coche('3');return false;\"><img src='../elements/images/enabled.png' border='0' /></a>";
        $html .= " / ";
        $html .= "<a href='#' onclick=\"decoche('3');return false;\"><img src='../elements/images/disabled.png' border='0' /></a>";
        $html .= "</td>\n";
    }
    $html .= "</tr>\n";
    $html .= "<tr>\n";
    echo $html;
}

// Fin function draw_table_result

/**
 * Fonction qui affiche les info-bulles
 *
 * @Parametres msg le n du message a afficher
 * @return l'info-bulle
 */
function msgaide($msg)
{
    return ("&nbsp;<u onmouseover=\"this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape('" . $msg . "')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>");
}
$msg1 = "Recherche les comptes des utilisateurs qui ne sont plus affectés à un groupe principal et transfert ces comptes à la corbeille.";
$msg2 = "Visualise la liste des comptes transférés dans la corbeille.";
$msg3 = "Permet de réactiver un ou des comptes sous reserve que les cn et/ou les cnNumber de ces comptes soient encore libres.";
$msg4 = "Efface les répertoires homes des utilisateurs situés dans la corbeille.";

$msg4bis = "Déplace les répertoires homes des utilisateurs situés dans la corbeille vers le dossier temporaire <br>/home/admin/_Trash_users.<br>";
$msg4bis .= "Cela donne un délai avant effacement et laisse la place libre dans /home/ pour un nouveau compte de meme cn.";

$msg5 = "Supprime les comptes de la corbeille !<br/><strong>ATTENTION</strong> : Ne supprimer les comptes de la corbeille que lorsque vous avez effectué l\'effacement des homes sur l\'ensemble des serveurs qui partagent votre annuaire avec votre LCS ou votre SE4.<br>";
$msg5 .= "Le syst&#232me lance ensuite une recherche des fichiers n\'appartenant plus à personne sur les ressources partagées de /var/sambaedu ";
$msg6 = "Ce compte, n\'est pas récupérable car il possède un cn ou un cnnumber désormais occupé.";
$msg7 = "Programme un scan de la partition de stockage /Classes à 21h00. Le scan recherche les dossiers des utilisateurs n\'existant plus.";
$msg8 = "Supprime le répertoire temporaire <br>/home/admin/_Trash_users dans lequel sont stockés d\'anciens homes.";

// Messages
$msg_confirm = "Avant de vider la corbeille, assurez-vous d\'avoir préalablement nettoyé les homes des comptes orphelins.<br>";
$msg_confirm .= "<a href=\"ldap_cleaner.php?do=4&phase=1\" target=\"main\">Nettoyage !</a>";

echo "<html>\n";
echo "  <head>\n";
echo "      <title>...::: Interface d'administration Serveur SE4 :::...</title>\n";

// Initialisation variables :
$PHP_SELF = $_SERVER['PHP_SELF'];
// Methode POST
$filtre = $_POST['filtre'] ?? '';
// $filter_type = $_POST['filter'];
$filter_type = $_POST['filter_type'] ?? '';
$nbr = $_POST['nbr'] ?? '';
$cat = $_POST['cat'] ?? '';
// Methodes POST ou GET
if (isset($_POST['phase']))
    $phase = $_POST['phase'];
elseif (isset($_GET['phase']))
    $phase = $_GET['phase'];
else
    $phase = '';

if (isset($_POST['do']))
    $do = $_POST['do'];
elseif (isset($_GET['do']))
    $do = $_GET['do'];
else
    $do = '';

$mode_clean = isset($_POST['mode_clean']) ? $_POST['mode_clean'] : (isset($_GET['mode_clean']) ? $_GET['mode_clean'] : NULL);

// Redirection vers phase suivante, gestion du sablier
// ## DEBUG echo "debug1 do:$do phase:$phase<br>";
// Cas 1 : Transfert des utilisateurs dans la Trash
if ($do == 1 && $phase != 1) {
    // ## DEBUG echo "debug2 do:$do phase:$phase<br>";
    echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"1;url='$PHP_SELF?do=1&phase=1'\">\n";
}
// Cas 2 : Examiner le contenu de la corbeille
if ($do == 2 && $phase != 1) {
    // ## DEBUG echo "debug2 do:$do phase:$phase<br>";
    echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"1;url='$PHP_SELF?do=2&phase=1'\">\n";
}
// Cas 3 : Effacer les homes des comptes orphelins
if ($do == 3 && $phase != 1) {
    // ## DEBUG echo "debug2 do:$do phase:$phase<br>";
    if (isset($mode_clean)) {
        echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"1;url='$PHP_SELF?do=3&phase=1&mode_clean=$mode_clean'\">\n";
    } else {
        echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"1;url='$PHP_SELF?do=3&phase=1'\">\n";
    }
}
// Cas 4 : Vider la corbeille
if ($do == 4 && $phase == 1) {
    // ## DEBUG echo "debug2 do:$do phase:$phase<br>";
    echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"1;url='$PHP_SELF?do=4&phase=2'\">\n";
}
// Cas 10 : Recuperation des utilisateurs de Trash vers People
if ($do == 10 && $phase == 2) {
    // ## DEBUG echo "debug2 $do $phase<br>";
    echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"1;url='$PHP_SELF?do=10&phase=3'\">\n";
}
// Fin traitement des redirections
echo "  </head>\n";
echo "  <body>\n";

// if (have_right($config, SE_ADMIN)) {

$html = "<div style=\"margin-bottom: 15%\"><H1>Gestion des comptes orphelins</H1>\n";
$html .= "<H3>Opérations courantes</H3>\n";

if ($do != "1")
    $html .= "<li><a href=\"ldap_cleaner.php?do=1\" target=\"main\">Transfert des comptes orphelins dans la corbeille</a>" . msgaide($msg1) . "</li>\n";
if ($do != "2")
    $html .= "<li><a href=\"ldap_cleaner.php?do=2\" target=\"main\">Examiner le contenu de la corbeille</a>" . msgaide($msg2) . "</li>\n";
$html .= "<li><a href=\"ldap_cleaner.php?do=10\" target=\"main\">Récupération de comptes orphelins depuis la corbeille</a>" . msgaide($msg3) . "</li>\n";
// if ($do !="3") $html .= "<li><a href=\"ldap_cleaner.php?do=3\" target=\"main\">Effacer les homes des comptes orphelins</a>".msgaide($msg4)."</li>\n";
if ($do != "3") {
    $html .= "<li><a href=\"ldap_cleaner.php?do=3\" onclick=\"return getconfirm();\" target=\"main\">Effacer les &#171;homes&#187; des comptes orphelins</a>" . msgaide($msg4) . "ou <a href=\"ldap_cleaner.php?do=3&amp;mode_clean=mv\" target=\"main\">les deplacer vers un dossier temporaire _Trash_users</a>" . msgaide($msg4bis) . "</li>\n";
    $html .= "<li><a href=\"ldap_cleaner.php?do=6\" target=\"main\">Supprimer le dossier temporaire _Trash_users</a>" . msgaide($msg8) . "</li>\n";
}
if ($do != "4")
    $html .= "<li><a href=\"ldap_cleaner.php?do=4\" target=\"main\">Vider la corbeille et purger les fichiers inutiles sur /var/sambaedu</a>" . msgaide($msg5) . "</li><br>\n";
$html .= "<H3>Résolution de problème</H3>\n";
$html .= "<li><a href=\"ldap_cleaner.php?do=5\" target=\"main\">Programmer la recherche et la suppression des dossiers utilisateurs obsolètes dans le répertoire /Classes</a>" . msgaide($msg7) . "</li>\n";

$html .= "<p></p>";

echo $html;

// Actions
switch ($do) {
    case 1:
        // Transfert des comptes orphelins dans la corbeille
        if ($phase != 1)
            // Affichage du sablier
            echo "<div align='center'><img src=\"images/wait.gif\" title=\"Patientez...\" align=\"middle\" border=\"0\">&nbsp;Transfert des comptes orphelins dans la corbeille en cours. Veuillez patienter...</div>";
        else {
            // On commence par controler s'il n'y a pas des utilisateurs qui ne sont plus ni dans Profs ni dans Eleves alors qu'ils ont le droit no_Trash_user

            $tmp_tab_no_Trash_user = list_members_right_profiles($config, "no_Trash_user");

            if (count($tmp_tab_no_Trash_user) > 0) {
                echo "<p>Controle des titulaires du droit no_Trash_user avant d'effectuer le transfert des comptes orphelins.</p>\n";
                echo "<blockquote>\n";
                $cpt_retablissement_no_trash = 0;
                $attribut = array(
                    "cn"
                );
                $cns = [];
                for ($loop = 0; $loop < count($tmp_tab_no_Trash_user); $loop ++) {
                    $cn1 = $tmp_tab_no_Trash_user[$loop];
                    $cn = ldap_dn2cn($cn1);

                    if (preg_match("/OU=Eleves/", $cn1)) {
                        $grp_no_Trash = "Eleves";
                    } elseif (preg_match("/OU=Profs/", $cn1)) {
                        $grp_no_Trash = "Profs";
                    } elseif (preg_match("/OU=Administratifs/", $cn1)) {
                        $grp_no_Trash = "Administratifs";
                    } else
                        $grp_no_Trash = "";

                    // if($grp_no_Trash!="") {
                    if (($grp_no_Trash != "") && ($cn != "admin")) {
                        $compte_existe = count(search_ad($config, $cn, "user", $config['dn']['people'])); // search_user($config, $cn);
                        if (count($compte_existe) == 0) {
                            // Le compte n'existe plus... et on a oublie de nettoyer no_Trash_user

                            echo "Le compte $cn n'existe plus.<br />Suppression de l'association de $cn au droit no_Trash_user: ";
                        } else {
                            // On controle si le compte est membre du groupe $grp_no_Trash
                            $attribut = array(
                                "member"
                            );
                            // $member = search_user("groups", "(&(cn=$grp_no_Trash)(member=$cn))", $attribut);
                            $res = search_people_group($config, $grp_no_Trash);
                            foreach ($res as $value) {
                                $cns[] = $value["cn"];
                            }
                            // if (have_right($config, $cn, "no_trash_user")) {
                            if (in_array($cn, $cns)) {
                                echo "$cn est deja membre du groupe $grp_no_Trash.";
                            } else {
                                echo "Rétablissement de $cn comme membre du groupe $grp_no_Trash: ";
                                // if (add_right($config, $cn, "no_trash_user")) {
                                if (groupaddmember($config, $cn, $grp_no_Trash)) {
                                    echo "<font color='green'>SUCCES</font>";
                                } else {
                                    echo "<font color='red'>ECHEC</font>";
                                }
                                $cpt_retablissement_no_trash ++;
                            }
                        }
                        echo "<br />\n";
                    }
                }
                // if ($cpt_retablissement_no_trash > 0) {
                // echo "<p>Un ou des utilisateurs ont été rétablis comme membres du groupe Profs pour éviter une mise à la corbeille.<br />Si ce n'était pas leur groupe d'appartenance initiale, il faudra corriger manuellement dans Annuaire/Accès à l'annuaire</p>\n";
                // }
                echo "</blockquote>\n";
            }

            // Transfert des comptes orphelins dans la corbeille
            if (trash_users($config))
                echo "<font color='green'><br>Le transfert des comptes orphelins dans la corbeille s'est déroulé avec succès.<br></font>";
            else
                echo "<div class=error_msg>Echec du tansfert des comptes orphelins dans la corbeille !</div>";
        }
        break;
    case 2:
        // Examiner le contenu de la corbeille
        if ($phase != 1)
            // Affichage du sablier
            echo "<div align='center'><img src=\"images/wait.gif\" title=\"Patientez...\" align=\"middle\" border=\"0\">&nbsp;Examen du contenu de la poubelle. Veuillez patienter...</div>";
        else {
            $users = search_ad($config, "*", "user", $config['dn']['trash']);
            echo "<p><img src=\"images/";
            if (count($users) == 0)
                echo "Poubelle_vide.png";
            else
                echo "Poubelle_pleine.png";
            echo "\" alt=\"Corbeille\" width=\"51\" height=\"65\" align=\"middle\" border=\"0\">&nbsp;Il y a <STRONG>" . count($users) . "</STRONG> utilisateur";
            if (count($users) > 0)
                echo "s";
            echo "&nbsp;dans la corbeille.</p>\n";
            echo "<UL>\n";
            for ($loop = 0; $loop < count($users); $loop ++)
                echo "<LI>" . utf8_decode($users[$loop]['cn']) . "</LI>\n";
            echo "</UL>\n";
        }
        break;

    case 3:
        // Nettoyage des repertoires home
        if ($phase != 1)
            // Affichage du sablier
            echo "<div align='center'><img src=\"images/wait.gif\" title=\"Patientez...\" align=\"middle\" border=\"0\">&nbsp;Le nettoyage des répertoires &#171;homes&#187; est en cours. Veuillez patienter...</div>";
        else {
            // echo "\$_GET['mode_clean']=".$_GET['mode_clean']."<br />";
            if ($mode_clean == 'mv') {
                echo "<h4>Déplacement des homes des comptes orhelins en cours...</h4>";
                echo clean_homes($config, false);
                echo "<p>Terminé.</p>\n";
            } else {
                echo "Suppression des homes des comptes orphelins en cours...</h4>";
                echo clean_homes($config, true);
                echo clean_profiles($config);
                echo "<p>Terminé.</p>\n";
            }
        }
        break;
    case 4:
        // Vidage de la corbeille
        if ($phase != 1 && $phase != 2)
            // Affichage du message de confirmation
            echo "<div class=error_msg>$msg_confirm</div>";
        elseif ($phase == 1)
            // Affichage du sablier
            echo "<div align='center'><img src=\"images/wait.gif\" title=\"Patientez...\" align=\"middle\" border=\"0\">&nbsp;Vidage de la corbeille en cours. Veuillez patienter...</div>";
        elseif ($phase == 2) {
            // echo "Le nettoyage de la corbeille s'est déroulé avec succès.<br>";
            $users = search_ad($config, "*", "user", $config['dn']['trash']);
            for ($loop = 0; $loop < count($users); $loop ++) {
                userdel($config, $users[$loop]["cn"]);
            }
            $users = search_ad($config, "*", "user", $config['dn']['trash']);
            if (count($users) == 0) {
                echo "<h4>Le nettoyage de la corbeille s'est déroulé avec succès.</h4>";
                echo "Une recherche sur les ressources partagées pour suppression des fichiers obsolètes sera lancée en arrière plan.<br>";
                echo "<h4>Suppression des homes des comptes orphelins en cours...</h4>";
                echo clean_homes($config, true);
                echo "<p>Terminé.</p>\n";
            } else
                echo "<div class=error_msg>Echec du nettoyage de la corbeille !</div>";
        }
        break;

    case 5:
        // Grand menage !!

        // echo "<h4>Grand ménage : suppression des fichiers obsolètes sur /home et /var/sambaedu</h4>";
        // echo "Fonction non implémentée pour le moment<br />";

        echo "<h4>Grand ménage : suppression des dossiers des utilisateurs n'existant plus dans le répertoire /Classes>";
        batch_command('find /var/sambaedu/Classes/ -maxdepth 2 -type d -name ".*" -exec echo rm -rf \"{}\" \;');
        batch_write("slow");
        echo "<div class='text'>Programmation pour 21h00 effectuée, un mail récapitulatif vous sera envoyé.</div>";
        break;

        // TO DEV...

        if ($ReturnValue != "0") {
            echo "<div class='error_msg'>Une erreur s'est produite???</div>";
        } else {
            echo "<div class='text'>Programmation pour 20h00 effectuée, un mail récapitulatif vous sera envoyé.</div>";
        }
        break;
        echo "Un mail récapitulatif vous sera envoyé";

    case 6:
        // Supression de trash_users !!

        echo "<h4>Supression du dossier /home/admin/Trash_users en cours....</h4>";
        batch_command("rm -fr /home/trash/*");
        echo "<div class='text'>Suppression Ok !</div>";
        break;

    case 10:
        // Recuperation de comptes orphelins
        // Choix d'un filtre de recherche
        if ($phase != 1 && $phase != 2 && $phase != 3) {
            $html = "<p><u>Recherche des comptes orphelins à transférer</u> :</p>\n";
            $html .= "<div style='margin-left: 40px'>\n";
            $html .= "<form action='ldap_cleaner.php?do=10' method = 'post'>\n";
            $html .= "Filtre de recherche&nbsp;";
            $html .= "<select name='filter_type'>\n";
            $html .= "<option value='contient'>contient</option>\n";
            $html .= "<option value='commence'>commence par</option>\n";
            $html .= "<option value='finit'>finit par</option>\n";
            $html .= "</select>\n";
            $html .= "<input type='text' name='filtre'>\n";
            $html .= "<input type='hidden' name='phase' Value='1'>\n";
            $html .= "<input type='submit' Value='Rechercher'>\n";
            $html .= "</form></div>\n";
            echo $html;
        } elseif ($phase == 1) {
            // Affichage de la liste des comptes orphelins
            // Interpretation du type de filtre
            if ($filter_type == "contient")
                if ($filtre != "*")
                    $filtre = "*" . $filtre . "*";
            if ($filter_type == "commence")
                $filtre = $filtre . "*";
            if ($filter_type == "finit")
                $filtre = "*" . $filtre;
            // Recherche des utilisateurs repondant au critere
            $users = search_ad($config, $filtre, "user", $config['dn']['trash']);
            echo "<div align='center'><img src=\"images/";
            if (count($users) == 0)
                echo "Poubelle_vide.png";
            else
                echo "Poubelle_pleine.png";
            echo "\" alt=\"Corbeille\" width=\"51\" height=\"65\" align=\"middle\" border=\"0\">&nbsp;Il y a <STRONG>" . count($users) . "</STRONG> utilisateur";
            if (count($users) >= 2)
                echo "s";
            echo "&nbsp;dans la corbeille qui répond";
            if (count($users) >= 2)
                echo "ent";
            echo " au <em>filtre</em> de recherche.</div>\n";
            // Affichage de la liste des utilisateurs a recuperer
            if (count($users) > 0) {
                $html = "<form action='ldap_cleaner.php?do=10' method = 'post'>\n";
                // Tableau d'affichage des resultats
                draw_table_result("Groupe principal", "Elève", "Professeur", "Administratif");
                for ($loop = 0; $loop < count($users); $loop ++) {
                    $html .= "<tr><td style='width: 300px;'>" . utf8_decode($users[$loop]["cn"]) . "</td>\n";
                    $users[$loop]['categorie'] = type_user($config, $users[$loop]["cn"]);
                    $html .= "<td style='text-align: center; width: 50px;'><input type='radio' id='cat_" . $loop . "' name='cat[$loop]' value='" . $users[$loop]['cn'] . ",Eleves'></td>\n";
                    $html .= "<td style='text-align: center; width: 50px;'><input type='radio' id='cat2_" . $loop . "' name='cat[$loop]' value='" . $users[$loop]['cn'] . ",Profs'></td>\n";
                    $html .= "<td style='text-align: center; width: 50px;'><input type='radio' id='cat_3" . $loop . "' name='cat[$loop]' value='" . $users[$loop]['cn'] . ",Administratifs'></td>\n";
                }
                $html .= "</tbody>\n</table>\n";
                $html .= "<input type='hidden' name='phase' Value='2'>\n";
                $html .= "<input type='hidden' name='nbr' Value='$loop'>\n";
                $html .= "<div style='margin-left: 200px'>\n";
                $html .= "<input type='submit' Value='Récupérer'>\n";
                $html .= " <input type='reset' Value='Réinitialiser'>\n";
                $html .= "</form></div>\n";
            } else
                $html = "<div class='alert_msg'>Pas de transfert à effectuer !</div>\n";
            echo $html;
        } elseif ($phase == 2) {
            // Transfert des comptes de trash -> peoples et positionnement des groupes principaux
            // Transfert des utilisateurs selectionne dans /tmp/list_recup
            for ($loop = 0; $loop < $nbr; $loop ++) {
                if (isset($cat[$loop])) {
                    $tmp = $cat[$loop];
                    exec("echo $tmp >> /tmp/list_recup");
                }
            }
            // Affichage du sablier
            echo "<div align='center'><img src=\"images/wait.gif\" title=\"Patientez...\" align=\"middle\" border=\"0\"> Récupération des comptes orphelins en cours. Veuillez patienter...</div>";
        } elseif ($phase == 3) {
            // Recuperation des utilisateurs selectionnes
            if (file_exists("/tmp/list_recup")) {
                $fd = fopen("/tmp/list_recup", "r");
                draw_table_result("Récupération dans la catégorie", "Eleves", "Profs", "Administratifs");
                while (! feof($fd)) {
                    $tmp = fgets($fd, 255);
                    if ($tmp) {
                        $trash_user = explode(",", trim($tmp));
                        $trash_member = $trash_user[0];
                        $trash_cat = $trash_user[1];
                        if ($trash_member != "") {
                            $recup = recup_user($config, $trash_member, $trash_cat);
                            // Affichage des utilisateurs recuperes
                            $html = "<tr><td style='width: 300px;'>";
                            if ($recup)
                                $html .= "<a href='people.php?cn=" . $trash_member . "'>";
                            $html .= utf8_decode($trash_member);
                            if ($recup)
                                $html .= "</a>";
                            $html .= "</td>\n";
                            if ($recup) {
                                $categorie = type_user($config, $trash_member);
                                $html .= "<td style='text-align: center; width: 50px;'>";
                                if ($categorie == "Eleves")
                                    $html .= "<b>X</b>";
                                else
                                    $html .= "&nbsp;";
                                $html .= "</td>\n";
                                $html .= "<td style='text-align: center; width: 50px;'>";
                                if ($categorie == "Profs")
                                    $html .= "<b>X</b>";
                                else
                                    $html .= "&nbsp;";
                                $html .= "</td>\n";
                                $html .= "<td style='text-align: center; width: 50px;'>";
                                if ($categorie == "Administratifs")
                                    $html .= "<b>X</b>";
                                else
                                    $html .= "&nbsp;";
                                $html .= "</td></tr>\n";
                            } else
                                $html .= "<td colspan='3' style='color: red; text-align: center; width: 50px;'>Compte irrécupérable !</td></tr>\n";
                            echo $html;
                        }
                    }
                }
                fclose($fd);
                unlink("/tmp/list_recup");
                echo "</tbody>\n</table>\n";
            } else
                echo "<div class=error_msg>Vous n'avez pas sélectionné d'utilisateur(s) à récupérer!</div>";
        }
        break; // Fin case
}
batch_write();
// } else echo "Vous n'avez pas les droits nécessaires pour cette action...";
$html = "";
admin_footer_html($html);
echo $html;
?>