<?php

/**

 * gestion des droits et delegations pour un utilisateur ou les membres d'un groupe
 * @Projet SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: manage_rights.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include_once "ldap.inc.php";
include "ihm.inc.php";

$dn = $_POST['cn'] ?? $_GET['cn'] ?? "";

$action = $_POST['action'] ?? $_GET['action'] ?? "";
$delrights = $_POST['delrights'] ?? [];
$newrights = $_POST['newrights'] ?? [];
$parc = $_POST['parc'] ?? "";
$profile = $_POST['profile'] ?? "";
$delegation = $_POST['delegation'] ?? "";
// debug_var();
echo "<h1>Annuaire</h1>\n";
// exit();
if ($dn == "") {
    echo "<p>ERREUR : Il faut choisir un nom</p>\n";
    $html = "";
    admin_footer_html($html);
    echo $html;
    die();
}

$filtre = "9_" . $dn;
echo aff_trailer("$filtre");

// effacement des caches ldap

apcu_delete(new APCUIterator('#^rights_#'));
apcu_delete(new APCUIterator('#^delegation_#'));
apcu_delete(new APCUIterator('#^search_#'));

$user = search_user($config, $dn);
if (empty($user)) {
    $user = search_group($config, $dn);
}

if (! have_right($config, SE_USER_ADMIN)) {
    echo ("Vous n'avez pas les droits suffisants pour accéder à cette fonction");
    $html = "";
    admin_footer_html($html);
    echo $html;
    die();
}
// effacement de tous les caches des délégations !
// apcu_delete(new APCUIterator('#^delegation_#'));
// apcu_delete(new APCUIterator('#^rights_#'));

switch ($action) {
    case "AddRights":
        // Inscription des droits dans l'annuaire
        echo "<H3>Inscription des droits pour <U>" . $user['cn'] . "</U></H3>";
        echo "<P>Vous avez sélectionné " . count($newrights) . " droit(s)<br>\n";
        for ($loop = 0; $loop < count($newrights); $loop ++) {
            $right = $newrights[$loop];
            echo "Délégation du droit <U>$right</U> à l'utilisateur " . $user['cn'] . "<br>";
            add_right_profile($config, $user['cn'], $right);
            echo "<br>";
        }
        break;
    case "DelRights":
        // Suppression des droits dans l'annuaire
        echo "<H3>Suppression des profils de droits pour <U>" . $user['cn'] . "</U></H3>";
        echo "<P>Vous avez sélectionné " . count($delrights) . " droit(s)<br>\n";
        for ($loop = 0; $loop < count($delrights); $loop ++) {
            $right = $delrights[$loop];
            echo "Suppression du droit <U>$right</U> pour l'utilisateur " . $user['cn'] . "<br>";
            remove_right_profile($config, $user['cn'], $right);
            echo "<br>";
        }
        break;
    case "AddDelegation":
        if (create_delegation($config, $parc, $dn, $profile)) {
            echo "Ajout d'une délégation pour le parc $parc, avec le profil $profile.<br><br>";
        }
        break;
    case "DelDelegation":
        if (delete_delegation($config, $delegation, $dn)) {
            echo "Suppression de la délégation pour le parc $parc, avec le profil $profile.<br><br>";
        }
        break;
}

// Affichage du nom et de la description de l'utilisateur
echo "<H3>Délégation de droits à " . $user["fullname"] . " (<U>" . $user['cn'] . "</U>)</H3>\n";
echo "Sélectionnez les profils de droits à supprimer (liste de gauche) ou à ajouter (liste de droite) ";
echo "et validez à l'aide du bouton correspondant.<BR><BR>\n";
// Lecture des droits disponibles

$list_current_rights = list_right_profiles($config, $user);
$list_all_rights = list_right_profiles($config, 'all');
$list_possible_rights = array_diff($list_all_rights, $list_current_rights);
echo "
<FORM method='post' action='../annu/manage_rights.php'>
    <INPUT TYPE='hidden' VALUE='" . $dn . "' NAME='cn'>
    <INPUT TYPE='hidden' NAME='action'>
    <INPUT TYPE='hidden' NAME='delegation'>
    <table class='table-bordered' align=center width='50%'>";
echo "<tr><td align=center class=menuheader colspan=\"2\" height=\"30\" >Récapitulatif des profils de droits</td>\n";
echo "</tr>\n";
echo "<tr><td class=menuheader height=\"30\" align=center>Profils de droits effectifs</td>\n";
echo "<td class=menuheader align=center>Profils de droits disponibles</td>\n";
echo "</tr>\n";
echo '  <TR>
            <TD VALIGN="center" align=\"center\">';
if (count($list_current_rights) > 15) {
    $size = 15;
} else {
    $size = count($list_current_rights);
}
if ($size > 0) {
    echo "<SELECT NAME=\"delrights[]\" SIZE=\"$size\" multiple=\"multiple\">";
    for ($loop = 0; $loop < count($list_current_rights); $loop ++) {
        $found = false;
        foreach ($user['memberof'] as $g) {
            if ($found = preg_match("/" . $list_current_rights[$loop] . "/", $g)) {
                break;
            }
        }
        if ($found) {
            echo "<option value='" . $list_current_rights[$loop] . "'>" . $list_current_rights[$loop] . "\n";
        } else {
            echo "<option value='" . $list_current_rights[$loop] . "' disabled>" . $list_current_rights[$loop] . " hérité\n";
        }
    }
    echo '</SELECT></td>';
} else {
    echo "<U>" . $user['cn'] . "</U> n'a aucun droit propre";
}
// droits disponibles
echo '<TD VALIGN="center" align="center">';
if (count($list_possible_rights) > 15) {
    $size = 15;
} else {
    $size = count($list_possible_rights);
}
if ($size > 0) {
    echo "<SELECT NAME=\"newrights[]\" SIZE=\"$size\" multiple=\"multiple\">";
    foreach ($list_possible_rights as $value) {
        echo "<option value='" . $value . "'>" . $value . "\n";
    }
    echo '</SELECT></td></tr></tr><tr><td>';
    // On desactive la possibilite de virer des droits pour admin
    if ($user['cn'] != 'admin' && $size > 0) {
        echo '<input type="submit" value="Retirer ces droits"
                onClick="this.form.action.value=\'DelRights\';return true;">';
    }
}
echo '          </TD>
<td>
    <input type="submit" value="Ajouter ces droits" onClick="this.form.action.value=\'AddRights\';return true;">';
echo '</TD>
</TR>
</TABLE>';
// affichage délégations
$delegations = list_delegations($config, $user);
echo "<table class='table-bordered' align=center width=\"50%\">\n";
echo "<tr><td align=center class=menuheader colspan=\"4\" height=\"30\" >Récapitulatif des délégations</td>\n";
echo "</tr>\n";
echo "<tr><td class=menuheader height=\"30\" align=center>Utilisateur/groupe</td>\n";
echo "<td class=menuheader align=center>groupe d'héritage</td>\n";
echo "<td class=menuheader align=center>Parc</td>\n";
echo "<td class=menuheader align=center>Profil de délégation</td>\n";
echo "<td class=menuheader align=center>Supprimer</td></tr>\n";
foreach ($delegations as $delegation) {
    $heritage = ($delegation['user'] != ldap_dn2cn($delegation['groupdn']));
    if ($heritage) {
        echo "<tr><td align=center>" . $delegation['user'] . " (hérité)</td>\n";
        echo "<td align=center>" . ldap_dn2cn($delegation['groupdn']) . "</td>\n";
    } else {
        echo "<tr><td align=center>" . $delegation['user'] . "</td>\n";
        echo "<td align=center>-</td>\n";
    }
    echo "<td align=center>" . ldap_dn2cn($delegation['parcdn']) . "</td>\n";
    echo "<td align=center>" . $delegation['profile'] . "</td>\n";
    if (! $heritage) {
        echo "<td align=center><input type=\"submit\" value=\"Supprimer\"
                onClick=\"this.form.action.value='DelDelegation';this.form.delegation.value='" . $delegation['samaccountname'] . "';return true;\">";
        echo "</td>\n";
    } else {
        echo "<td></td>\n";
    }

    echo "</tr>";
}
echo "<tr><td align=center>Nouvelle délégation...</td><td></td>";
echo "<td align=center><select name=parc>";
foreach (search_ad($config, "*", "parc") as $parc) {
    echo "<option value=\"" . $parc['samaccountname'] . "\">" . $parc['cn'] . "</option>";
}
echo "</select></td>";
echo "<td align=center><select name=profile>";
foreach ($list_all_rights as $profile) {
    echo "<option value=\"" . $profile . "\">" . $profile . "</option>";
}
echo "</select></td>";
echo '<td align=center><input type="submit" value="Valider"
                onClick="this.form.action.value=\'AddDelegation\';return true;">';
echo "</tr>";

echo "</table><br><br></FORM>\n";

$rights = right_info(list_rights($config, $user));
$html = "<br><table>";
$html .= "<tr>";
$html .= "<th>Droits effectifs : </th>";
$html .= "</tr>";
foreach ($rights as $msg) {
    $html .= "<td>" . $msg . "</td>";
    $html .= "</tr>";
}
$html .= "</table>";
echo $html;
// echo "find epage";
echo "<H3>Note : Les profils de droits hérités d'un groupe ne pourront être supprimés au niveau de l'utilisateur.</H3>";
$html = "";
admin_footer_html($html);
echo $html;
?>