<?php
/**
 * permet de rafraîchir ou de créer le cookie de sesion pour l'admin ent dans le
 * cas de l'authentification double facteur.
 * Appelé par cron, fait juste le rafraichissement.
 *
 * Appellé par un téléphone avec une requete POST -F "message=contenu_du sms" -F "key=se4_api_key", fait l'auth 2FA
 *
 * @Projet SambaEdu
 * @auteurs denis bonnenfant
 * @Licence Distribue selon les termes de la licence GPL
 *
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
header_authorize_script($config);
include "ihm.inc.php";
require_once ("fonc_outils.inc.php");
require_once 'ent.inc.php';

$html = "";
$code = $_POST['mfa_code'] ?? "";

$debug_mfa_ent = $config['debug_mfa_ent'] ?? 0;

if ($debug_mfa_ent == 1) {
    trigger_error("Code reçu au début de mfa_ent.php : !!" . $code . "!!");
    $fp = fopen('/tmp/f2a.txt', 'a');
    $date = new DateTime();
    $date = $date->format("d-m-Y H:i:s");
    fwrite($fp, $date . ' : ');
}

$se4_key = $_POST['se4_key'] ?? $_GET['se4_key'] ?? "";

if ($se4_key == $config["se4_key"] && $_SERVER['REMOTE_ADDR'] == $config['se4fs_ip'] && empty($code)) {
    // keepalive sur l'ent
    if (@$config['ent_type'] == "openent") {
        if (! openent_admin_logon($config, $html, false)) {
            if ($debug_mfa_ent == 1) {
                fwrite($fp, '2FA expire' . PHP_EOL);
            }
        } else {
            if ($debug_mfa_ent == 1) {
                fwrite($fp, '2FA still alive' . PHP_EOL);
            }
        }
    }
} elseif (have_right($config, SE_ADMIN)) {
    if ($debug_mfa_ent == 1) {
        trigger_error("Code reçu sur mfa_ent.php après have_right : !!" . $code . "!!");
    }
    $msg = "";
    if (openent_admin_logon($config, $msg, true, false, $code)) {
        header($_SERVER["SERVER_PROTOCOL"] . " 200 OK");
        $html .= "Double authentification réussie : " . $msg;
    } else {
        header($_SERVER["SERVER_PROTOCOL"] . " 403 Forbidden");
        $html .= "Double authentification échouée : " . $msg;
    }
} else {
    header($_SERVER["SERVER_PROTOCOL"] . " 403 Forbidden");
    header("Location:/interdit.html");
    exit();
}

if (! apcu_exists('mail_mfa_ent')) {
    echo $html;
    apcu_store('mail_mfa_ent', true, 86400);
}
?>