<?php

/**
 * Fiche utilisateur
 * @Version 11/2018 - keyser
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: people.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include "ihm.inc.php";
require_once "fonc_parc.inc.php";
require_once "logs.inc.php";
require_once ("remote.inc.php");

echo "<h1>Annuaire</h1>\n";

$cn = $_POST['cn'] ?? $_GET['cn'] ?? "";
$machine = $_POST['machine'] ?? $_GET['machine'] ?? "";
$activer = $_POST['activer'] ?? "";
$delegation = $_POST['delegation'] ?? $_GET['delegation'] ?? "";
if (empty($cn)) {
    echo "<p style='color:red;'>ERREUR: pas de nom choisi.</p>";
    $html = "";
    admin_footer_html($html);
    echo $html;
    die();
}
$refresh = $_POST['refresh'] ?? $_GET['refresh'] ?? false;
// teste les droits
$admin_annu = have_right($config, SE_USER_ADMIN);
$can_read_annu = have_right($config, SE_USER_READ);
$admin_sovajon = have_right($config, SE_USER_PASSWORD_INIT | SE_USER_READ | SE_USER_MODIFY);
$admin_se = have_right($config, SE_ADMIN);

echo aff_trailer("3");

$user = search_user($config, $cn);
if (empty($user['cn'])) {
    echo "<p style='color:red;'>ERREUR: pas de nom choisi.</p>";
    $html = "";
    admin_footer_html($html);
    echo $html;
    die();
}

if (! empty($activer)) {
    set_local_admin_right($config, $cn);
}

$list_current_rights = array();
$list_current_groups = array();
$rights_branch = $config['dn']['rights'];
// var_dump($rights_branch);
if (isset($user['memberof'])) {
    foreach ($user['memberof'] as $line) {
        if (preg_match("/$rights_branch/i", $line)) {
            $list_current_rights[] = $line;
        } else {
            $list_current_groups[] = $line;
        }
    }
}
if (($cn == "Administrator") || ($cn == "administrator")) {
    $user["fullname"] = "Administrator";
    $user["email"] = "root";
}
// var_dump($list_current_groups);
$fullname = $user['fullname'] ?? $user['cn'];
echo "<a href='people.php?cn=" . $user["cn"] . "' title=\"Rafraîchir la page\"><H2>" . $fullname . " (Login : " . $user['cn'] . ")</H2></a>\n";
if ($etab = etab_to_name($config, $user['etab'])) {
    echo "Établissement de rattachement : " . $etab . "<br>\n";
}
echo "Connexions en cours : ";
foreach (get_user_status($config, $user['cn']) as $m) {
    echo "<a href='../parcs/cherche_machine.php?mpenc=" . $m['machine'] . "'> " . $m['machine'] . " le " . $m['logintime'] . " </a>, \n";
}
echo "<br>\n";

$from = urlencode("../annu/people.php?cn=" . $cn . "&machine=" . $machine);
echo "<a href=\"../parcs/rdp.php?refresh=1&machine=" . $machine . "&from=" . $from . "\"><img src=\"../elements/images/rdp.png\" alt=\"Accès distant...\"></a>";

if ($admin_annu && (isset($_GET['create_home'])) && ($_GET['create_home'] == 'y')) {
    echo "<p><b>Création du dossier personnel de " . $user["cn"] . "&nbsp;: </b>";
    exec("sudo /usr/share/sambaedu/shares/shares.avail/mkhome.sh " . $user["cn"], $ReturnValue2);
    if (count($ReturnValue2) == 0) {
        echo "<span style='color:green'>OK</span></p>";
    } else {
        echo "</p><pre style='color:red'>";
        foreach ($ReturnValue2 as $key => $value) {
            echo "$value";
        }
    }
    echo "</pre>";
}
if (isset($user["email"])) {
    echo "Adresse mél : <a href=\"mailto:" . $user["email"] . "\"><tt>" . $user["email"] . "</a></tt><br>\n";
}
?>
<table valign="top" align="top" border="0" width="80%">
    <tr>
        <td valign="top">
<?php
if (isset($user["description"]))
    echo "<p>" . $user["description"] . "</p>";

if (count($list_current_groups)) {
    echo "<U>Membre des groupes</U> :<BR><UL>\n";
    foreach ($list_current_groups as $group) {

        // Si les bons droits on place un lien sur les groupes
        echo "<LI>";
        if ($can_read_annu or $admin_annu or $admin_sovajon) {
            echo "<A href=\"group.php?filter=" . $group . "\">";
        }
        echo ldap_dn2cn($group);
        if (! empty($config['etab_ou']) && ldap_dn2uai($group) != $config['etab_ou'] && ldap_dn2uai($group) != 0) {
            echo " " . etab_to_name($config, ldap_dn2uai($group));
        }
        if ($can_read_annu or $admin_annu or $admin_sovajon) {
            echo "</A>";
        }
        // echo "<font size=\"-2\"> " . $group[0]["description"];
        // if (is_my_pp($config, $group[0]['cn'], $config['login']))
        // echo "<strong><font color=\"#ff8f00\">&nbsp;(professeur principal") . ")</font></strong>";
        echo "</LI>\n";
        // echo "</font></li>";

        if ($admin_annu) {
            ?>

            <ul>
                <li><a
                    href="del_user_group_direct.php?cn_user=<?php echo $user["cn"]?>&dn_group=<?php

            echo $group;
            if (ldap_dn2cn($group) == "Eleves" || ldap_dn2cn($group) == "Profs" || ldap_dn2cn($group) == "Administratifs") {
                echo "\"onclick=\"return getconfirm_all()";
            } else {
                echo "\"onclick=\"return getconfirm()";
            }
            ?>";><font size="2"><?php echo "retirer du groupe"; ?></a> <br>
                    </font></li>
            </ul>
<?php
        }

        // fin modif
    }
    echo "</UL>";
}
?>
        </td>
        <td valign=top>
<?php
if (have_right($config, SE_USER_ADMIN)) {
    echo "<U>Droits actuellement attribués</U> :<BR><UL>\n";
    if (count($list_current_rights)) {
        foreach ($list_current_rights as $right) {
            echo "<li>" . ldap_dn2cn($right) . "<br></li>";
        }
    } else {
        echo "<li>Aucun droit propre</li>";
    }
    ?>

<u>Action possible</u>&nbsp;: <br />
            <ul style="color: red;">
                <li><a
                    href="add_user_group.php?cn=<?php echo $user["cn"] ?>"><?php echo "Gérer les établissements, fonctions et groupes"; ?></a><br>

            </ul>

<?php
}

// Affichage Menu people_admin
if ($admin_annu && $cn != "Administrator") {
    echo "
    <br>
    <u>Autres actions possibles</u>&nbsp;: <br/>
    <ul style=\"color: red;\">
        <li><a href=\"mod_user_entry.php?cn=" . $user['cn'] . "\">Modifier le compte</a></li>
        <li><a href=\"pass_user_init.php?cn=" . $user['cn'] . "\">Réinitialiser le mot de passe</a></li>";

    if ($user['useraccountcontrol'] == 512) {
        echo "
        <li><a href=\"desac_user_entry.php?cn=" . $user["cn"] . "\" onclick= return getconfirm()>Désactiver ce compte</a><br/>";
        if (file_exists('/home/' . $user["cn"])) {
            echo "
        <li><span style='color:black'>Le dossier personnel existe.</span></li>";
        } else {
            echo "
        <li>Le dossier personnel n'existe pas.<br /><a href='people.php?cn=" . $user["cn"] . "&amp;create_home=y'>Créer le dossier personnel maintenant</a><br />(<em>sinon, il sera créé lors de la premiere connexion de l'utilisateur</em>)</li>";
        }
    } else {
        // si compte desactive
        echo "
        <li><a href=\"desac_user_entry.php?cn=" . $user["cn"] . "&action=activ\">Activer ce compte</a><br>\n";
        if (! file_exists('/home/' . $user["cn"])) {
            echo "
        <li>Le dossier personnel n'existe pas.<br /><a href='people.php?cn=" . $user["cn"] . "&amp;create_home=y'>Créer le dossier personnel maintenant</a><br />(<em>sinon, il sera créé lors de la premiere connexion de l'utilisateur</em>)</li>";
        }
    }
    ?><li><a href="del_user.php?cn=<?php echo $user["cn"] ?>"
                onclick="return getconfirm();"><?php echo "Supprimer le compte"; ?></a><br>

        <li><a
                href="del_nt_profile.php?cn=<?php echo $user["cn"] ?>&action=del"
                onclick="return getconfirm();"><?php echo "Regénérer le profil errant Windows"; ?></a><br>
        <?php
    /*
     * exec("/usr/share/sambaedu/sbin/getUserProfileInfo.pl $user[cn]", $AllOutPut, $ReturnValue);
     *
     * if ($AllOutPut[0] == "lock") {
     * echo "
     * <li><a href=\"del_nt_profile.php?cn=" . $user["cn"] . "&action=unlock\">Déverrouiller le profil Windows...") . "</a><br>\n";
     * } else {
     * echo "
     * <li><a href=\"del_nt_profile.php?cn=" . $user["cn"] . "&action=lock\">Verrouiller le profil Windows...") . "</a><br>\n";
     * }
     */
    ?>





<?php
} // Fin affichage menu people_admin

if ($admin_se) {
    echo "<li><a href=\"manage_rights.php?cn=" . $user["cn"] . "\">Gérer les droits</a><br>";
    echo "<li><a href=\"../parcs/show_histo.php?selectionne=3&amp;user=$cn\">Voir les connexions</a><br>"; // Ajout leb
}
echo "</ul>";

// Test de l'appartenance a la classe pour le droit sovajon_is_admin
// Afin d'eviter les doublons si le mec est admin_is_admin il ne peut pas
// voir cette partie puisqu'il peut la voir par ailleurs

// si les droits étendus du groupe profs sont activés, le test sur la classe n'est pas nécessaire
$acl_group_profs_classes = exec("cd /var/sambaedu/Classes; /usr/bin/getfacl . | grep group:Profs >/dev/null && echo 1");

if ((is_my_eleve($config, $config['login'], $user["cn"])) or ($acl_group_profs_classes == 1) and (have_right($config, SE_USER_PASSWORD_INIT | SE_USER_READ | SE_USER_MODIFY)) and ($config['login'] != $user["cn"])) {
    // On teste si $user[cn] n'est pas un prof
    if (is_eleve($config, $user["cn"])) {
        echo "<br>\n";
        echo "<u>Autres actions possibles</u>&nbsp;: <br />";
        echo "<ul style=\"color: red;\">\n";

        echo "<li><a href=\"pass_user_init.php?cn=" . $user["cn"] . "\">Réinitialiser le mot de passe</a><br>";
        echo "<li><a href=\"mod_user_entry.php?cn=" . $user["cn"] . "\">Modifier le compte de mon élève ...</a><br>\n";
        // $test_desac = search_ad($config, $user["cn"], "user");
        // if ($test_desac[0]['useraccountcontrol'] == 512) {
        // // si compte active
        // //echo "<li><a href=\"desac_user_entry.php?cn=" . $user["cn"] . "\" onclick= return getconfirm()>Désactiver ce compte") . " </a><br>\n";
        // } else {
        // // si compte desactive
        // //echo "<li><a href=\"desac_user_entry.php?cn=" . $user["cn"] . "&action=activ\" >Activer ce compte") . " </a><br>\n";
        // }

        echo "<li><a href=\"del_nt_profile.php?cn=" . $user["cn"] . "&action=del\">Regénérer le profil Windows de mon élève...</a><br>\n";

        // exec("/usr/share/sambaedu/sbin/getUserProfileInfo.pl $user[cn]", $AllOutPut, $ReturnValue);
        // if ($AllOutPut[0] == "lock") {
        // echo "<li><a href=\"del_nt_profile.php?cn=" . $user["cn"] . "&action=unlock\">Déverrouiller le profil Windows...") . "</a><br>\n";
        // } else {
        // echo "<li><a href=\"del_nt_profile.php?cn=" . $user["cn"] . "&action=lock\">Verrouiller le profil Windows...") . "</a><br>\n";
        // }
        echo "</ul>\n";
    } // Fin test si prof
}

// test du cas ou on veut modifier son propre compte
if ($config['login'] == $user["cn"]) {
    echo "<u>Action possible</u>&nbsp;: <br />";
    // echo "<br>\n";
    echo "<ul style=\"color: red;\">\n";
    echo "<li><A HREF=\"../parcs/show_histo.php?selectionne=3&user=" . $user["cn"] . "\">Voir mes connexions</A>";
    echo "<li><A HREF=\"../infos/du.php?wrep=/home/" . $user['cn'] . "&cn=" . $user['cn'] . "\">Espace occupé par mon Home</A>";
    // echo "<li><a href=\"del_nt_profile.php?cn=" . $user["cn"] . "&action=del\">Regenerer mon profil Windows...") . "</a><br>\n";
    // exec("/usr/share/sambaedu/sbin/getUserProfileInfo.pl $user[cn]", $AllOutPut, $ReturnValue);
    // if ($AllOutPut[0] == "lock") {
    // echo "<li><a href=\"del_nt_profile.php?cn=" . $user["cn"] . "&action=unlock\">Déverrouiller mon profil Windows...") . "</a><br>\n";
    // } else {
    // echo "<li><a href=\"del_nt_profile.php?cn=" . $user["cn"] . "&action=lock\">Verrouiller mon profil Windows...") . "</a><br>\n";
    // }

    // if (have_right($config, "fond_can_change")) {
    // echo "<li><a href=\"../fond_ecran/fond_perso.php\">Personnaliser mon fond d'écran") . "</a><br>\n";
    // }

    echo "</ul>\n";
}
?>


        </td>
    </tr>
</table>


<?php
// modif proposee par Laurent COOPER
if ((is_prof($config, $user["cn"])) && file_exists("/var/www/sambaedu/annu/teacher.php")) {
    echo " \n <ul style=\"color:red;\"> \n <li> <a href=\"teacher.php\"> Mes services </a> </li> </ul>\n";
}
if ($config['login'] == $user["cn"]) {
    $liste = list_delegations_right($config, SE_COMPUTER_ELEVATE, $config['login']);
    if (have_right($config, SE_COMPUTER_ELEVATE)) {
        $texte = "toutes les machines du domaine";
    } else {
        $texte = "les machines et parcs <br>" . implode(" ", array_map('ldap_dn2cn', array_column($liste, 'parcdn'))) . "</br>";
    }
    $reste = get_local_admin_right($config, $config['login']);
    if ($reste < 0) {
        echo "<h1>Administration locale des postes</h1>";
        echo "Vous avez le droit d'administrer " . $texte . " de façon permanente. Attention vous en êtes admin local !<br>";
    } elseif ($reste > 0) {
        echo "<h1>Administration locale des postes</h1>";
        echo "Vous avez le droit d'administrer " . $texte . " durant " . round($reste / 60, 0) . " minutes. Par mesure de sécurité vous devez vous reconnecter sur les postes pour en être l'administrateur local.<br>";
    } elseif (have_right($config, SE_COMPUTER_ELEVATE) || count($liste) > 0) {
        echo "<h1>Administration locale des postes</h1>";
        echo "Vous avez le droit d'administrer " . $texte . ". Par mesure de sécurité vous devez d'abord activer ce droit pour une durée de deux heures. Vous devrez vous reconnecter sur les postes pour en être l'administrateur local.<br>";
        echo "<form action=\"people.php\" method=\"post\">";
        // if (! empty($salles)) {
        // echo "<select name=delegation>";
        // foreach ($salles as $salle) {
        // echo "<option value=" . $salle['name'] . ">" . $salle['name'] . "</option>";
        // }
        // echo "</select>";
        // }
        // echo "<input type=hidden name='activer' value='Activer'>";
        echo "<input type=submit name='activer' value='Activer'>";
        echo "<input type=hidden name='cn' value='" . $config['login'] . "'>";
        echo "</form>";
    }
}
// echo "</table>";

$html = "";
admin_footer_html($html);
echo $html;
?>