<?php

/**
 * Affiche une liste d'utilisateurs a partir de l'annuaire
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: peoples_list.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include_once "ldap.inc.php";
include "ihm.inc.php";

$filter_people = '';
// tableau de profs
$lesprofs = search_ad($config, "*", "memberof", "Profs");
$list_prof_grp = array();
foreach ($lesprofs as $key => $value) {
    $list_prof_grp[$key] = $value["cn"];
}

if ((have_right($config, SE_USER_ADMIN)) || (have_right($config, SE_USER_READ)) || (have_right($config, SE_USER_PASSWORD_INIT | SE_USER_READ | SE_USER_MODIFY))) {

    $priority_surname = $_POST['priority_surname'] ?? '';
    $fullname = $_POST['fullname'] ?? '';
    $priority_name = $_POST['priority_name'] ?? '';
    $nom = $_POST['nom'] ?? '';
    $priority_classe = $_POST['priority_classe'] ?? '';
    $classe = $_POST['classe'] ?? '';
    $priority_login = $_POST['priority_login'] ?? '';
    $login = $_POST['login'] ?? '';

    echo "<h1>Annuaire</h1>\n";

    echo "<div style='float:right; width:16px; '><a href='add_user.php' title='Ajouter un utilisateur'><img src='/elements/images/add.png' width='16px' height='16px'  alt='Ajouter un utilisateur' /></a></div>\n";

    if (! empty($fullname) || ! empty($nom) || ! empty($login)) {
        // Convertion en utf_8
        get_config($config, true, true);
        $nom = utf8_encode($nom);
        $fullname = utf8_encode($fullname);
        if (! empty($_SESSION['etab'])) {
            $filter_people = "(&(objectclass=user)(!(objectclass=computer))(memberof=cn=" . $_SESSION['etab'] . "," . $config['dn']['etablissements'] . ")";
        } else {
            $filter_people = "(&(objectclass=user)(!(objectclass=computer))";
        }
        // Construction du filtre de la branche people
        if ($login) {
            // Recherche sur sn
            if ($priority_login == "contient") {
                $filter_people .= "(cn=*$login*)";
            } elseif ($priority_login == "commence") {
                $filter_people .= "(sn=$login*)";
            } else {
                $filter_people = "(sn=*$login)";
            }
        } elseif ($nom && ! $fullname) {
            // Recherche sur sn
            if ($priority_name == "contient") {
                $filter_people .= "(sn=*$nom*)";
            } elseif ($priority_name == "commence") {
                $filter_people .= "(sn=$nom*)";
            } else {
                $filter_people = "(sn=*$nom)";
            }
        } elseif ($fullname && ! $nom) {
            // Recherche sur cn
            if ($priority_surname == "contient") {
                $filter_people .= "(displayname=*$fullname*)";
            } elseif ($priority_surname == "commence") {
                $filter_people .= "(displayname=$fullname*)";
            } else {
                $filter_people .= "(displayname=*$fullname)";
            }
        } elseif ($fullname && $nom) {
            // Recherche sur sn ET cn
            if ($priority_name == "contient") {
                if ($priority_surname == "contient") {
                    $filter_people .= "(sn=*$nom*)(displayname=*$fullname*)";
                } elseif ($priority_surname == "commence") {
                    $filter_people .= "(sn=*$nom*)(displayname=$fullname*)";
                } else {
                    $filter_people .= "(sn=*$nom*)(displayname=*$fullname)";
                }
            } elseif ($priority_name == "commence") {
                if ($priority_surname == "contient") {
                    $filter_people .= "(sn=$nom*)(displayname=*$fullname*)";
                } elseif ($priority_surname == "commence") {
                    $filter_people .= "(sn=$nom*)(displayname=$fullname*)";
                } else {
                    $filter_people .= "(sn=$nom*)(displayname=*$fullname)";
                }
            } else {
                if ($priority_surname == "contient") {
                    $filter_people .= "(sn=*$nom)(displayname=*$fullname*)";
                } elseif ($priority_surname == "commence") {
                    $filter_people .= "(sn=*$nom)(displayname=$fullname*)";
                } else {
                    $filter_people .= "(sn=*$nom)(displayname=*$fullname)";
                }
            }
        }

        // Remplacement de *** ou ** par *
        $filter_people = preg_replace("/\*\*\*/", "*", $filter_people);
        $filter_people = preg_replace("/\*\*/", "*", $filter_people);
        $filter_people .= ")";
        // echo $filter_people . "<br>";
        if (empty($classe)) {
            $users = search_ad($config, $filter_people, "filter", get_config($config, true, true)['dn']['people']);
            @usort($users, "cmp_nom");
            // Affichage menu haut de page
            echo aff_trailer("3");

            if (! empty($users)) {
                if (count($users) == 1) {
                    echo "<p><STRONG>" . count($users) . "</STRONG> utilisateur répond à ces critères de recherche</p>\n";
                } else {
                    echo "<p><STRONG>" . count($users) . "</STRONG> utilisateurs répondent à ces critères de recherche</p>\n";
                }
                foreach ($users as $user) {
                    if (preg_match("/" . $config['dn']['trash'] . "/i", $user['dn'])) {
                        echo "<img src=\"images/Poubelle_vide.png\" width=18 height=18 hspace=1 border=0>A supprimer : \n";
                        echo "<A href=\"del_user.php?cn=" . $user["cn"] . "\">" . $user["fullname"] . " (" . $user["cn"] . ")</A></br>\n";
                    } else {
                        if (in_array($user["cn"], $list_prof_grp)) {
                            echo "<img src=\"images/gender_teacher.gif\" width=18 height=18 hspace=1 border=0>\n";
                        } else {
                            if (@$user["sexe"] == "F") {
                                echo "<img src=\"images/gender_girl.gif\" width=14 height=14 hspace=3 border=0>\n";
                            } else {
                                echo "<img src=\"images/gender_boy.gif\" width=14 height=14 hspace=3 border=0>\n";
                            }
                        }
                        $name = $user["fullname"] ?? "";
                        echo "<A href=\"people.php?cn=" . $user["cn"] . "\">" . $name . " (" . $user["cn"] . ")</A></br>\n";
                    }
                }
            } else {
                echo " <STRONG>Pas de résultats</STRONG> correspondant aux critères sélectionnés.<BR>\n";
            }
        }
    } elseif (! empty($classe)) {
        echo aff_trailer("3");
        // Recherche des classes et equipes dans la branche groups de l'annuaire
        if ($priority_classe == "contient") {
            $filter_classe = "(cn=Classe_*$classe*)";
        } elseif ($priority_classe == "commence") {
            $filter_classe = "(cn=Classe_$classe*)";
        } else {
            $filter_classe = "(cn=Classe_*$classe)";
        }
        // Remplacement de *** ou ** par *
        $filter_classe = preg_replace("/\*\*\*/", "*", $filter_classe);
        $filter_classe = preg_replace("/\*\*/", "*", $filter_classe);
        // recherches des classes
        $groups = filter_group($config, $filter_classe);
        $people = array();
        for ($loop = 0; $loop < count($groups); $loop ++) {
            $peuple = search_people_group($config, $groups[$loop]["cn"]);
            foreach ($peuple as $key => $value) {
                $peuple[$key]["group"] = $groups[$loop]["cn"];
            }
            $people = array_merge($peuple, $people);
        }

        if (count($people)) {
            if (count($people) == 1) {
                echo "<p><STRONG>" . count($people) . "</STRONG> utilisateur répond à ces critères de recherche.</p>\n";
            } else {
                echo "<p><STRONG>" . count($people) . "</STRONG> utilisateurs répondent à ces critères de recherche.</p>\n";
            }
            // affichage des resultats
            foreach ($people as $p) {
                if ($loop == 0 || $p["group"] != $people[$loop - 1]["group"]) {
                    echo "<BR><U>Classe</U> : " . $p["group"] . "<BR>\n";
                }
                if (preg_match("/" . $config['dn']['trash'] . "/i", $p['dn'])) {
                    echo "<img src=\"images/Poubelle_vide.png\" width=18 height=18 hspace=1 border=0>A supprimer : \n";
                    echo "<A href=\"del_user.php?cn=" . $p["cn"] . "\">" . $p["fullname"] . " (" . $p["cn"] . ")</A></br>\n";
                } else {
                    if (in_array($p["cn"], $list_prof_grp)) {
                        echo "<img src=\"images/gender_teacher.gif\" width=18 height=18 hspace=1 border=0>\n";
                    } else {
                        // if ($p["sexe"] == "F") {
                        // echo "<img src=\"images/gender_girl.gif\" width=14 height=14 hspace=3 border=0>\n";
                        // }
                        // else {
                        echo "<img src=\"images/gender_boy.gif\" width=14 height=14 hspace=3 border=0>\n";
                    }
                    echo "<A href=\"people.php?cn=" . $p["cn"] . "\">" . $p["fullname"] . "</A><BR>\n";
                }
            }
        } else {
            echo " <STRONG>Pas de résultats</STRONG> correspondant aux critères sélectionnés.<BR>
                      Retour au <A href=\"annu.php\">formulaire de recherche</A>...<BR>\n";
        }
    } else {
        // Aucun criteres de recherche
        echo " <STRONG>Pas de résultats !</STRONG><BR>
            Veuillez compléter au moins l'un des trois champs (nom, prénom, classe) du <A href=\"annu.php\">formulaire de recherche</A> !<BR>\n";
    }
}

$html = "";
admin_footer_html($html);
echo $html;
?>