<?php

/**
 * Reinitialisation/Modification des mots de passe
 * @Version 02/2020 - keyser
 * @Projet SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: /
 * file: reinit_mdp.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
require ("ihm.inc.php");
require ("fonc_outils.inc.php");
require ("ent.inc.php");

$force = $_POST['force'] ?? "false";
if ($force == "true") {
    $force = true;
} else {
    $force = false;
}

$change = $_POST['change'] ?? "true";
if ($change == "true") {
    $change = true;
} else {
    $change = false;
}
$etab = $_POST['uai'] ?? 0;

// debug_var();

if (! have_right($config, SE_USER_ADMIN | SE_USER_PASSWORD_INIT)) {
    die("Vous n'avez pas les droits suffisants pour accéder à cette fonction</BODY></HTML>");
}
echo "<h1>Réinitialisation/modification de mots de passe</h1>\n";
$pwdPolicy = $config['pwdPolicy'];

// ==========================================================
// Phase de choix des parametres
// echo "<center>\n";
if (! isset($_POST['is_posted']) || isset($_POST['uai_posted'])) {
    // echo "<center>\n";
    echo "<form action=\"reinit_mdp.php\" enctype='multipart/form-data' method=\"post\">\n";

    echo "<p>Cette page est destinée à réinitialiser/modifier les mots de passe par lots.</p>\n";

    $etabs = list_etabs($config);
    $etabs[0] = 0;
    /*
     * if (count($etabs) > 1 && ! isset($config['etab_ou'])) {
     * ksort($etabs, SORT_ASC);
     * $choix = "<table><tr><td>Choisir l'établissement pour filtrer les groupes <br>";
     * $choix .= "<SELECT NAME=\"uai\" SIZE=\"1\" onchange=submit()>";
     * foreach ($etabs as $e) {
     * $choix .= "<option value=\"" . $e . "\"";
     * if ($etab == $e) {
     * $choix .= " selected";
     * }
     * if ($e == 0) {
     * $choix .= ">groupes communs à tout le domaine\n";
     * } else {
     * $choix .= ">" . etab_to_name($config, $e) . "\n";
     * }
     * $choix .= "</option>";
     * }
     * $choix .= "</SELECT></td></tr></table>\n";
     * $choix .= "<input type=\"hidden\" name=\"uai_posted\" value=\"1\">\n";
     * echo $choix;
     * } else {
     */
    if (empty($config['etab_ou']) && ! empty($etab)) {
        $config['etab_ou'] = $etab;
        $config = get_config($config, true, $etab);
    }
    if (! empty($config['etab_ou']) || count($etabs) == 1) {
        echo "<p>Vous pouvez&nbsp;:</p>\n";
        echo "<table summary='Choix du mode'>\n";
        echo "<tr>\n";
        echo "<select name=force>";
        echo "<option value=true ";
        if ($force) {
            echo " selected";
        }
        echo ">reinitialiser tous les utilisateurs selectionnés</option>";
        echo "<option value=false ";
        if (! $force) {
            echo " selected";
        }
        echo ">reinitialiser uniquement les utilisateurs sélectionnés non activés</option>";
        echo "</select>";
        echo "</span></td>\n";
        echo "</tr>\n";
        echo "<tr>\n";
        echo "<select name=change>";
        echo "<option value=true ";
        if ($change) {
            echo " selected";
        }
        echo ">fixer un code d'activation à changer</option>";
        echo "<option value=false ";
        if (! $change) {
            echo " selected";
        }
        echo ">imposer un mot de passe définitif (DANGER)</option>";
        echo "</select>";
        echo "</span></td>\n";
        echo "</tr>\n";
        echo "</table>\n";

        echo "<div id='div_choix_groupes'>\n";
        echo affiche_all_groups($config, "left", "user");

        echo "<div id=\"attribution\" align='center'>\n";
        echo "<input type=\"hidden\" name=\"is_posted\" value=\"1\">\n";
        echo "<input type=\"hidden\" name=\"uai\" value=\"" . $etab . "\">\n";
        // echo "<input type=\"submit\" value=\"Valider\">\n";
        echo "<input type=\"reset\" value=\"Annuler\">\n";
        echo "</div>\n";

        echo "</div>\n";
    } else {
        // central
        echo "<p>Vous pouvez&nbsp;:</p>\n";
        echo "<table summary='Choix du mode'>\n";
        echo "<tr>\n";
        echo "<select name=force>";
        echo "<option value=true ";
        if ($force) {
            echo " selected";
        }
        echo ">reinitialiser tous les utilisateurs selectionnés</option>";
        echo "<option value=false ";
        if (! $force) {
            echo " selected";
        }
        echo ">reinitialiser uniquement les utilisateurs sélectionnés non activés</option>";
        echo "</select>";
        echo "</span></td>\n";
        echo "</tr>\n";
        echo "<tr>\n";
        echo "<select name=change>";
        echo "<option value=true ";
        if ($change) {
            echo " selected";
        }
        echo ">fixer un code d'activation à changer</option>";
        echo "<option value=false ";
        if (! $change) {
            echo " selected";
        }
        echo ">imposer un mot de passe définitif (DANGER)</option>";
        echo "</select>";
        echo "</span></td>\n";
        echo "</tr>\n";
        echo "</table>\n";

        echo "<div id='div_choix_groupes'>\n";
        echo affiche_all_groups($config, "left", "central");

        echo "<div id=\"attribution\" align='center'>\n";
        echo "<input type=\"hidden\" name=\"is_posted\" value=\"1\">\n";
        echo "<input type=\"hidden\" name=\"uai\" value=\"" . $etab . "\">\n";
        // echo "<input type=\"submit\" value=\"Valider") . "\">\n";
        echo "<input type=\"reset\" value=\"Annuler\">\n";
        echo "</div>\n";

        echo "</div>\n";
    }
    echo "<div id=\"div_validation\" align='center'>\n";
    echo "<input type=\"submit\" value=\"Valider\">\n";
    echo "</div>\n";

    echo "</form>\n";

    $html = "";
    admin_footer_html($html);
    echo $html;
    die();
}
// ==========================================================

// Phase de traitement

// echo "<center>\n";

$classe_gr = isset($_POST['classe_gr']) ? $_POST['classe_gr'] : array();
$equipe_gr = isset($_POST['equipe_gr']) ? $_POST['equipe_gr'] : array();
$matiere_gr = isset($_POST['matiere_gr']) ? $_POST['matiere_gr'] : array();
$autres_gr = isset($_POST['autres_gr']) ? $_POST['autres_gr'] : array();
if (empty($config['etab_ou']) && ! empty($etab)) {
    $config['etab_ou'] = $etab;
    $config = get_config($config, true, $etab);
}

// On lance l'operation pour chaque groupe demande !!!
$listing = [];
if (count($classe_gr)) {
    foreach ($classe_gr as $grp) {
        echo "<h4>Réinitialisation des mots de passe pour les membres du groupe " . $grp . "&nbsp;:</h4>\n";
        echo "<pre class='listing'>";
        $members = list_members_group($config, $grp);
        foreach ($members as $user) {
            echo reinit_passwd($config, $user, $listing, $force, $change, true);
        }
        echo "</pre>\n";
        echo "<hr />\n";
    }
}

if (count($equipe_gr)) {
    foreach ($equipe_gr as $grp) {
        echo "<h4>Réinitialisation des mots de passe pour les membres du groupe " . $grp . "&nbsp;:</h4>\n";
        echo "<pre class='listing'>";
        $members = list_members_group($config, $grp);
        foreach ($members as $user) {
            echo reinit_passwd($config, $user, $listing, $force, $change, true);
        }
        echo "</pre>\n";
        echo "<hr />\n";
    }
}

if (count($matiere_gr)) {
    foreach ($matiere_gr as $grp) {
        echo "<h4>Réinitialisation des mots de passe pour les membres du groupe " . $grp . "&nbsp;:</h4>\n";
        echo "<pre class='listing'>";
        $members = list_members_group($config, $grp);
        foreach ($members as $user) {
            echo reinit_passwd($config, $user, $listing, $force, $change, true);
        }
        echo "</pre>\n";
        echo "<hr />\n";
    }
}

if (count($autres_gr)) {
    foreach ($autres_gr as $grp) {
        echo "<h4>Réinitialisation des mots de passe pour les membres du groupe " . $grp . "&nbsp;:</h4>\n";
        echo "<pre class='listing'>";
        $members = list_members_group($config, $grp);
        foreach ($members as $user) {
            if (empty($config['etab_ou']) || $user['etab'] == $config['etab_ou']) {
                echo reinit_passwd($config, $user, $listing, $force, $change, true);
            }
        }
        echo "</pre>\n";
        echo "<hr />\n";
    }
}
if (! empty($_POST['user'])) {
    echo "<h4>Réinitialisation des mots de passe pour " . $_POST['user'] . "</h4>\n";
    echo "<pre class='listing'>";
    echo reinit_passwd($config, search_user($config, $_POST['user']), $listing, $force, $change, true);
    echo "</pre>\n";
    echo "<hr />\n";
}

// echo "<p><a href='" . $_SERVER['PHP_SELF'] . "'>Retour</a></p>";
// echo "</center>\n";

apcu_store('listing_' . session_id(), $listing, 1200);
echo generate_listing('listing_' . session_id());

$html = "";
admin_footer_html($html);
echo $html;

?>