<?php

/**
 * Recherche les utilisateurs a partir de l'annuaire
 * @Projet SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @note
 */

/**
 *
 * @Repertoire: annu
 * file: search.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include "ihm.inc.php";

if ((have_right($config, SE_USER_READ)) || (have_right($config, SE_USER_ADMIN))) {
    $config = get_config($config, true, $_SESSION['etab']);

    echo "<h1>Annuaire</h1>\n";
    echo aff_trailer("2");

    $titre = "Rechercher un utilisateur";
    $texte = "<form action=\"peoples_list.php\" method='post' id='form1'>\n";
    $texte .= "<table>\n";
    $texte .= "<tbody>\n";
    $texte .= "<tr>\n";
    $texte .= "<td>Nom complet :</td>\n";
    $texte .= "<td>\n";
    $texte .= "<select name=\"priority_surname\">\n";
    $texte .= "<option value=\"contient\">contient</option>\n";
    $texte .= "<option value=\"commence\">commence par</option>\n";
    $texte .= "<option value=\"finit\">finit par</option>\n";
    $texte .= "</select>\n";
    $texte .= "</td>\n";
    $texte .= "<td><input type=\"text\" name=\"fullname\" id=\"fullname\"></td>\n";
    $texte .= "</tr>\n";
    $texte .= "<tr>\n";
    $texte .= "<td>Nom :</td>\n";
    $texte .= "<td>\n";
    $texte .= "<select name=\"priority_name\">\n";
    $texte .= "<option value=\"contient\">contient</option>\n";
    $texte .= "<option value=\"commence\">commence par</option>\n";
    $texte .= "<option value=\"finit\">finit par</option>\n";
    $texte .= "</select>\n";
    $texte .= "</td>\n";
    $texte .= "<td><input type=\"text\" name=\"nom\" id=\"nom\"></td>\n";
    $texte .= "</tr>\n";
    $texte .= "<tr>\n";
    $texte .= "<td>Classe :</td>\n";
    $texte .= "<td>\n";
    $texte .= "<select name=\"priority_classe\">\n";
    $texte .= "<option value=\"contient\">contient</option>\n";
    $texte .= "<option value=\"commence\">commence par</option>\n";
    $texte .= "<option value=\"finit\">finit par</option>\n";
    $texte .= "</select>\n";
    $texte .= "</td>\n";
    $texte .= "<td><input type=\"text\" name=\"classe\" id=\"classe\"></td>\n";
    $texte .= "</tr>\n";
    $texte .= "<tr>\n";
    $texte .= "<td>Login :</td>\n";
    $texte .= "<td>\n";
    $texte .= "<select name=\"priority_login\">\n";
    $texte .= "<option value=\"contient\">contient</option>\n";
    $texte .= "<option value=\"commence\">commence par</option>\n";
    $texte .= "<option value=\"finit\">finit par</option>\n";
    $texte .= "</select>\n";
    $texte .= "</td>\n";
    $texte .= "<td><input type=\"text\" name=\"login\" id=\"login\"></td>\n";
    $texte .= "</tr>\n";

    $texte .= "</tbody>\n";
    $texte .= "</table>\n";
    $texte .= "<div align=center>
    <input type=\"submit\" id='input_submit_1' value=\"Lancer la requête\" />
    <input type=\"button\" id='input_submit_2' value=\"Lancer la requête\" style='display:none' onclick='test_form1()' />
</div>";
    $texte .= "</form>\n";
    echo mktable($titre, $texte);

    // Recherche d'un groupe (classe, Equipe, Cours ...)
    $titre = "Rechercher un groupe (classe, équipe, cours ...)</h2>\n";
    $texte = "<form action=\"groups_list.php\" method='post' id='form2'>\n";
    $texte .= "<table>\n";
    $texte .= "<tbody>\n";
    $texte .= "<tr>\n";
    $texte .= "<td>Groupe :</td>\n";
    $texte .= "<td>\n";
    $texte .= "<select name=\"priority_group\">\n";
    $texte .= "<option value=\"contient\">contient</option>\n";
    $texte .= "<option value=\"commence\">commence par</option>\n";
    $texte .= "<option value=\"finit\">finit par</option>\n";
    $texte .= "</select>\n";
    $texte .= "</td>\n";
    $texte .= "<td><input type=\"text\" name=\"group\" id=\"group\"></td>\n";
    $texte .= "</tr>\n";
    $texte .= "</tbody>\n";
    $texte .= "</table>\n";
    $texte .= "<div align=center>
    <input type=\"submit\" id='input_submit_3' value=\"Lancer la requête\" />
    <input type=\"button\" id='input_submit_4' value=\"Lancer la requête\" style='display:none' onclick='test_form2()' />
</div>";
    $texte .= "</form>\n";
    echo "<BR>";

    $texte .= "<script type='text/javascript'>
    document.getElementById('input_submit_1').style.display='none';
    document.getElementById('input_submit_2').style.display='';
    document.getElementById('input_submit_3').style.display='none';
    document.getElementById('input_submit_4').style.display='';

    if(document.getElementById('fullname')) {
        document.getElementById('fullname').focus();
    }

    function test_form1() {
        if((document.getElementById('fullname').value=='')&&(document.getElementById('nom').value=='')&&(document.getElementById('classe').value=='')&&(document.getElementById('login').value=='')) {
            alert('Tous les champs du formulaire sont vides.');
        }
        else {
            document.getElementById('form1').submit();
        }
    }

    function test_form2() {
        if(document.getElementById('group').value=='') {
            alert('Le champ groupe ne peut pas etre vide.');
        }
        else {
            document.getElementById('form2').submit();
        }
    }

</script>";

    echo mktable($titre, $texte);
}
$html = "";
admin_footer_html($html);
echo $html;
?>