<?php
//
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include "ihm.inc.php";

$profile = $_POST['profile'] ?? "";
$rights = $_POST['rights'] ?? [];
$action = $_POST['action'] ?? "";
$description = $_POST['description'] ?? "";

function list_profiles($config, $profile)
{
    $profiles = search_ad($config, "*", "right");
    array_unshift($profiles, [
        'cn' => "Nouveau..."
    ]);
    $html = "<select name=profile>";
    foreach ($profiles as $right) {
        $html .= "<option value='" . $right['cn'] . "' ";
        if ($profile == $right['cn']) {
            $html .= "selected";
        }
        $html .= ">" . $right['cn'];
    }
    $html .= "</select>";
    $html .= "<input type='submit' name='action' value='Afficher'>";
    $html .= "<input type='submit' name='action' value='Supprimer'>";
    return $html;
}

function edit_profile($config, $profile)
{
    $html = "";
    $available_rights = right_info(SE_ADMIN);
    if ($profile == "Nouveau...") {
        $rights = [];
        $html .= "<p>Nom du nouveau profil : <input type='text' name='profile' size=20/><br>
Description du profil : <input type='text' name='description' size=20/></p>";
    } else {
        $profile = search_ad($config, $profile, "right")[0];
        // $html = '<input type="hidden" name="profile" value="' . $profile['cn'] . '">';

        $description = $profile['description'] ?? "";
        if (! isset($profile['info'])) {
            $map = [
                "se3_is_admin" => SE_ADMIN,
                "Annu_is_admin" => SE_COMPUTER_ADMIN,
                "computer_is_admin" => SE_COMPUTER_ADMIN,
                "password_can_reinit" => SE_USER_PASSWORD_INIT,
                "annu_can_read" => SE_USER_PASSWORD_INIT | SE_USER_READ,
                "sovajon_is_admin" => SE_ELEVE_ADMIN
            ];
            $profile['info'] = $map[$profile['cn']] ?? SE_NO_RIGHT;
        }
        $rights = right_info($profile['info']);
        $html .= "<p>Profil sélectionné : " . $profile['cn'] . "<br>
Description du profil : <input type='text' name='description' value='" . $description . "'/></p>";
    }
    $html .= "<table>";
    $html .= "<tr>";
    $html .= "<th>Droit</th>";
    $html .= "<th></th>";
    $html .= "</tr>";
    foreach ($available_rights as $k => $msg) {
        if (isset($rights[$k])) {
            $check = '<input type="checkbox" name="rights[]" value="' . $k . '" checked/>' . "\n";
        } else {
            $check = '<input type="checkbox" name="rights[]" value="' . $k . '" />' . "\n";
        }
        $html .= "<tr>";
        $html .= "<td>" . $msg . "</td>";
        $html .= "<td>" . $check . "</td>";
        $html .= "</tr>";
    }
    $html .= "</table>";
    $html .= '<input type="submit" name="action" value="Modifier">';
    return $html;
}

if (have_right($config, SE_ADMIN)) {
    // echo "<pre>" . print_r($_FILES, true) . "</pre>";
    echo "<h1>Gestion des profils d'autorisations des utilisateurs</h1>";
    echo "<p>Cette page permet de définir des profils qui pourront être attribués aux utilisateurs et groupes, leur donnant différents niveaux de privilèges.
 Ces profils peuvent aussi être utilisés pour les délégations de parcs.</p>";

    echo "<form method=\"post\" action=\"profiles.php\" enctype=\"multipart/form-data\">\n";
    $right = 0;
    foreach ($rights as $r) {
        $right |= $r;
    }
    apcu_delete(new APCUIterator('#^rights_#'));
    switch ($action) {
        case "Supprimer":
            $p = search_ad($config, $profile, "right")[0] ?? false;
            if (! empty($profile) && $profile != "Nouveau..." && is_array($p)) {
                if (groupdelbydn($config, $p['dn'])){
                    echo "profil " . $profile . " supprimé<br>";
                }
            }
            apcu_delete(new APCUIterator('#^rights_#'));
            echo list_profiles($config, $profile);
            break;
        case "Modifier":
            if ($profile != "Nouveau...") {
                $p = search_ad($config, $profile, "right")[0] ?? false;
                if (! empty($profile) && empty($p)) {
                    groupadd($config, $profile, $config['rights_rdn'], $description, "", $right);
                    $p = search_ad($config, $profile, "right")[0];
                }
                if ($right != $p['info']) {
                    modify_ad_attr($config, $p, "info", $right);
                }
                if ($description != $p['description']) {
                    modify_ad_attr($config, $p, "description", $description);
                }
                // }
            }
        case "Afficher":
            echo list_profiles($config, $profile);
            echo edit_profile($config, $profile);
            break;
        default:
            echo list_profiles($config, $profile);
    }
    echo "</form>";
} else {
    echo "Vous n'avez pas les droits nécessaires pour ouvrir cette page...";
}
// Footer
$html = "";
admin_footer_html($html);
echo $html;
?>