<?php

/**

 * Page pour l'authentification
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: /
 * file: auth.php
 *
 */

// Initialisation:
// $error = 0;
require_once 'config.inc.php';
$config = get_config();
require_once 'ldap.inc.php';
require_once 'functions.inc.php';
require 'test_dates.inc.php';

$error = $_GET['error'] ?? "";

include_once 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
$html .= "<div>";

$etab_choix = $_POST['etab'] ?? $_GET['etab'] ?? $config['etab_ou'] ?? 0;
$etab = $config['etab_ou'] ?? 0;

$etabs = activated_etabs($config);
$index = array_search($etab_choix, array_column($etabs, 'uai'));

if (! empty($etab_choix) && $etab_choix != $etab && $index !== false && $etabs[$index]['activated']) {
    header("Location: ../" . $etab_choix . "/auth.php");
    exit();
}
$choix = "";
if ($etab == 0) {
    // $etabs = list_etabs($config);
    // $etabs[0] = 0;
    if (count($etabs) > 1) {
        sort_by_key('uai', $etabs);
        $choix .= "Choisir l'établissement à administrer <br>";

        // $choix .= "<select name=\"etab\" size=\"1\" onchange=submit()>";
        $choix .= '<datalist id="ListEtab">';
        foreach ($etabs as $e) {
            $choix .= "<option value=\"" . $e['uai'] . "\"";
            if ($etab == $e['uai']) {
                // $choix .= " selected";
                $ActualValue = $e['uai'] . " " . etab_to_name($config, $e['uai']);
            }
            if ($e['uai'] == 0) {
                $choix .= ">Domaine entier\n";
                $ActualValue = "Domaine entier";
            } else {
                $choix .= ">" . $e['uai'] . " " . etab_to_name($config, $e['uai']);
                if (! $e['activated']) {
                    $choix .= " <b>virtuel</b>";
                }
                $choix .= "\n";
                $choix .= "</option>";
            }
        }
        $choix .= '</datalist>';
        // $choix .= "</select></td></tr></table>\n";
        $choix .= '<input list="ListEtab" id="etab" name="etab" size="50" value="' . $ActualValue . '" onfocus="this.value=' . "''" . ';" />';
        $choix .= ' <button class="btn btn-primary" type="button" onClick="submit();">
                        <i>Choisir</i>
                    </button>';
        $choix .= "\n";
    }
}
// $request = $_GET["request"] ?? "";
/*
 * On limite $request à index.php
 * pour empêcher le phishing
 */
$request = "index.php";

$al = $_GET["al"] ?? 0;
$login_name = $_POST["login"] ?? "";

// @TODO prendre en compte $etab pour la branche ou le serveur

if ($al != 0 && (! empty($login_name)) && isset($_POST["passwd"])) {
    if ($etab == 0) {
        $config = get_config($config, true, true);
    }
    if (open_session($config, $login_name, $_POST["passwd"], @$_POST["newpasswd"])) {
        $home = search_user($config, $login_name)['etab'];
        if (! empty($home) && ! empty($etab) && $home != $etab) {
            header("Status: 301 Moved Permanently", false, 301);
            header("Location: /" . $etab . "/" . $request . "");
            exit();
        } else {
            header("Status: 301 Moved Permanently", false, 301);
            header("Location: /" . $request . "");
            exit();
        }
        // exit();
    } else {
        if (empty($login_name)) {
            header("Location: ../auth.php?al=0&error=2");
            exit();
        } else {
            header("Location: ../auth.php?al=0&error=1");
            exit();
        }
    }
} else {
    $texte = "";
    $texte .= "<p>Afin de pouvoir accéder à l'interface <EM>SambaÉdu</EM>, veuillez indiquer votre identifiant et votre mot de passe sur le réseau.</p>\n";
    $texte .= "<form name = 'auth' action='auth.php?al=1&request=" . rawurlencode($request) . "' method='post' >\n";
    $texte .= "<table><tr>";
    $texte .= $choix;
    $texte .= "<td>";
    if ($etab == 0) {
        $texte .= "Identifiant :</td><td><input type='text' name='login' size='20' maxlength='30'><br>\n";
    } else {
        $texte .= "Identifiant pour $etab :</td><td><input type='text' name='login' size='20' maxlength='30'><br>\n";
    }
    $texte .= "</td></tr><tr><td>\n";
    $texte .= "Mot de passe :</td><td><input type='password' name='passwd' size='20' maxlength='20'><br>\n";
    // $texte .= "</td></tr><tr align=\"right\"><td></td><td>\n";
    $texte .= "<input type='hidden' name='string_auth' value=''>";
    $texte .= "<input type='hidden' name='time' value=''>";
    $texte .= "<input type='hidden' name='client_ip' value='" . remote_ip() . "'>";
    $texte .= "<input type='hidden' name='timestamp' value='" . time() . "'>";
    $texte .= "</td></tr><tr><td>\n";
    $texte .= "<tr><td></td><td><input type='submit' VALUE='Valider'><br>\n";
    $texte .= "</td></tr></table>\n";
    $texte .= "</form>\n";

    $html .= "<h3><strong>Authentification...</strong></h3>";
    $html .= $texte;
    if ($error == 1) {
        $html .= "<div class='alert_msg'>Erreur d'authentification !</div>";
    }

    // Test de l'ecart entre la date du serveur et la date du client
    // S'il y a plus de 200 secondes d'ecart, on affiche une alert() javascript:
    $html .= test_et_alerte_dates();

    admin_footer_html($html, false);
    echo $html;
}
?>