<?php

/**

 * Permet de configurer certains éléments du serveur

 * @Projet SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: /
 * file: conf_params.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
require_once "ihm.inc.php";
require_once ("samba.inc.php");
require_once ("partages.inc.php");

// debug_var();

if (! have_right($config, SE_ADMIN)) {
    die("Vous n'avez pas les droits suffisants pour accéder à cette fonction</BODY></HTML>");
}

$action = $_GET['action'] ?? "";
$get_varb = $_GET['varb'] ?? "";
$get_valeur = $_GET['valeur'] ?? "";
$rules = get_password_rule($config);
$length = $rules['min-pwd-length'] ?? 5;
if ($rules['complexity'] == "on")
    $complexity = true;
else
    $complexity = false;
if ($length <= 8 && ! $complexity) {
    $ddn = true;
} else {
    $ddn = false;
}
// Change dans la base
if ($action == "change") {
    switch ($get_varb) {
        case "UAI":
            $get_valeur = strtoupper(trim($get_valeur));
            if (! preg_match('/^\d{7}[A-Z]$/i', $get_valeur)) {
                $get_valeur = "";
            }
            set_config($config, $get_varb, strtolower($get_valeur));
            break;

        case "pwdPolicy":
            if (isset($_GET['activation_code']) && $_GET['activation_code'] != $config['activation_code']) {
                $testcode = verifPwd($_GET['activation_code'], $length);
                if ($testcode[0]) {
                    set_param($config, "activation_code", $_GET['activation_code']);
                }
            }

            if (isset($_GET['no_passwd_change']) && $_GET['no_passwd_change'] != $config['no_passwd_change']) {
                set_param($config, "no_passwd_change", $_GET['no_passwd_change']);
            } else {
                set_param($config, "no_passwd_change", "0");
            }
            set_config($config, $get_varb, $get_valeur);
            break;
        case "pwdlength":
            if (isset($_GET['pwdlength']) && $_GET['pwdlength'] != $length) {
                set_password_rule($config, NULL, $_GET['pwdlength']);
                $length = $_GET['pwdlength'];
            }
            break;
        case "complexity":
            if (isset($_GET['complexity']) && $_GET['complexity'] != $rules['complexity']) {
                set_password_rule($config, $_GET['complexity']);
                $rules['complexity'] = $_GET['complexity'];
            }
            break;
        case "proxy_type":
            switch ($get_valeur) {
                case "aucun":
                    set_param($config, "server_proxy", 0);
                    set_param($config, "proxy_url", "");
                    break;
                case "automatique":
                    if (! empty($config['proxy_address'])) {
                        $ip_amon = $config['ip_amon'] ?? $config['proxy_address'] ?? $config['nameserver'];
                        $ligne = exec("host " . $ip_amon . " " . $ip_amon);
                        $amon_domain = substr(explode(".", explode(" ", $ligne)[4], 2)[1], 0, - 1);
                    }
                    $urls = [
                        $_GET['proxy_url'] ?? "",
                        "http://wpad." . $amon_domain . "/wpad.dat",
                        "http://" . $config['proxy_address'] . "/wpad.dat",
                        "http://wpad." . $config['domain'] . "/wpad.dat"
                    ];
                    require_once (dirname(__FILE__) . '/vendor/autoload.php');
                    $client = new GuzzleHttp\Client();
                    foreach ($urls as $url) {
                        try {
                            $response = $client->request('GET', $url);
                            if ($response) {
                                break;
                            } else {
                                $url = false;
                            }
                        } catch (Exception $e) {
                            $url = false;
                        }
                    }
                    if ($url) {
                        set_param($config, "proxy_url", $url);
                    } else {
                        set_param($config, "proxy_url", "");
                    }
                    break;
                default:
                    break;
            }
            if (isset($_GET['proxy_address']) && $_GET['proxy_address'] != $config['proxy_address']) {
                set_param($config, "proxy_address", $_GET['proxy_address']);
            }
            if (isset($_GET['proxy_port']) && $_GET['proxy_port'] != $config['proxy_port']) {
                set_param($config, "proxy_port", $_GET['proxy_port']);
            }
            if (isset($_GET['server_proxy'])) {
                if ($_GET['server_proxy'] != @$config['server_proxy']) {
                    set_param($config, "server_proxy", $_GET['server_proxy']);
                }
            } else {
                set_param($config, "server_proxy", 0);
            }
            set_config($config, $get_varb, $get_valeur);
            break;

        case "defaultintlevel":
            setintlevel($get_valeur);
            set_config($config, $get_varb, $get_valeur);
            break;

        case "autoriser_part_pub":
            set_config($config, $get_varb, $get_valeur);
            $dossier_pub = "/var/sambaedu/Docs/public";
            system("sudo mkdir -p $dossier_pub");
            system("sudo chown admin:domain\\ admins $dossier_pub");
            if ($get_valeur == "y") {
                $acls = array(
                    "user::rwx",
                    "user:admin:rwx",
                    "group::rwx",
                    "group:domain\\040admins:rwx",
                    "mask::rwx",
                    "other::rwx",
                    "default:user::rwx",
                    "default:user:admin:rwx",
                    "default:group::rwx",
                    "default:group:domain\\040admins:rwx",
                    "default:mask::rwx",
                    "default:other::rwx"
                );
                set_acls("$dossier_pub", $acls);
            } else {
                system("sudo setfacl -b $dossier_pub");
                system("sudo chmod 770 $dossier_pub");
                $acls = array(
                    "user::rwx",
                    "user:admin:rwx",
                    "group::rwx",
                    "group:domain\\040admins:rwx",
                    "mask::rwx",
                    "default:user:admin:rwx",
                    "default:group:domain\\040admins:rwx",
                    "default:mask::rwx"
                );
                set_acls("$dossier_pub", $acls);
            }
            break;

        case "admin_w":
            $smbconf = read_smb_conf();
            if ($get_valeur == "y") {
                $smbconf['install']['read only'] = "no";
            } else {
                $smbconf['install']['read only'] = "yes";
            }
            write_smb_conf($smbconf);
            break;

        default:
            set_config($config, $get_varb, $get_valeur);
            break;
    }

    // on recharge la config après modif
    $config = get_config($config, 1);
}

echo "<h1>Paramétrage du serveur</H1>\n";

// Affichage du form de mise a jour des paramatres
echo "<br><br>";
echo "<center>";
echo "<table class='table-bordered' width=\"80%\">\n";
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo "Paramétrage de l'interface " . replace_element($config, "SambaEdu", "SambaEdu");
echo "</TD></TR>\n";

// Niveau d'interface
/*
 * echo "<TR><TD>Niveau d'interface</TD><TD align=\"center\">";
 * if ($action == "modif_intlevel") {
 *
 * echo "<form method=\"get\" action=\"conf_params.php\">";
 * echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
 * echo "<input type=\"hidden\" name=\"varb\" value=\"defaultintlevel\">";
 * echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
 * echo "<option";
 * if ($config['defaultintlevel'] == "1") {
 * echo " selected";
 * }
 * echo " value=\"1\">Débutant</option>";
 * echo "<option";
 * if ($config['defaultintlevel'] == "2") {
 * echo " selected";
 * }
 * echo " value=\"2\">Intermédiaire</option>";
 * echo "<option";
 * if ($config['defaultintlevel'] == "3") {
 * echo " selected";
 * }
 * echo " value=\"3\">Confirmé</option>";
 * echo "<option";
 * if ($config['defaultintlevel'] == "4") {
 * echo " selected";
 * }
 * echo " value=\"4\">Expert</option>";
 * echo "</select>\n";
 * echo "<u onmouseover=\"return escape('Permet de sélectionner le niveau de l\'interface Se4.')\"><img name=\"action_image2\" src=\"elements/images/system-help.png\" alt=\"help\"></u>";
 * echo "</form>\n";
 * } else {
 * if (! isset($config['defaultintlevel'])) {
 * $intlevel = "Expert";
 * } elseif ($config['defaultintlevel'] == "1") {
 * $intlevel = "Débutant";
 * } elseif ($config['defaultintlevel'] == "2") {
 * $intlevel = "Intermédiaire";
 * } elseif ($config['defaultintlevel'] == "3") {
 * $intlevel = "Confirmé";
 * } elseif ($config['defaultintlevel'] == "4") {
 * $intlevel = "Expert";
 * }
 * echo "<u onmouseover=\"return escape('Mode d\'affichage')\">";
 * echo "<a href=conf_params.php?action=modif_intlevel>$intlevel</a>";
 * echo "</u>";
 * }
 * echo "</td></tr>\n";
 */

// Affichage page Etat

echo "<TR><TD>Affiche la page d'état</TD><TD align=\"center\">";

if (! isset($config['affiche_etat'])) {
    echo "<u onmouseover=\"return escape('<b>Etat : Désactivé</b><br><br>Permet d\'afficher l\'état du serveur à chaque démarrage de l\'interface')\">";
    echo "<a href=conf_params.php?action=change&amp;varb=affiche_etat&amp;valeur=1&amp;cat=6><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
    echo "</u>";
} else {
    echo "<u onmouseover=\"return escape('<b>Etat : Activé</b><br><br>Permet de ne plus faire afficher l\'interface de l\'état du serveur à chaque lancement de l\'interface d\'administration du serveur.')\">";
    echo "<a href=conf_params.php?action=change&amp;varb=affiche_etat&amp;valeur=0&amp;cat=6><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\" ></a>";
    echo "</u>";
}
echo "</td></tr>\n";

// Mode debug

echo "<TR><TD>Mode débuggage</TD><TD align=\"center\">";
$debug = [
    0 => 'Aucun',
    1 => 'debug PHP',
    2 => 'profilage'
];
echo "<form method=\"get\" action=\"conf_params.php\">";
echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
echo "<input type=\"hidden\" name=\"varb\" value=\"debug\">";
echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
$cdebug = $config['debug'] ?? 0;
foreach ($debug as $k => $txt) {
    echo "<option";
    if ($cdebug == $k) {
        echo " selected";
    }
    echo " value = $k>$txt</option>";
}
echo "</select></form>";
echo "</td></tr>\n";

// Cle d'authentification
/*
 * echo "<TR><TD>Clé d'authentification</TD><TD align=\"center\">";
 * echo "<u onmouseover=\"return escape('La clé d\'authentification correspond à la clé de cryptage entre le serveur Se4 et le navigateur, pour le cryptage des échanges.<br>Par défaut, tous les serveurs ont la même clé, cliquer ici pour la modifier.<br>Ne pas oublier de vider votre navigateur pour pouvoir vous reconnecter.')\">";
 * echo "<a href=setup_keys.php?cat=2><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
 * echo "</u>";
 * echo "</td></tr>\n";
 */

// Gestion des comptes utilisateur
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo "Configuration des comptes utilisateurs";
echo "</TD></TR>\n";

// cnPolicy
echo "<TR><TD>Format des logins</TD><TD align=\"center\">";
if ($action == "modif_uidP") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"cnPolicy\">";
    echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
    // echo "<option"; if ($cnPolicy=="0") { echo " selected"; } echo " value=\"0\">prenom.nom</option>";
    echo "<option";
    if ($config['cnPolicy'] == "1") {
        echo " selected";
    }
    echo " value=\"1\">prenom.nom (tronqué à 19)</option>";
    echo "<option";
    if ($config['cnPolicy'] == "2") {
        echo " selected";
    }
    echo " value=\"2\">p.nom (tronqué à 15)</option>";
    echo "<option";
    if ($config['cnPolicy'] == "3") {
        echo " selected";
    }
    echo " value=\"3\">pnom (tronqué à 8)</option>";
    echo "<option";
    if ($config['cnPolicy'] == "4") {
        echo " selected";
    }
    echo " value=\"4\">nomp (tronqué à 8)</option>";
    echo "<option";
    if ($config['cnPolicy'] == "5") {
        echo " selected";
    }
    echo " value=\"5\">nomprenom (tronqué à 18)</option>";
    echo "</select>\n";
    echo "<u onmouseover=\"return escape('Permet de choisir le type de login.<br> Cette option ne modifie pas les comptes existants, mais les comptes qui seront créés.<br><br>Si vous avez un Slis vous devez choisir nomp (tronqué à 8)')\">";
    echo "<img name=\"action_image2\"  src=\"elements/images/system-help.png\" alt=\"Help\">";
    echo "</u></form>";
} else {
    if (! isset($config['cnPolicy']))
        $config['cnPolicy'] = "0";
    if ($config['cnPolicy'] == "0") {
        $uidP = "prenom.nom";
    }
    if ($config['cnPolicy'] == "1") {
        $uidP = "prenom.nom (tronqué à 19)";
    }
    if ($config['cnPolicy'] == "2") {
        $uidP = "p.nom (tronqué à 15)";
    }
    if ($config['cnPolicy'] == "3") {
        $uidP = "pnom (tronqué à 8)";
    }
    if ($config['cnPolicy'] == "4") {
        $uidP = "nomp (tronqué à 8)";
    }
    if ($config['cnPolicy'] == "5") {
        $uidP = "nomprenom (tronqué à 18)";
    }
    echo "<u onmouseover=\"return escape('Permet de modifier le format de login.<br> Ce changement ne modifie pas les comptes déjà créés.<br><br>Les types disponibles sont :<br>prenom.nom<br>prenom.nom (tronqué à 19)<br>pnom (tronqué à 19)<br>pnom (tronqué à 8)<br>nomp (tronqué à 8).<br>nomprenom (tronqué à 18).<br><br>Si vous avez un Slis, vous devez choisir nomp (troqué à 8). ')\">";
    echo "<a href=conf_params.php?action=modif_uidP>$uidP</a>";
    echo "</u>";
}
echo "</td></tr>\n";

// pwdPolicy
echo "<TR><TD>Mots de passe initiaux : permet de choisir la stratégie de création des mots de passe initiaux.<p>
Dans le cas d'une synchronisation ENT, il est très fortement de conseillé de choisir un code d'activation unique, car sinon il sera très difficile
de fournir aux utilisateurs ayant déjà activé leur compte ENT un moyen de se connecter,
car on ne peut pas connaitre leur mot de passe ENT.<p>Les nouveaux utilisateurs ENT auront dans tous les cas comme mot de passe initial
 le code d'activation de l'ent.</TD><TD align=\"center\">";
if ($action == "modif_pwdP") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"pwdPolicy\">";
    echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
    echo "<option";
    if (! isset($config['pwdPolicy']))
        $config['pwdPolicy'] = "0";
    if ($config['pwdPolicy'] == "0" || $config['pwdPolicy'] == "1") {
        if ($ddn) {
            echo " selected";
        }
    }
    if (! $ddn) {
        echo " disabled";
    }
    echo " value=\"1\">basé sur la date de naissance</option>";
    echo "<option";
    echo " value=\"2\"";
    if ($config['pwdPolicy'] == "2") {
        echo " selected";
    }
    echo ">aléatoire ($length car.)</option>";
    echo "<option";
    if ($config['pwdPolicy'] == "3") {
        echo " selected";
    }
    echo " value=\"3\">code d'activation</option>";

    echo "</select>\n";
    if ($config['pwdPolicy'] < 2 && $ddn) {
        if (isset($config['no_passwd_change']) && $config['no_passwd_change'] == "1") {
            echo " <br>Changement de mot de passe non demandé (DANGER) <input type=checkbox name=\"no_passwd_change\" value=\"1\" checked ONCHANGE=\"this.form.submit();\">";
        } else {
            echo " <br>Changement de mot de passe non demandé (DANGER) <input type=checkbox name=\"no_passwd_change\" value=\"1\" ONCHANGE=\"this.form.submit();\">";
        }
    }
    if ($config['pwdPolicy'] == "3") {
        if (! $testcode[0]) {
            echo "<br>" . $testcode[1] . "<br>";
        }
        $config['activation_code'] = $config['activation_code'] ?? "";

        echo " <br><input type=text name=\"activation_code\" value=\"" . $config['activation_code'] . "\" ONCHANGE=\"this.form.submit();\">";
    }
    echo "</form>";
} else {
    if (! isset($config['pwdPolicy']))
        $config['pwdPolicy'] = "0";
    if ($config['pwdPolicy'] == "0" || $config['pwdPolicy'] == "1") {
        $pwdP = "basé sur la date de naissance";
        if (! $ddn) {
            $pwdP .= "<br> Choix Invalide !<br>";
        }
    }
    if ($config['pwdPolicy'] == "2") {
        $pwdP = "aléatoire ($length car.)";
    }
    if ($config['pwdPolicy'] == "3") {
        $config['activation_code'] = $config['activation_code'] ?? "";
        $testcode = verifPwd($config['activation_code'], $length, $complexity);
        if (! $testcode[0]) {
            $pwdP = $testcode[1];
        } else {
            $pwdP = "code d'activation : [" . $config['activation_code'] . "]";
        }
    }
    echo "<u onmouseover=\"return escape('Permet de choisir le format des mots de passe initiaux. ')\">";
    echo "<a href=conf_params.php?action=modif_pwdP>$pwdP</a>";
    echo "</u>";
}
echo "</td></tr>\n";

// longueur password
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo "Longueur mini du mot de passe";
echo "</TD></TR>\n";
echo "<tr><td>La longueur du mot de passe mini doit correspondre à celle utilisée dans votre ENT, ou portail d'authentification unique</td><td align=\"center\">";
if ($action == "pwdlength") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"pwdlength\">";
    echo "<INPUT TYPE=\"text\"  name =\"pwdlength\"  value=\"$length\" \">";
    echo "<button>Valider</button>";
    echo "</form>";
} else {
    echo "<u onmouseover=\"return escape('Longueur mini du mot de passe')\">";
    echo "<a href=conf_params.php?action=pwdlength&amp;valeur=" . $length . ">$length</a>";
}
echo "</td></TR>\n";
// comlexité password
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo "Complexité du mot de passe";
echo "</TD></TR>\n";
echo "<tr><td>Si la complexité est activée, le mot de passe devra comporter au moins 3 catégories sur les 4 : minuscules, majuscules, chiffres et caractères spéciaux (choix conseillé)</td><td align=\"center\">";
echo "<form method=\"get\" action=\"conf_params.php\">";
echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
echo "<input type=\"hidden\" name=\"varb\" value=\"complexity\">";
echo "<select name =\"complexity\" ONCHANGE=\"this.form.submit();\">";
$choix = [
    "on" => "Activé (Conseillé)",
    "off" => "Desactivé"
];
foreach ($choix as $k => $txt) {
    echo "<option";
    if ($rules['complexity'] == $k) {
        echo " selected";
    }
    echo " value = $k>$txt</option>";
}
echo "</select></form>";
echo "</td></TR>\n";
// Configuration du serveur smtp
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo "Configuration de l'expédition des messages système";
echo "</TD></TR>
";
// domaine
echo "<TR><TD>Domaine</TD><TD align=\"center\">";
// if ($config['mail_domain'] == "") {
$config['mail_domain'] = $config['domain'];
// }
if ($action == "modif_domain") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"mail_domain\">";
    echo "<input type=\"text\" name=\"valeur\"  value=\"" . $config['mail_domain'] . "\"><input type=\"submit\" value=\"Ok\"> ";
    echo "<u onmouseover=\"return escape('Indiquer le domaine, qui sera ajouté aux mails. Ce changemant n\'affectera que les nouveaux comptes créés.')\"><img name=\"action_image2\"  src=\"elements/images/system-help.png\" alt=\"Help\"></u>";
    echo "</form>";
} elseif (isset($config['mail_domain'])) {
    echo "<u onmouseover=\"return escape('Nom de domaine utilisé pour les mails.')\">";
    echo $config['mail_domain'];
    echo "</u>";
} else {
    echo "<u onmouseover=\"return escape('Indiquer le domaine, qui sera ajouté aux mails. Ce changemant n\'affectera que les nouveaux comptes créés.')\">";
    echo "<a href=conf_params.php?action=modif_domain><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
    echo "</u>";
}
echo "</td></tr>\n";

// SMTP
echo "<TR><TD>Expédition des messages système</TD><TD align=\"center\">";
if (file_exists("/etc/msmtprc")) {
    echo "<u onmouseover=\"return escape('Permet de configurer l\'expédition des mails, en indiquant le serveur smtp de votre provider.')\">";
    echo "<a href=conf_smtp.php><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
    echo "</u>";
    echo "</form>";
} else {
    echo "<u onmouseover=\"return escape('<b>Attention : </b> Ce serveur ne peut pas envoyer de messages, cela permet d\'être informé d\'un disfonctionnement.<br> Il est souhaitable de le configurer.')\">";
    echo "<a href=conf_smtp.php><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
    echo "</u>";
}
echo "</td></tr>\n";

// Configuration des serveurs
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo "Configuration pour les mises à jour et serveurs internes";
echo "</TD></TR>\n";
// Canal de mise à jour
echo "<TR><TD>Canal de mise à jour SambaÉdu</TD><TD align=\"center\">";
if ($action == "modif_depot") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"depot_type\">";
    echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
    echo "<option";
    if (empty($config['depot_type']) || $config['depot_type'] == "stable") {
        echo " selected";
    }
    echo " value=\"stable\">stable</option>";
    echo "<option";
    if (! empty($config['depot_type']) && $config['depot_type'] == "se4XP") {
        echo " selected";
    }
    echo " value=\"se4XP\">expérimental</option>";
    echo "<option";
    if (! empty($config['depot_type']) && $config['depot_type'] == "irundo") {
        echo " selected";
    }
    echo " value=\"irundo\" disabled>Abonnement</option>";
    echo "</select>\n";
    echo "</form>";
} else {
    switch (@$config['depot_type']) {
        case "se4XP":
            echo "<u onmouseover=\"return escape('<b>Dépôt expériemental, mises à jour très fréquentes et derniers développements.</b><br>')\">";
            echo "<a href=conf_params.php?action=modif_depot>expérimental</a>";
            echo "</u>";
            break;
        case "irundo":
            echo "<u onmouseover=\"return escape <b>Dépôt Entreprise, accessible uniquement avec un abonnement de support auprès d'Irundo.</b><br>\">";
            echo "<a href=conf_params.php?action=modif_depot>irundo</a>";
            echo "</u>";
            break;
        default:
            echo "<u onmouseover=\"return escape('<b>Dépôt stable, celui à utiliser en production</b><br>')\">";
            echo "<a href=conf_params.php?action=modif_depot>stable</a>";
            echo "</u>";
    }
}
echo "</td></tr>\n";

// Adresse du Proxy
echo "<TR><TD>Type du proxy</TD><TD align=\"center\">";
if ($action == "modif_proxy") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"proxy_type\">";
    echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
    echo "<option";
    if (empty($config['proxy_type']) || $config['proxy_type'] == "aucun") {
        echo " selected";
    }
    echo " value=\"aucun\">pas de proxy</option>";
    echo "<option";
    if ($config['proxy_type'] == "manuel") {
        echo " selected";
    }
    echo " value=\"manuel\">proxy manuel pour les clients</option>";
    echo "<option";
    if ($config['proxy_type'] == "automatique") {
        echo " selected";
    }
    echo " value=\"automatique\">autoconfiguration du proxy pour les clients</option>";
    echo "</select>\n";
    if (! empty($config['proxy_type']) && $config['proxy_type'] != "aucun" && $config['proxy_type'] != "automatique") {
        echo "http://<input type=\"text\" name=\"proxy_address\"  value=\"" . $config['proxy_address'] . "\">:";
        echo "<input type=\"text\" name=\"proxy_port\"  value=\"" . $config['proxy_port'] . "\">";
        echo "<input type=\"submit\" value=\"Ok\"><br>";
        if (isset($config['server_proxy']) && $config['server_proxy'] == "1") {
            echo " <br>proxy pour le serveur <input type=checkbox name=\"server_proxy\" value=\"1\" checked >"; // ONCHANGE=\"this.form.submit();\">";
        } else {
            echo " <br>proxy pour le serveur <input type=checkbox name=\"server_proxy\" value=\"1\" >"; // ONCHANGE=\"this.form.submit();\">";
        }
    } elseif (! empty($config['proxy_type']) && $config['proxy_type'] == "automatique") {
        echo "<input type=\"text\" name=\"proxy_url\"  value=\"" . @$config['proxy_url'] . "\">:";
        echo "<input type=\"submit\" value=\"Ok\"><br>";
        if (isset($config['server_proxy']) && $config['server_proxy'] == "1") {
            echo " <br>proxy pour le serveur <input type=checkbox name=\"server_proxy\" value=\"1\" checked >"; // ONCHANGE=\"this.form.submit();\">";
        } else {
            echo " <br>proxy pour le serveur <input type=checkbox name=\"server_proxy\" value=\"1\" >"; // ONCHANGE=\"this.form.submit();\">";
        }
    }
    echo "<u onmouseover=\"return escape('Indiquer, si vous en utilisez un pour vos connexions à internet, le proxy et son port.<br><br>Ex : 172.16.0.1:8080 ')\"><img name=\"action_image2\"  src=\"elements/images/system-help.png\" alt=\"Help\"></u>";
    echo "</form>";
} else {
    switch ($config['proxy_type']) {
        case "manuel":
            echo "<u onmouseover=\"return escape('<b>Etat : Proxy manuel configuré pour les clients</b><br>')\">";
            echo "Manuel : <a href=conf_params.php?action=modif_proxy>http://" . $config['proxy_address'] . ":" . $config['proxy_port'] . " pour les clients";
            if (@$config['server_proxy']) {
                echo "<br>et proxy manuel pour le serveur</a>";
            } else {
                echo "<br>et pas de proxy pour le serveur</a>";
            }
            echo "</u>";
            break;
        case "automatique":
            echo "<u onmouseover=\"return escape('<b>Etat : Proxy automatique configuré pour les clients</b><br>')\">";
            $proxy_url = $config['proxy_url'] ?? "non défini";
            echo "Automatique : <a href=conf_params.php?action=modif_proxy>URI :  " . $proxy_url . " pour les clients";
            if (@$config['server_proxy']) {
                echo "<br>et proxy manuel pour le serveur</a>";
            } else {
                echo "<br>et pas de proxy pour le serveur</a>";
            }
            echo "</u>";
            break;
        default:
            echo "<u onmouseover=\"return escape('<b>Etat : Pas de proxy, connexion directe à internet</b><br><br>Indiquer, si vous en utilisez un pour vos connexions à internet, le proxy et son port.<br><br>Ex : 172.16.0.1:8080 ')\">";
            echo "<a href=conf_params.php?action=modif_proxy><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
            echo "</u>";
            break;
    }
}
echo "</td></tr>\n";

echo "<tr><td>Adresse IP du serveur Amon</td><td align=\"center\">";
$ip_amon = $config['ip_amon'] ?? "";
if ($action == "ip_amon") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"ip_amon\">";
    echo "<INPUT TYPE=\"text\"  name =\"valeur\"  value=\"$ip_amon\" \">";
    echo "<button>Valider</button>";
    echo "</form>";
} else {
    if (! empty($ip_amon)) {
        echo "<u onmouseover=\"return escape('Adresse IP du serveur Amon si existant')\">";
        echo "<a href=conf_params.php?action=ip_amon&amp;valeur=" . $ip_amon . ">$ip_amon</a>";
    } else {
        echo "<u onmouseover=\"return escape('Indiquer l\'adresse IP du serveur Amon si existant afin qu\'il soit utilisé pour le wpad')\">";
        echo "<a href=conf_params.php?action=ip_amon>Pas de serveur Amon</a>";
    }
}
echo "</td></tr>\n";

// Partages
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo "Partages";
echo "</TD></TR>
";

// echo "<tr><td>Purge journalière de la ressource public ") . "</td><td align=\"center\">";
//
// if (isset($config['purge_public'])) {
// echo "<u onmouseover=\"return escape('<b>Etat : Activé</b><br><br>Cliquer ici afin de désactiver la purge automatique du partage public. <br>Cela permet de supprimer automatiquement toutes les nuits les fichiers dans la ressource public.')") . "\">";
// echo "<a href=conf_params.php?action=change&amp;varb=purge_public&amp;valeur=0&amp;cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
// } else {
// echo "<u onmouseover=\"return escape('<b>Etat : Désactivé</b><br><br>Cliquer ici afin d\'activer une purge automatique de la ressource public.')") . "\">";
// echo "<a href=conf_params.php?action=change&amp;varb=purge_public&amp;valeur=1&amp;cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
// }
//
// echo "</td></tr>\n";

echo "<tr><td>Autoriser l'accès à la ressource public</td><td align=\"center\">";
if (! isset($config['autoriser_part_pub']))
    $config['autoriser_part_pub'] = "n";
if ($config['autoriser_part_pub'] == "y") {
    echo "<u onmouseover=\"return escape('<b>Etat : Activé</b><br><br>Cliquer ici afin de d\'interdire l\'accès au dossier /var/sambaedu/Docs/public')\">";
    echo "<a href=conf_params.php?action=change&amp;varb=autoriser_part_pub&amp;valeur=n&amp;cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
} else {
    echo "<u onmouseover=\"return escape('<b>Etat : Désactivé</b><br><br>Cliquer ici afin de d\'autoriser l\'accès au dossier /var/sambaedu/Docs/public')\">";
    echo "<a href=conf_params.php?action=change&amp;varb=autoriser_part_pub&amp;valeur=y&amp;cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
}

echo "</td></TR>\n";
echo "<tr><td>Autoriser l'écriture dans install</td><td align=\"center\">";
if (read_smb_conf()['install']['read only'] == "no") {
    echo "<u onmouseover=\"return escape('<b>Etat : Activé</b><br><br>Cliquer ici afin d\'interdire l\'accès en écriture pour admin au dossier install')\">";
    echo "<a href=conf_params.php?action=change&varb=admin_w&valeur=n&cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
} else {
    echo "<u onmouseover=\"return escape('<b>Etat : Désactivé</b><br><br>Cliquer ici afin d\'autoriser l\'écriture pour admin dans le dossier install')\">";
    echo "<a href=conf_params.php?action=change&amp;varb=admin_w&amp;valeur=y&amp;cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
}

echo "</td></TR>\n";

// UAI
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo "Informations sur l'établissement";
echo "</TD></TR>\n";
echo "<tr><td>Merci de préciser l'UAI de l'établissement.
        Cette information nous permet d'envoyer des alertes de sécurité aux établissements. <br />
        Indiquer 0000000X pour un serveur de test ou un établissement sans UAI. <br /></td><td align=\"center\">";
$UAI = $config['UAI'] ?? "";
if ($action == "UAI") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"UAI\">";
    echo "<INPUT TYPE=\"text\"  name =\"valeur\"  value=\"$UAI\" \">";
    echo "<button>Valider</button>";
    echo "</form>";
} else {
    if (! empty($UAI)) {
        echo "<u onmouseover=\"return escape('Merci d\'indiquer l\'UAI de l\'établissement')\">";
        echo "<a href=conf_params.php?action=UAI&amp;valeur=" . $UAI . ">$UAI</a>";
    } else {
        echo "<u onmouseover=\"return escape('Merci d\'indiquer l\'UAI de l\'établissement')\">";
        echo "<a href=conf_params.php?action=UAI>UAI de la forme NNNNNNNX</a>";
    }
}
echo "</td></TR>\n";

echo "<tr><td>Nom de l'établissement. <br />
Dans le cas d'un établissement sans UAI, merci de préciser son nom.</td><td align=\"center\">";
$etab_name = $config['etab_name'] ?? "";
if ($action == "etab_name") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"etab_name\">";
    echo "<input TYPE=\"text\" name =\"valeur\"  value=\"$etab_name\" \">";
    echo "<button>Valider</button>";
    echo "</form>";
} else {
    if (! empty($etab_name)) {
        echo "<u onmouseover=\"return escape('Nom de votre établissement')\">";
        echo "<a href=conf_params.php?action=etab_name&amp;valeur=" . $etab_name . ">$etab_name</a>";
    } else {
        echo "<u onmouseover=\"return escape('Merci d\'indiquer le nom de l\'établissement')\">";
        echo "<a href=conf_params.php?action=etab_name>Merci d'indiquer le nom de l'établissement</a>";
    }
}
echo "</td></TR>\n";

/*
 * Mail de contact (alertes de sécurité)
 */
echo "<tr><td>Mail de contact<br/>
Cette adresse sera utilisée en cas d'alerte de sécurité par exemple.</td><td align=\"center\">";
$mail_alert = $config['mail_alert'] ?? "";
if ($action == "mail_alert") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"mail_alert\">";
    echo "<INPUT TYPE=\"text\"  name =\"valeur\"  value=\"$mail_alert\" \">";
    echo "<button>Valider</button>";
    echo "</form>";
} else {
    if (! empty($mail_alert)) {
        echo "<u onmouseover=\"return escape('Mail de contact')\">";
        echo "<a href=conf_params.php?action=mail_alert&amp;valeur=" . $mail_alert . ">$mail_alert</a>";
    } else {
        echo "<u onmouseover=\"return escape('Merci d\'indiquer le mail de contact.')\">";
        echo "<a href=conf_params.php?action=mail_alert>Merci d'indiquer le mail de contact.</a>";
    }
}
echo "</td></TR>\n";

echo "</table></center>";

$html = "";
admin_footer_html($html);
echo $html;
?>