<?php

/**
 * Permet de configurer le smtp pour expedier les messages msmtp
 * @Version $Id$
 * @Projet SambaEdu
 * @auteurs Équipe SambaEdu
 * @Licence Distribue selon les termes de la licence GPL
 * @note
 */

/**
 *
 * @Repertoire: /
 * file: conf_smtp.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include_once "ldap.inc.php";
include "ihm.inc.php";


/**
 * Fonction pour obtenir les valeurs deja definies dans msmtp.conf
 *
 * Retourne la valeur de name contenue dans msmtp.conf
 *
 * @Parametres $name
 * @return $var
 */
function variable($Name)
{ // retourne la valeur de Name
    $fichier_conf = "/etc/msmtprc";
    if (file_exists("$fichier_conf")) {
        $lignes = file("$fichier_conf");
        foreach ($lignes as $num => $ligne) {
            if (preg_match("/$Name (.*)/", $ligne, $reg)) {
                $var = trim($reg[1]);
                // var_dump($var);
                return $var;
            }
        }
    }
} // fin function

echo "<H1>Configure le SMTP</H1>\n";


$action = $_POST['action'] ?? $_GET['action'] ?? "";

$dc_from = $_GET['dc_from'] ?? "";
$dc_domain = $_GET['dc_domain'] ?? "";
$dc_root = $_GET['dc_root'] ?? "";
$dc_host = $_GET['dc_host'] ?? "";
$dc_host_port = $_GET['dc_host_port'] ?? "";
$dc_AuthUser = $_GET['dc_AuthUser'] ?? "";
$dc_AuthPass = $_GET['dc_AuthPass'] ?? "";
$dc_UseTLS = $_GET['dc_UseTLS'] ?? "";
$dc_UseSTARTTLS = $_GET['dc_UseSTARTTLS'] ?? "";
$dc_CertCheck = $_GET['dc_CertCheck'] ?? "";

if (! have_right($config, SE_ADMIN)) {
    die("Vous n'avez pas les droits suffisants pour accéder à cette fonction</BODY></HTML>");
}
$fichier_conf = "/etc/msmtprc";
if (! file_exists($fichier_conf)) {
    system("sudo touch $fichier_conf");
}
system("sudo chown www-admin $fichier_conf");
system("sudo chmod 640 $fichier_conf");

$file_alias = "/etc/aliases";
if (! file_exists($file_alias)) {
    system("sudo touch $file_alias");
}
system("sudo chown www-admin $file_alias");
system("sudo chmod 640 $file_alias");

// Creation du fichier de conf de msmtp et /etc/aliases
if ($action == "msmtp_mod") {
    if ($dc_from == "" || $dc_host == "" || $dc_root == "") {
        echo "<div class='alert_msg'>Un paramètre est manquant !</div>";
    } else {

        $fp = fopen("$file_alias", "w+");
        $DEFAUT = "# Genere par l'interface de Se4fs
root: $dc_root
default: $dc_root
";
        fwrite($fp, $DEFAUT);
        fclose($fp);

        $fp = fopen("$fichier_conf", "w+");
        $DEFAUT = "
# Genere par l'interface de Se4fs
defaults
account default
host $dc_host
port $dc_host_port
from $dc_from
domain $dc_domain
aliases /etc/aliases

";
        if ($dc_AuthUser != "") {
            $DEFAUT .= "auth on
    ";
            $DEFAUT .= "user $dc_AuthUser
    ";
        }
        if ($dc_AuthPass != "")
            $DEFAUT .= "password $dc_AuthPass
    ";
        if ($dc_UseTLS == "YES")
            $DEFAUT .= "tls on
    ";
        if ($dc_UseSTARTTLS == "NO") {
            $DEFAUT .= "tls_starttls off
    ";
        } else {
            $DEFAUT .= "tls_starttls on
    ";
        }
        if ($dc_CertCheck == "NO")
            $DEFAUT .= "tls_certcheck off
    ";

        fwrite($fp, $DEFAUT);
        fclose($fp);

        $subject = "Test de la configuration de votre serveur SE4FS";
        $message = "Message envoyé par le serveur SE4FS";
        mail($dc_root, $subject, $message);
        echo "";
        $html = "<div class='text'>Configuration enregistrée !<br>";
        $html .= "Un mail de test a été envoyé à $dc_root";
        $html .= "</div>\n";
        echo "$html";
    }
    unset($action);
}

// test la presence du paquet
$msmtp = exec("dpkg -l | grep msmtp-mta > /dev/null && echo ok");
// Si deja installe
if ($msmtp == "ok") {

    $link_mail = "/usr/bin/mail";
    if (! file_exists($link_mail)) {
        system("sudo ln -s /usr/bin/msmtp $link_mail");
    }
    echo "<form method=\"get\" action=\"conf_smtp.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"msmtp_mod\">";
    echo "<br><br>";
    echo "<table align=center width=\"80%\" class='table-bordered' cellspacing=\"0\" cellpadding=\"0\" >\n";
    echo "<tr><td colspan=\"3\" align=\"center\"  class=\"menuheader\" height=\"30\">Configuration de la messagerie</td></tr>\n";
    $dc_domain = variable("domain");
    if ($dc_domain == "") {
        $dc_domain = exec("hostname -d");
    }
    $dc_from = variable("from");
    // if ($dc_from == "") {
    // $dc_from = "root@"."$dc_domain";
    // }

    echo "<tr>";
    echo "<td>Domaine :</td>";

    echo "<td><input name=\"dc_domain\" type=\"text\" size=\"40\" value=\"$dc_domain\"  ></td>\n";
    echo "<td align=\"center\"><u onmouseover=\"return escape('Indiquer ici le domaine de votre établissement. Par exemple lycée.ac-académie.fr<br>Si vous n\'avez pas d\'IP fixe vous ne possédez pas de domaine, vous risquez alors de ne pas pouvoir envoyer de messages<br>')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>&nbsp;</td>";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "<td>Serveur SMTP :</td>";
    $dc_host = variable("host");
    echo "<td><input name=\"dc_host\" type=\"text\" size=\"40\" value=\"$dc_host\"  ></td>\n";
    echo "<td align=\"center\"><u onmouseover=\"return escape('Indiquer ici le serveur qui vous permet d\'expédier les messages.<br><br> En général, il s\'agira du smtp de votre provider. (smtp.free.fr par exemple). ')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>&nbsp;</td>";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "<td>Port du serveur SMTP :</td>";
    $dc_host_port = variable("port");
    echo "<td><input name=\"dc_host_port\" type=\"text\" size=\"40\" value=\"$dc_host_port\"  ></td>\n";
    echo "<td align=\"center\"><u onmouseover=\"return escape('Indiquer ici le port du serveur qui vous permet d\'expédier les messages.<br>Généralement 25, 465 ou 587')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>&nbsp;</td>";
    echo "</tr>\n";

    echo "<tr>";
    echo "<td>Adresse expéditeur utilisée par le smtp :</td>";
    echo "<td><input name=\"dc_from\" type=\"text\" size=\"40\" value=\"$dc_from\"  ></td>\n";
    echo "<td align=\"center\"><u onmouseover=\"return escape('Indiquer ici l\'adresse mail qui sera utilisé pour le smtp. Il est impératif que les deux soient en concordance<br>Si vous n\'avez pas d\'IP fixe vous ne possédez pas de domaine, vous risquez alors de ne pas pouvoir envoyer de messages<br>')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>&nbsp;</td>";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "<td>Identifiant de connexion au smtp (si nécessaire) :</td>";
    $dc_AuthUser = variable("user");
    echo "<td><input name=\"dc_AuthUser\" type=\"text\" size=\"40\" value=\"$dc_AuthUser\"  ></td>\n";
    echo "<td align=\"center\"><u onmouseover=\"return escape('Indiquer ici l\'identifiant de connexion au smtp.')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>&nbsp;</td>";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "<td>Mot de passe de connexion au smtp (si nécessaire) :</td>";
    $dc_AuthPass = variable("password");
    echo "<td><input name=\"dc_AuthPass\" type=\"password\" size=\"40\" value=\"$dc_AuthPass\"  ></td>\n";
    echo "<td align=\"center\"><u onmouseover=\"return escape('Indiquer ici le mot de passe de connexion au smtp.')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>&nbsp;</td>";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "<td>Utiliser le mode sécurisé TLS :</td>";
    $dc_UseTLS = variable("tls");
    echo "<td><select name=\"dc_UseTLS\">";
    echo "<option value=\"NO\">Non</option>";
    echo "<option value=\"YES\"";
    if ($dc_UseTLS == "on")
        echo " selected";
    echo ">Oui</option>";
    echo "</select></td>\n";
    echo "<td align=\"center\"><u onmouseover=\"return escape('A utiliser en cas de mode sécurisé')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>&nbsp;</td>";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "<td>Utiliser le mode sécurisé STARTTLS :</td>";
    $dc_UseSTARTTLS = variable("tls_starttls");
    echo "<td><select name=\"dc_UseSTARTTLS\">";
    echo "<option value=\"NO\">Non</option>";
    echo "<option value=\"YES\"";
    if ($dc_UseSTARTTLS == "on")
        echo " selected";
    echo ">Oui</option>";
    echo "</select></td>\n";
    echo "<td align=\"center\"><u onmouseover=\"return escape('A utiliser en cas de mode sécurisé')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>&nbsp;</td>";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "<td>Vérifer le certificat du serveur SMTP :</td>";
    $dc_CertCheck = variable("tls_certcheck");
    echo "<td><select name=\"dc_CertCheck\">";
    echo "<option value=\"NO\">Non</option>";
    echo "<option value=\"YES\"";
    if ($dc_CertCheck == "")
        echo " selected";
    echo ">Oui</option>";
    echo "</select></td>\n";
    echo "<td align=\"center\"><u onmouseover=\"return escape('A utiliser en cas de mode sécurisé')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>&nbsp;</td>";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "<td>Boite de réception :</td>";
    $lignes = file("$file_alias");
    foreach ($lignes as $ligne) {
        // var_dump($ligne);
        if (preg_match("/root: (.*)/", $ligne, $reg)) {
            $dc_root = trim($reg[1]);
            // var_dump($root_mail);
        }
    }

    echo "<td><input name=\"dc_root\" type=\"text\" size=\"40\" value=\"$dc_root\" ></td>";
    echo "<td align=\"center\"><u onmouseover=\"return escape('Indiquer l\'adresse qui va recevoir les mails générés par le système.')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u>&nbsp;</td>";
    echo "</tr>\n";
    echo "</table>\n";
    echo "<br><br>";
    echo "<center><input type=\"submit\"  value=\"Valider\"></center>";
    echo "</form>\n";
} else {
    echo "Le paquet msmtp ne semble pas installé sur la machine";
    echo "<BR><BR>";
    echo "Vous devez d'abord exécuter sur le serveur un apt-get install msmtp";
}

$html = "";
admin_footer_html($html);
echo $html;
?>