<?php
/*
 * génération d'un fichier applications-$action.cmd, qui est lancé depuis la gpo "se4_applications" qui execute un script au startup/logon/logoff/shutdown
 *
 * curl.exe -F "os=windows" -F "action=$action" -F "user=%username%" -F "machine=%computername%" "http://###_SE4FS_NAME_###/gpo/applications.php">%windir%\applications-$action.cmd
 * if exist %windir%\applications-$action.cmd (call %windir%\applications-$action.cmd)
 *
 * on passe le nom de la machine le script et user, et on récupère un fichier cmd ou bash qui est exécuté au boot ou a l'ouverture de session
 *
 */
// génération des scripts à exécuter pour la configuration des applications.
// on génere un script à partir des modèles dans /etc/sambaedu/applications/* (personnalisations locales) ou /usr/share/sambaedu/applications/* (scripts de la distrib). Le local est prioritaire.
// windows : $action.windows
// linux : $action.linux
// les modèles peuvent contenir des substitutions de variables de conf : ###_PARAMETRE_###, ils seront remplacés automatiquement
// pour les scripts dans /etc/ il est possible de passer un nom, groupe, parc, machine : startup@parc.linux par exemple
// bien evidemment seuls les parcs seront pris en compte lors du statup, vu qu'il n'y a pas de user à ce stade.
//
// Les scripts générés sont typiquement utilisés pour DL des fichiers de conf, et le copier au bon endroit
//
require "config.inc.php";
$config = get_config();
require_once ("traitement_data.inc.php");

require "ldap.inc.php";
require "logs.inc.php";
require "remote.inc.php";
require "applications.inc.php";

$conf = HTMLPurifier_Config::createDefault();
$purifier = new HTMLPurifier($conf);
$machine = $_POST['machine'] ?? $_GET['machine'] ?? "";
$action = $_POST['action'] ?? $_GET['action'] ?? "";
$os = $_POST['os'] ?? $_GET['os'] ?? "windows";
$uuid = $_POST['uuid'] ?? $_GET['uuid'] ?? "";
$speed = $_POST['speed'] ?? $_GET['speed'] ?? 100000000;
if ($speed < 100000000) {
    $s = SAMBAEDU_SLOW_NET_ERROR;
} else {
    $s = 0;
}

$uuid = trim(strtolower($uuid));
$user = $_POST['user'] ?? $_GET['user'] ?? "";
$id = $_POST['id'] ?? $_GET['id'] ?? "";
$ret = $_POST['ret'] ?? $_GET['ret'] ?? "1";
$userprofile = $_POST['userprofile'] ?? $_GET['userprofile'] ?? "";
$application = $_POST['application'] ?? $_GET['application'] ?? "";
$action = $purifier->purify($action);
$os = $purifier->purify($os);
$user = $purifier->purify($user);
$machine = strtolower($purifier->purify($machine));
$machine = preg_replace("/^l-/", "", $machine);
$mcn = $machine;
if ($action == "logout")
    $action = "logoff";

$scripts = $scripts_server = [];

if ($action == "logon-system" || $action == "logoff-system") {
    // if (preg_match("/[A-Z0-9-]*\$$/", $user)){
    // exit();
    // }
    if (empty($machine)) {
        // ne devrait jamais se produire, mais cela semble arriver...
        $out = "rem oups appel sans arguments !\r
exit 1\r
";
        echo $out;
        file_put_contents("/tmp/applications-$action-error-last.log", $out);
        exit();
    }
    // if (apcu_fetch($action . "." . $machine . "." . $user)) {
    // protection contre des lancements intempestifs
    // file_put_contents("/tmp/applications-$action-error1-last.log", "erreur 75");
    // exit();
    // } else {
    apcu_store($action . "." . $machine . "." . $user, $action, 300);
    // }
    $scripts['system'] = [
        local_admin($config, $user, $machine, $action, $os)
    ];
}
if ($ret != "0") {
    $id = get_app_scripts_info($config, $user, $userprofile, $machine, $action, $os, $id);
}
if (! empty($id)) {

    $packages = "";
    $info = apcu_fetch("apps." . $id);
    if (! $info) {
        file_put_contents("/tmp/applications-error.log", $action . " : " . $machine . " " . $user . " " . $id . " expiré. ", FILE_APPEND);
        exit();
    }
    $user = $info['user'];
    $userprofile = $info['userprofile'];
    $machine = $info['machine'];
    $list = $info['list'];
    $liste_applications = $info['liste_applications'];
    $u = $user['cn'] ?? "";
    $config['user'] = $user['cn'] ?? "";
    $machine['cn'] = $machine['cn'] ?? $mcn;
    $config['machine'] = $machine['cn'];
    if ($action == "shutdown" || $action == "logoff") {
        delete_remote_connexion($config, $machine['cn']);
    } elseif ($action == "startup" && ($os == "linux" || $os == "windows") && ! in_array($os, get_os($config, $machine))) {
        set_os($config, $machine['cn'], $os);
    }
    if (empty($machine['iphostnumber'])) {
        $machine['iphostnumber'] = $_SERVER['REMOTE_ADDR'];
    }
    // logs
    $err = [
        'startup' => SAMBAEDU_STARTUP_APP_ERROR,
        'shutdown' => SAMBAEDU_SHUTDOWN_APP_ERROR,
        'logon' => SAMBAEDU_LOGON_APP_ERROR,
        'logoff' => SAMBAEDU_LOGOFF_APP_ERROR,
        'logon-system' => SAMBAEDU_LOGON_SYS_APP_ERROR,
        'logoff-system' => SAMBAEDU_LOGOFF_SYS_APP_ERROR,
        'wpkg' => SAMBAEDU_WPKG_ERROR
    ];
    if ($ret == "0") {
        // fin d'exec des scripts
        if ($action != "wpkg") {
            if (! empty($uuid)) {
                register_machine_hardware($config, $machine, $uuid);
            }
            log_connexion($config, $u, $machine['cn'], $os, $action, "", $err[$action], true);
        }
        if (empty($u)) {
            $u = $machine['cn'];
        }
        // effacement de l'id
        if ($action == "shutdown" || $action == "logoff") {
            apcu_delete($action . "." . $machine['cn'] . "." . $u);
            apcu_delete("apps." . $id);
        }
        // file_put_contents("/tmp/applications-$action-clear.log", $machine . " " . $id . " fini. ", FILE_APPEND);
        exit();
    } elseif ($action == "startup" && $os == "linux") {
        // dns_add_ptr($config, $machine['cn'], $_SERVER["REMOTE_ADDR"]);
    }
    if ($action != "wpkg") {
        // log de l'evenement, et on ajoute l'erreur réseau lent dans tous les cas si présente.
        log_connexion($config, $u, $machine['cn'], $os, $action, $machine['iphostnumber'], $err[$action] | $s);
    }
    // redirections de profil
    gen_redirect_scripts($action, $list, $liste_applications, $os, $scripts, $u, $userprofile);
    // scripts officiels sambaedu
    gen_scripts(false, $action, $list, $liste_applications, $os, $scripts, $scripts_server, $packages, $application, $userprofile);

    // personnalisations locales si besoin
    gen_scripts(true, $action, $list, $liste_applications, $os, $scripts, $scripts_server, $packages, $application, $userprofile);

    $out = [];
    foreach ($scripts_server as $name => $script) {
        $out = array_merge($out, separe_scripts($os, $name), $script);
    }
    if (empty($config['cloud_perso_name'])) {
        $config['cloud_perso_name'] = "Mes Documents";
    }
    write_param($config, $out);
    $tmpfile = sys_get_temp_dir() . "/" . hash("md5", $action) . "-" . microtime();
    $script = "#!/bin/bash";
    $script .= implode("", $out);
    file_put_contents($tmpfile, $script);
    exec("chmod +x " . $tmpfile);
    exec("sudo " . $tmpfile);
    unlink($tmpfile);

    $out = [];
    if (! empty($packages) && $os == "linux") {
        $out = [
            "local_packages=\"" . trim($packages) . "\"\n"
        ];
    }
} else {
    $out = [];
    $packages = "";
    $id = "";
    $u = $user;
}
if ($os == "windows" && $action == "startup") {
    $header = [
        'windows' => "rem cmd\r\nrem " . $action . "\r
rem script de configuration des applications windows\r
set TAG=" . $info['salle'] . "," . $config['UAI'] . "\r
for /f \"skip=1 delims=\" %%s in ('\"wmic nic where NetEnabled=true get speed\"') do (set SPEED=%%s
goto speed)\r
:speed\r
for /f \"skip=1 delims=$\" %%f in ('\"wmic path win32_computersystemproduct get uuid\"') do (set UUID=%%f
goto uuid)\r
:uuid\r
set id=" . $id . "\r
if [%SE4FS%]==[] (set SE4FS=" . $config['se4fs_name'] . "\r
setx SE4FS " . $config['se4fs_name'] . " /m)\r\n"
    ];
} else {
    $header = [
        'windows' => "rem cmd\r\nrem " . $action . "\r
rem script de configuration des applications windows profile=" . $userprofile . "\r
set id=" . $id . "\r
if [%SE4FS%]==[] (set SE4FS=" . $config['se4fs_name'] . ")\r\n",
        'linux' => "#!/bin/bash\n#" . $action . "\n# script de configuration des applications Linux\nid=" . $id . "\n"
    ];
    // if ($action == "logon"){
    // $header['windows'] .= "schtasks /run /I /tn logon-system\r\n";
    // }
}
$footer = [
    'windows' => "\r\ncurl -F \"os=" . $os . "\" -F \"uuid=%UUID%\" -F \"speed=%SPEED%\" -F \"id=$id\" -F \"action=" . $action . "\" -F \"ret=0\"  \"http://" . $config['se4fs_name'] . "/gpo/applications.php\">NUL\r
exit /b\r\n",
    'linux' => "\n/usr/bin/curl -s -F \"id=$id\" -F \"action=" . $action . "\" -F \"os=" . $os . "\" -F \"ret=0\" http://" . $config['se4fs_name'] . "." . $config['domain'] . "/gpo/applications.php\n"
];

if ($os == "linux" && ($action == "logon" || $action == "logoff")) {
    $scripts['sudo'] = [
        "sudo /usr/share/sambaedu/scripts/system_script " . $action . "-system\n"
    ];
}

foreach ($scripts as $name => $script) {
    $out = array_merge($out, separe_scripts($os, $name), $script);
}
write_param($config, $out);

$out = $header[$os] . implode("", $out);
$out .= $footer[$os];

if ($os == "windows") {
    $out = preg_replace("/:: /", "REM ", $out);
}

echo $out;
if (empty($u)) {
    $u = $machine['cn'] ?? $mcn;
}
file_put_contents("/tmp/applications-$action-$u-last.log", $out);
?>
