<?php

function admin_header_html($config, &$html, $checks = false)
{
    $wait = false;
    $_SESSION['current'] = basename($_SERVER['PHP_SELF']);
    $_SESSION['query'] = $_SERVER['QUERY_STRING'];
    $html .= '
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <title>Interface d\'administration ' . replace_element($config, "SambaEdu", "SambaÉdu") . '</title>
    <style type="text/css">
        body {
            background: url(' . replace_element($config, "LogoFond", "/elements/images/fond_SE4.png") . ') #f0f1f6 bottom right no-repeat fixed;
        }
    </style>
';

    if ($checks) {
        check_ad($config);
        check_system_accounts($config);
        $wait = configure_fpm($config);
        if ($wait) {
            $html .= "<meta http-equiv=\"refresh\" content=\"120;URL=index.php\">";
        }

        $nologin = "/etc/nologin";
        if (! file_exists($nologin)) {
            exec("sudo touch $nologin");
            exec("sudo chattr +i $nologin");
        }

        $acls = array(
            "user::rwx",
            "group::rwx",
            "group:domain\\040admins:rwx",
            "mask::rwx",
            "other::r-x",
            "default:user::rwx",
            "default:group::rwx",
            "default:group:domain\\040admins:rwx",
            "default:mask::rwx",
            "default:other::r-x"
        );
        create_dir_acls("/var/sambaedu/Docs", "admin", $acls);
        create_dir_acls("/var/sambaedu/Classes", "www-admin", $acls);
        create_dir_acls("/var/sambaedu/Progs", "admin", $acls);
        create_dir_acls("/var/sambaedu/Progs/ro", "admin", $acls);

        $replacements = array(
            'default:other::r-x' => 'default:other::rwx'
        );

        foreach ($acls as $key => $value) {
            if (isset($replacements[$value])) {
                $acls[$key] = $replacements[$value];
            }
        }
        create_dir_acls("/var/sambaedu/Progs/rw", "admin", $acls);
    }
    /*
     * nécessite bootstrap
     */
    $html .= '
<link type="text/css" rel="stylesheet" href="/vendor/twbs/bootstrap/dist/css/bootstrap.min.css">
<script src="/vendor/twbs/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
<link type="text/css" rel="stylesheet" href="/elements/style_sheets/sambaedu.css"/>
<link type="text/css" rel="stylesheet" href="../vendor/fortawesome/font-awesome/css/all.min.css" />
';

    $html .= '
</head>
<body>
';

    if ($wait) {
        $html .= "<img src=\"../elements/images/travaux2.png\" width=\"50\" height=\"50\">";
        $html .= "<h1>Le serveur demandé est en cours de configuration, veuillez patienter deux minutes...</h1>";
        admin_footer_html($html, false);
        exit();
    }
}

function admin_topbar_html($config, &$html)
{
    $LogoNormal = replace_element($config, "LogoNormal", "/elements/images/logo-normal.gif");
    $html .= '
<!-- Topbar -->
<nav class="navbar navbar-expand navbar-light topbar mb-0 static-top shadow" style="background:#20293b;">
        
    <a href="https://www.sambaedu.org/" target="_blank">
        <img name="logo" src="' . $LogoNormal . '" border="0" alt="logo" style="max-width:90%;  height:90%;"/>
    </a>
            
        <!-- Topbar Navbar -->
        <ul class="navbar-nav mx-auto" >
            <li class="nav-item dropdown no-arrow mx-auto">
                <a href="https://www.sambaedu.org/-La-documentation-" target="_blank" title="Consulter la documentation">
                    <span class="topbar-icon fa-solid fa-book fa-2x mx-3 "></span>
                </a>
            </li>
            <li class="nav-item dropdown no-arrow mx-auto">
                <a href="https://www.sambaedu.org/Les-canaux-de-communication" target="_blank" title="Nous contacter">
                    <span class="topbar-icon fa-solid  fa-2x  fa-handshake-angle  mx-3"></span>
                </a>
            </li>
            <li class="nav-item dropdown no-arrow mx-auto">
                <a href="../user/index.php" TARGET="_blank" title="Interface utilisateur">
                    <span class="topbar-icon  fa fa-2x fa-user menu_icon mx-3"></span>
                </a>
            </li>
			<li class="nav-item dropdown no-arrow mx-auto">
                <a href="../logout.php" title="Se déconnecter">
                    <span class="topbar-icon fa-solid  fa-2x  fa-right-from-bracket  mx-3"></span>
                </a>
            </li>
        </ul>
</nav>
';
}

/*
 * Menu accordéon en CSS+JS avec Bootstrap et Collapse
 * nécessite : composer require twbs/bootstrap
 */
function menu_css($config, &$html, $refresh = false)
{
    $URI = trim($_SERVER['REQUEST_URI'], "/");
    $URI = preg_replace('/\?+.*/', '', $URI);
    $login = $config['login'];
    if (empty($config['etab_ou'])) {
        if (empty($_SESSION['etab_ou'])) {
            $root_path = "/";
        } else {
            $root_path = "/" . $_SESSION['etab_ou'] . "/";
        }
    } else {
        $root_path = "/" . $config['etab_ou'] . "/";
    }
    $liens = array(
        0
    );
    require_once ("menu.inc.php");
    $rights = list_rights($config, $config['login'], true, true);
    $getintlevel = getintlevel();
    $html .= '
<div id="menu" style="position:absolute; left: 0px; top: max(100px, 10%); width: max(150px, 15%);">
';
    $html .= '
    <div class="accordion" id="accordionMenu">
';
    foreach ($liens as $menu => $cle) {
        $rightname = $cle['right'] ?? SE_NO_RIGHT;
        $level = $cle['level'] ?? 4;
        if (isset($cle['text']) && ($rightname == SE_NO_RIGHT || (~ $rights & $rightname) == 0) && $level <= $getintlevel) {
            // print_r($cle['sub']);
            $active = false;
            if (! empty(preg_grep('|' . preg_quote($URI) . '|', array_column($cle['sub'], 'link')))) {
                $active = true;
                $collapsed = "";
                $expanded = "true";
                $show = "show";
            } else {
                $collapsed = "collapsed";
                $expanded = "false";
                $show = "";
            }
            $html .= '
        <div class="accordion-item">
            <h2 class="accordion-header" id="panelsStayOpen-heading' . $menu . '">
                <button class="accordion-button ' . $collapsed . '" type="button" data-bs-toggle="collapse" data-bs-target="#panelsStayOpen-collapse' . $menu . '" aria-expanded="' . $expanded . '" aria-controls="panelsStayOpen-collapse' . $menu . '">
                    ' . $cle['text'] . '
                </button>
            </h2>
';
            $html .= '
            <div id="panelsStayOpen-collapse' . $menu . '" class="accordion-collapse collapse ' . $show . '" aria-labelledby="panelsStayOpen-heading' . $menu . '">
                <div class="accordion-body">
';
            foreach ($cle['sub'] as $values) {
                // ajouter active à la classe pour une surbrillance
                if (($values['right'] == SE_NO_RIGHT || (~ $rights & $values['right']) == 0) && $values['level'] <= $getintlevel) {
                    $active = "";
                    if ($values['link'] == $URI) {
                        $active = "active";
                    }
                    $html .= '
                    <a class="list-group-item list-group-item-action small ' . $active . '" href="' . $root_path . $values['link'] . '">' . $values['text'] . '</a>
';
                }
            }
            $html .= '
                </div>
            </div>
        </div>';
        }
    }
    $html .= '
    </div>
';
    $html .= '
</div>
';

    $html .= '
<script type="text/javascript" src="../javascript/jquery/jquery.min.js"></script>
';
    // if (isset($config['ent_type']) && $config['ent_type'] == "openent") {
    // require_once 'ent.inc.php';
    // $html .= ask_ent_mfa_code($config);
    // }
    if (! isset($config['UAI']) || ! preg_match('/^\d{7}[A-Z]$/i', $config['UAI'])) {
        $html .= '
<script type="text/javascript">
    var UAI = prompt("Merci d\'indiquer l\'UAI de votre établissement.\nEntrer 0000000X pour les serveurs de test ou sans UAI.\nDans ce cas, merci de préciser le nom de votre établissement dans la page « Paramètres serveur »");
    $.ajax(
    {
        type: "GET",
        url: "../conf_params.php",
        data: {
                "action":"change",
                "varb":"UAI",
                "valeur":UAI
            },
        success: function(data)
        {
            alert("Paramétrage de l\'UAI OK");
        }
    });
</script>
';
    }

    $html .= '
<script type="text/javascript">
    function getconfirm() {
        if(confirm("Confirmez-vous la suppression ?")) {
            return true;
        } else {
            return false;
        }
    }
    function getconfirm_all() {
        if(confirm("ATTENTION, en supprimant un utilisateur de son groupe principal, \nil est supprimé de tous les autres groupes !! \nConfirmez-vous la suppression ?")) {
            return true;
        } else {
            return false;
        }
    }
    function getformatconfirm() {
        if(confirm("Confirmez-vous le formatage ? (cela peut etre long)")) {
            return true;
        } else {
            return false;
        }
    }
    function getlongconfirm() {
        if(confirm("Cette operation peut etre longue...")) {
            return true;
        } else {
            return false;
        }
    }
    function popuprecherche(page,nom,option){
       window.open(page,nom,option);
    }
    function Reporter(l) {
        var nouveau=l.options[l.options.selectedIndex].value;
        window.opener.document.forms["visu"].elements["nouveau"].value=nouveau;
    }
</script>
';
    if ($URI == "test.php") {
        $html .= '<script type="text/javascript" src="/elements/js/prototype.js"></script>';
    }
    $html .= '
<div style="position: absolute; left: max(150px, 15%); top: max(50px, 10%); width: min(calc(100% - 150px), 85%); padding:1em;">
';
}

function admin_menu_html($config, &$html, $refresh = false)
{
    /*
     * Bascule sur le nouveau menu en CSS et bootstrap
     */
    $html .= menu_css($config, $html, $refresh);
    return null;
}

function admin_footer_html(&$html, $retour = true, )
{
    global $config, $authlink;

    if (isset($authlink)) {
        mysqli_close($authlink);
    }
    if (isset($config['bind']) && ($config['bind'])) {
        //@ldap_close($config['bind']);
    }
    if ($retour) {
        $previous = $_SESSION['from'] ?? $_GET['from'] ?? $_SERVER['HTTP_REFERER'] ?? "people.php";
        if (preg_match("/menu.php/", $previous)) {
            $previous = "people.php";
        }
        if (! empty($_SESSION['query'])) {
            $previous .= "?" . $_SESSION['query'];
        }
        $_SESSION['from'] = $_SESSION['current'];
        $html .= '
    <h2>
        <a href="' . $previous . '">Retour... </a>
    </h2>';

        // <script type="text/javascript" src="/includes/wz_tooltip.js"></script>';
    }

    $html .= '
</div>
<script src="../elements/js/sambaedu.js"></script>
</body>
</html>
';
}

?>