<?php

function separe_scripts($os, $name)
{
    if ($os == "windows") {
        return [
            "\r\nrem script [" . $name . "]\r\n"
        ];
    } else {
        return [
            "\n# script[" . $name . "]\n"
        ];
    }
}

function once_script($file, $index, $app, $action, $local, $os, &$scripts)
{
    if ($action == "startup") {
        if ($local) {
            $local = ".local";
            $path = "/etc/sambaedu/applications/";
        } else {
            $local = "";
            $path = "/usr/share/sambaedu/applications/";
        }
        $filename = $path . $app . "/" . $file;
        if (file_exists($filename)) {
            $md5 = md5_file($filename);
            if ($os == "linux") {
                $scripts[$app . $index . $local] = [
                    "[ -f \"/etc/sambaedu/applications/" . $app . $index . "-md5\" ] && local_md5=\$(cat /etc/sambaedu/applications/" . $app . $index . "-md5)\n",
                    "if [ \"\${local_md5}\" != \"$md5\" ] ; then\n"
                ];
                $scripts[$app . $index . $local] = array_merge($scripts[$app . $index . $local], file($filename));
                $scripts[$app . $index . $local] = array_merge($scripts[$app . $index . $local], [
                    "echo \"" . $md5 . "\">\"/etc/sambaedu/applications/" . $app . $index . "-md5\"\n",
                    "fi\n"
                ]);
            } else {
                $scripts[$app . $index . $local] = [
                    "if exist  \"%windir%\\" . $app . $index . ".md5\" (for /F \"usebackq delims=\"  %%A in  (\"%windir%\\" . $app . $index . ".md5\") do (set \"local_md5=%%A\"))\r\n",
                    "if [%local_md5%] NEQ [$md5] (\r\n"
                ];
                $liste = array();
                foreach (file($filename) as $ligne) {
                    $liste[] = $ligne . "\r\n";
                }
                $scripts[$app . $index . $local] = array_merge($scripts[$app . $index . $local], $liste);
                $scripts[$app . $index . $local] = array_merge($scripts[$app . $index . $local], [
                    "echo " . $md5 . ">%windir%\\" . $app . $index . ".md5\r\n)\r\n"
                ]);
            }
        }
    }
}

function gen_scripts($local, $action, $list, $liste_applications, $os, &$scripts, &$scripts_server, &$packages, $application = "", $userprofile = "")
{
    if ($local) {
        $path = "/etc/sambaedu/applications/";
        $l = ".local";
    } else {
        $path = "/usr/share/sambaedu/applications/";
        $l = "";
    }
    if (empty($application)) {
        $apps = scandir($path, SCANDIR_SORT_DESCENDING);
    } else {
        $apps = [
            $application
        ];
    }
    foreach ($apps as $app) {
        if ($app != ".." && $app != "." && is_dir($path . $app)) {
            if ($action != "wpkg") {
                foreach (scandir($path . $app . "/") as $file) {
                    $m = [];
                    // prise en en compte non appartenance au groupe
                    if (preg_match("/^" . $action . "((-(server|once|wpkg))?(@(-)?(.*))?)\." . $os . "$/", $file, $m)) {
                        if (empty($m[4]) || ((empty($m[5]) && in_array(strtolower($m[6]), array_map('strtolower', $list))) || (! empty($m[5]) && ! in_array(strtolower($m[6]), array_map('strtolower', $list))))){
                            $s = $m[3] ?? "";
                            if (! empty($m[2]) && $s == "once") {
                                once_script($file, $m[1], $app, $action, $local, $os, $scripts);
                            } elseif (! empty($m[2]) && $s == "server") {
                                $scripts_server[$app . $s . $l] = file($path . $app . "/" . $file);
                            } elseif (! empty($m[2]) && $s == "wpkg" && in_array(strtolower($app), $liste_applications)) {
                                $scripts[$app . $s . $l] = file($path . $app . "/" . $file);
                            } elseif (empty($m[2])) {
                                $scripts[$app . "." . $m[0] . $l] = file($path . $app . "/" . $file);
                            }
                        }
                    }
                }
            } elseif (in_array(strtolower($app), $liste_applications) && file_exists($path . $app . "/wpkg." . $os)) {
                $scripts[$app . ".wpkg" . $l] = file($path . $app . "/wpkg." . $os);
            }
            // liste des packages a installer
            if (file_exists($path . $app . "/packages.list")) {
                $packages .= implode(" ", array_map('rtrim', file($path . $app . "/packages.list"))) . " ";
            }
            foreach ($list as $name) {
                if (file_exists($path . $app . "/packages@" . $name . ".list")) {
                    $packages .= implode(" ", array_map('rtrim', file($path . $app . "/packages@" . $name . ".list"))) . " ";
                }
            }
        }
    }
}

/**
 * genere les cmd pour la mise en place des redirections du profile
 *
 * 3 cas possibles
 * Local->Roaming : les préférences sont remises dans le profil itinérant (cela peut grossir, copie des données à l'ouvrture de session). La jonction est fait a chaque fois.
 * Local->Roaming->Server : les préférences Local sont accédées depuis le serveur : persistence des données. on fait un double redirect en passant par roaming afin de faire persister le link roaming->server qui doit être créé en system
 * Roaming->Server : le profil itinérant est accédé depuis le serveur : pas de copie des données, utile pour les applis avec des "gros" profils itinérants. Le lien persiste, il est fait juste une fois
 *
 * @param unknown $action
 * @param unknown $list
 * @param unknown $liste_applications
 * @param unknown $os
 * @param unknown $scripts
 */
function gen_redirect_scripts($action, $list, $liste_applications, $os, &$scripts, $user, $userprofile)
{
    if ($os == "windows" && ($action == "logon" || $action == "logon-system") && ! in_array("Portables", $list)) {
        if (file_exists("/usr/share/sambaedu/applications/folders/redirects.json")) {
            $redirects = json_decode(file_get_contents("/usr/share/sambaedu/applications/folders/redirects.json"), true);
        }
        if (file_exists("/etc/sambaedu/applications/folders/redirects.json")) {
            $redirects = array_merge(json_decode(file_get_contents("/etc/sambaedu/applications/folders/redirects.json"), true), $redirects);
        }
        file_put_contents("/tmp/redirections-$action-last.log", print_r($redirects, true));

        foreach ($redirects as $app => $redirect) {
            if (in_array(strtolower($app), $liste_applications)) {

                if (! empty($redirect['server'])) {
                    if ($action == "logon") {
                        $ps = explode("\\", $redirect['server']);
                        if (count($ps) > 1) {
                            // on créee la destination array_pop($ps);
                            $d = "";
                            foreach ($ps as $p) {
                                $d .= "\\" . $p;
                                $scripts[$app . ".redirects"][] = "IF NOT EXIST \"\\\\%SE4FS%\\users\\" . $user . $d . "\" (MD \"\\\\%SE4FS%\\users\\" . $user . $d . "\")\r\n";
                            }
                        }
                        $ps = explode("\\", $redirect['link']);
                        if (count($ps) > 1) {
                            array_pop($ps);
                            $d = "";
                            foreach ($ps as $p) {
                                $d .= "\\" . $p;
                                $scripts[$app . ".redirects"][] = "IF NOT EXIST \"" . $userprofile . $d . "\" (MD \"" . $userprofile . $d . "\")\r\n";
                            }
                        }
                        if (! empty($redirect['dest'])) {
                            // jonction de local vers un dossier dans Roaming
                            $ps = explode("\\", $redirect['dest']);
                            if (count($ps) > 1) {
                                array_pop($ps);
                                $d = "";
                                foreach ($ps as $p) {
                                    $d .= "\\" . $p;
                                    $scripts[$app . ".redirects"][] = "IF NOT EXIST \"" . $userprofile . $d . "\" (MD \"" . $userprofile . $d . "\")\r\n";
                                }
                            }
                            $scripts[$app . ".redirects"][] = "IF EXIST \"" . $userprofile . "\\" . $redirect['link'] . "\" (RD /Q \"" . $userprofile . "\\" . $redirect['link'] . "\")\r\n";
                            $scripts[$app . ".redirects"][] = "IF NOT EXIST \"" . $userprofile . "\\" . $redirect['link'] . "\" (MKLINK /J \"" . $userprofile . "\\" . $redirect['link'] . "\"  \"" . $userprofile . "\\" . $redirect['dest'] . "\")\r\n";
                        }
                    } else {
                        // logon-system
                        // lien vers le dossier du serveur
                        if (! empty($redirect['dest'])) {
                            $scripts[$app . ".redirects"][] = "IF NOT EXIST \"" . $userprofile . "\\" . $redirect['dest'] . "\" (MKLINK /D \"" . $userprofile . "\\" . $redirect['dest'] . "\" \"\\\\%SE4FS%\\users\\" . $user . "\\" . $redirect['server'] . "\")\r\n";
                        } else {
                            $scripts[$app . ".redirects"][] = "IF NOT EXIST \"" . $userprofile . "\\" . $redirect['link'] . "\" (MKLINK /D \"" . $userprofile . "\\" . $redirect['link'] . "\" \"\\\\%SE4FS%\\users\\" . $user . "\\" . $redirect['server'] . "\")\r\n";
                        }
                    }
                } else {
                    // jonction Local -> Roaming
                    if ($action == "logon") {
                        $ps = explode("\\", $redirect['dest']);
                        if (count($ps) > 1) {
                            array_pop($ps);
                            $d = "";
                            foreach ($ps as $p) {
                                $d .= "\\" . $p;
                                $scripts[$app . ".redirects"][] = "IF NOT EXIST \"" . $userprofile . $d . "\" (MD \"" . $userprofile . $d . "\")\r\n";
                            }
                        }
                        $scripts[$app . ".redirects"][] = "IF NOT EXIST \"" . $userprofile . "\\" . $redirect['dest'] . "\" (MD \"" . $userprofile . "\\" . $redirect['dest'] . "\")\r\n";
                        $ps = explode("\\", $redirect['link']);
                        if (count($ps) > 1) {
                            array_pop($ps);
                            $d = "";
                            foreach ($ps as $p) {
                                $d .= "\\" . $p;
                                $scripts[$app . ".redirects"][] = "IF NOT EXIST \"" . $userprofile . $d . "\" (MD \"" . $userprofile . $d . "\")\r\n";
                            }
                        }
                        // $scripts[$app . ".redirects"][] = "if exist \"" . $userprofile . "\\" . $redirect['link'] . "\" rd /q \"" . $userprofile . "\\" . $redirect['link'] . "\"\r\n";
                        $scripts[$app . ".redirects"][] = "IF NOT EXIST \"" . $userprofile . "\\" . $redirect['link'] . "\" (MKLINK /J \"" . $userprofile . "\\" . $redirect['link'] . "\"  \"" . $userprofile . "\\" . $redirect['dest'] . "\")\r\n";
                    }
                }
            }
        }
    }
}

function local_admin($config, $user, $machine, $action, $os = "windows")
{
    $script = "";
    if ($os == "windows") {
        if (preg_match("/^" . $machine . "/i", $user)) {
            if ($action != "logoff-system") {
                $script .= "rem on doit boucler pour attendre que l'utilisateur soit bien connecte\r
:user\r
for /f \"tokens=2 delims=\\ \" %%a in ('query session ^| findstr /c:\"Acti\"') do set userlogin=%%a\r
if [%userlogin%]==[] (ping -n 1 localhost\r
goto user)\r
";
                $script .= "rem on boucle jusqu'a avoir un profile\r
:profile\r
for  /f \"tokens=1 delims=\" %%a in ('wmic useraccount where name^=\"%userlogin%\" get sid ^| findstr S-1-5') do set SID=%%a\r
for  /f \"tokens=3 delims= \" %%a in ('reg query \"HKLM\\Software\\Microsoft\\Windows NT\\CurrentVersion\\ProfileList\\%SID%\" /v ProfileImagePath  ^| findstr ProfileImagePath') do set profile=%%a\r
if [%profile%]==[] (ping -n 1 localhost\r
goto profile)\r
";
                $script .= ":dl\r
curl.exe -o \"%TEMP%\\applications-" . $action . "-%userlogin%.cmd\" -F \"action=" . $action . "\" -F \"machine=%computername%\" -F \"userprofile=%profile%\" -F \"user=%userlogin%\" \"http://" . $config['se4fs_name'] . "/gpo/applications.php\">NUL\r
if exist \"%TEMP%\\applications-" . $action . "-%userlogin%.cmd\" (call \"%TEMP%\\applications-" . $action . "-%userlogin%.cmd\")\r
";
            }
        } else {
            $script .= "set userlogin=" . $user . "\r\n";
            if (get_local_admin_right($config, $user) != 0) {
                if ($action == "logon-system") {
                    if (have_right($config, SE_COMPUTER_ADMIN, $user) || have_delegation($config, $machine, "manage", $user)) {
                        $script .= "net localgroup administrateurs " . $config['samba_domain'] . "\\" . $user . " /add\r\n";
                        $script .= "set admin=1\r\n";
                    }
                } else {
                    $script .= "net localgroup administrateurs " . $config['samba_domain'] . "\\" . $user . " /delete\r\n";
                }
            }
        }
    } else {
        if (get_local_admin_right($config, $user) != 0) {
            $u = strtr($user, ".", "_");
            if ($action == "logon-system") {
                if (have_right($config, SE_COMPUTER_ADMIN, $user) || have_delegation($config, $machine, "manage", $user)) {
                    $script .= "echo \"" . $user . " ALL=(ALL:ALL) ALL \" > /etc/sudoers.d/$u\n";
                    $script .= "chmod 0440 /etc/sudoers.d/$u\n";
                }
            } else {
                $script .= "[ -f /etc/sudoers.d/$u ] && rm -f /etc/sudoers.d/$u\n";
            }
        }
    }
    return $script;
}

function get_app_scripts_info($config, $user, $userprofile, $machine, $action, $os, $id = "")
{
    if ($user == "Debian-gdm" || (preg_match("/^" . $machine . "/i", $user) || $user == "root") && $action != "startup" && $action != "shutdown") {
        // pas de script pour les utilisateurs ci-dessus au logon/logoff donc également pour la première cnx logon-system, où user == machine$
        $id = false;
    } else {
        if (empty($id)) {
            // $id = session_id();
            // on reutilise le même id pour les tâches *-system
            $id = md5(strtolower($user) . strtolower($machine) . preg_replace("/-system/", "", $action));
        }
        if (! apcu_fetch("apps." . $id)) {
            $userl = $machinel = [];
            $admin = 0;
            // ajout de la gestion des parcs/groupes/wpkg
            // $machine = preg_replace("/^l-/", "", $machine);
            if (! empty($machine)) {
                if ($action == "startup") {
                    check_computer($config, $machine);
                }
                $machinel = search_machine($config, $machine, true);
            }
            $machinel['cn'] = $machinel['cn'] ?? $machine;
            if (! empty($user)) {
                $userl = search_user($config, $user);
                exec("/usr/share/sambaedu/shares/share.avail/mkhome.sh " . $user);
            } else {
                $cnx_user = get_machine_status($config, $machinel['cn']);
                if (! empty($cnx_user['user'][0]['name'])) {
                    $userl = search_user($config, $cnx_user['user'][0]['name']);
                }
            }
            $user = $userl['cn'] ?? $user;
            $parcs = [];
            if (! empty($machinel['dn'])) {
                $salle = ldap_dn2cn(ldap_dn2oudn($machinel['dn']));
                // $parcs[] = $machine['cn'];
                if (isset($machinel['memberof'])) {
                    foreach ($machinel['memberof'] as $parc) {
                        $parcs[] = ldap_dn2cn($parc);
                    }
                }
                unset($parcs[$salle]);
            } else {
                $salle = "";
            }
            $groups = $groups_e = [];
            $list_u = $list_ue = $list_m = [];
            if (isset($userl['cn'])) {
                //if (empty($userprofile)) {
                //    $userprofile = "c:\\users\\" . $userl['cn'];
                //}
                if (get_local_admin_right($config, $userl['cn']) > 0 && (have_right($config, SE_COMPUTER_ADMIN, $userl['cn']) || have_delegation($config, $machinel['cn'], "manage", $userl['cn']))) {
                    $admin = 1;
                }
                foreach ($userl['memberof'] as $group) {
                    $groups[] = ldap_dn2cn($group);
                    $groups_e[] = ldap_dn2sam($group);
                }
                $list_u = array_unique(array_merge([
                    $userl['cn']
                ], $groups));
                $list_ue = array_unique(array_merge([
                    $userl['cn']
                ], $groups_e));
            }
            $list_m = array_unique(array_merge([
                $machinel['cn']
            ], [
                $salle
            ], $parcs));
            $list = array_unique(array_merge($list_u, $list_m));
            $liste_applications = [];
            if (! empty($action) && ! empty($os)) {

                if (file_exists("../includes/wpkg_lib.php")) {
                    require "wpkg_lib.php";
                    require "wpkg_libsql.php";
                    $liste_applications = array_map('strtolower', array_column(array_column(info_poste_applications($config, $machinel['cn']), "info_app"), "id_nom_app"));
                    if ($os == "windows") {
                        array_push($liste_applications, "edge");
                    }
                }
            }
            apcu_store("apps." . $id, [
                'user' => $userl,
                'userprofile' => $userprofile,
                'salle' => $salle,
                'machine' => $machinel,
                'list' => $list, // tous les groupes user et parc
                'list_u' => $list_u, // groupes
                'list_ue' => $list_ue, // groupes avec prefix
                'list_m' => $list_m, // parcs
                'liste_applications' => $liste_applications,
                'admin' => $admin,
                'os' => $os
            ], 1800);
        }
    }
    return $id;
}
?>
