<?php

function set_debug($config)
{
    $debug = $config['debug'] ?? 0;
    $sambaedu = get_fpm_conf("/fpm/pool.d/sambaedu.conf");
    $xdebug = get_fpm_conf("/mods-available/xdebug.ini");
    $xdebug['zend_extension'] = "xdebug";
    $mode = $xdebug['xdebug.mode'] ?? "inconnu";
    switch ($mode) {
        case "off":
            $debug_file = 0;
            break;
        case "trace":
            $debug_file = 1;
            break;
        case "profile":
            $debug_file = 2;
            break;
        default:
            $debug_file = "";
    }
    if ($debug != $debug_file) {
        switch ($debug) {
            case 1:
                $xdebug['xdebug.mode'] = "trace";
                $xdebug['xdebug.show_error_trace'] = 1;
                $xdebug['xdebug.collect_params'] = 3;
                $sambaedu['sambaedu']['php_flag']['display_errors'] = "on";
                set_param($config, "debug", "1");
                echo "Mode debug activé dans 1 min !<br>";
                break;
            case 2:
                $xdebug['xdebug.mode'] = "profile";
                $xdebug['xdebug.show_error_trace'] = 0;
                $xdebug['xdebug.collect_params'] = 0;
                // $xdebug['xdebug.log'] = "/tmp";
                $xdebug['xdebug.profiler_append'] = 0;
                $xdebug['xdebug.profiler_output_name'] = "cachegrind.out%R";
                set_param($config, "debug", "2");
                echo "Mode profilage activé dans 1 min !<br>";
                break;
            default:
                $xdebug['xdebug.mode'] = "off";
                $xdebug['xdebug.show_error_trace'] = 0;
                $xdebug['xdebug.collect_params'] = 0;
                $sambaedu['sambaedu']['php_flag']['display_errors'] = "off";
                set_param($config, "debug", "0");
                echo "Mode debug désactivé dans 1 min !<br>";
        }
        $ret = set_fpm_conf($xdebug, "/mods-available/xdebug.ini", false);
        $ret &= set_fpm_conf($sambaedu, "/fpm/pool.d/sambaedu.conf");
        return $ret;
        // if ($ret) {
        // batch_command("systemctl reload php" . PHP_MAJOR_VERSION . "." . PHP_MINOR_VERSION . "-fpm.service");
        // batch_write("fast");
        // }
    }
}

?>