<?php

/*
 * Affiche le formulaire de configuration d'un flux d'informations
 * suppression et ajout de la configuration en cours pour le flux d'infos.
 */
function form_choose_info()
{
    $toRemove = $_POST['remove'] ?? "";
    $toAdd = $_POST['ADD'] ?? "";
    $imageDuration = $_POST['images'] ?? "";
    if (! empty($toRemove)) {
        foreach ($toRemove as $k => $v) {
            remove_config_display("flux", $k);
        }
    } elseif (! empty($toAdd)) {
        $name = $_POST['name'] ?? "";
        $URL = $_POST['URL'] ?? "";
        $duration = $_POST['duration'] ?? "";
        $numbers = $_POST['numbers'] ?? "";
        write_config_display("flux", $name, "url", $URL);
        write_config_display("flux", $name, "duration", $duration);
        write_config_display("flux", $name, "numbers", $numbers);
    } elseif (! empty($imageDuration)) {
        $duration = $_POST['duration'] ?? "";
        write_config_display("images", "images", "duration", $duration);
    }
    $conf = read_config_display();
    $html = "";
    if (! empty($conf['flux'])) {
        $html .= "<h2> Modification des flux existants : </h2>";
        $html .= "<form class=\"form\" action=\"config.php\" method=\"post\">";
        $html .= "<ul>";
        foreach ($conf['flux'] as $k => $v) {
            $html .= "<li>";
            $html .= "nom : <b>$k</b> <br />";
            $html .= "URL : " . $v['url'] . " <br />";
            $html .= "Durée d'affichage : " . $v['duration'] . " <br />";
            $html .= "Nombre d'articles lus :" . $v['numbers'] . " <br />";
            $html .= "</li>";
            $html .= '<p><input color="red"  type="submit" name="remove[\'' . $k . '\']" value="Supprimer ce flux"/></p>';
        }
        $html .= "</ul>";
        $html .= "</form>";
        if (! empty($conf['images']['duration'])) {
            $duration = $conf['images']['duration'];
        } else {
            $duration = 3;
        }
        $html .= "<h2> Durée d'affichage des images en seconde : </h2>";
        $html .= "<form class=\"form\" action=\"config.php\" method=\"post\">";
        $html .= 'Durée d\'affichage de chaque image (en secondes)  : <input type="text" name="duration" value="' . $duration . '" size="2">';
        $html .= '<p><input type="submit" name="images" value="Valider"/></p>';
        $html .= "</form>";
    }
    $html .= "<h2> Ajout d'un flux : </h2>";
    $html .= "<form class=\"form\" action=\"config.php\" method=\"post\">";
    $html .= 'Nom du flux : <input type="text" name="name" value="Nom du flux" size="20">';
    $html .= '<br />';
    $html .= 'URL du flux : <input type="text" name="URL" value="URL du flux" size="20">';
    $html .= '<br />';
    $html .= 'Nombre d\'articles à lire  : <input type="text" name="numbers" value="5" size="2">';
    $html .= '<br />';
    $html .= 'Durée d\'affichage de chaque information (en secondes)  : <input type="text" name="duration" value="5" size="2">';
    $html .= '<p><input type="submit" name="ADD" value="Ajouter le flux"/></p>';
    $html .= "</form>";
    $html .= '<br />';
    return $html;
}

/*
 * Lis la configuration json de l'affichage dynamique
 */
function read_config_display()
{
    if (file_exists("/etc/sambaedu/sambaedu.conf.d/display.json") && $txt = file_get_contents("/etc/sambaedu/sambaedu.conf.d/display.json")) {
        return json_decode($txt, true);
    }
    return [];
}

/*
 * Si premier flux saisi, efface le fichier json de configuration puis crée la valeur $data pour la clé $key dans le flux $flux
 * Si flux saisi autre que le premier, ajoute le flux saisi au précédent.
 */
function write_config_display($item, $flux, $key, $data)
{
    $local_display_config = read_config_display();
    if (($flux == "images") || ($flux == "diapo")) {
        $local_display_config[$item][$key] = $data;
    } else {
        $local_display_config[$item][$flux][$key] = $data;
    }
    file_put_contents("/etc/sambaedu/sambaedu.conf.d/display.json", json_encode($local_display_config, JSON_PRETTY_PRINT));
}

/*
 * Efface le flux $flux de la conf
 */
function remove_config_display($item, $flux)
{
    $local_display_config = read_config_display();
    foreach ($local_display_config as $k => $v) {
        if ("$k" == "$item") {
            foreach ($v as $kk => $vv) {
                if ("'" . $kk . "'" == "$flux") {
                    unset($local_display_config["$item"]["$kk"]);
                }
            }
        }
    }
    file_put_contents("/etc/sambaedu/sambaedu.conf.d/display.json", json_encode($local_display_config, JSON_PRETTY_PRINT));
}

/*
 * Formulaire pour l'url d'un diaporama public
 */
function form_diaporama_public()
{
    $form = '';
    $conf = read_config_display();
    if (isset($conf['diapo']) && isset($conf['diapo']['nb'])) {
        $nb_display = $conf['diapo']['nb'] + 1;
    } else {
        $nb_display = 0;
    }
    $url_diapo = $_POST['url_diapo'] ?? "";
    ;
    $ip_display = $_POST['ip_display'] ?? "";
    ;
    if (isset($_POST['url_diapo'])) {
        write_config_display("diapo", "diapo", "nb", $nb_display);
        write_config_display("diapo", "diapo", 'url' . $nb_display, $url_diapo);
        write_config_display("diapo", "diapo", 'ip' . $nb_display, $ip_display);
        $conf = read_config_display(); // relecture de la conf après modif
    }
    echo "<h2> Configuration actuelle </h2>";
    for ($i = 1; $i <= $nb_display; $i ++) {
        if (isset($_POST['remove'][$i])) {
            $conf["diapo"]["nb"] = $conf["diapo"]["nb"] - 1;
            unset($conf["diapo"]["url" . $i]);
            unset($conf["diapo"]["ip" . $i]);
            for ($j = $i + 1; $j < $nb_display; $j ++) {
                $k = $j - 1;
                $conf["diapo"]["url" . $k] = $conf["diapo"]["url" . $j];
                $conf["diapo"]["ip" . $k] = $conf["diapo"]["ip" . $j];
                unset($conf["diapo"]["url" . $j]);
                unset($conf["diapo"]["ip" . $j]);
            }
            file_put_contents("/etc/sambaedu/sambaedu.conf.d/display.json", json_encode($conf, JSON_PRETTY_PRINT));
        }
        if (! empty($conf['diapo']['url' . $i])) {
            $url_diapo = $conf['diapo']['url' . $i];
            $ip_display = $conf['diapo']['ip' . $i];
            $form .= "<form class=\"form\" action=\"config.php\" method=\"post\">";
            $form .= "<h4> Ecran $i :</h4>";
            $form .= "<h6>url configurée :</h6> $url_diapo </br>";
            $form .= "<h6>sur l'écran :</h6> $ip_display</br>";
            $form .= "<input type='submit' name='remove[$i]' value='Supprimer'/>";
            $form .= "</form>";
        }
    }
    $form .= "<h2> Ajout d'une URL d'un diaporama (type Canva, Google slides, Genial.ly...)</h2>";
    $form .= "<form class=\"form\" action=\"config.php\" method=\"post\">";
    $form .= 'URL : <input type="url" name="url_diapo" value="URL du diaporama">';
    $form .= 'iP : <input type="ip" name="ip_display" value="ip de l\'écran">';
    $form .= '<br/>';
    $form .= '<p><input type="submit" name="VALIDER" value="VALIDER"/></p>';
    $form .= "</form>";
    $form .= '<br/>';
    return $form;
}
?>
