<?php

/*
 * construit un tableau à partir des différentes préférences.
 *
 */
function ff_import_policy($config, string $id, string $os, $auto = true)
{
    $liste = [
        "default"
    ];
    if ($info = apcu_fetch("apps." . $id)) {
        $liste = array_merge($liste, $info['list']);
    }
    // 1 récupération des templates
    $json = json_decode(file_get_contents("/usr/share/sambaedu/applications/firefox/default.json"), true);

    // 2 valeurs automatiquement modifiées
    if ($auto) {
        $json['policies']['PopupBlocking'] = [
            'Allow' => [
                "http://" . $config['se4fs_name'],
                $config['se4_url'] ?? ""
            ]
        ];
        $proxy_map = [
            'manuel' => "manual",
            'aucun' => "none",
            'automatique' => "autoDetect"
        ];

        $json['policies']['Proxy'] = [
            'Mode' => $proxy_map[$config['proxy_type']],
            'Locked' => true,
            'UseHTTPProxyForAllProtocols' => true,
            'Passthrough' => "<local>",
            'AutoLogin' => false,
            'UseProxyForDNS' => false
        ];
        $json['policies']['DNSOverHTTPS'] = [
            'Enabled' => false,
            'Locked' => true
        ];
        if ($config['proxy_type'] == "manuel" && ! empty($config['proxy_address']) && ! empty($config['proxy_port'])) {
            $json['policies']['Proxy']['HTTPProxy'] = $config['proxy_address'] . ":" . $config['proxy_port'];
        }
    }
    // 3 ajout des modifs locales
    $files = scandir("/etc/sambaedu/applications/firefox");
    foreach ($liste as $nom) {
        foreach ($files as $file) {
            if (preg_match("@^(.*)\.json$@i", $file, $m)) {
                if ($m[1] == $nom) {
                    $local_json = json_decode(file_get_contents("/etc/sambaedu/applications/firefox/" . $file), true);
                    $json = array_replace_recursive($json, $local_json);
                }
            }
        }
    }
    return $json;
}

function ff_export_policy($config, $json, $path = "")
{
    if (! empty($path)) {
        return file_put_contents($path, json_encode($json, JSON_PRETTY_PRINT));
    } else {
        return json_encode($json, JSON_PRETTY_PRINT);
    }
}

function ff_form_policy($config, $json)
{
    $html = "<h1>Marque Pages Firefox</h1>";
    $html .= '<form class="form" action="" method="post">';
    $key = 0;
    $links = $json['policies']['Bookmarks'] ?? [];
    $folders = array_unique(array_column($links, "Folder"));
    if (count($links) > 0) {
        foreach ($links as $key => $link) {
            $html .= 'Titre : ';
            $html .= '<input type="text" name="Title[' . $key . ']" id="Title[' . $key . ']" value="' . $link['Title'] . '" size="20"  />';
            $html .= '<br />';
            $html .= 'URL du serveur lien : ';
            $html .= '<input type="text" name="URL[' . $key . ']" id="URL[' . $key . ']" value="' . $link['URL'] . '" size="50"  />';
            $html .= '<br />';
            $html .= 'Dossier : ';
            $html .= '<input type="text" name="Folder[' . $key . ']" id="Folder[' . $key . ']" value="' . $link['Folder'] . '" size="20"  />';
            // $html .= 'position : ';
            // $html .= '<input type="text" name="pos[' . $key . ']" id="pos[' . $key . ']" value="' . $key . '" size="2" />';
            $html .= '<br />';
            $html .= '<p><input color="red" type="submit" name="suppr[' . $key . ']" value="Supprimer ce lien"/></p>';
            $html .= '<br />';
        }
    }
    /**
     * Ajout d'un lien
     */
    $key += 1;
    $html .= "<h1>Ajouter un lien</h1>";
    $html .= 'Titre : ';
    $html .= '<input type="text" name="Title[' . $key . ']" id="Title[' . $key . ']" value="" size="20"  />';
    $html .= '<br />';
    $html .= 'URL du serveur lien : ';
    $html .= '<input type="text" name="URL[' . $key . ']" id="URL[' . $key . ']" value="" size="50"  />';
    $html .= '<br />';
    $html .= 'Dossier : ';
    $html .= '<input type="text" name="Folder[' . $key . ']" id="Folder[' . $key . ']" value="" size="20"  />';
    $html .= '<br />';
    $html .= '<input type="submit" name="valider" value="Valider l&rsquo;ajout"/>';
    $html .= '<br />';
    // page d'accueil
    $html .= "<h1>Page d'accueil</h1>";
    $html .= 'URL : ';
    $html .= '<input type="text" name="Homepage" id="Homepage" value="' . @$json['policies']['Homepage']['URL'] . '" size="50"  />';
    $html .= '<br />';

    // extensions

    $html .= '<input type="submit" name="valider" value="Valider les modifications"/>';
    $html .= "<h1>Extensions Firefox</h1>";
    $choix = [
        "blocked" => "Bloquée",
        // "allowed" => "Autorisée",
        "force_installed" => "Installée (forcée)"
    ];
    $links = $json['policies']['ExtensionSettings'] ?? [];
    if (count($links) > 0) {
        foreach ($links as $key => $link) {
            if ($key != "*") {
                $html .= 'Extension : ' . $key . "<br>";
                $html .= 'Action : ';
                $html .= "<select name='installation_mode[" . $key . "]' >";
                foreach ($choix as $c => $t) {
                    $html .= "<option value=" . $c . " ";
                    if ($c == $link['installation_mode']) {
                        $html .= "selected";
                    }
                    $html .= ">" . $t;
                }
                $html .= "</select><br>";
                if ($link['installation_mode'] != "blocked") {
                    $html .= 'URL du xpi (installation uniquement) : ';
                    $html .= '<input type="text" name="install_url[' . $key . ']" id="install_url[' . $key . ']" value="' . $link['install_url'] . '" size="50"  />';
                    $html .= '<br />';
                }
                $html .= '<p><input color="red" type="submit" name="ext_suppr[' . $key . ']" value="Supprimer ce lien"/></p>';
                $html .= '<br />';
            }
        }
    }
    $html .= '<input type="submit" name="valider" value="Valider les modifications"/>';

    /**
     * Ajout d'un lien
     */
    $html .= "<h1>Ajouter une extension</h1>";
    $html .= 'Identifiant (a récupérer sur une install manuelle, laisser vide si inconnu) : ';
    $html .= '<input type="text" name="ext_id" id="ext_id" value="" size="20"  />';
    $html .= '<br>';
    $html .= 'URL du xpi (pour détection automatique de l\'Id) : ';
    $html .= '<input type="text" name="install_url[new]" id="install_url[new]" value="" size="50"  />';
    $html .= '<br />';
    $html .= 'Action : ';
    $html .= "<select name='installation_mode[new]' >";
    foreach ($choix as $c => $t) {
        $html .= "<option value=" . $c . " ";
        $html .= ">" . $t;
    }
    $html .= "</select><br>";
    $html .= '<input type="submit" name="valider" value="Valider les modifications"/>';
    $html .= '</form>';
    return $html;
}

// thunderbird
/*
 * construit un tableau à partir des différentes préférences.
 *
 */
function tb_import_policy($config, string $id, $auto = true)
{
    $liste = [
        "default"
    ];
    if ($info = apcu_fetch("apps." . $id)) {
        $liste = array_merge($liste, $info['list']);
    }
    // 1 récupération des templates
    $json = json_decode(file_get_contents("/usr/share/sambaedu/applications/thunderbird/default.json"), true);

    // 2 valeurs automatiquement modifiées
    if ($auto) {
        $proxy_map = [
            'manuel' => "manual",
            'aucun' => "none",
            'automatique' => "autoDetect"
        ];

        $json['policies']['Proxy'] = [
            'Mode' => $proxy_map[$config['proxy_type']],
            'Locked' => true,
            'UseHTTPProxyForAllProtocols' => true,
            'Passthrough' => "<local>",
            'AutoLogin' => false,
            'UseProxyForDNS' => false
        ];
        $json['policies']['DNSOverHTTPS'] = [
            'Enabled' => false,
            'Locked' => true
        ];
        if ($config['proxy_type'] == "manuel" && ! empty($config['proxy_address']) && ! empty($config['proxy_port'])) {
            $json['policies']['Proxy']['HTTPProxy'] = "http://" . $config['proxy_address'] . ":" . $config['proxy_port'];
        }
    }
    // 3 ajout des modifs locales
    $files = scandir("/etc/sambaedu/applications/thunderbird");
    foreach ($files as $file) {

        if (preg_match("@(.*)\.json@", $file, $m)) {
            if (in_array($m[1], $liste)) {
                $local_json = json_decode(file_get_contents("/etc/sambaedu/applications/thunderbird/" . $file), true);
                $json = array_replace_recursive($json, $local_json);
            }
        }
    }

    return $json;
}

function get_ff_ext_id($config, string $url, string &$html)
{
    $id = false;
    $fileName = basename($url);
    // $html .= sys_get_temp_dir() . "/" . $fileName;
    require_once (dirname(__FILE__) . '/../vendor/autoload.php');
    $opt = [
        'cookies' => true
    ];
    curl_proxy_options($config, $opt);
    $client = new GuzzleHttp\Client($opt);
    // set_time_limit (0);
    try {
        $client->request('GET', $url, [
            'sink' => sys_get_temp_dir() . "/" . $fileName
        ]);
        if (file_exists(sys_get_temp_dir() . "/" . $fileName)) {
            $zip = new ZipArchive();
            if ($zip->open(sys_get_temp_dir() . "/" . $fileName) === TRUE) {
                $manifest = json_decode($zip->getFromName('manifest.json'), true);
                $zip->close();
                if (isset($manifest['applications']['gecko']['id'])) {
                    $id = $manifest['applications']['gecko']['id'];
                } elseif (isset($manifest['browser_specific_settings']['gecko']['id'])) {
                    $id = $manifest['browser_specific_settings']['gecko']['id'];
                } else {
                    $html .= "Ceci n'est pas une extension Firefox !<br>";
                }
            } else {
                $html .= "Format incompatible, ceci n'est pas une extension Firefox !<br>";
            }

            unlink(sys_get_temp_dir() . "/" . $fileName);
        } else {
            $html .= "Pas de fichier extension<br>";
        }
    } catch (Exception $e) {
        $html .= "Erreur de téléchargement de l'extension<br>";
    }
    return $id;
}

?>