<?php
use Google\Exception;

function change_gsuite_password($config, $user, $password, $alias = "")
{
    require_once (dirname(__FILE__) . '/../vendor/autoload.php');
    putenv('GOOGLE_APPLICATION_CREDENTIALS=/etc/sambaedu/google-api.json');
    $scopes = array(
        'https://www.googleapis.com/auth/admin.directory.user'
    );
    try {
        $client = new Google_Client();
        $client->useApplicationDefaultCredentials();
        $client->setSubject("reseau@diderot.org");
        $client->setScopes($scopes);
        $service = new \Google\Service\Directory($client);
        $email = $user . "@" . $config['domain'];
        $userObj = new Google\Service\Directory\User(array(
            'password' => sha1($password),
            'hashFunction' => 'SHA-1',
            'changePasswordAtNextLogin' => false
        ));

        $results = $service->users->update($email, $userObj);
        $mail = $results->getPrimaryEmail();
        if (! empty($alias) && $alias != $mail) {
            $userObj = new \Google\Service\Directory\User(array(
                'alias' => $alias
            ));
            $results = $service->users->update($email, $userObj);
            $mail = $results->getAlias();
        }
        return $mail;
    } catch (Exception $ex) {
        print_r($ex->getMessage());
        return false;
    }
}
