<?php

function network_create_script($config, $id, $os, $action)
{
    $script = "";
    if ($info = apcu_fetch("apps." . $id)) {
        if ($os == 'linux') {
            $script_wifi_wpa = "";
            $script_802_1x_wired = "";
            $script_802_1x_wifi = "";

            if (! empty($config['wpa_ssid']) && ! empty($config['wpa_password'])) {
                // on configure le wifi en wpa2-psk
                $script_wifi_wpa .= "        if [ \"\$ssid\" == \"" . $config['wpa_ssid'] . "\" ]; then
            echo \"configuration wifi : \$interface pour le wpa2-psk\"
            nmcli c modify \$interface 802-11-wireless-security.key-mgmt wpa-psk \
802-11-wireless-security.psk " . $config['wpa_password'] . " || true
        fi
";
            }

            if (! empty($config['802_1x_wired']) || ! empty($config['802_1x_ssid'])) {
                $machine_key = exec("ssh -i /etc/sambaedu/id_rsa -o StrictHostKeyChecking=no root@" . $config['se4ad_name'] . "." . $config['domain'] . " pdbedit -Lw " . $info['machine']['samaccountname'] . " | cut -d \":\" -f4");
            }

            if (! empty($config['802.1x_wired'])) {
                // on configure le filaire en 802.1x
                $script_802_1x_wired .= "        echo \"configuration ethernet : \$interface pour le 802.1x\"
        nmcli c modify \$interface 802-1x.eap peap 802-1x.identity host/" . strtoupper($info['machine']['samaccountname']) . " \
802-1x.phase2-auth mschapv2 802-1x.password " . $machine_key . " 802-1x.optional true \
802-1x.phase1-peaplabel 1 802-1x.auth-timeout 3 802-1x.system-ca-certs true || true
";
            }

            if (! empty($config['802_1x_ssid'])) {
                // on configure le wifi en peap mschapv2
                $script_802_1x_wifi .= "        if [ \"\$ssid\" == \"" . $config['802.1x_ssid'] . "\" ]; then
            echo \"configuration wifi : \$interface pour le 802.1x peap mschapv2\"
            nmcli c modify \$interface 802-1x.eap peap 802-1x.identity host/" . strtoupper($info['machine']['samaccountname']) . " \
802-1x.phase2-auth mschapv2 802-1x.password " . $machine_key . " \
802-1x.phase1-peaplabel 1 802-1x.auth-timeout 10 802-1x.system-ca-certs true || true
        fi
";
            }

            $script_wired = "    if nmcli -t -f connection.type c show \$interface | grep -q \"ethernet\" ; then
        echo \"configuration filaire : \$interface\"
        nmcli c modify \$interface 802-3-ethernet.wake-on-lan magic || true
" . $script_802_1x_wired . "
    fi
";

            $script_wifi = "    if nmcli -t -f connection.type c show \$interface | grep -q \"802-11-wireless\" ; then
        echo \"configuration wifi : \$interface\"
        ssid=\$(nmcli -t -f 802-11-wireless.ssid c show \$interface | cut -d\":\" -f2)
" . $script_wifi_wpa . "
" . $script_802_1x_wifi . "
    fi
";

            $script .= "OLDIFS=\$IFS
IFS=\"
\"
for interface in \$(nmcli -t -f UUID c show) ; do
" . $script_wired . "
" . $script_wifi . "
done
IFS=\$OLDIFS
";
        }
    }
    return $script;
}

?>