<?php

function apply_partages($config, $action)
{
    $html = apcu_fetch("html_partages_" . session_id());
    $classes = apcu_fetch("folders_classes_" . session_id());
    if (count($classes) > 0) {
        $classe = array_shift($classes);
        $niveau = urldecode($classe);
        switch ($action) {
            case "create":
                $html .= "<b>Création de la classe : " . $niveau . "</b><br />\n";
            case "refresh":
                // Rafraichissement de la classe:
                $html .= "<b>rafraîchissement de la classe : " . $niveau . "</b><br />\n";
                $html .= update_classes($config, $niveau);
                break;
            case "clean":
                $html .= "<b>Nettoyage de la classe : $niveau</b><br />\n";
                $reps_eleves = array();
                $reps_eleves = scandir("/var/sambaedu/Classes/Classe_" . $niveau);
                $exclusion = [
                    ".",
                    "..",
                    "_travail",
                    "_profs",
                    "_echange"
                ];
                foreach ($reps_eleves as $rep_eleve) {
                    if (! in_array($rep_eleve, $exclusion) && ! preg_match("/^\..*$/", $rep_eleve)) {
                        $rep_archive = "/var/sambaedu/Classes/Classe_" . $niveau . "/" . $rep_eleve . "/Archives";
                        if (is_dir("$rep_archive")) {
                            // echo "Suppression de $rep_archive !<br>";
                            system("/usr/bin/sudo rm -rf '" . $rep_archive . "'");
                        }
                    }
                }
                break;
            case "delete":
                $html .= "<b>Suppression de la classe : $niveau</b>\n";
                $niveau = "/var/sambaedu/Classes/Classe_" . $niveau;
                system("/usr/bin/sudo rm -rf '" . $niveau . "'");
                if (! is_dir("$niveau")) {
                    $html .= " OK <br>\n";
                } else {
                    $html .= " Echec<br>\n";
                }
                break;
        }
        apcu_store("folders_classes_" . session_id(), $classes, 500);
        $html .= "<form action=\"rep_classes.php#end\" method=\"post\" name=\"partages\">\n";
        $html .= "<input type=\"hidden\" name=\"action\" value=\"" . $action . "\">\n";
        echo "</form>";
        if (count($classes) == 0) {
            $end = true;
        } else {
            $end = false;
        }
    } else {
        $end = true;
    }
    apcu_store("html_partages_" . session_id(), $html, 500);
    return $end;
}

function form_partages($config, $action, $select_folders_classes)
{
    $html = "<br />\n";
    // on crée le dossier si il n'existe pas
    $dirClasses = "/var/sambaedu/Classes";
    exec("sudo mkdir -p " . $dirClasses);
    // Recherche de la liste des classes dans l'annuaire
    $list_classes = list_classes($config, "*");
    $indice = 0;
    foreach (scandir($dirClasses) as $dirClasse) {
        if ((preg_match("/^Classe_/", $dirClasse)) && (! preg_match("/^Classe_grp/", $dirClasse))) {
            $dirClasse = preg_replace("/^Classe_/", "", $dirClasse);
            $dossiers_classes[] = $dirClasse;
        }
    }
    if (isset($dossiers_classes)) {
        array_multisort($dossiers_classes, SORT_STRING);
    } else
        $dossiers_classes = array();
    $new_classes = array();
    // Creation d'un tableau des nouvelles ressources a créer par
    // elimination des ressources deja existantes
    $k = 0;
    for ($i = 0; $i < count($list_classes); $i ++) {
        // $html .= "\$list_classes[$i]=".$list_classes[$i]."<br />";
        $exist = false;
        for ($j = 0; $j < count($dossiers_classes); $j ++) {
            // $html .= "\$dossiers_classes[$j]=".$dossiers_classes[$j]."<br />";
            if ($list_classes[$i] == $dossiers_classes[$j]) {
                $exist = true;
                break;
            } else {
                $exist = false;
            }
        }

        if (! $exist) {
            $new_classes[$k]['cn'] = $list_classes[$i];
            $k ++;
        }
    }
    $old_classes = [];
    foreach ($dossiers_classes as $dossier_classe) {
        if (! in_array($dossier_classe, $list_classes)) {
            $old_classes[] = $dossier_classe;
        }
    }
    // Affichage de la table
    $html .= "<H1>Gestion des ressources classes</H1>\n";
    $html .= "<br />\n";
    $html .= "<table class='table-bordered' CELLPADDING=3 CELLSPACING=1 RULES=COLS>\n";
    $html .= "<tr class=\"menuheader\" height=\"30\">\n";
    $html .= "<td align=\"center\">Classes à créer ";
    $html .= "<u onmouseover=\"return escape('Classes disponibles dans l\'annuaire, mais dont le répertoire n\'a pas encore été créé sur le serveur.<br /><b>Remarque :</b> Un répertoire peut être créé, que si il existe une équipe correspondante.')\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u></td>\n";
    $html .= "<td align=\"center\">Partages classes existants </td>";
    $html .= "<td align=\"center\">Partages classes obsolètes ";
    $html .= "</td></tr>\n";
    $html .= "<tr><td align=\"center\">\n";
    $right = have_right($config, SE_SHARE_ADMIN);
    $admin = have_right($config, SE_ADMIN);
    // Affichage menu de sélection des sous-dossiers classes a créer
    if (count($new_classes) > 15)
        $size = 15;
    else
        $size = count($new_classes);
    if (count($new_classes) > 0) {
        $html .= "<form action=\"rep_classes.php\" method=\"post\">\n";
        $html .= "<select size=\"" . $size . "\" name=\"folders_classes[]\" multiple=\"multiple\">\n";
        foreach ($new_classes as $new_classe) {
            if ($admin || ($right && in_array($new_classe["cn"], list_classes($config, $config['login']))))
                $html .= "<option value=" . urlencode($new_classe["cn"]) . ">" . $new_classe["cn"] . "\n";
        }
        $html .= "</select><br />\n";
        $html .= "<input type=\"hidden\" name=\"action\" value=\"create\">\n";
        $html .= "<input type=\"submit\" value=\"Créer\">\n";
        $html .= "</form>\n";

        // Vérification selection d'au moins une classe
        if ($action == "create" && empty($select_folders_classes)) {
            $html .= "<div class='error_msg'>Vous devez sélectionner au moins une classe !</div>\n";
        }
    } else {
        $html .= "<div class='error_msg'>Pas de nouvelles classes !</div>\n";
    }

    $html .= "</td><td align=\"center\">\n";
    if (count($dossiers_classes) > 15)
        $size = 15;
    else
        $size = count($dossiers_classes);
    if (count($dossiers_classes) > 0) {
        $html .= "<form action=\"rep_classes.php\" method=\"post\">\n";
        $html .= "<select size=\"" . $size . "\" name=\"folders_classes[]\" multiple=\"multiple\">\n";
        foreach ($dossiers_classes as $dossier_classe) {
            if ($admin || ($right && in_array($dossier_classe, list_classes($config, $config['login']))))
                $html .= "<option value=" . urlencode($dossier_classe) . ">" . $dossier_classe . "\n";
        }
        $html .= "</select><br />\n";
        // $html .= "<input type=\"hidden\" name=\"refresh_classes\" value=\"true\">\n";
        $html .= "<input type=\"radio\" name=\"action\" value=\"refresh\" id = \"refresh\" checked>\n";
        $html .= "<label for=\"refresh\">Rafraîchir</label>";
        $html .= "<u onmouseover=\"return escape('Choisir les classes que l\'on souhaite rafraî;chir,<br />par exemple suite à l\'ajout de nouveaux élèves.<br /> En cas de migration d\'une année à une autre, les dossiers de l\'année précédente des élèves seront copiés dans un sous-dossier Archive dans le dossier de la nouvelle année de l\'élève.<br /> Si l\'élève n\'est plus dans l\'établissement, son dossier est caché avec un point.<br />')\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u>\n";
        $html .= "<input type=\"radio\" name=\"action\" value=\"clean\" id = \"clean\">\n";
        $html .= "<label for=\"clean\">Nettoyer</label>";
        $html .= "<u onmouseover=\"return escape('Choisir les classes sur lesquelles on souhaite nettoyer les dossiers archives.<br />')\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u>\n";
        // $html .= "<input type=\"hidden\" name=\"delete_folders_classes\" value=\"true\">\n";
        $html .= "<input type=\"radio\" name=\"action\" value=\"delete\" id = \"delete\" onClick=\"return areyousure()\">\n";
        $html .= "<label for=\"delete\">Supprimer</label>";

        $html .= "<u onmouseover=\"return escape('<br /><b>Attention, la suppression entrainera la perte des données de la classe.</b>')\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u>\n";
        $html .= "<br><input type=\"submit\" value=\"Valider\">\n";
        $html .= "</form>\n";
        // Vérification selection d'au moins une classe
        if ($action == "delete" || $action == "refresh" || $action == "clean" && empty($select_folders_classes)) {
            $html .= "<div class='error_msg'>Vous devez sélectionner au moins une classe !</div>\n";
        }
    }
    $html .= "</td><td align=\"center\">\n";
    if (count($old_classes) > 15)
        $size = 15;
    else
        $size = count($old_classes);
    if (count($old_classes) > 0) {
        $html .= "<form action=\"rep_classes.php\" method=\"post\">\n";
        $html .= "<select size=\"" . $size . "\" name=\"folders_classes[]\" multiple=\"multiple\">\n";
        foreach ($old_classes as $old_classe) {
            if ($admin || ($right && in_array($old_classe, list_classes($config, $config['login']))))
                $html .= "<option value=" . urlencode($old_classe) . ">" . $old_classe . "\n";
        }
        $html .= "</select><br />\n";
        $html .= "<input type=\"hidden\" name=\"action\" value=\"delete\">\n";
        $html .= "<input type=\"submit\" value=\"supprimer\" onClick=\"return areyousure()\">\n";
        $html .= "<u onmouseover=\"return escape('<br /><b>Attention, la suppression entrainera la perte des données de la classe.</b>')\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u>\n";
        $html .= "</form>\n";

        // Vérification selection d'au moins une classe
        if ($action == "delete" && empty($select_folders_classes)) {
            $html .= "<div class='error_msg'>Vous devez sélectionner au moins une classe !</div>\n";
        }
    } else {
        $html .= "<div class='error_msg'>Pas d'anciennes classes</div>\n";
    }
    $html .= "</td></tr>\n";
    $html .= "</table>\n";
    $html .= "<br />\n";
    $html .= "<H3>Rafraîchir les répertoires classes existants</H3>\n";
    $html .= "<form action=\"rep_classes.php\" method=\"post\">\n";
    $html .= "<br /><br />\n";
    $html .= "<input type=\"hidden\" name=\"action\" value=\"refresh_all\">\n";
    $html .= "<input type=\"submit\" onClick=\"alert('Cette opération peut être très longue !')\" value=\"Rafraîchir toutes les classes\">\n";
    $html .= "<u onmouseover=\"return escape('Permet de reforcer les droits (ACL) sur les classes existantes.<br /><b>Attention : Cette opération peut être longue.</b>')\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u>\n";
    $html .= "</form>\n";
    return $html;
}
