<?php

function test_remote($machine, $type = "all")
{
    /*
     * if (empty($type))
     * $type = "all";
     *
     * if ($type == "all") {
     * if (ts($machine, .5)) {
     * if (vnc($machine, .5)) {
     * return "all";
     * } else {
     * return "rdp";
     * }
     * } elseif (vnc($machine, .5)) {
     * return "vnc";
     * } else {
     * return false;
     * }
     * } elseif ($type == "rdp" && ts($machine, .5)) {
     * return "rdp";
     * } elseif ($type == "vnc" && vnc($machine, .5)) {
     * return "vnc";
     * } else {
     * return false;
     * }
     */
    if (ts($machine, 0.02)) {
        return "rdp";
    } else {
        return false;
    }
}

function add_unique($nom, &$liste)
{
    $found = false;
    $ret = array();
    if (empty($liste))
        $ret[] = $nom;
    else {
        foreach ($liste as $poste) {
            if ($nom['cn'] != $poste['cn']) {
                $ret[] = $poste;
            } else {
                $ret[] = array_replace($poste, $nom);
                $found = true;
            }
        }
        if (! $found) {
            $ret[] = $nom;
        }
    }
    $liste = $ret;
}

function remove_unique($nom, &$liste)
{
    $ret = array();
    foreach ($liste as $poste) {
        if ($nom['cn'] != $poste['cn'])
            $ret[] = $poste;
    }
    $liste = $ret;
}

function remote_status($config, $login, $poste, $type = "", $action = "")
{
    if (strtolower($poste['cn']) == $config['se4fs_name']) {
        exec("sudo w -hs|grep 'root'|grep -q '" . $config['se4fs_ip'] . "'", $out, $res);
        if ($res == 0) {
            $poste['status'] = 'login';
            $poste['remote'] = 'ssh';
        } else {
            $poste['status'] = 'on';
        }
        $poste['score'] = 1000;
    } else {
        $status = get_machine_status($config, $poste['cn']);
        if (empty($action)) {
            // log de connexion
            $poste['status'] = $status['state'];
            $poste['score'] = $status['score'];
        } else {
            $poste['status'] = $action;
        }
        if (! $status['locked'] || $status['locked'] == $login) {
            // test ports rdp/vnc
            if ($type == "ssh" || $type = test_remote($poste['cn'], $type)) {
                // if ($type = test_remote($poste['iphostnumber'], $type)) {
                $poste['type'] = $type;
                // $poste['timer'] = 0;
                $poste['remote'] = list_remote_connexion($config, $poste['cn'], $login);
                // poste allumé et opérationnel
                if (isset($status['user']) && is_array($status['user']) && count($status['user']) > 0) {
                    foreach ($status['user'] as $user) {

                        if ($user['name'] == $login) {
                            // session ouverte
                            $poste['status'] = 'login';
                            break;
                        } elseif ($user['name'] != "wpkg" && $status['state'] != "linux") {
                            // session ouverte par un autre utilisateur
                            $poste['status'] = 'no';
                        } else {
                            // poste dispo
                            $poste['status'] = 'on';
                        }
                    }
                } else {
                    // poste dispo
                    $poste['status'] = 'on';
                }
            } elseif ($action == "wait") {
                // le poste n'est pas prêt
                // if (empty($poste['timer'])){
                // $poste['timer'] = time();
                // }
                // if (time() - $poste['timer'] > 120) {
                // le poste ne s'est pas allumé ou ports fermés
                // $poste['status'] = 'no';
                // }
            } else {
                $poste['status'] = 'off';
            }
        } else {
            $poste['status'] = 'no';
        }
    }
    return $poste;
}

/**
 * Recherche une machine libre dans les parcs pour lesquels l'utilisateur a le droit de faire du rdp
 * - 1 renvoie la machine à laquelle l'utilisateur est connecté
 * - 2 renvoie une machine allumée du parc
 * - 3 liste les machines éteintes
 *
 *
 *
 * @param unknown $config
 * @param unknown $login
 * @return unknown
 */
function find_remote_list($config, $login, $force = false, $machine = "", $action = "")
{
    $time = time();
    $liste = [];
    $remote = apcu_fetch('remote');
    if (! empty($remote[$login]) && ! $force) {
        $liste = $remote[$login]['liste'];
        $postes = $remote[$login]['postes'];
    }
    if (count($liste) == 0 || $force) {
        // recherche des postes autorisés
        $postes = array();
        $parcs = list_delegations_right($config, SE_COMPUTER_CONTROL, $login);
        // $parcs = array_merge($parcs, list_delegations($config, $login, true, "vnc"));
        foreach ($parcs as $parc) {
            $postes = array_merge($postes, array_slice(list_members_parc_fast($config, $parc['parcdn'], true), 0, 50));
        }
        $postes = array_unique_multi($postes);
    }
    if (empty($action)) {
        // on traite le statut des postes pas encore traités
        if (count($postes) > 0) {
            foreach ($postes as $k => $poste) {
                add_unique(remote_status($config, $login, $poste), $liste);
                unset($postes[$k]);
                if (time() - $time > 10) {
                    break;
                }
            }
        }

        // on cherche les postes ou l'utilisateur est déjà connecté, même en en dehors des délégations
        foreach (get_user_status($config, $login) as $m) {
            $poste = search_machine($config, $m['machine']);
            add_unique(remote_status($config, $login, $poste), $liste);
        }
    }
    // on ajoute le poste demandé
    if (! empty($machine) && strtolower($machine) != $config['se4fs_name']) {
        $poste = search_machine($config, $machine);
        add_unique(remote_status($config, $login, $poste, "", $action), $liste);
    }
    // on ajoute se4fs si admin
    if (have_right($config, SE_ADMIN)) {
        $poste = search_machine($config, $config['se4fs_name']);
        add_unique(remote_status($config, $login, $poste, "ssh", $action), $liste);
    }
    $etats = [
        'login',
        'wait',
        'on',
        'off',
        'no'
    ];
    $liste_triee = [];
    foreach ($liste as $k => $poste) {
        if (! isset($poste['score'])) {
            $liste[$k]['score'] = 0;
        }
    }
    if (isset($liste[0]['score'])) {
        array_multisort(array_column($liste, "score"), SORT_DESC, $liste);
        foreach ($etats as $etat) {
            foreach ($liste as $poste)
                if ($poste['status'] == $etat) {
                    if ($poste['cn'] == $machine)
                        array_unshift($liste_triee, $poste);
                    else
                        $liste_triee[] = $poste;
                }
        }
    }
    lock('remote');
    if (! $remote = apcu_fetch('remote')) {
        $remote = [];
    }
    $remote[$login] = [
        'liste' => $liste_triee,
        'postes' => $postes
    ];
    apcu_store('remote', $remote, 1000);
    unlock('remote');
    return $liste_triee;
}

/**
 * Crée un jeton d'accès guacamole permettant
 *
 * - l'accès direct à la machine demandée (après allumage si besoin).
 * - l'accès veyon à la machine avec un rebond sur une machine disponible du même parc dans l'établissement (vm du pve local en priorité, sinon une machine du parc)
 * - l'accès veyon-master au parc demandé avec un rebond sur une machine disponible du même parc dans l'établissement (une machine dispo du parc en priorité, vm du pve sinon)
 *
 * cette fonction est destinée aux techniciens ou administrateurs, depuis les interfaces central ou admin.
 * En cas d'allumage de la machine, on n'attend pas le démarrage, la fenêtre guacamole est tout de suite affichée.
 *
 * @param unknown $config
 * @param unknown $login
 * @return unknown
 */
function create_remote_admin_token($config, $machine, $mode = "rdp", $timeout = 7200)
{
    if (! empty($config['guacamole_url'])) {
        if (! empty($_SESSION['passwd'])) {
            $password = $_SESSION['passwd'];
        }
        if ($mode == "rdp") {
            $machine = search_machine($config, $machine);
            $etab = $machine['etab'];
            $machine = get_machine_status($config, $machine, $etab);
            if ($machine['state'] == "off") {}
        }
        $machines = [];
        $connections = [];
        foreach ($machines as $machine) {
            if (preg_match("/se4[fs|ad]/", $machine)) {
                $type = "ssh";
            } else {
                $type = "rdp";
            }
            switch ($type) {
                case "vnc":
                    break;
                case "ssh":
                    // guacamole veut une clé privée au format PEM
                    // Attention si la clé est ancienne il est possible qu'elle soit refusée
                    // dans ce cas il faut soit la renouveler, soit ajouter le chiffrage
                    // PubkeyAcceptedAlgorithms +ssh-rsa dans /etc/ssh/sshd_config (pas terrible en terme de sécu)
                    //
                    if (! file_exists("/etc/sambaedu/id_rsa.pem")) {
                        copy("/etc/sambaedu/id_rsa", "/etc/sambaedu/id_rsa.pem");
                        system("sudo ssh-keygen -p -N \"\" -m PEM -f /etc/sambaedu/id_rsa.pem");
                    }
                    $connections['ssh root sur ' . $machine] = array(
                        'parameters' => array(
                            "hostname" => $machine,
                            "port" => 22,
                            "username" => "root",
                            "private-key" => file_get_contents("/etc/sambaedu/id_rsa.pem")
                        ),
                        'protocol' => "ssh"
                    );
                    break;
                default:
                    $connections['rdp sur ' . $machine] = array(
                        'protocol' => 'rdp',
                        'parameters' => array(
                            "hostname" => $machine,
                            "port" => 3389,
                            "password" => $password,
                            "username" => $config['login'],
                            "domain" => $config['samba_domain'],
                            "server-layout" => "fr-fr-azerty",
                            "ignore-cert" => true,
                            "enable-font-smoothing" => true,
                            "resize-method" => "display-update",
                            "enable-printing" => true,
                            "printer-name" => "Guacamole"
                        )
                    );
                    $connections['veyon sur ' . $machine] = array(
                        'protocol' => 'rdp',
                        'parameters' => array(
                            "hostname" => $machine,
                            "port" => 3389,
                            "password" => $password,
                            "username" => $config['login'],
                            "domain" => $config['samba_domain'],
                            "server-layout" => "fr-fr-azerty",
                            "ignore-cert" => true,
                            "enable-font-smoothing" => true,
                            "resize-method" => "display-update",
                            "enable-printing" => true,
                            "printer-name" => "Guacamole",
                            "remote-app" => "||Veyon Master"
                        )
                    );
                /*
                 * $connections['veyon direct sur ' . $machine] = array(
                 * 'protocol' => 'rdp',
                 * 'parameters' => array(
                 * "hostname" => $machine,
                 * "port" => 3389,
                 * "password" => $password,
                 * "username" => $user,
                 * "domain" => $config['samba_domain'],
                 * "server-layout" => "fr-fr-azerty",
                 * "ignore-cert" => true,
                 * "enable-font-smoothing" => true,
                 * "resize-method" => "display-update",
                 * "enable-printing" => true,
                 * "printer-name" => "Guacamole",
                 * "remote-app" => "||Veyon Poste"
                 * )
                 * );
                 */
            }
        }
        $token = [
            'username' => $config['login'],
            'expires' => (time() + $timeout) * 1000,
            'connections' => $connections
        ];
        if (empty($config['guac_priv_key'])) {
            set_config($config, 'guac_priv_key', bin2hex(openssl_random_pseudo_bytes(16)), "guacamole");
        }
        $json = json_encode($token);

        // Ne FONCTIONNE PAS, on utilise le script bash de référence
        // $config['guac_priv_key'] = "4C0B569E4C96DF157EEE1B65DD0E4D41";
        // $json = file_get_contents("/tmp/json2");
        // $iv = "0x00000000000000";
        // $data = hash_hmac("sha256", $json, $config['guac_priv_key'], true) . $json;
        // $ret['data'] = $data;
        // $ret = openssl_encrypt($data, "aes-128-cbc", $config['guac_priv_key'], $options=0, $iv);
        // echo $json;
        $file = "/tmp/token." . time();
        exec("touch $file && chmod 600 $file");
        file_put_contents($file, $json);
        exec("/usr/share/sambaedu/scripts/encrypt-json.sh " . $config['guac_priv_key'] . " " . $file, $out);
        $ret = $out[0];
        unlink($file);
    } else {
        $ret = true;
    }
    return $ret;
}

function list_remote_connexion($config, $machine, $name)
{
    $type = "";
    if (! empty($config['guacamole_url'])) {
        $user = search_user($config, $name);
        $remote = search_ad($config, $machine, "remote");
        if (count($remote) > 0 && isset($remote[0]['member']) && is_array($remote[0]['member'])) {
            if (in_array($user['dn'], $remote[0]['member'])) {
                $type = $remote[0]['guacconfigprotocol'];
            }
        }
    }
    return $type;
}

/**
 * crée une connexion rdp ou vnc pour l'utilisateur sur la machine.
 * pour le moment les 2 sont exclusifs, on
 * supprime le profil existant pour créer le nouveau.
 *
 * @param unknown $config
 * @param unknown $machine
 * @param unknown $name
 * @param string $type
 * @return boolean
 */
function create_remote_connexion($config, $machine, $name, $type = "rdp")
{
    $ret = ouadd($config, "ou=rdp," . $config['ldap_base_dn'], "", "dn");
    if (! empty($config['guacamole_url'])) {
        $user = search_user($config, $name);
        $remote = search_ad($config, $machine, "remote");
        $ret = true;
        if (count($remote) > 0) {
            $ret = delete_remote_connexion($config, $machine);
        }
        $dn = "cn=remote_" . $machine . ",ou=rdp," . $config['ldap_base_dn'];
        if (strcasecmp($machine, $config['se4fs_name']) == 0) {
            $type = "ssh";
        }
        switch ($type) {
            case "vnc":
                $attrs = array(
                    'objectclass' => array(
                        'top',
                        'group',
                        'guacConfigGroup'
                    ),
                    'cn' => "remote_" . $machine,
                    'samAccountName' => "remote_" . $machine,
                    'guacConfigParameter' => array(
                        "hostname=" . $machine,
                        "port=5900",
                        "password=" . $config['vnc_password']
                    ),
                    'guacConfigProtocol' => "vnc",
                    'member' => $user['dn']
                );
                break;
            case "ssh":
                // guacamole veut une clé privée au format PEM
                if (! file_exists("/etc/sambaedu/id_rsa.pem")) {
                    copy("/etc/sambaedu/id_rsa", "/etc/sambaedu/id_rsa.pem");
                    system("sudo ssh-keygen -p -N \"\" -m PEM -f /etc/sambaedu/id_rsa.pem");
                }
                $attrs = array(
                    'objectclass' => array(
                        'top',
                        'group',
                        'guacConfigGroup'
                    ),
                    'cn' => "remote_" . $machine,
                    'samAccountName' => "remote_" . $machine,
                    'guacConfigParameter' => array(
                        "hostname=" . $machine,
                        "port=22",
                        "username=root",
                        "private-key=" . file_get_contents("/etc/sambaedu/id_rsa.pem")
                    ),
                    'guacConfigProtocol' => "ssh",
                    'member' => $user['dn']
                );
                break;
            default:
                $attrs = array(
                    'objectclass' => array(
                        'top',
                        'group',
                        'guacConfigGroup'
                    ),
                    'cn' => "remote_" . $machine,
                    'samAccountName' => "remote_" . $machine,
                    'guacConfigParameter' => array(
                        "hostname=" . $machine,
                        "port=3389",
                        "password=\${GUAC_PASSWORD}",
                        "username=\${GUAC_USERNAME}@" . $config['domain'],
                        // "domain=" . $config['samba_domain'],
                        "server-layout=fr-fr-azerty",
                        "ignore-cert=true",
                        "security=any",
                        "enable-font-smoothing=true",
                        "resize-method=display-update",
                        "enable-printing=true",
                        "printer-name=Guacamole"
                    ),
                    'guacConfigProtocol' => "rdp",
                    'member' => $user['dn']
                );
        }
        if ($ret) {
            $ret = ldap_add($config['bind'], $dn, $attrs);
            if ($ret) {
                apcu_store("ldap_cache_invalid", true, 60);
            } else {
                $err = ldap_error($config['bind']);
                trigger_error($err);
            }
        }
    } else {
        // $ret = "<input type=\"hidden\" name=\"refresh\" value=\"1\">";
        $ret = true;
    }
    return $ret;
}

function delete_remote_connexion($config, $machine)
{
    if (! empty($config['guacamole_url'])) {
        return groupdel($config, "remote_" . $machine);
    } else {
        return true;
    }
}

function display_remote_list($config, $login)
{
    $type = "all";
    $html = $message = $script = "";
    $force = $res = false;
    $action = $_POST['action'] ?? "";
    $time = $_POST['time'] ?? time();
    $machine = $_POST['machine'] ?? $_GET['machine'] ?? "";
    $open = $_POST['open'] ?? 0;
    $end = $_POST['end'] ?? 1;
    $post_type = $_POST['type'] ?? "rdp";
    $post_window = $_POST['window'] ?? $_GET['window'] ?? "0";
    if (empty($machine) && $end) {
        $force = true;
    }
    $liste = find_remote_list($config, $login, $force, $machine, $action) ?? [];
    // $html .= "<pre>" . print_r($liste[0], true) . "</pre>";
    // si on a selectionné une machine
    if ($remote = apcu_fetch('remote')) {
        // $html .= "<pre>" . print_r($remote, true) . "</pre>";
        $end = (is_array(@$remote[$login]['postes']) && (count($remote[$login]['postes']) == 0));
    } else {
        $end = true;
    }
    $refresh = ! $end;

    if (! empty($machine)) {
        $p = array_search($machine, array_column($liste, 'cn'));
        $poste = $liste[$p] ?? [];
        // si on a selectionné une machine
        if (! empty($poste)) {
            switch ($poste['status']) {
                case 'login':
                case 'on':
                    // if ($poste['remote'] == $post_type) {
                    // $res = true;
                    // } else {
                    $res = create_remote_connexion($config, $machine, $login, $post_type);
                    computer_lock($machine, $login);
                    $open = 0;
                    // }
                    if ($res) {
                        $url = $config['guacamole_url'];
                        if ($open == 0) {
                            if ($post_window == 1) {
                                $script = "<script type=\"text/javascript\">
function openOnce(url, target){
    var winref = window.open('', target, 'resizable=yes,height=1080,width=1920');
    if(winref.location.href === 'about:blank'){
        winref.location.href = url;
        var refresh = true;
    }else if(winref.location.href === '" . $url . "/#/'){
        var refresh = true;
    }else{
        var refresh = false;
    }
    return winref;
}
openOnce('" . $url . "', 'guacamole');

</script>";
                            }
                            $open = 1;
                            $refresh = true;
                        } elseif ($post_window == 0) {
                            header("Location: " . $url);
                        } else {
                            $refresh = false;
                            $script = "<script type=\"text/javascript\">
        var refresh = false;
</script>";
                        }
                    }

                    $action = "login";
                    break;
                case "wait":
                    $diff = time() - $time;
                    if ($diff > 120) {
                        $liste[$p]['status'] = "no";
                        $action = "no";
                    } else {
                        sleep(5);
                        $message = $diff . "s";
                        $html .= "Allumage en cours... <progress max=\"120\" value=" . $diff . "> " . $diff . "% </progress>";
                        $script = "<script type=\"text/javascript\">
        var refresh = true;
</script>";
                        $refresh = true;
                        $action = "wait";
                    }
                    break;
                case "off":
                    start_poste($config, "wol", $poste['cn']);
                    computer_lock(strtolower($poste['cn']), $login);
                    sleep(5);
                    $liste[$p]['status'] = "wait";
                    $time = time();
                    $refresh = true;
                    $script = "<script type=\"text/javascript\">
        var refresh = true;
</script>";
                    $action = "wait";
                    break;
                default:
                    $action = "";
            }
        }
        // $html .= "index $p poste : <pre>" . print_r($liste[$p], true) . "</pre>";

        $remote[$login]['liste'] = $liste;
        apcu_store('remote', $remote, 600);
    }
    // $html .= "nb de machines : " . count($liste) . " nb en attente : " . count($remote[$login]['postes']) . " ";
    if (! $end) {
        $progress = 100 * count($liste) / (count($liste) + count($remote[$login]['postes']));
        $html .= "Détection des machines... <progress max=\"100\" value=" . $progress . "> " . $progress . "% </progress>";
        $script = "<script type=\"text/javascript\">
        var refresh = true;
</script>";
    }
    $categories = [
        'wait' => "attente d'allumage depuis " . $message,
        'login' => "rejoindre la session déjà ouverte",
        'on' => "se connecter sur la machine",
        'off' => "allumer et se connecter à la machine",
        'no' => "non disponible, déjà occupé"
    ];
    $html .= "<FORM action=\"\" id=\"remote\" method=\"post\" name=\"remote\">\n";
    $html .= "<label Choisir le poste pour la connexion à distance>";
    $html .= "<select name=\"machine\" size=6>";
    $i = 0;
    $oldstat = "";
    foreach ($liste as $poste) {
        if (isset($poste['cn'])) {
            if ($poste['status'] != $oldstat) {
                if ($i > 0) {
                    $html .= "</optgroup>";
                }
                $oldstat = $poste['status'];
                $html .= "<optgroup label=\"" . $categories[$poste['status']] . "\">";
            }
            $remote_msg = "";
            $html .= "<option value=\"" . $poste['cn'] . "\"";
            if ($i ++ == 0 && $end) { // && (empty($machine) || $machine == $poste['cn'])) {
                $html .= " selected";
                $type = $poste['remote'] ?? $post_type;
            }
            if (($poste['status'] == "on" || $poste['status'] == "login") && ! empty($poste['remote'])) {
                if ($poste['status'] == "on") {
                    $remote_msg = " en attente de connexion " . $poste['remote'];
                } else {
                    $remote_msg = " ouvert en " . $poste['remote'];
                }
            }
            $html .= ">" . $poste['cn'] . $remote_msg . "</option>";
        }
    }

    $html .= "</select>";
    $html .= "</label>";
    $html .= "<input type=\"hidden\" name=\"open\" value=\"" . $open . "\">";
    $html .= "<input type=\"hidden\" name=\"end\" value=\"" . $end . "\">";
    $html .= "<input type=\"hidden\" name=\"time\" value=\"" . $time . "\">";
    $html .= "<input type=\"hidden\" name=\"type\" value=\"" . $type . "\">";
    /*
     * true
     * if ($type == "all") {
     * $html .= "<div>
     * <input type=\"radio\" id=\"rdp\" name=\"type\" value=\"rdp\"";
     * if ($post_type == "rdp") {
     * $html .= " checked ";
     * }
     * $html .= ">";
     * $html .= "<label for=\"rdp\">Connexion RDP</label>
     * <input type=\"radio\" id=\"vnc\" name=\"type\" value=\"vnc\"";
     * if ($post_type == "vnc") {
     * $html .= " checked ";
     * }
     * $html .= ">";
     * $html .= "<label for=\"vnc\">Connexion VNC</label>
     * </div>";
     * } else {
     * $html .= "<input type=\"hidden\" name=\"type\" value=\"" . $type . "\">";
     * }
     */
    $config['se4_url'] = $config['se4_url'] ?? "http://" . $config['se4fs_name'];
    $html .= "<br><label for=\"rdp\">Ouverture de la connexion dans une fenêtre séparée (il faut préalablement autoriser les popup pour " . $config['se4_url'] . ") : </label>
    <input type=\"checkbox\" id=\"window\" name=\"window\" value=\"1\"";
    if ($post_window == "1" || @$config['guacamole_window'] == 1) {
        $html .= " checked ";
    }
    $html .= ">";
    $html .= "<div>";
    $url = $config['guacamole_url'];
    $html .= "Si la fenêtre d'accès distant ne s'ouvre pas, ouvrez une nouvelle fenêtre à cette adresse : <a href='" . $url . "'>" . $url . "</a>.";
    $html .= "<div>";
    $html .= "<input type=\"hidden\" name=\"action\" value=\"" . $action . "\">";
    $html .= "<input type=\"submit\" name=\"valider\" value=\"Valider\">";
    /*
     * $html .= "<FORM action=\"\" id=\"actualiser\" method=\"post\" name=\"actualiser\">\n";
     * $html .= "<input type=\"hidden\" name=\"machine\" value=\"\">";
     * $html .= "<input type=\"hidden\" name=\"type\" value=\"" . $post_type . "\">";
     * $html .= "<input type=\"submit\" name=\"action\" value=\"Actualiser\">";
     * $html .= "</form>";
     */
    $html .= "</div>";
    $html .= "</form>";

    $html .= $script;
    if ($refresh) {
        $html .= "<script type=\"text/javascript\">
if (refresh){
    var wait = setTimeout(document.remote.submit(), 10000);
}
</script>";
    }
    return $html;
}

/**
 * genere un token d'authentification permettant la connection directe guacamole pour l'utilisateur sur toutes les machines
 * listées.
 * Contrairement au mode ldap, on ne fait aucune vérif sur l'état des machines qui peuvent être éteintes ou occupées.
 * Elles seront mises dans la liste dans tous les cas.
 *
 * le token contient toutes les infos des connexions, il n'y a aucune mémorisation par guacamole de ces sessions,
 * qui sont donc indépendantes des sessions ldap.
 *
 * si le token est régénéré, il faut deconnecter/reconnecter le navigateur pour actualiser. en revanche les sessions rdp restent actives
 *
 * Le token est valide pour une durée limitée (2H par défaut).
 * le mot de passe utilisé pour la connexion doit avoir été mémorisé auparavant par l'application web, soit lors de l'auth, soit via un fichier de configuration.
 * En cas d'absence de mot de passe, l'auth guacamole sera demandée
 *
 * Cette fonction est exclusivement destinée à connecter des sessions administrateur.
 *
 * @param unknown $config
 * @param unknown $machines
 * @param unknown $user
 * @param unknown $password
 * @param number $timeout
 * @return boolean
 */
function create_remote_tokens($config, $machines, $user, $password = "", $timeout = 7200)
{
    if (! empty($config['guacamole_url'])) {
        if (empty($password) && ! empty($_SESSION['passwd'])) {
            $password = $_SESSION['passwd'];
        }
        foreach ($machines as $machine) {
            if (preg_match("/se4[fs|ad]/", $machine)) {
                $type = "ssh";
            } else {
                $type = "rdp";
            }
            switch ($type) {
                case "vnc":
                    break;
                case "ssh":
                    // guacamole veut une clé privée au format PEM
                    // Attention si la clé est ancienne il est possible qu'elle soit refusée
                    // dans ce cas il faut soit la renouveler, soit ajouter le chiffrage
                    // PubkeyAcceptedAlgorithms +ssh-rsa dans /etc/ssh/sshd_config (pas terrible en terme de sécu)
                    //
                    if (! file_exists("/etc/sambaedu/id_rsa.pem")) {
                        copy("/etc/sambaedu/id_rsa", "/etc/sambaedu/id_rsa.pem");
                        system("sudo ssh-keygen -p -N \"\" -m PEM -f /etc/sambaedu/id_rsa.pem");
                    }
                    $connections['ssh root sur ' . $machine] = array(
                        'parameters' => array(
                            "hostname" => $machine,
                            "port" => 22,
                            "username" => "root",
                            "private-key" => file_get_contents("/etc/sambaedu/id_rsa.pem")
                        ),
                        'protocol' => "ssh"
                    );
                    break;
                default:
                    $connections['rdp sur ' . $machine] = array(
                        'protocol' => 'rdp',
                        'parameters' => array(
                            "hostname" => $machine,
                            "port" => 3389,
                            "password" => $password,
                            "username" => $user,
                            "domain" => $config['samba_domain'],
                            "server-layout" => "fr-fr-azerty",
                            "ignore-cert" => true,
                            "enable-font-smoothing" => true,
                            "resize-method" => "display-update",
                            "enable-printing" => true,
                            "printer-name" => "Guacamole"
                        )
                    );
                    $connections['veyon sur ' . $machine] = array(
                        'protocol' => 'rdp',
                        'parameters' => array(
                            "hostname" => $machine,
                            "port" => 3389,
                            "password" => $password,
                            "username" => $user,
                            "domain" => $config['samba_domain'],
                            "server-layout" => "fr-fr-azerty",
                            "ignore-cert" => true,
                            "enable-font-smoothing" => true,
                            "resize-method" => "display-update",
                            "enable-printing" => true,
                            "printer-name" => "Guacamole",
                            "remote-app" => "||Veyon Master"
                        )
                    );
                /*
                 * $connections['veyon direct sur ' . $machine] = array(
                 * 'protocol' => 'rdp',
                 * 'parameters' => array(
                 * "hostname" => $machine,
                 * "port" => 3389,
                 * "password" => $password,
                 * "username" => $user,
                 * "domain" => $config['samba_domain'],
                 * "server-layout" => "fr-fr-azerty",
                 * "ignore-cert" => true,
                 * "enable-font-smoothing" => true,
                 * "resize-method" => "display-update",
                 * "enable-printing" => true,
                 * "printer-name" => "Guacamole",
                 * "remote-app" => "||Veyon Poste"
                 * )
                 * );
                 */
            }
        }
        $token = [
            'username' => $user,
            'expires' => (time() + $timeout) * 1000,
            'connections' => $connections
        ];
        if (empty($config['guac_priv_key'])) {
            set_config($config, 'guac_priv_key', bin2hex(openssl_random_pseudo_bytes(16)), "guacamole");
        }
        $json = json_encode($token);

        // Ne FONCTIONNE PAS, on utilise le script bash de référence
        // $config['guac_priv_key'] = "4C0B569E4C96DF157EEE1B65DD0E4D41";
        // $json = file_get_contents("/tmp/json2");
        // $iv = "0x00000000000000";
        // $data = hash_hmac("sha256", $json, $config['guac_priv_key'], true) . $json;
        // $ret['data'] = $data;
        // $ret = openssl_encrypt($data, "aes-128-cbc", $config['guac_priv_key'], $options=0, $iv);
        // echo $json;
        $file = "/tmp/token." . time();
        exec("touch $file && chmod 600 $file");
        file_put_contents($file, $json);
        exec("/usr/share/sambaedu/scripts/encrypt-json.sh " . $config['guac_priv_key'] . " " . $file, $out);
        $ret = $out[0];
        unlink($file);
    } else {
        $ret = true;
    }
    return $ret;
}

/**
 * genere un token d'authentification permettant la connection directe guacamole pour l'utilisateur sur une machine
 * listées.
 * Contrairement au mode ldap, on ne fait aucune vérif sur l'état des machines qui peuvent être éteintes ou occupées.
 *
 * le token contient toutes les infos des connexions, il n'y a aucune mémorisation par guacamole de ces sessions,
 * qui sont donc indépendantes des sessions ldap.
 *
 * si le token est régénéré, il faut deconnecter/reconnecter le navigateur pour actualiser. en revanche les sessions rdp restent actives
 *
 * Le token est valide pour une durée limitée (2H par défaut).
 * le mot de passe utilisé pour la connexion doit avoir été mémorisé auparavant par l'application web, soit lors de l'auth, soit via un fichier de configuration.
 * En cas d'absence de mot de passe, l'auth guacamole sera demandée
 *
 * Cette fonction est exclusivement destinée à connecter des sessions administrateur / technicien.
 *
 * accès via veyon à l'aide de :
 * https://github.com/kimmknight/remoteapptool?tab=readme-ov-file
 * doit être installé sur tous les postes de rebond pour pouvoir lancer veyon-master en mode remoteApp
 *
 * @param unknown $config
 * @param unknown $machines
 * @param unknown $user
 * @param unknown $password
 * @param number $timeout
 * @return $url
 */
function create_remote_token($config, $machine, $type, $user, $password = "", $timeout = 7200)
{
    if (! empty($config['guacamole_url'])) {
        if (empty($password) && ! empty($_SESSION['passwd'])) {
            $password = $_SESSION['passwd'];
        }

        if (preg_match("/se4[fs|ad]/", $machine['cn'])) {
            $type = "ssh";
        } else {
         //   $type = "rdp";
        }
        switch ($type) {
            case "vnc":
                break;
            case "ssh":
                // guacamole veut une clé privée au format PEM
                // Attention si la clé est ancienne il est possible qu'elle soit refusée
                // dans ce cas il faut soit la renouveler, soit ajouter le chiffrage
                // PubkeyAcceptedAlgorithms +ssh-rsa dans /etc/ssh/sshd_config (pas terrible en terme de sécu)
                //
                if (! file_exists("/etc/sambaedu/id_rsa.pem")) {
                    copy("/etc/sambaedu/id_rsa", "/etc/sambaedu/id_rsa.pem");
                    system("sudo ssh-keygen -p -N \"\" -m PEM -f /etc/sambaedu/id_rsa.pem");
                }
                $connections['ssh root sur ' . $machine['cn']] = array(
                    'parameters' => array(
                        "hostname" => $machine['cn'],
                        "port" => 22,
                        "username" => "root",
                        "private-key" => file_get_contents("/etc/sambaedu/id_rsa.pem")
                    ),
                    'protocol' => "ssh"
                );
                break;
            case "rdp":
                $connections['rdp sur ' . $machine['cn']] = array(
                    'protocol' => 'rdp',
                    'parameters' => array(
                        "hostname" => $machine['cn'],
                        "port" => 3389,
                        "password" => $password,
                        "username" => $user,
                        "domain" => $config['samba_domain'],
                        "server-layout" => "fr-fr-azerty",
                        "ignore-cert" => true,
                        "enable-font-smoothing" => true,
                        "resize-method" => "display-update",
                        "enable-printing" => true,
                        "printer-name" => "Guacamole"
                    )
                );
                break;
            case "master":
                $connections['master sur ' . $machine['cn']] = array(
                    'protocol' => 'rdp',
                    'parameters' => array(
                        "hostname" => $machine['cn'],
                        "port" => 3389,
                        "password" => $password,
                        "username" => $user,
                        "domain" => $config['samba_domain'],
                        "server-layout" => "fr-fr-azerty",
                        "ignore-cert" => true,
                        "enable-font-smoothing" => true,
                        "resize-method" => "display-update",
                        "enable-printing" => true,
                        "printer-name" => "Guacamole",
                        "remote-app" => "||Veyon Master" // veyon-master
                    )
                );
                break;
            case "veyon":
                $connections['veyon sur ' . $machine['cn']] = array(
                    'protocol' => 'rdp',
                    'parameters' => array(
                        "hostname" => $machine['cn'],
                        "port" => 3389,
                        "password" => $password,
                        "username" => $user,
                        "domain" => $config['samba_domain'],
                        "server-layout" => "fr-fr-azerty",
                        "ignore-cert" => true,
                        "enable-font-smoothing" => true,
                        "resize-method" => "display-update",
                        "enable-printing" => true,
                        "printer-name" => "Guacamole",
                        "remote-app" => "||Veyon Poste" // veyon-cli remote-access control $poste
                    )
                );
        }
        $token = [
            'username' => $user,
            'expires' => (time() + $timeout) * 1000,
            'connections' => $connections
        ];
        if (empty($config['guac_priv_key'])) {
            set_config($config, 'guac_priv_key', bin2hex(openssl_random_pseudo_bytes(16)), "guacamole");
        }
        $json = json_encode($token);

        // Ne FONCTIONNE PAS, on utilise le script bash de référence
        // $config['guac_priv_key'] = "4C0B569E4C96DF157EEE1B65DD0E4D41";
        // $json = file_get_contents("/tmp/json2");
        // $iv = "0x00000000000000";
        // $data = hash_hmac("sha256", $json, $config['guac_priv_key'], true) . $json;
        // $ret['data'] = $data;
        // $ret = openssl_encrypt($data, "aes-128-cbc", $config['guac_priv_key'], $options=0, $iv);
        // echo $json;
        // https://central.moncollege95.fr/0951696c/guacamole/#/client/cmRwIHN1ciAyMy12cHRlYzEtMTY5NmMAYwBqc29u?data=fv7ouomrZWze0sGR6kXWZttlfMb%2FuVx5X1W%2BrAyX7HjV5IJlCIlUZdCvKvHrpwidvdrpmuKxVJ4lyowajdmXbjJI6G%2FV0uoRNUtM4y%2Fu%2B05fBHCXJafQWja3P%2BmwzPVTLtuT%2FQfSbcvmkQMx2X4giVhFI0VsjfCGI%2F9y8%2Bq2r9xAdPDZOeFa23NZFLIf9bD9ugNuOWXqJ0pbfIYnCxULqAT0PUUFCytwVe34%2BZUJIbkfGdwhUnzHe2QBTRS7T7KrcOHb8cXwsDeKL3zPqWrn1xq58xgOmsD5TbP7zgFUWB0l4Ghd1npigNeZzQj4MGdH2rpo6uumifXTQQxswToyQiZqcT489GEJmSlXq%2BC%2Bvy0hQWZ60t81ZneMT7HmefSH5Crm2RVAksrjeKk7ia8qxy0y3EzMmgRYVV3t17Atwm7iGNWFAAepUB16gxkYl5bT97iIy6GcN9Kgn3iHogn9d0C5dPdm350vf0DO%2FZhSOISa9gqSa8jCAIDg4z8TOay%2BbIKm%2FbW6Ug0J7ld10ZiaJO057grdjbNlD39Gy1vcGTjdL%2F7A35E2EMNoucAzL3fG
        // 
        $file = "/tmp/token." . time();
        exec("touch $file && chmod 600 $file");
        file_put_contents($file, $json);
        exec("/usr/share/sambaedu/scripts/encrypt-json.sh " . $config['guac_priv_key'] . " " . $file, $out);
        $url = preg_replace("#/guacamole/#", "/" . $machine['etab'] . "/guacamole/", $config['guacamole_url']);
        $ret = $url . "#/?data=" . urlencode($out[0]);
        unlink($file);
    } else {
        $ret = true;
    }
    return $ret;
}

function configure_guacamole_server($config)
{
    $changed = false;
    $file = [];
    if (file_exists("/etc/tomcat10/server.xml") && false) {
        exec("sudo cat /etc/tomcat10/server.xml", $file);
        $version = 10;
    } elseif (file_exists("/etc/tomcat9/server.xml")) {
        exec("sudo cat /etc/tomcat9/server.xml", $file);
        $version = 9;
    }
    if (! empty($file)) {
        $file = implode("\n", $file);
        $xml = new DOMDocument();
        $xml->formatOutput = true;
        $xml->preserveWhiteSpace = false;
        $xml->loadXML($file);
        $xpath = new DOMXPath($xml);
        $key = $xpath->query("/Server/Service/Engine/Host/Valve[@internalProxies]")->item(0);
        if (! is_null($key)) {
            if (empty($config['reverse_proxy'])) {
                $key->parentNode->removeChild($key);
                $changed = true;
            } else {
                $revprox = $key->getAttribute('internalProxies');
                if ($revprox != $config['reverse_proxy']) {
                    $key->setAttribute('internalProxies', $config['reverse_proxy']);
                    $changed = true;
                }
            }
        } else {
            $key = $xpath->query("/Server/Service/Engine/Host")->item(0);
            $node = $xml->createElement("Valve");
            $node->setAttribute('className', "org.apache.catalina.valves.RemoteIpValve");
            $node->setAttribute('directory', "logs");
            $node->setAttribute('internalProxies', $config['reverse_proxy']);
            $node->setAttribute('remoteIpHeader', "x-forwarded-for");
            $node->setAttribute('remoteIpProxiesHeader', "x-forwarded-by");
            $node->setAttribute('protocolHeader', "x-forwarded-proto");
            $key->appendChild($node);
            $changed = true;
        }
        exec("sudo test -f /etc/guacamole/guacamole.properties", $out, $res);
        if ($res == 0) {
            unset($file);
            exec("sudo cp /etc/guacamole/guacamole.properties /tmp/guacamole.properties");
            exec("sudo chown www-admin /tmp/guacamole.properties");
            $file = file("/tmp/guacamole.properties");
            $params = [
                'se4ad_name' => $config['se4ad_name'],
                'ldap_port' => $config['ldap_port'],
                'people_rdn' => $config['people_rdn'],
                'ldap_base_dn' => $config['ldap_base_dn'],
                'admin_rdn' => $config['admin_rdn'],
                'ldap_admin_name' => $config['ldap_admin_name'],
                'ldap_admin_passwd' => $config['ldap_admin_passwd']
            ];
            $changed |= write_param($params, $file);
            foreach ($file as $line) {
                $m = [];
                if (preg_match("|^\s*([^#][[:alnum:]-]*)\s*:\s*(.*)$|", $line, $m)) {
                    $guac[$m[1]] = $m[2];
                }
            }
            if (! empty($guac['json-secret-key'])) {
                if ($guac['json-secret-key'] != $config['guac_priv_key']) {
                    $guac['json-secret-key'] = $config['guac_priv_key'];
                    $changed = true;
                }
            } else {
                $guac['json-secret-key'] = $config['guac_priv_key'];
                $changed = true;
            }
            if (empty($guac['extension-priority'])) {
                $guac['extension-priority'] = "ldap";
                $changed = true;
            }
        }
        if ($changed) {
            $xml->save("/tmp/server.xml");
            system("sudo cp /tmp/server.xml /etc/tomcat$version/server.xml");
            system("sudo chown tomcat:tomcat /etc/tomcat$version/server.xml");
            if ($version == 10) {
                // system("sudo rm -f /etc/tomcat9/server.xml");
            }
            if (! empty($guac)) {
                $file = "# conf guacamole sambaedu autogeneree\n";
                foreach ($guac as $param => $val) {
                    $file .= $param . ": " . $val . "\n";
                }
                file_put_contents("/tmp/guacamole.properties", $file);
                system("sudo mv /tmp/guacamole.properties /etc/guacamole/guacamole.properties");
                system("sudo chown tomcat:tomcat /etc/guacamole/guacamole.properties");
            }
            system("sudo systemctl restart tomcat$version.service");
        }
        return true;
    } else {
        return false;
    }
}
?>