<?php

/*
 * gestion des sites AD
 *
 * fonctions super basiques, uniquement destinées à la topologie * utiliée par le project sambaedu.
 * ne pas utiliser pour autre chose !
 * 1 - creer le site
 * 2 - faire un lien avec le central
 * 3 - ajouter des subnets au site
 * 4 - mettre au domaine l'AD du site en passant le nom du site lors de la mise au domaine.
 *
 * En cas de souci régler cela dans les consoles AD Sites et DNS...
 */
function etab_networks($config)
{
    putenv('RES_OPTIONS=retrans:1 retry:1 timeout:1 attempts:1');
    $data = [];
    $contents = file_get_contents("/etc/sambaedu/adressage.csv");
    $contents = explode("\n", $contents);
    foreach ($contents as $num => $line) {
        $index = - 1;
        $line = rtrim($line);
        if ($num == 0) {
            if (preg_match("/UAI/i", $line)) {
                $keys = preg_replace("/\"/", "", explode(";", $line, 80));
            }
        } elseif (! empty($line)) {
            $index = $num - 1;
            $val = preg_replace("/\"/", "", explode(";", $line, 80));
            if (count($val) > 0) {
                foreach ($keys as $ind => $key) {
                    if (! empty($key)) {
                        $data[$index][$key] = strtolower($val[$ind]) ?? "";
                    }
                }
            }
        }
    }
    $d = [];
    foreach ($data as $k => $e) {
        $uai = $e['UAI'];
        $ip = gethostbyname("se4fs-" . $uai);
        if ($ip == "se4fs-" . $uai) {
            $d[$uai]['se4fs_ip'] = long2ip(ip2long($e['Serveurs']) + $config['central_se4fs_ip']);
        } else {
            $d[$uai]['se4fs_ip'] = $ip;
        }
        $ip = gethostbyname("se4ad-" . $uai);
        if ($ip == "se4ad-" . $uai) {
            $d[$uai]['se4ad_ip'] = long2ip(ip2long($e['Serveurs']) + $config['central_se4ad_ip']);
        } else {
            $d[$uai]['se4ad_ip'] = $ip;
        }
        // ip du proxmox
        $ns = explode(".", $e['Serveurs']);
        $d[$uai]['pve_ip'] = implode(".", [
            $ns[0],
            $config['central_pve_net'],
            $ns[2],
            $config['central_pve_ip']
        ]);
        foreach ($e as $i => $v) {
            if (isset($config['central_' . $i . '_mask']) && isset($config['central_' . $i . '_vlan'])) {
                $d[$uai]['networks'][$i] = [
                    'net' => $v . $config['central_' . $i . '_mask'],
                    'vlan' => $config['central_' . $i . "_vlan"]
                ];
            }
        }
    }
    return $d;
}

function etab_coordinates($config, $etab)
{
    require_once (dirname(__FILE__) . '/../vendor/autoload.php');

    $url = "http://nominatim.openstreetmap.org/";
    $opt = [
        'base_uri' => $url
    ];
    curl_proxy_options($config, $opt);
    $client = new GuzzleHttp\Client($opt);

    $defaultHeader = [
        'verify' => false,
        'headers',
        array(
            'User-Agent' => 'sambaEdu'
        )
    ];
    try {
        $nominatim = new maxh\Nominatim\Nominatim($url, $defaultHeader, $client);
        $search = $nominatim->newSearch()
            ->country($etab['country'] ?? 'France')
            ->city($etab['city'] ?? "")
            ->postalcode($etab['code'] ?? "")
            ->street($etab['name'] ?? "")
            ->format('json')
            ->addressDetails(false);
        $result = $nominatim->find($search);
        if (isset($result[0])) {
            return $result[0]['lat'] . "," . $result[0]['lon'];
        } else {
            return "0.0";
        }
    } catch (\maxh\Nominatim\Exceptions\InvalidParameterException $e) {
        // If you set invalid parameter in instance
        var_dump($e->getMessage());
    } catch (\GuzzleHttp\Exception\ClientException $e) {
        // If you have any exceptions with Guzzle
        var_dump($e->getMessage());
    } catch (\maxh\Nominatim\Exceptions\NominatimException $e) {
        // If you set a wrong instance of Nominatim
        var_dump($e->getMessage());
    }
}

function add_etab(array $config, array $etab)
{
    $ou_rdn = $config['etablissements_rdn'];
    if (count(search_ad($config, $etab['UAI'], "etablissement")) == 0) {
        $info = array(
            "cn" => $etab['UAI'],
            "objectclass" => array(
                "top",
                "group"
            ),
            'displayname' => $etab['name'],
            'info' => $etab['Id GPEI'] ?? 0,
            'description' => $etab['typeEtab'] . " " . $etab['name'] . " " . $etab['city'] ?? "",
            "samaccountname" => $etab['UAI'],
            "grouptype" => 0x80000002,
            "textencodedoraddress" => etab_coordinates($config, $etab)
        );
        // Ajout
        // $config['bind'] = bind_ad_gssapi($config);
        $ret = ldap_add($config['bind'], "CN=" . $etab['UAI'] . "," . $ou_rdn . "," . $config['ldap_base_dn'], $info);
        echo "CN=" . $etab['UAI'] . "," . $ou_rdn . "," . $config['ldap_base_dn'];
        // var_dump($info);
        $err = ldap_error($config['bind']);
        // ldap_close($config['bind']);
        if ($ret) {
            apcu_store("ldap_cache_invalid", true, 60);
            apcu_delete("etabs");
            $config = get_config($config, false, $etab['UAI']);
            check_ad($config);
        } else {
            trigger_error($err . " : " . "CN=" . $etab['UAI'] . "," . $ou_rdn . "," . $config['ldap_base_dn']);
        }
        return $ret;
    } else
        return true;
}

function create_site(array $config, string $name)
{
    $attrs = [
        "objectclass" => [
            "top",
            "site"
        ],
        "cn" => $name,
        "name" => $name,
        "description" => "Site " . etab_to_name($config, $name)
    ];
    $ret = ldap_add($config['bind'], "CN=" . $name . ",CN=Sites,CN=Configuration," . $config['ldap_base_dn'], $attrs);
    $attrs = [
        "objectclass" => [
            "top",
            "serversContainer"
        ],
        "cn" => "Servers",
        "name" => "Servers"
    ];
    $ret &= ldap_add($config['bind'], "CN=Servers,CN=" . $name . ",CN=Sites,CN=Configuration," . $config['ldap_base_dn'], $attrs);
    $attrs = [
        "objectclass" => [
            "top",
            "applicationSiteSettings",
            "nTDSSiteSettings"
        ],
        "cn" => "NTDS Site Settings",
        "name" => "NTDS Site Settings"
    ];
    $ret &= ldap_add($config['bind'], "CN=NTDS Site Settings,CN=" . $name . ",CN=Sites,CN=Configuration," . $config['ldap_base_dn'], $attrs);

    if ($ret) {
        apcu_store("ldap_cache_invalid", true, 60);
    } else {
        $err = ldap_error($config['bind']);
        trigger_error("site : cn=" . $name . ",CN=Sites,CN=Configuration," . $config['ldap_base_dn'] . " : " . $err);
    }
    return $ret;
}

function create_site_link(array $config, string $name, string $site = "temp")
{
    $attrs = [
        "objectclass" => [
            "top",
            "siteLink"
        ],
        "cost" => 100,
        "replInterval" => 180,
        "cn" => $name,
        "name" => $name,
        "description" => "lien vers " . etab_to_name($config, $name),
        "siteList" => [
            "CN=Central,CN=Sites,CN=Configuration," . $config['ldap_base_dn'],
            "CN=" . $site . ",CN=Sites,CN=Configuration," . $config['ldap_base_dn']
        ]
    ];
    $ret = ldap_add($config['bind'], "CN=" . $name . ",CN=IP,CN=Inter-Site Transports,CN=Sites,CN=Configuration," . $config['ldap_base_dn'], $attrs);
    if ($ret) {
        apcu_store("ldap_cache_invalid", true, 60);
    } else {
        $err = ldap_error($config['bind']);
        trigger_error("link : cn=" . $name . ",CN=IP,CN=Inter-Site Transports,CN=Sites,CN=Configuration," . $config['ldap_base_dn'] . " : " . print_r($attrs));
    }
    return $ret;
}

function create_site_subnet(array $config, string $subnet, string $site, string $type = "", int $vlan)
{
    $attrs = [
        "objectclass" => [
            "top",
            "subnet"
        ],
        "cn" => $subnet,
        "name" => $subnet,
        "location" => $vlan,
        "description" => "reseau " . $type . " pour " . etab_to_name($config, $site),
        "siteObject" => "CN=" . $site . ",CN=Sites,CN=Configuration," . $config['ldap_base_dn']
    ];

    $ret = ldap_add($config['bind'], "CN=" . $subnet . ",CN=Subnets,CN=Sites,CN=Configuration," . $config['ldap_base_dn'], $attrs);
    if ($ret) {
        apcu_store("ldap_cache_invalid", true, 60);
    } else {
        $err = ldap_error($config['bind']);
        trigger_error("subnet : CN=" . $subnet . ",CN=Subnets,CN=sites,CN=Configuration," . $config['ldap_base_dn'] . " : " . $err);
    }
    return $ret;
}

function create_site_dhcp(&$config)
{
    $networks = get_network($config, false);
    if (empty($config['etab_ou']) && ! preg_match("/se4fs-[0-9]{7}[a-z]/i", $config['se4fs_name'])) {
        $subnets = search_ad($config, "*", "subnet");
        $central = true;
    } else {
        $config = get_config($config, true, $config['etab_ou']);
        $subnets = search_ad($config, $config['etab_ou'], "subnet");
        $central = false;
    }
    foreach ($subnets as $subnet) {
        $vlan = false;
        list ($net, $cidr) = explode("/", $subnet['cn']);
        $mask = - 1 << (32 - (int) $cidr);
        $nb = 2 ** (32 - $cidr);
        $n['reseau'] = $net;
        $broadcast = ip2long($net) | ~ $mask;
        $n['masque'] = long2ip($mask);
        $n['gateway'] = long2ip($broadcast - 1);
        $n['ip_min'] = long2ip(ip2long($net) + $nb / 8);
        $n['ip_max'] = long2ip($broadcast - 2);
        $n['begin_range'] = long2ip(ip2long($net) + $nb / 4);
        $n['end_range'] = long2ip(ip2long($net) + $nb * 3 / 4);
        if ($central) {
            if ($subnet['location'] == 100) {
                // sous réseaux serveurs des établissements dans la conf du central pour permettre le bootstrap des serveurs
                $vlan = explode(".", $n['reseau'])[2];
            }
        } elseif ($config['network'] == $n['reseau']) {
            // sous réseau par défaut (serveurs)
            $vlan = 0;
        } else {
            // vlans du site
            $vlan = $subnet['location'];
        }
        if ($vlan !== false) {
            foreach ($n as $k => $val) {
                if (! isset($networks[$k][$vlan]) || $val != long2ip($networks[$k][$vlan])) {
                    // ecriture de la conf dhcp
                    if ($vlan == 0) {
                        set_param($config, "dhcp_" . $k, $val, "dhcp");
                    } else {
                        set_param($config, "dhcp_" . $k . "_" . $vlan, $val, "dhcp");
                    }
                }
            }
        }
    }
}

function create_awx_host($config, $name, $ip, $site, $description)
{
    require_once (dirname(__FILE__) . '/../vendor/autoload.php');
    $opt = [
        'base_uri' => $config['awx_uri'],
        'cookies' => true
    ];
    curl_proxy_options($config, $opt);
    $client = new GuzzleHttp\Client($opt);
    try {
        $response = $client->request('GET', '/api/v2/inventories/' . $config['awx_inventory_id'] . '/hosts/?search=' . $name, [
            GuzzleHttp\RequestOptions::AUTH => [
                $config['awx_user'],
                $config['awx_password']
            ]
        ]);
        if ($response) {
            $found = (json_decode((string) $response->getBody(), true)['count'] > 0);
        }
        if ($found) {
            // echo "awx déjà fait pour $name et $site<br>";
            return true;
            // return json_decode((string) $response->getBody(), true)['results'][0];
        }

        if ($response = $client->request('POST', '/api/v2/inventories/' . $config['awx_inventory_id'] . '/hosts/', [
            GuzzleHttp\RequestOptions::AUTH => [
                $config['awx_user'],
                $config['awx_password']
            ],
            GuzzleHttp\RequestOptions::JSON => [
                'name' => $name,
                'description' => $description,
                'variables' => json_encode([
                    "ansible_host" => $ip,
                    "site" => $site
                ])
            ]
        ])) {
            echo "awx fait pour $name et $site<br>";
            return true;
        } else {
            return false;
        }
    } catch (\GuzzleHttp\Exception\RequestException $e) {
        echo "awx erreur pour $name <br><pre>" . print_r($e, true) . "</pre>";
        return false;
    }
}

function get_haproxy_session($config, $version)
{
    require_once (dirname(__FILE__) . '/../vendor/autoload.php');
    $opt = [
        'base_uri' => $config['haproxy_uri'],
        'cookies' => true
    ];
    curl_proxy_options($config, $opt);
    $client = new GuzzleHttp\Client($opt);
    try {
        $response = $client->request('POST', '/v2/services/haproxy/transactions?version=' . $version, [
            GuzzleHttp\RequestOptions::AUTH => [
                $config['haproxy_user'],
                $config['haproxy_password']
            ],
            GuzzleHttp\RequestOptions::JSON => []
        ]);
        if ($response) {
            return json_decode((string) $response->getBody(), true)['id'];
        }
    } catch (\GuzzleHttp\Exception\RequestException $e) {
        return false;
    }
}

function get_haproxy_backends($config)
{
    require_once (dirname(__FILE__) . '/../vendor/autoload.php');
    $opt = [
        'base_uri' => $config['haproxy_uri'],
        'cookies' => true
    ];
    curl_proxy_options($config, $opt);
    $client = new GuzzleHttp\Client($opt);
    try {
        $response = $client->request('GET', '/v2/services/haproxy/configuration/backends', [
            GuzzleHttp\RequestOptions::AUTH => [
                $config['haproxy_user'],
                $config['haproxy_password']
            ],
            GuzzleHttp\RequestOptions::JSON => []
        ]);
        if ($response) {
            return json_decode((string) $response->getBody(), true);
        }
    } catch (\GuzzleHttp\Exception\RequestException $e) {
        return false;
    }
}

function create_haproxy_backend($config, $name, $ip)
{
    $backends = get_haproxy_backends($config);
    if (! in_array($name, array_column($backends['data'], "name"))) {
        $id = get_haproxy_session($config, $backends['_version']);
        require_once (dirname(__FILE__) . '/../vendor/autoload.php');
        $opt = [
            'base_uri' => $config['haproxy_uri'],
            'cookies' => true
        ];
        curl_proxy_options($config, $opt);
        $client = new GuzzleHttp\Client($opt);
        try {
            $client->request('POST', '/v2/services/haproxy/configuration/backends', [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ],
                GuzzleHttp\RequestOptions::QUERY => [
                    'transaction_id' => $id
                ],
                GuzzleHttp\RequestOptions::JSON => [
                    'name' => $name,
                    'mode' => "http",
                    'connect_timeout' => 3000,
                    'server_timeout' => 300000,
                    'httpchk_params' => [
                        "method" => "OPTIONS",
                        "uri" => "/",
                        "version" => "HTTP/1.1"
                    ]
                ]
            ]);
            $client->request('POST', '/v2/services/haproxy/configuration/servers', [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ],
                GuzzleHttp\RequestOptions::QUERY => [
                    'transaction_id' => $id,
                    'backend' => $name
                ],
                GuzzleHttp\RequestOptions::JSON => [
                    'name' => "se4fs-" . $name,
                    "address" => $ip,
                    "port" => 80,
                    "check" => "enabled",
                    "inter" => 20000
                ]
            ]);
            $client->request('POST', '/v2/services/haproxy/configuration/http_request_rules', [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ],
                GuzzleHttp\RequestOptions::QUERY => [
                    'transaction_id' => $id,
                    'parent_type' => "backend",
                    'parent_name' => $name
                ],
                GuzzleHttp\RequestOptions::JSON => [
                    'type' => "replace-path",
                    'path_fmt' => "/\\1",
                    'path_match' => "^/" . $name . "/(.*)",
                    'index' => 0
                ]
            ]);

            $client->request('POST', '/v2/services/haproxy/configuration/acls', [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ],
                GuzzleHttp\RequestOptions::QUERY => [
                    'transaction_id' => $id,
                    'parent_type' => "frontend",
                    'parent_name' => "central_front"
                ],
                GuzzleHttp\RequestOptions::JSON => [
                    'acl_name' => "acl_" . $name,
                    "criterion" => "path_beg",
                    "value" => "/" . $name . "/",
                    'index' => 0
                ]
            ]);
            $client->request('POST', '/v2/services/haproxy/configuration/backend_switching_rules', [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ],
                GuzzleHttp\RequestOptions::QUERY => [
                    'transaction_id' => $id,
                    'frontend' => "central_front"
                ],
                GuzzleHttp\RequestOptions::JSON => [
                    'cond' => "if",
                    "cond_test" => "acl_" . $name,
                    "name" => $name,
                    "index" => 0
                ]
            ]);
            $response = $client->request('PUT', '/v2/services/haproxy/transactions/' . $id, [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ]
            ]);

            if ($response) {
                return (json_decode((string) $response->getBody(), true)['status'] == "success");
            }
        } catch (\GuzzleHttp\Exception\RequestException $e) {
            // return $e;
            return false;
        }
    }
}

function create_haproxy_guacamole_backend($config, $name, $ip)
{
    $name = "guacamole_" . $name;
    $backends = get_haproxy_backends($config);
    if (! in_array($name, array_column($backends['data'], "name"))) {
        $id = get_haproxy_session($config, $backends['_version']);
        require_once (dirname(__FILE__) . '/../vendor/autoload.php');
        $opt = [
            'base_uri' => $config['haproxy_uri'],
            'cookies' => true
        ];
        curl_proxy_options($config, $opt);
        $client = new GuzzleHttp\Client($opt);
        try {
            $client->request('POST', '/v2/services/haproxy/configuration/backends', [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ],
                GuzzleHttp\RequestOptions::QUERY => [
                    'transaction_id' => $id
                ],
                GuzzleHttp\RequestOptions::JSON => [
                    'name' => $name,
                    'mode' => "http",
                    'connect_timeout' => 3000,
                    'server_timeout' => 300000,
                    'httpchk_params' => [
                        "method" => "OPTIONS",
                        "uri" => "/",
                        "version" => "HTTP/1.1"
                    ]
                ]
            ]);
            $client->request('POST', '/v2/services/haproxy/configuration/servers', [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ],
                GuzzleHttp\RequestOptions::QUERY => [
                    'transaction_id' => $id,
                    'backend' => $name
                ],
                GuzzleHttp\RequestOptions::JSON => [
                    'name' => $name,
                    "address" => $ip,
                    "port" => 8080,
                    "check" => "enabled",
                    "inter" => 20000
                ]
            ]);
            $client->request('POST', '/v2/services/haproxy/configuration/http_request_rules', [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ],
                GuzzleHttp\RequestOptions::QUERY => [
                    'transaction_id' => $id,
                    'parent_type' => "backend",
                    'parent_name' => $name
                ],
                GuzzleHttp\RequestOptions::JSON => [
                    'type' => "replace-path",
                    'path_fmt' => "/\\1",
                    'path_match' => "^/" . $name . "/(.*)",
                    'index' => 0
                ]
            ]);
            
            $client->request('POST', '/v2/services/haproxy/configuration/acls', [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ],
                GuzzleHttp\RequestOptions::QUERY => [
                    'transaction_id' => $id,
                    'parent_type' => "frontend",
                    'parent_name' => "central_front"
                ],
                GuzzleHttp\RequestOptions::JSON => [
                    'acl_name' => "acl_" . $name,
                    "criterion" => "path_beg",
                    "value" => "/guacamole/",
                    'index' => 0
                ]
            ]);
            $client->request('POST', '/v2/services/haproxy/configuration/backend_switching_rules', [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ],
                GuzzleHttp\RequestOptions::QUERY => [
                    'transaction_id' => $id,
                    'frontend' => "central_front"
                ],
                GuzzleHttp\RequestOptions::JSON => [
                    'cond' => "if",
                    "cond_test" => "acl_" . $name,
                    "name" => $name,
                    "index" => 0
                ]
            ]);
            $response = $client->request('PUT', '/v2/services/haproxy/transactions/' . $id, [
                GuzzleHttp\RequestOptions::AUTH => [
                    $config['haproxy_user'],
                    $config['haproxy_password']
                ]
            ]);
            
            if ($response) {
                return (json_decode((string) $response->getBody(), true)['status'] == "success");
            }
        } catch (\GuzzleHttp\Exception\RequestException $e) {
            // return $e;
            return false;
        }
    }
}


function test_site($config)
{
    $res = create_site($config, "test");
    $res &= create_site_link($config, "test", "test");
    $res &= create_site_subnet($config, "192.168.222.0/24", "test", "test", 100);
    return $res;
}

function push_ssh_commands(array $config, array $commands, array $sites)
{
    $html = "";
    $header = [
        "#!/bin/bash",
        "rm -f /tmp/admin_script_normal.sh"
    ];
    $commands = array_merge($header, $commands);
    foreach ($sites as $etab) {
        if (fping("se4fs-" . $etab)) {
            foreach ($commands as $command) {
                system("ssh -i /etc/sambaedu/id_rsa -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null root@se4fs-" . $etab . " \"echo \\\"" . $command . "\\\" >> /tmp/admin_script_normal.sh\"");
            }
            system("ssh -i /etc/sambaedu/id_rsa -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null root@se4fs-" . $etab . " \" chmod 755 /tmp/admin_script_normal.sh\"");
            $html .= " envoi au serveur " . $etab . " de  \"" . $command . "\"<br>\n";
        }
    }
    return $html;
}

function apt_update_sites($config, $sites)
{
    $commands = [
        "apt-get update",
        "DEBIAN_FRONTEND=noninteractive apt-get full-upgrade -y"
    ];
    push_ssh_commands($config, $commands, $sites);
}

function activate_etab($config, $uai)
{
    $etabs = etab_networks($config);
    $site = $etabs[$uai];
    $html = "site " . $uai . " :<br>\n";
    $ret = true;
    $config = get_config($config, false);
    if (! search_ad($config, $uai, "site")) {
        if ($ret = create_site($config, $uai)) {
            $ret &= create_site_link($config, $uai, $uai);
            foreach ($site['networks'] as $k => $val) {
                $ret &= create_site_subnet($config, $val['net'], $uai, $k, $val['vlan']);
            }
        }
    }
    create_site_dhcp($config);
    // $ret &= create_awx_host($config, "pve-" . $uai, $site['pve_ip'], $uai, "serveur pve pour " . etab_to_name($config, $uai));
    $ret &= create_awx_host($config, "se4fs-" . $uai, $site['se4fs_ip'], $uai, "serveur se4fs pour " . etab_to_name($config, $uai));
    $ret &= create_awx_host($config, "se4ad-" . $uai, $site['se4ad_ip'], $uai, "serveur se4ad pour " . etab_to_name($config, $uai));
    $ret &= create_haproxy_backend($config, $uai, $site['se4fs_ip'], $uai);
    $ret &= create_nc_api_user($config, $uai);
    if ($ret) {
        $html .= " création site $uai OK, \n";
    } else {
        $html .= " création site $uai ERREUR<br>\n";
    }
    return $html;
}

?>