<?php

function connexion_db_stats($config)
{
    $link = mysqli_connect("localhost", "sambaedu", $config['sql_passwd'], "sambaedu");
    mysqli_set_charset($link, "utf8");
    return $link;
}

function deconnexion_db_stats($link)
{
    mysqli_close($link);
}

function get_stats_poste_date($link, $netbios_name, $date)
{
    $query = mysqli_prepare($link, "SELECT h00, h01, h02, h03, h04, h05, h06, h07, h08, h09, h10, h11, h12, h13, h14, h15, h16, h17, h18, h19, h20, h21, h22, h23 FROM connexions_stat WHERE netbios_name=? and date=?");
    mysqli_stmt_bind_param($query, "ss", $netbios_name, $date);
    mysqli_stmt_execute($query);
    mysqli_stmt_bind_result($query, $res_h00, $res_h01, $res_h02, $res_h03, $res_h04, $res_h05, $res_h06, $res_h07, $res_h08, $res_h09, $res_h10, $res_h11, $res_h12, $res_h13, $res_h14, $res_h15, $res_h16, $res_h17, $res_h18, $res_h19, $res_h20, $res_h21, $res_h22, $res_h23);
    mysqli_stmt_store_result($query);
    $num_rows = mysqli_stmt_num_rows($query);
    if ($num_rows != 0) {
        while (mysqli_stmt_fetch($query)) {
            $tab = array(
                0 => sprintf("%04d", decbin($res_h00)),
                1 => sprintf("%04d", decbin($res_h01)),
                2 => sprintf("%04d", decbin($res_h02)),
                3 => sprintf("%04d", decbin($res_h03)),
                4 => sprintf("%04d", decbin($res_h04)),
                5 => sprintf("%04d", decbin($res_h05)),
                6 => sprintf("%04d", decbin($res_h06)),
                7 => sprintf("%04d", decbin($res_h07)),
                8 => sprintf("%04d", decbin($res_h08)),
                9 => sprintf("%04d", decbin($res_h09)),
                10 => sprintf("%04d", decbin($res_h10)),
                11 => sprintf("%04d", decbin($res_h11)),
                12 => sprintf("%04d", decbin($res_h12)),
                13 => sprintf("%04d", decbin($res_h13)),
                14 => sprintf("%04d", decbin($res_h14)),
                15 => sprintf("%04d", decbin($res_h15)),
                16 => sprintf("%04d", decbin($res_h16)),
                17 => sprintf("%04d", decbin($res_h17)),
                18 => sprintf("%04d", decbin($res_h18)),
                19 => sprintf("%04d", decbin($res_h19)),
                20 => sprintf("%04d", decbin($res_h20)),
                21 => sprintf("%04d", decbin($res_h21)),
                22 => sprintf("%04d", decbin($res_h22)),
                23 => sprintf("%04d", decbin($res_h23))
            );
        }
    } else {
        $tab = array(
            0 => sprintf("%04d", decbin(0)),
            1 => sprintf("%04d", decbin(0)),
            2 => sprintf("%04d", decbin(0)),
            3 => sprintf("%04d", decbin(0)),
            4 => sprintf("%04d", decbin(0)),
            5 => sprintf("%04d", decbin(0)),
            6 => sprintf("%04d", decbin(0)),
            7 => sprintf("%04d", decbin(0)),
            8 => sprintf("%04d", decbin(0)),
            9 => sprintf("%04d", decbin(0)),
            10 => sprintf("%04d", decbin(0)),
            11 => sprintf("%04d", decbin(0)),
            12 => sprintf("%04d", decbin(0)),
            13 => sprintf("%04d", decbin(0)),
            14 => sprintf("%04d", decbin(0)),
            15 => sprintf("%04d", decbin(0)),
            16 => sprintf("%04d", decbin(0)),
            17 => sprintf("%04d", decbin(0)),
            18 => sprintf("%04d", decbin(0)),
            19 => sprintf("%04d", decbin(0)),
            20 => sprintf("%04d", decbin(0)),
            21 => sprintf("%04d", decbin(0)),
            22 => sprintf("%04d", decbin(0)),
            23 => sprintf("%04d", decbin(0))
        );
    }
    mysqli_stmt_close($query);
    return $tab;
}

function get_list_netbios_name($link)
{
    $query = mysqli_prepare($link, "SELECT netbios_name FROM `connexions_stat` group by netbios_name ASC");
    mysqli_stmt_execute($query);
    mysqli_stmt_bind_result($query, $res_netbios_name);
    mysqli_stmt_store_result($query);
    $num_rows = mysqli_stmt_num_rows($query);
    $tab = array();
    if ($num_rows != 0) {
        while (mysqli_stmt_fetch($query)) {
            $tab[] = $res_netbios_name;
        }
    }
    mysqli_stmt_close($query);
    return $tab;
}

function test_stats($link)
{
    $return = 0;
    $query = mysqli_prepare($link, "SHOW COLUMNS FROM connexions where field='id'");
    mysqli_stmt_execute($query);
    mysqli_stmt_bind_result($query, $res_field, $res_type, $res_null, $res_key, $res_default, $res_extra);
    mysqli_stmt_store_result($query);
    $num_rows_check1 = mysqli_stmt_num_rows($query);
    mysqli_stmt_close($query);

    if ($num_rows_check1 == 1) {
        $query = mysqli_prepare($link, "SHOW COLUMNS FROM connexions where field='flag_stat'");
        mysqli_stmt_execute($query);
        mysqli_stmt_bind_result($query, $res_field, $res_type, $res_null, $res_key, $res_default, $res_extra);
        mysqli_stmt_store_result($query);
        $num_rows_check2 = mysqli_stmt_num_rows($query);
        mysqli_stmt_close($query);
        if ($num_rows_check2 == 1) {
            $query = mysqli_prepare($link, "SHOW TABLES WHERE Tables_in_sambaedu='connexions_stat'");
            mysqli_stmt_execute($query);
            mysqli_stmt_bind_result($query, $res_tables);
            mysqli_stmt_store_result($query);
            $num_rows_check3 = mysqli_stmt_num_rows($query);
            mysqli_stmt_close($query);
            if ($num_rows_check3 == 1) {
                $return = 1;
            } else {
                $update_query = mysqli_prepare($link, "CREATE TABLE `connexions_stat` (
													  `id_connexions_stat` bigint(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
													  `netbios_name` varchar(15) NOT NULL,
													  `date` date NOT NULL,
													  `h00` bit(4) NOT NULL DEFAULT b'0',
													  `h01` bit(4) NOT NULL DEFAULT b'0',
													  `h02` bit(4) NOT NULL DEFAULT b'0',
													  `h03` bit(4) NOT NULL DEFAULT b'0',
													  `h04` bit(4) NOT NULL DEFAULT b'0',
													  `h05` bit(4) NOT NULL DEFAULT b'0',
													  `h06` bit(4) NOT NULL DEFAULT b'0',
													  `h07` bit(4) NOT NULL DEFAULT b'0',
													  `h08` bit(4) NOT NULL DEFAULT b'0',
													  `h09` bit(4) NOT NULL DEFAULT b'0',
													  `h10` bit(4) NOT NULL DEFAULT b'0',
													  `h11` bit(4) NOT NULL DEFAULT b'0',
													  `h12` bit(4) NOT NULL DEFAULT b'0',
													  `h13` bit(4) NOT NULL DEFAULT b'0',
													  `h14` bit(4) NOT NULL DEFAULT b'0',
													  `h15` bit(4) NOT NULL DEFAULT b'0',
													  `h16` bit(4) NOT NULL DEFAULT b'0',
													  `h17` bit(4) NOT NULL DEFAULT b'0',
													  `h18` bit(4) NOT NULL DEFAULT b'0',
													  `h19` bit(4) NOT NULL DEFAULT b'0',
													  `h20` bit(4) NOT NULL DEFAULT b'0',
													  `h21` bit(4) NOT NULL DEFAULT b'0',
													  `h22` bit(4) NOT NULL DEFAULT b'0',
													  `h23` bit(4) NOT NULL DEFAULT b'0'
													) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
                mysqli_stmt_execute($update_query);
                mysqli_stmt_close($update_query);
                $update_query = mysqli_prepare($link, "ALTER TABLE `connexions_stat` ADD UNIQUE KEY `netbios_name` (`netbios_name`,`date`);");
                mysqli_stmt_execute($update_query);
                mysqli_stmt_close($update_query);
                $return = 0;
            }
        } else {
            $update_query = mysqli_prepare($link, "ALTER TABLE `connexions` ADD `flag_stat` TINYINT(1) NOT NULL DEFAULT '0';");
            mysqli_stmt_execute($update_query);
            mysqli_stmt_close($update_query);
            $return = 0;
        }
    } else {
        $return = 0;
    }
    return $return;
}

function generate_stats_week($config, $netbios_name)
{
    $nb_creneau = 11;
    $hr_debut = 8;
    $nb_jour = 6;
    $startx = 50;
    $starty = 60;
    $hauteur_qh = 6;
    $largeur_jr = 100;
    $largeur_chr = 5;
    $largeur_chr2 = 8;
    $jour = array(
        "Dimanche",
        "Lundi",
        "Mardi",
        "Mercredi",
        "Jeudi",
        "Vendredi",
        "Samedi"
    );

    if (isset($_GET['date_start']))
        $date_start = $_GET['date_start'];
    else
        $date_start = date("Y-m-d", mktime(0, 0, 0, date("m"), date("d") - 7, date("Y")));

    $date_day = date("w", strtotime($date_start));
    $date_start = date("Y-m-d", strtotime("-" . ($date_day - 1) . "day", strtotime($date_start)));

    if (isset($_GET['hr_debut']))
        $hr_debut = $_GET['hr_debut'] + 0;
    else
        $hr_debut = 8;

    if (isset($_GET['nb_creneau']))
        $nb_creneau = $_GET['nb_creneau'] + 0;
    else
        $nb_creneau = 11;

    if (isset($_GET['nb_jour']))
        $nb_jour = $_GET['nb_jour'] + 0;
    else
        $nb_jour = 6;

    $largeur_im = $starty * 2 + $largeur_jr * $nb_jour;
    $hauteur_im = $startx * 2 + $hauteur_qh * 4 * $nb_creneau;

    $im = @imagecreate($largeur_im, $hauteur_im) or die("Impossible d'initialiser la bibliotheque GD");
    $background_color = imagecolorallocate($im, 255, 255, 255);

    $color_red = imagecolorallocate($im, 233, 14, 91);
    $color_green = imagecolorallocate($im, 14, 233, 91);
    $color_black = imagecolorallocate($im, 0, 0, 0);
    $color_gray = imagecolorallocate($im, 100, 100, 100);
    $text_color = imagecolorallocate($im, 0, 0, 0);

    imagefilledrectangle($im, $starty, $startx, $starty + $largeur_jr * $nb_jour, $startx + 4 * $hauteur_qh * $nb_creneau, $color_red);

    $stats_link = connexion_db_stats($config);
    for ($i = 0; $i < $nb_jour; $i ++) {
        $date_tmp = date("Y-m-d", strtotime("+" . $i . "day", strtotime($date_start)));
        $tab = get_stats_poste_date($stats_link, $netbios_name, $date_tmp);
        for ($ii = 0; $ii < 4; $ii ++) {
            for ($jj = 0; $jj < $nb_creneau; $jj ++) {
                if ($tab[$jj + $hr_debut][$ii] == "1")
                    imagefilledrectangle($im, $starty + $largeur_jr * $i, $startx + ($jj * 4 + $ii) * $hauteur_qh, $starty + $largeur_jr * ($i + 1), $startx + ($jj * 4 + 1 + $ii) * $hauteur_qh, $color_green);
            }
        }
    }
    deconnexion_db_stats($stats_link);

    imageline($im, $starty, $startx, $starty + $largeur_jr * $nb_jour, $startx, $color_black);
    imagestring($im, 1, $starty - 20, $startx, $hr_debut . "h", $text_color);

    for ($i = 1; $i <= $nb_creneau; $i ++) {
        imagestring($im, 1, $starty - 20, $startx + ($hauteur_qh * 4) * $i, ($i + $hr_debut) . "h", $text_color);
        imageline($im, $starty, $startx + ($hauteur_qh * 4) * $i, $starty + $largeur_jr * $nb_jour, $startx + ($hauteur_qh * 4) * $i, $color_black);
        // imageline($im, $starty,$startx+($hauteur_qh*4)*$i-$hauteur_qh,$starty+$largeur_jr*$nb_jour,$startx+($hauteur_qh*4)*$i-$hauteur_qh,$color_gray);
        // imageline($im, $starty,$startx+($hauteur_qh*4)*$i-$hauteur_qh*2,$starty+$largeur_jr*$nb_jour,$startx+($hauteur_qh*4)*$i-$hauteur_qh*2,$color_gray);
        // imageline($im, $starty,$startx+($hauteur_qh*4)*$i-$hauteur_qh*3,$starty+$largeur_jr*$nb_jour,$startx+($hauteur_qh*4)*$i-$hauteur_qh*3,$color_gray);
    }
    imageline($im, $starty, $startx, $starty, $startx + ($hauteur_qh * 4) * $nb_creneau, $color_black);
    for ($i = 1; $i <= $nb_jour; $i ++) {
        $ratio = round(($largeur_jr - strlen($jour[$i % 7]) * $largeur_chr) / 2, 0);
        imagestring($im, 1, $starty + $largeur_jr * ($i - 1) + $ratio, $startx - 10, $jour[$i % 7], $text_color);
        imageline($im, $starty + $largeur_jr * $i, $startx, $starty + $largeur_jr * $i, $startx + ($hauteur_qh * 4) * $nb_creneau, $color_black);
    }

    $titre = "Poste " . $netbios_name;
    $titre2 = "du " . date("d/m/Y", strtotime($date_start)) . " au " . date("d/m/Y", strtotime("+6day", strtotime($date_start)));
    $len_titre = strlen($titre);
    imagestring($im, 4, ($largeur_im - $len_titre * $largeur_chr2) / 2, 5, $titre, $text_color);
    $len_titre = strlen($titre2);
    imagestring($im, 4, ($largeur_im - $len_titre * $largeur_chr2) / 2, 20, $titre2, $text_color);
    ob_start();
    imagepng($im);
    $image_data = ob_get_contents();
    ob_end_clean();
    imagedestroy($im);
    return $image_data;
}
?>
