<?php

/**
 *
 */
function html_user_interface($config)
{
    $login = $config['login'];
    $user = search_user($config, $login);
    $config['etab_ou'] = $config['etab_ou'] ?? 0;
    // liste des établissements suivant le profil
    if (count(my_etabs($config, $user)) > 1 && have_right($config, SE_USER_ADMIN | SE_COMPUTER_ADMIN, $user, true)) {
        $etabs = array_merge(my_etabs($config, $user), activated_etabs($config));
    } else {
        $etabs = my_etabs($config, $user);
    }
    $redirect = $_GET['redirect'] ?? 0;
    // si pas de valeur choisie on prend l'étab de rattachement
    $etab_choix = $_POST['etab'] ?? $_GET['etab'] ?? $_SESSION['etab'] ?? $etabs[0]['uai'] ?? $config['etab_ou'];
    $_SESSION['etab'] = $etab_choix;
    if ($redirect == 0) {

        $_SESSION['redirects'] = $_SESSION['redirects'] ?? 0;

        // $index = 0 : rattacheement
        $index = array_search($etab_choix, array_column($etabs, 'uai'));
        $index_local = array_search($config['etab_ou'], array_column($etabs, 'uai'));

        if (! empty($config['etab_ou'])) {
            // on est sur un site
            if ($index === false || ! $etabs[$index]['activated']) {
                // l'étab n'existe pas encore, ou n'est pas activé on utilise le central.
                $_SESSION['redirects'] ++;
                if ($_SESSION['redirects'] > 4) {
                    echo "Erreur : boucle de redirection ! " . $etabs[$index]['uai'] . " : " . $index . " -> " . $index_local;
                    exit();
                }
                header("Location: /user/index.php?redirect=1");
            } elseif ($index_local === false) {
                // cnx ssur un etab non autorisé :
                if ($etabs[$index]['activated']) {
                    // redirect etab de rattachement
                    $_SESSION['redirects'] ++;
                    if ($_SESSION['redirects'] > 4) {
                        echo "Erreur : boucle de redirection ! " . $etabs[$index]['uai'] . " : " . $index . " -> " . $index_local;
                        exit();
                    }
                    $u = $etabs[0]['uai'];
                    if ($u == 0) {
                        $e = "";
                    } else {
                        $e = $u . "/";
                    }
                    header("Location: /" . $e . "user/index.php?redirect=1");
                } else {
                    // redirect central
                    $_SESSION['redirects'] ++;
                    if ($_SESSION['redirects'] > 4) {
                        echo "Erreur : boucle de redirection ! " . $etabs[$index]['uai'] . " : " . $index . " -> " . $index_local;
                        exit();
                    }

                    header("Location: /user/index.php?redirect=1");
                }
            } elseif ($index_local != $index) {
                // changement d'etab
                $_SESSION['redirects'] ++;
                if ($_SESSION['redirects'] > 4) {
                    echo "Erreur : boucle de redirection ! " . $etabs[$index]['uai'] . " : " . $index . " -> " . $index_local;
                    exit();
                }

                if (! empty($etabs[$index]['uai']) && $etabs[$index]['uai'] != 0) {
                    header("Location: /" . $etabs[$index]['uai'] . "/user/index.php?redirect=1");
                } else {
                    header("Location: /user/index.php?redirect=1");
                }
            }
        } else {
            // on est sur le central :
            if (! empty($etabs[$index]['uai']) && $etabs[$index]['uai'] != 0 && $etabs[$index]['activated']) {
                if ($_SESSION['redirects'] > 4) {
                    echo "Erreur : boucle de redirection ! " . $etabs[$index]['uai'] . " : " . $index . " -> " . $index_local;
                    exit();
                }

                header("Location: /" . $etabs[$index]['uai'] . "/user/index.php?redirect=1");
            }
        }
    }
    $page = $_POST['page'] ?? $_GET['page'] ?? "";
    $config = get_config($config, true, $etab_choix);
    $fullName = $user['fullname'] ?? $user['cn'];
    $sexe = $user['sexe'] ?? "M";
    $html_top = user_interface_entete($config, $user, $fullName, $page, $etabs, $etab_choix);
    $html_foot = user_interface_footer();
    $html = '<article>Etablissement : ' . etab_to_name($config, $etab_choix) . '' . welcome_message($config, $user, $fullName, $page) . '</article>';
    switch ($page) {
        case "dx":
            disconnect();
            if (! empty($_SESSION['oauth2state'])) {
                header("Location: " . $config['openent_uri']);
            } else {
                header("Location: ../index.html");
            }
            $html = html_login_form($config);
            $html_top = "";
            $html_foot = "";
            break;
        /*
         * case "mail":
         * $html = html_mail_form($config);
         * $html_top = "";
         * $html_foot = "";
         * break;
         */
        case "param":
        default:
            $html .= '<article><h1>Vos informations</H1>' . user_infos($config, $user);
            // <article>' . change_pwd($config, $login) . '</article>";
            // '<article>' . cloud_access($config, $login) . '</article>'.
            $html .= "<p>" . links($config, $user) . "</p>";
            $html .= "</article>";
            break;
        case "visio":
            $html .= '
            <article>' . visio_to_join($config, $login) . ' </article>';
            if (! is_eleve($config, $login)) {
                $html .= '
                <article> ' . form_create_bbb($config, $fullName, $sexe) . '</article>';
            }
            $html .= '
            <article>' . list_records($config, $login) . '</article>
            ';
            break;
        case "connect":
            $html .= '
            <article>' . connect_pc($config, $login) . '</article>
            ';
            break;
        case "shares":
            $html .= '
            <article>' . shares($config, $user) . '</article>
            ';
            break;
        case "devoirs":
            $html .= '
            <article>' . devoirs($config, $user) . '</article>
            ';
            break;
        case "echanges":
            $html .= '
            <article>' . echanges($config, $user) . '</article>
            ';
            break;
        case "links":
            $html .= '
            <article>' . change_pwd($config, $login, "", true) . '</article>
            ';
            break;
        case "applis":
            $html .= '
            <article>' . assign_applis($config, $login) . '</article>
            ';
            break;
        case "reinit":
            $html .= '
            <article-fullpage>' . reinit_pwd($config, $user) . '</article-fullpage>
            ';
            if (! empty($config['temp_users']) && empty($config['no_temp_users']) && have_right($config, SE_USER_CREATE_TEMP)) {
                $html .= '
            <article>' . create_temp_users($config, $user) . '</article>
            ';
            }
            break;
    }
    return $html_top . $html . $html_foot;
}

/*
 * Réinitialisation d'un compte d'élève par un de ses profs
 *
 */
function reinit_pwd($config, $user)
{
    $html = $html2 = "";
    $html .= "<H1>Réinitialisation des mots de passe de vos élèves ou des groupes dont vous êtes responsables.</H1>";
    $html .= "<p>Vous pouvez réinitialiser le mot de passe d'un des membres du groupe. </p>
		<p>Attention : indiquez lui dès à présent le code d'activation à usage unique généré afin qu'il soit en mesure d'ouvrir sa session.</p>";
    if (empty($config['ent_educonnect']) && ! empty($config['openent_uri'])) {
        $html .= "<p>Si l'identifiant initial ENT existe, il doit être utilisé pour la première connexion à l'ENT. L'ouverture de la session sur un ordinateur peut se faire en utilisant
				<b>identifiant_initial_ENT@" . $config['domain'] . "</b></p>";
    }

    // if (! have_right($config, SE_USER_PASSWORD_INIT, $user) || is_eleve($config, $user)) {
    // return $html;
    // }
    $ChoixClasse = $_POST['classe'] ?? "";
    $SovajonAReinit = $_POST['sovajon'] ?? "";

    sync_ent($config);
    $listClasses = list_classes_filtered($config, $user);
    if (in_array("Profs", $listClasses)) {
        $msg_classe = "Groupes";
    } else {
        $msg_classe = "Classes";
    }
    if (! empty($SovajonAReinit)) { // if (! apcu_fetch('ent_lock')) {
                                    // Réinitialisation des comptes selectionnés
        $listing = [];
        foreach ($SovajonAReinit as $value) {
            $html2 .= "<li>"; // Réinitialisation du compte : " . $value . ".";
                              // Recherche d'utilisateurs dans la branche people
            $info = search_user($config, $value);
            if (count($info) > 0 && (count(array_intersect(list_classes_filtered($config, $info, true), $listClasses)) > 0)) {
                $html2 .= reinit_passwd($config, $info, $listing, true, true);
            }
            $html2 .= "</li>";
        }
        $listing_name = "listing_" . session_id();
        apcu_store($listing_name, $listing);
        if (count($SovajonAReinit) > 0) {
            $html2 .= generate_listing($listing_name, false);
        }
    }
    $html .= '<form name="reinit" action="" method="post" id="reinit">';
    $html .= '<label for="classe" style="display : inline;">' . $msg_classe . ' :</label>';
    // $html .= '<select id="classe" name="classe" onchange="submit()" >';
    $html .= '<select id="classe" name="classe" >';
    $html .= '<option value="">Choix</option>';
    foreach ($listClasses as $classe) {
        $selected = "";
        if ($ChoixClasse == $classe) {
            $selected = "SELECTED";
        }
        $html .= '<option value="' . $classe . '" ' . $selected . '>' . $classe . '</option>';
    }
    $html .= "</select>";
    // $html .= '<input type="submit" name="valider" value="Valider">';
    $html .= "";
    // $html .= "</form>";

    $html .= "";

    if (! empty($ChoixClasse)) {
        // $html .= '<form name="reinit" action="" method="post">';
        $html .= "<center>";
        $html .= "<table>";
        $html .= "<tr>";
        $html .= "<th>Nom</th>";
        $html .= "<th>Prénom</th>";
        $html .= "<th>Identifiant</th>";
        $html .= "<th>Identifiant initial ENT</th>";
        $html .= "<th>Etat d'activation</th>";
        $html .= "<th>Tout selectionner";
        $html .= '<input type="checkbox" id="select-all">';
        $html .= " <br/>À activer";
        $html .= '<input type="checkbox" value="" id="select-2activate">';
        $html .= "</th>";
        $html .= "</tr>";
        if (preg_match("/Profs|Administratifs|Documentaliste|Agent|Medical|Direction|Secretariat|VieScol|Autres/", $ChoixClasse)) {
            $c = $ChoixClasse;
        } else {
            $c = "Classe_" . $ChoixClasse;
        }
        $people = search_people_group($config, $c);
        $passwords = apcu_fetch("passwords");
        if (! is_array($passwords)) {
            $passwords = [];
        }
        foreach ($people as $sovajon) {
            if (isset($sovajon['cn'])) {
                $checked = "";
                $toActivate = false;
                if ($sovajon['pwdlastset'] == 0) {
                    if (! empty($listing[$sovajon['dn']]['pwd'])) {
                        $pwd = $listing[$sovajon['dn']]['pwd'];
                        if (isset($listing[$sovajon['dn']]['pwde']) && $listing[$sovajon['dn']]['pwde'] != $pwd) {
                            $msg = "Code d'activation ENT : " . $listing[$sovajon['dn']]['pwde'] . "<br>Code d'accès aux ordinateurs<i>. $pwd .</i>";
                        } else {
                            $msg = "code d'activation ENT : " . $pwd;
                        }
                    } else {
                        $msg = "À activer";
                        $checked = ""; // "checked";
                        $toActivate = true;
                    }
                } else {
                    $msg = "mot de passe déjà changé ";
                }

                $html .= "<tr>";
                $html .= "<td>" . $sovajon['nom'] . "</td>";
                $html .= "<td>" . $sovajon['prenom'] . "</td>";
                $html .= "<td>" . $sovajon['cn'] . "</td>";
                $upn = $sovajon['userprincipalname'] ?? $sovajon['cn'];
                $o = explode("@", $upn)[0];
                if ($o != $sovajon['cn']) {
                    $html .= "<td>" . $o . "</td>";
                } else {
                    $html .= "<td></td>";
                }
                $html .= "<td>" . $msg . "</td>";
                $html .= "<td>";
                if ($toActivate) {
                    $html .= "<span value=\"toActivate\">";
                }
                $html .= "<input type=\"checkbox\"  name=\"sovajon[]\" value=\"" . $sovajon['cn'] . "\" " . $checked . " />";
                if ($toActivate) {
                    $html .= "</span>";
                }
                $html .= "</tr>";
            }
        }
        $html .= "</table>";
        $html .= "</center>";
        $html .= '<input type="submit" id="reinitpass" name="reinitpass" value="Réinitialiser ce(s) compte(s).">';
        // $html .= "</form>";
    }
    $html .= "</form>";
    $html .= $html2;

    // else {
    // $html .= "Un import est en cours, veuillez réessayer ultérieurement !";
    // }

    $html .= "";
    return $html;
}

/*
 * Création de comptes temporaires par le prof/perdir/refnum
 *
 */
function create_temp_users($config, $user)
{
    $html = $html2 = "";
    $html .= " <h1 class=\"h4 font-weight-bold text-primary\">Création d'utilisateurs temporaires</h1>";
    $html .= "<h2  class=\"h4\">Vous pouvez créer des comptes utilisateurs temporaires  :</h2>
<ul>
<li class=\"font-weight-lighter\">Attention, ces comptes seront effacés automatiquement lors de leur expiration. Toutes leurs données seront définitivement perdues.</li>";
    if (empty($config['no_temp_profiles'])) {
        $html .= "<li class=\"font-weight-lighter\">Pour les comptes élèves et profs, vous pouvez les associer à une classe existante ou créer une classe temporaire.</li>
<li class=\"font-weight-lighter\">Si vous êtes prof vous serez automatiquement ajouté à l'équipe de la classe choisie.</li>";
    }
    $html .= "</ul>";

    $classetemp = $_POST['classetemp'] ?? "";
    $nb = $_POST['nbtemp'] ?? 0;
    $duree = $_POST['dureetemp'] ?? 0;
    if (empty($config['no_temp_profiles'])) {
        if ($user['fonction'] == "Documentaliste" || have_right($config, SE_USER_CREATE_TEMP, $user)) {
            $msg_classe = "Classes";
            $listClasses = list_classes($config, "*");
            sort($listClasses);
            $typelist = [
                "Profs",
                "Eleves",
                "invite"
            ];
            $type = $_POST['typetemp'] ?? 'invite';
        } else {
            $msg_classe = "Classes";
            $listClasses = list_classes($config, $user);
            sort($listClasses);
            $typelist = [
                "Eleves"
            ];
            $type = $_POST['typetemp'] ?? 'Eleves';
        }
        array_unshift($listClasses, "");
        if (! empty($classetemp) && ! in_array($classetemp, $listClasses)) {
            array_unshift($listClasses, $classetemp);
        } else {
            array_unshift($listClasses, "Nouvelle...");
        }
    } else {
        $msg_classe = "";
        $typelist = [
            "invite"
        ];
        $type = $_POST['typetemp'] ?? 'invite';
    }

    if ($nb > 0) {
        // création des comptes temporaires
        $listing = [];
        $html2 .= "<ul>";
        for ($n = 0; $n < $nb; $n ++) {
            $html2 .= "<li>";
            create_temp_user($config, $html2, $listing, $type, $duree, $classetemp);
            $html2 .= "</li>";
        }
        $html2 .= "</ul>";
        if (is_prof($config, $user) && ! empty($classetemp) && preg_match("/Temp_/", $classetemp)) {
            add_user_group($config, $classetemp, $user, false, "classe");
        }
        $nb = 0;
        $listing_name = "listing_temp_" . session_id();
        apcu_store($listing_name, $listing);
        $html2 .= generate_listing($listing_name, false);
    }
    // affichage formulaire
    $html .= '<form name="tempusers" action="" method="post" id="tmpusers">';
    if ($type != 'invite') {
        // choix classe pour les comptes profs et eleves
        if ($classetemp == "Nouvelle...") {
            $html .= '<label for="classetempinput" style="display : inline;"> nom de classe temporaire : </label>';
            $html .= "<input id=\"classetempinput\" type=\"text\" name=\"classetemp\" value=\"Temp_\" onchange=\"submit()\">";
        } else {
            $html .= '<label for="classetemp" style="display : inline;">' . $msg_classe . ' : </label>';
            // $html .= '<select id="classe" name="classe" onchange="submit()" >';
            $html .= '<select id="classetemp" name="classetemp" onchange="submit()">';
            foreach ($listClasses as $classe) {
                $selected = "";
                if ($classetemp == $classe) {
                    $selected = "SELECTED";
                }
                $html .= '<option value="' . $classe . '" ' . $selected . '>' . $classe . ' </option>';
            }
            $html .= "</select>";
        }
    }
    $html .= '<label for="typetemp" style="display : inline;">profil du compte : </label>';
    // $html .= '<select id="classe" name="classe" onchange="submit()" >';
    $html .= '<select id="typetemp" name="typetemp" onchange="submit()">';
    foreach ($typelist as $t) {
        $selected = "";
        if ($type == $t) {
            $selected = "SELECTED";
        }
        $html .= '<option value="' . $t . '" ' . $selected . '>' . $t . '</option>';
    }
    $html .= "</select><br>";

    $html .= '<br><label for="nbtempinput" style="display : inline;">Nombre de comptes temporaires à créer : </label>';
    $html .= '<select id="nbtemp" name="nbtemp" >';
    for ($n = 0; $n < 31; $n ++) {
        $html .= '<option value="' . $n . '">' . $n . '</option>';
    }
    $html .= "</select><br>";
    $html .= '<br><label for="dureetemp" style="display : inline;">Durée de vie du compte (en comptant aujourd\'hui) : </label>';
    $html .= '<select id="dureetemp" name="dureetemp" >';
    for ($n = 0; $n < 7; $n ++) {
        $html .= '<option value="' . $n . '">' . $n + 1 . ' jour(s)</option>';
    }
    $html .= "</select><br>";
    if (! empty($_POST['etab'])) {
        $html .= '<input type="hidden" name="etab" value="' . $_POST['etab'] . '">';
    }
    $html .= '<input type="submit"  class="btn btn-primary" name="valider" value="Valider">';
    $html .= "";
    $html .= "</form>";
    $html .= "<hr>";
    $html .= $html2;
    $html .= "";
    return $html;
}

function echanges($config, $user)
{
    if (is_prof($config, $user) && ! empty($config['cloud_migrated']) && $config['cloud_migrated'] == 1) {
        return echanges_nc($config, $user);
    } else {
        return echanges_samba($config, $user);
    }
}

/*
 * Formulaire pour permettre aux profs
 * d'activer/désactiver le répertoire échange
 * pour leur classe
 */
function echanges_samba($config, $user)
{
    $html = "    ";
    $html .= " <h1>Pour chacune de vos classes vous pouvez activer ou désactiver le répertoire d'échanges.</h1>";
    /*
     * Action
     */
    $classe = $_POST['classe'] ?? "";
    $action = $_POST['action'] ?? "";
    if (! empty($classe) && ! empty($action)) {
        if ($action == "Activer") {
            $html .= update_classes($config, $classe, true, true);
        } else {
            $html .= update_classes($config, $classe, true, false);
        }
        batch_write("fast");
        system("sudo /tmp/partages.sh");
    }
    /*
     * formulaire
     */
    $listClasses = list_classes($config, $user);
    natcasesort($listClasses);
    $html .= "<ul>";

    foreach ($listClasses as $classe) {
        $html .= '<form name="echanges" action="" method="post">';
        $ClasseNomRep = "Classe_" . "$classe";
        $ClasseNomMin = strtolower($ClasseNomRep);
        $echangeDir = "/var/sambaedu/Classes/" . "$ClasseNomRep" . "/_echange";

        $check = get_facl("$echangeDir");
        if ($check["$ClasseNomMin"]['mode'] == "rwx") {
            $html .= "<li>Répertoire échange de la " . "$classe" . "  actuellement <b class='green'>activé</b>.";
            $html .= '<input type="submit" name="action" value="Désactiver">';
        } else {
            $html .= "<li>Répertoire échange de la " . "$classe" . "  actuellement <b class='red'>désactivé</b>.";
            $html .= '<input type="submit" name="action" value="Activer">';
        }
        $html .= '<input type="hidden" name="classe" value="' . $classe . '">';
        $html .= "";
        $html .= "</li>";
        $html .= "</form>";
    }
    $html .= "</ul>";

    return $html;
}

/*
 * Formulaire pour permettre aux profs
 * d'activer/désactiver le répertoire échange sur le cloud
 * pour leur classe
 */
function echanges_nc($config, $user)
{
    $html = "    ";
    $html .= " <h1>Pour chacune de vos classes et groupes vous pouvez activer ou désactiver le répertoire d'échanges sur le cloud de l'établissement.</h1>";
    /*
     * Action
     */
    $classe = $_POST['classe'] ?? "";
    // if (! $echanges = apcu_fetch("echanges" . $user['cn'])) {
    $echanges = list_nc_echanges($config, $user);
    // }

    if (! empty($classe)) {
        $res = toggle_nc_echange($config, $classe, $echanges, $html);
    }
    // $html .= "<pre>" . print_r($echanges, true) . "</pre>";

    /*
     * formulaire
     */
    $html .= "<ul>";

    foreach ($echanges as $groupe => $c) {
        $html .= '<form name="echanges" action="" method="post">';
        if ($c['id'] != 0) {
            $html .= "<li>Répertoire échange du groupe " . $c['type'] . " " . "$groupe" . "  actuellement <b class='green'>activé</b>.";
            $html .= '<input type="submit" name="action" value="Désactiver">';
        } else {
            $html .= "<li>Répertoire échange du groupe " . $c['type'] . " " . "$groupe" . "  actuellement <b class='red'>désactivé</b>.";
            $html .= '<input type="submit" name="action" value="Activer">';
        }
        $html .= '<input type="hidden" name="classe" value="' . $groupe . '">';
        $html .= "";
        $html .= "</li>";
        $html .= "</form>";
    }
    $html .= "</ul>";
    $html2 = "<ul><center>";
    $html2 .= "<table>";
    $html2 .= "<tr>";
    $html2 .= "<th span=2><b class='red'>Elèves n'ayant pas activé leur dossiers</b></th>";
    $html2 .= "</tr>";
    $html2 .= "<th>Classe</th>";
    $html2 .= "<th>nom de l'élève</th>";
    $html2 .= "</tr>";
    $na = 0;
    if (is_array($echanges['not_activated'])) {
        foreach ($echanges['not_activated'] as $nom => $groupe) {
            $classe = explode("@", $nom)[1] ?? $nom;
            foreach ($groupe as $eleve) {
                $na ++;
                $html2 .= "<tr>";
                $html2 .= "<td>" . $classe . "</td>";
                $html2 .= "<td><b class='red'>" . $eleve . "</b></td>";
                $html2 .= "</tr>";
            }
        }
    }
    $html2 .= "</table>";
    $html2 .= "</center></ul>";
    $html2 .= "<ul>";
    if ($na) {
        $html .= $html2;
    }

    apcu_store("echanges" . $user['cn'], $echanges);

    return $html;
}

/*
 * Formulaire pour permettre aux profs
 * d'associer les matieres à leurs classes et groupes
 *
 * lors de l'import, les profs sont mis dans toutes les matières définies pour leurs services. Celles ci sot définies
 * de façon globale.
 * le lien devra être fait par le prof en fonction de ses choix pédagogiqes.
 *
 * Pour chaque classe/goupe G on crée un groupe Matiere@M@G qui contient le ou les profs concernés.
 * Ce groupe servira ensuite à générer les partages.
 *
 * Ces groupes ne sont pas mis à jour lors des synchros (sauf en cas de suppression des matières ou classes dans l'annuaire)
 */
function shares(array $config, array &$user)
{
    $html = "    ";
    $html .= " <h1>Pour chacune de vos classes et groupes vous devez activer au moins une matière si vous voulez disposer d'un dossier partagé avec vos élèves sur le cloud de l'établissement.</h1>";
    /*
     * Action
     */
    $post_shares = $_POST['shares'] ?? [];
    $action = $_POST['action'] ?? [];
    $matieres_classe = list_prof_matieres($config, $user);
    if (count($post_shares) > 0) {
        // @TODO
        // return $html;
        // mettre le groupe dans la matiere
        foreach ($post_shares as $g => $share) {
            if (! empty($action[$g])) {
                foreach ($share as $s) {
                    // $group = type_group($config, $g);
                    // $html .= "$g : <pre>" . print_r(search_ad($config, $g, "group", $config['dn']['groups']), true) . "</pre>";
                    // $html .= "$g : <pre>" . print_r($group, true) . "</pre>";
                    $mc = $matieres_classe[$g] ?? [];
                    $mce = list_classe_matieres($config, $s);
                    if (count($mce) > 0) {
                        $mc = array_intersect($mc, $mce);
                    }
                    if (in_array("Aucune", $share)) {
                        $add = [];
                        $del = $mc;
                    } else {
                        $add = array_diff($share, $mc);
                        $del = array_diff($mc, $share);
                    }
                    foreach ($add as $m) {
                        add_prof_matiere_classe($config, $user, $m, $g);
                        // $not_activated[$m . "@" . $g] = update_nc_matieres($config, $m . "@" . $g, $user, $html);
                    }
                    $del = array_diff($mc, $share);
                    foreach ($del as $m) {
                        del_prof_matiere_classe($config, $user, $m, $g);
                    }
                    if (count($mc) > 0 && $action[$g] == "Mettre à jour") {
                        foreach ($mc as $n) {
                            $nom = $n . "@" . $g;
                            $html .= "$nom : ";
                            $html1 = "";
                            $not_activated[$nom] = update_nc_matieres($config, "/Matieres/" . $nom, $user, $html1);
                        }
                    }
                }
            }
        }
        // générer les partages cloud correspondants
    }
    $user = search_user($config, $user['cn']);
    $shares = list_classes($config, $user, true);
    $matieres = list_matieres($config, $user);
    $matieres_classe = list_prof_matieres($config, $user);
    /*
     * formulaire
     */
    $html .= "<center>"; // "<ul>";
    $html .= '<form name="shares" action="" method="post">
        <input type=hidden name=action>';

    foreach ($shares as $c) {
        // $html .= "$g : <pre>" . print_r($add, true) . "</pre>";
        $mc = $matieres_classe[$c['nom']] ?? [];
        $mce = list_classe_matieres($config, $c['nom']);
        if (count($mce) > 0) {
            $matieres = array_intersect($matieres, $mce);
        }
        if (count($matieres) == 1) {
            // pas besoin d'afficher une liste de choix. On affiche juste un bouton activer/desactiver
            $html .= "<h2>Matière  disponible pour le groupe " . $c['type'] . " " . $c['nom'] . " : </h2>";
            $html .= $matieres[0];
            if (count($mc) > 0) {
                $html .= "<input type=hidden name=\"shares[" . $c['nom'] . "][]\" value=\"\">";
                $html .= '<input type="submit" name="action[' . $c['nom'] . ']" value="Desactiver">';
            } else {
                $html .= "<input type=hidden name=\"shares[" . $c['nom'] . "][]\" value=\"" . $matieres[0] . "\">";
                $html .= '<input type="submit" name="action[' . $c['nom'] . ']" value="Activer">';
            }
        } else {
            $html .= "<h2>Matières activées pour le groupe " . $c['type'] . " " . $c['nom'] . " : </h2>";
            $html .= "<p>";
            $html .= "<select name=\"shares[" . $c['nom'] . "][]\" multiple>";
            $html .= "<option value=\"Aucune\">Aucune</option>";
            foreach ($matieres as $matiere) {
                $html .= "<option value=\"" . $matiere . "\" ";
                if (in_array($matiere, $mc, true) || count($matieres) == 1) {
                    $html .= "selected ";
                }
                $html .= ">" . $matiere . "</option>";
            }
            $html .= "</select>";
            $html .= "</p>";
            /*
             * if ($c['id'] != 0) {
             * $html .= "<li>Répertoire matière du groupe " . $c['type'] . " " . "$groupe" . " actuellement <b class='green'>activé</b>.";
             * $html .= '<input type="submit" name="action" value="Désactiver">';
             * } else {
             * $html .= "<li>Répertoire échange du groupe " . $c['type'] . " " . "$groupe" . " actuellement <b class='red'>désactivé</b>.";
             * $html .= '<input type="submit" name="action" value="Activer">';
             * }
             */
            // $html .= '<input type="hidden" name="classe" value="' . $c['nom'] . '">';
            $html .= '<input type="submit" name="action[' . $c['nom'] . ']" value="Associer">';
        }
        $html .= '<input type="submit" name="action[' . $c['nom'] . ']" value="Mettre à jour">';
        $html .= '<br><i>Attention la mise à jour peut prendre un peu de temps !</i><br>';
    }
    $html .= "</form>";
    $html .= "</center>"; // "</ul>";
    $html2 = "<center>";
    $html2 .= "<table>";
    $html2 .= "<tr>";
    $html2 .= "<th span=2>Elèves n'ayant pas activé leur dossiers</th>";
    $html2 .= "</tr>";
    $html2 .= "<th>Classe</th>";
    $html2 .= "<th>nom de l'élève</th>";
    $html2 .= "</tr>";
    $na = 0;
    if (is_array($not_activated)) {
        // print_r($not_activated);
        $old = "";
        foreach ($not_activated as $nom => $groupe) {
            $classe = explode("@", $nom)[1];
            // $matiere = explode("@", $nom)[0];
            if ($classe != $old) {
                $old = $classe;
                foreach ($groupe as $eleve) {
                    $na ++;
                    $html2 .= "<tr>";
                    $html2 .= "<td>" . $classe . "</td>";
                    $html2 .= "<td><b class='red'>" . $eleve . "</b></td>";
                    $html2 .= "</tr>";
                }
            }
        }
    }
    $html2 .= "</table>";
    $html2 .= "</center>";
    $html2 .= ""; // "<ul>";
    if ($na) {
        $html .= $html2;
    }

    // apcu_store("shares" . $user['cn'], $shares);

    return $html;
}

/*
 * Formulaire pour permettre aux profs
 * d'associer les matieres à leurs classes et groupes
 *
 * lors de l'import, les profs sont mis dans toutes les matières définies pour leurs services. Celles ci sot définies
 * de façon globale.
 * le lien devra être fait par le prof en fonction de ses choix pédagogiqes.
 *
 * Pour chaque classe/goupe G on crée un groupe Matiere@M@G qui contient le ou les profs concernés.
 * Ce groupe servira ensuite à générer les partages.
 *
 * Ces groupes ne sont pas mis à jour lors des synchros (sauf en cas de suppression des matières ou classes dans l'annuaire)
 */
function devoirs(array $config, array &$user)
{
    $html = "    ";
    $html .= " <h1>Gestion des devoirs</h1>";
    $html .= "<h2>Vous pouvez gérer les devoirs demandés à vos élèves.Pour créer un devoir vous devez  :</h2>
<ul>
<li>1 - Déposer soit un fichier, soit un dossier contenant l'ensemble des documents de travail dans votre dossier
<b>/Mes groupes/MATIERE@CLASSE/Devoirs</b>.</li>
<li>2 - Venir sur cette page.
Le nom du fichier ou du dossier sera le nom du devoir et il sera renommé automatiquement :
<b>/Mes groupes/MATIERE@CLASSE/Devoirs/NOM_DU_DEVOIR/Sujet</b></li>
<li> 3 - Lorsque vous activez ce devoir, un fichier ou dossier du nom du devoir sera créé pour chaque élève qui le verra dans :
<b>/Mes devoirs/MATIERE/</b>.
<br />De votre côté vous verrez dans le dossier :
<b>/Mes groupes/MATIERE@CLASSE/Devoirs/NOM_DU_DEVOIR</b>
un fichier ou dossier <b>nom.prenom</b> pour chaque élève.</li>
<li>4 - Quand les élèves ont terminé leur travail, vous pouvez verrouiller leurs fichiers, ou les cacher. Vous pouvez alors les corriger.</li>
</ul>";

    $action = $_POST['statut'] ?? [];

    $devoirs = list_nc_devoirs($config, $user, $html);
    // $html .= "<pre>" . print_r($action, true) . "</pre>";

    if (! empty($devoirs)) {
        foreach ($devoirs as $nom => $devoir) {
            if (isset($action[$nom]) && $action[$nom] != $devoir['statut']) {
                // $html .= "<pre>" . print_r($devoirs[$nom], true) . "</pre>";
                toggle_nc_devoir($config, $devoirs, $nom, $user, $action[$nom], $html);
            }
        }
    }
    /*
     * formulaire
     */
    $statuts = [
        'rafraichir' => "Mettre à jour suite à l'activation de partages élèves",
        'desactive' => "Désactivé : sujet non distribué aux élèves",
        'active' => "Activé : les élèves peuvent travailler sur le(s) documents",
        'verrouille' => "Verrouillé : les élèves ne peuvent pas modifier le(s) documents",
        'supprime' => "Supprimer complètement le devoir"
    ];
    $html2 = "<center>";
    $html2 .= "<table>";
    $html2 .= "<tr>";
    $html2 .= "<th span=2>Elèves n'ayant pas activé leur dossier</th>";
    $html2 .= "</tr>";
    $html2 .= "<th>Classe</th>";
    $html2 .= "<th>nom de l'élève</th>";
    $html2 .= "</tr>";
    $na = 0;
    foreach ($devoirs as $nom => $devoir) {
        if (isset($devoir['not_activated']) && is_array($devoir['not_activated'])) {
            foreach ($devoir['not_activated'] as $eleve) {
                $na ++;
                $html2 .= "<tr>";
                $html2 .= "<td>" . $devoir['classe'] . "</td>";
                $html2 .= "<td><b class='red'>" . $eleve . "</b></td>";
                $html2 .= "</tr>";
            }
        }
    }
    $html2 .= "</table>";
    $html2 .= "</center>";

    $html2 .= ""; // "<ul>";
    if ($na) {
        $html .= $html2;
    }

    if (! empty($devoirs)) {
        $html .= '<form name="devoirs" action="" method="post">
			<input type=hidden name=action>';

        $html .= "<table>";
        $html .= "<tr>";
        $html .= "<th>Devoir</th>";
        $html .= "<th>Matière</th>";
        $html .= "<th>Classe</th>";
        $html .= "<th>Choisir l'action dans la liste...</th>";
        $html .= "<th>Nombre d'élèves actifs</th>";
        $html .= "</tr>";
        foreach ($devoirs as $nom => $devoir) {
            $html .= "<tr>";
            $html .= "<td>" . $nom . "</td>";
            $html .= "<td>" . $devoir['matiere'] . "</td>";
            $html .= "<td>" . $devoir['classe'] . "</td>";
            $html .= "<td><select name=\"statut[" . $nom . "]\" onchange=\"submit()\" >";
            foreach ($statuts as $s => $msg) {
                if ($s == $devoir['statut']) {
                    $html .= "<option value=\"" . $s . "\" selected >" . $msg . "</option>";
                } else {
                    $html .= "<option value=\"" . $s . "\">" . $msg . "</option>";
                }
            }
            $html .= "</select></td>";
            $html .= "<td>" . count($devoir['eleves']) . "/" . $devoir['effectif'] . "</td>";
            $html .= "</tr>";
        }
        $html .= "</table>";
        $html .= "</form>";
        $html .= '<br><i>Attention la mise à jour peut prendre un peu de temps !</i><br>';
    }
    return $html;
}

/*
 * Formulaire pour permettre aux refnum et aux profs d'assigner des applications aux salles dont ils ont
 * une délégation de gestion
 *
 * La liste des applications est définie dans un fichier json
 * /etc/sambaedu/applications/delegated_apps.json
 *
 * c'est une simple liste des id wpkg des applications.
 *
 * Dans le cas d'une application déjà installée, son choix par le refnum forcera les associations de fichiers
 * définie pour cette application
 *
 */
function assign_applis(array $config, string $user)
{
    require_once "wpkg_libsql.php";
    $html = "";
    $html .= "<h1>Affecter des applications à un parc</h1>";
    $p = $_POST['parc'] ?? "";
    $parcs = [];
    if (have_right($config, SE_WPKG_ASSIGN)) {
        $allparcs = search_parcs($config, "*", "parc");
        foreach ($allparcs as $k => $parc) {
            if ($parc['name'] != "base") {
                $parcs[]['parcdn'] = $parc['gdn'];
            }
        }
    } else {
        $parcs = list_delegations($config, $user, true); // SE_COMPUTER_INSTALL);
    }
    $html .= '<form name="applis" action="" method="post">';
    $html .= "Parcs de machines configurables<br><select name=\"parc\" onchange=\"submit()\" >";
    $html .= "<option value=\"\" >Selectionner...</option>";
    foreach ($parcs as $parc) {
        if ($p == $parc['parcdn']) {
            $html .= "<option value=\"" . $parc['parcdn'] . "\" selected >" . ldap_dn2cn($parc['parcdn']) . "</option>";
            $selected_parc = $parc;
        } else {
            $html .= "<option value=\"" . $parc['parcdn'] . "\">" . ldap_dn2cn($parc['parcdn']) . "</option>";
        }
    }
    $html .= "</select><br>";
    if (isset($selected_parc['parcdn'])) {
        $parcdn = $selected_parc['parcdn'];
        if (isset($_POST['apps'])) {
            // $html .= "<pre> voulu:" . print_r( $_POST['apps'], true) . "</pre>";
            // $html .= "<pre>orig: " . print_r(array_column($applications_salle_orig, "id_app"), true) . "</pre>";
            // $html .= "<pre>restant: " . print_r(array_column($applications_salle, "id_app"), true) . "</pre>";
            set_entite_apps($config, $_POST['apps'], ldap_dn2cn($parcdn), "parc");
        }
        // il faut récupérer l'info pour tous le parcs parents + tous les postes
        // pas vraiment de méthode fiable, car les machines peuvent être dan des parcs non hièrarchiques
        // le mieux est de regarder une machine au hasard, la première de la liste...
        $machines = list_members_parc_fast($config, $parcdn);
        // var_dump($machines);
        foreach ($machines as $machine) {
            $applications = array_column(info_poste_applications($config, $machine), "info_app");
            if (is_array($applications) && count($applications) > 0) {
                break;
            }
        }

        // on ne permet la suppression que pour les applications associées au parc courant
        // return $html;
        $applications_salle = info_parc_appli($config, ldap_dn2cn($parcdn));
        if (is_array($applications) && is_array(array_column($applications, "id_nom_app")) && file_exists("/etc/sambaedu/applications/assigned_apps.json")) {

            $dispo = json_decode(file_get_contents("/etc/sambaedu/applications/assigned_apps.json"));
            $list = [];
            $liste_applications = array_column(liste_applications($config), NULL, "id_nom_app");
            // $html .= "<pre>orig: " . print_r($liste_applications, true) . "</pre>";

            foreach ($dispo as $app) {
                $k = array_search($app, array_column($applications, "id_nom_app"));
                if ($k !== false) {
                    $categorie = $applications[$k]["categorie_app"];
                    if (empty($categorie)) {
                        $categorie = "Non classé";
                    }
                    $s = array_search($app, array_column($applications_salle, "id_nom_app", "id_app"));
                    if ($s !== false) {
                        $list[$categorie]['removable'][] = [
                            'nom' => $app,
                            'id' => $applications[$k]['id_app'],
                            'display' => $applications[$k]['nom_app']
                        ];
                        unset($applications_salle[$s]);
                    } else {
                        $list[$categorie]['disabled'][] = [
                            'nom' => $app,
                            'id' => $applications[$k]["id_app"],
                            'display' => $applications[$k]['nom_app']
                        ];
                    }
                } elseif (isset($liste_applications[$app])) {
                    $categorie = $liste_applications[$app]['categorie_app'];
                    if (empty($categorie)) {
                        $categorie = "Non classé";
                    }
                    $list[$categorie]['installable'][] = [
                        'nom' => $app,
                        'id' => $liste_applications[$app]['id_app'],
                        'display' => $liste_applications[$app]['nom_app']
                    ];
                }
            }

            $html .= "<h1>Liste des applications pouvant être associées à ce parc (sélectionner ou déselectionner les applications)</h1>\n";
            $html .= "<div class=\"row\">\n";
            foreach ($list as $categorie => $a) {
                $html .= "<div class=\"col-xl-3 col-md-6 mb-4\">\n";
                $html .= "<h1>" . $categorie . "</h1>\n";
                foreach ($a as $type => $t) {
                    foreach ($t as $ligne) {
                        switch ($type) {
                            case "removable":
                                $html .= "<input type=checkbox name=\"apps[]\" value=\"" . $ligne['id'] . "\" checked > " . $ligne['display'] . "<br>\n";
                                break;
                            case "installable":
                                $html .= "<input type=checkbox name=\"apps[]\" value=\"" . $ligne['id'] . "\" > " . $ligne['display'] . "<br>\n";
                                break;
                            case "disabled":
                                $html .= "<input type=checkbox name=\"bidon[]\" value=\"" . $ligne['id'] . "\" checked disabled > " . $ligne['display'] . " (hérité)<br>\n";
                        }
                    }
                }
                $html .= "</div>\n";
            }
            foreach ($applications_salle as $l) {
                $html .= "<input type=hidden name=\"apps[]\" value=\"" . $l['id_app'] . "\">\n";
            }
            $html .= "</div>\n";

            $html .= '<input type="submit"  class="btn btn-primary" name="valider" value="Valider">';
            // $html .= "</div>";
        }
        $html .= "</form>\n";
    }

    return $html;
}

function user_infos($config, $user)
{
    $html = "";
    $list_current_groups = array();
    if (isset($user['memberof'])) {
        foreach ($user['memberof'] as $line) {
            if (preg_match("/Classe|Equipe|Profs|Eleves/i", $line)) {
                $list_current_groups[] = ldap_dn2cn($line);
            }
        }
    }
    if (rsort($list_current_groups)) {
        $html .= "<p> Vous êtes membre des groupes :\n</p>";
        foreach ($list_current_groups as $group) {
            $html .= "<LI>";
            $html .= $group;
            $html .= "</LI>\n";
        }
    }

    return $html;
}

function disconnect()
{
    return session_destroy();
}

function welcome_message($config, $user, $login, $page)
{
    $html = "";
    switch ($page) {
        case "dx":
            break;
        case "visio":
            $html .= "<H1>Tous les services de visioconférence</H1>";
            $html .= "<p>Si votre établissement dispose d'un serveur de visioconférence associé au serveur SambaÉdu,
                        vous pouvez ici rejoindre un salon de visioconférence ouvert ou retrouver et
                        lire l'enregistrement d'une conférence.</p>
                      <p>Si vous en avez les droits, vous pouvez aussi démarrer un salon.
                         Si vous quittez inopinément le salon que vous avez créé
                        (suite à un problème de connexion par exemple)
                        vous pouvez le retrouver ici, en rafraîchissant la page, afin de le rejoindre.</p>";
            break;
        case "connect":
            $html .= "<H1>Connectez vous à un ordinateur de l'établissement</H1>";
            $html .= "<p>Si votre établissement l'a configuré, vous pouvez utiliser ce service afin de vous connecter
                à distance à un ordinateur du réseau.
                Vous avez la possibilité d'ouvrir une session sur un ordinateur de l'établissement.</p>
                      <p>Vous pouvez demander l'ouverture de ce droit à votre administrateur.</p>";
            break;
        case "links":
            $html = "";
            break;
        case "reinit":
            $html = "";
            break;
        case "param":
        default:
            // $html .= "<H1>Les services offerts par votre serveur <b>SambaÉdu</b></H1>";
            $html .= "<p> </p>";
            break;
    }
    return $html;
}

function visio_to_join($config, $login)
{
    require_once ("bbb.inc.php");
    $html = "";
    $bbb_list = config_bbb($config);
    if (count($bbb_list) > 0) {

        $hash = md5($config['ldap_base_dn']);
        $html .= liste_meetings2join_bbb($config, $login, $bbb_list, $hash);
    }
    return $html;
}

function list_records($config, $login)
{
    require_once ("bbb.inc.php");
    $html = "";
    $suppr_html = "";
    $bbb_list = config_bbb($config);
    if (count($bbb_list) > 0) {
        $hash = md5($config['ldap_base_dn']);
        if (! is_eleve($config, $login)) {
            $suppr = $_POST['supprimer'] ?? "";
            if (! empty($suppr)) {
                $recordID = $_POST['recordID'] ?? "";
                $bbbServer = $_POST['bbbServer'] ?? "";
                $suppr_html .= remove_record_bbb($config, $bbb_list, $recordID, $bbbServer);
            }
        }
        $html .= html_liste_records_bbb($config, $login, $bbb_list, $hash);
    }
    return $html . $suppr_html;
}

function connect_pc($config, $login)
{
    require_once ("remote.inc.php");
    require_once ("logs.inc.php");
    require_once ("fonc_parc.inc.php");
    require_once ("fonc_outils.inc.php");
    require_once ("dhcpd.inc.php");
    $html = "<H1>Se connecter à un ordinateur de l'établissement</H1>";
    $html .= "<center>";
    // $html .= "liste : " . print_r(list_delegations($config, $login),true);
    // $html .= "liste : " . print_r(list_delegations_right($config, $login, SE_COMPUTER_CONTROL),true);
    $html .= display_remote_list($config, $login);
    $html .= "</center>";
    $html .= "<p class=\"machine\">Vous pouvez vous connecter sur le poste dans la nouvelle fenêtre qui va s'ouvrir.
Pensez à bien vous déconnecter à la fin de votre travail<br>
Si vous voulez changer de mode de connexion, ou de machine vous devez vous déconnecter, soit en fermant la session, soit en fermant guacamole (CTL + ALT + MAJ dans le navigateur, et cliquer en haut à droite sur votre nom, puis déconnecter)</p>";
    return $html;
}

/**
 * affiche les éléments permettant le paramétrage des différents accès cloud définis pour l'établissement
 *
 * @param array $config
 * @param array $login
 * @return string
 */
function links(array $config, array $login)
{
    // Verif presence rclone
    if (is_dir('/var/sambaedu/unattended/install/packages/rclone')) {
        $cloud = [];
        // cloud etab
        $html = cloud_etab_access($config, $login, $cloud);
        if (isset($config['cloud_perso']) && in_array($config['cloud_name'], $cloud) && groupaddmember($config, $login, "Cloud_etab")) {
            migrate_to_nc($config, $login, "home");
        }
        // apps.education
        $html .= cloud_apps_access($config, $login, $cloud);
        // drive.monlycee.net
        $html .= cloud_drive_idf_access($config, $login, $cloud);

        if (empty($config['no_cloud_migrate'])) {
            $html .= form_cloud_migrate($config, $login, $cloud);
        }
    } else {
        $html = '';
    }
    $html .= "<H1>Les liens vers les services de l'établissement</H1>";
    if (isset($config['link_url'])) {
        $link_url_array = explode(",", $config['link_url']);
        $link_text_array = explode(",", $config['link_text']);
        foreach ($link_url_array as $key => $value) {
            $html .= "<li><a href='" . $value . "' title=' ' target='_blank'>";
            $html .= $link_text_array[$key];
            $html .= '</a></li>';
        }
    }
    // if (have_right($config, SE_COMPUTER_ADMIN, $login['cn'])) {
    // $html .= "Admin OK";
    // } else {
    // $html .= list_rights($config, $login['cn']) | ~ SE_COMPUTER_ADMIN;
    // }
    return $html;
}

function change_pwd($config, $login, $old_password = "", $stack = false)
{

    /*
     * Changement du mot de passe
     */
    $auth = false;
    $rules = get_password_rule($config);
    $length = $rules['min-pwd-length'];
    if ($rules['complexity'] == "on")
        $complexity = true;
    else
        $complexity = false;
    $old_password = $_POST['old_password'] ?? $old_password ?? "";
    $dummy = $_POST['dummy'] ?? "";
    $dummy1 = $_POST['dummy1'] ?? "";
    $ret = [];
    $success = [];
    $html = "";
    $ent = ((isset($_SESSION['auth']) && $_SESSION['auth'] == "ent") || (! empty($config['ent_auth']) && $config['ent_auth'] == 1));
    if (! $ent) {
        $html .= "<H1>Modifier mon mot de passe</H1>";
        if (! empty($old_password) && ! empty($dummy) && ! empty($dummy1)) {
            // $test_old = user_valid_passwd($config, $login, $old_password);
            // if ($test_old == 0) {
            // $ret[] = "Votre mot de passe actuel est erroné";
            // }
            if ($dummy != $dummy1) {
                $ret[] = "Les mots de passe ne coïncident pas";
            }
            if (! verifPwd($dummy, $length, $complexity)[0]) {
                $ret[] = verifPwd($dummy, $length, $complexity)[1];
            }
            if (count($ret) < 1) {
                $auth = usersetpassword($config, $login, $dummy, false, $old_password, $stack);
                if ($auth) {
                    $success[] = "Votre mot de passe a été modifié.";
                    $cloud_stack = ! empty($config['cloud_stack']) || $stack;
                    if (! empty($config['cloud_uri']) && configure_user_cloud($config, $login, $dummy, $html, $cloud_stack)) {
                        $success[] = "Et votre accès au cloud " . $config['cloud_uri'];
                        if ($cloud_stack) {
                            $success[] = " sera configuré d'ici 24 heures.";
                        }
                        if ($stack) {
                            $success[] = " Veuillez patienter quelques minutes avant d'utiliser votre compte.";
                        }
                    }
                } else {
                    $ret[] = "Votre mot de passe n'a pas été modifié. Vous devez en choisir un différent des trois précédents.";
                }
            }
        }

        foreach ($ret as $message) {
            $html .= '<p class="error">' . $message . '</p>';
        }
        foreach ($success as $message) {
            $html .= '<p class="success">' . $message . '</p>';
        }
        if ($auth) {
            /*
             * On détruit la session pour relancer la connexion après le changement de mot de passe
             */
            disconnect();
            if (is_eleve($config, $login) && ! empty($config['central_url'])) {
                $url = $config['central_url'];
            } else {
                $url = "";
            }

            $html .= '<form name="chpwd" action="' . $url . '" method="post">
    			<input type="hidden" value="" name="login">
                <input type="hidden" value="" name="password">
                <input type="submit" value="OK" id="chpwdValid">
                </label>
                </form>';
        } else {
            $html .= "<script>var minPWlength = " . json_encode($length + 1) . ";</script>";
            $html .= '<form name="chpwd" action="" method="post">
            <div class="parent">
    			<label>Mot de passe actuel :</label>
                <input type="password" name="old_password" size="20" id="password" value="' . $old_password . '">
                <span id="password-field" class="fa fa-fw fa-eye field-icon toggle-password"></span>
                <label>Nouveau mot de passe :</label>
    			<input type="password" value="" name="dummy" size="20" maxlength="20" id="dummy" onkeyup="PasswordModifyEvents()">
    			<span id="password-field" class="fa fa-fw fa-eye field-icon toggle-password"></span>
    			<p id="dummy_text"></p>
                <label>Ressaisir nouveau mot de passe : </label>
    			<input type="password" value="" name="dummy1" size="20"	maxlength="20" id="dummy1" onkeyup="PasswordModifyEvents()">
    			<span id="password-field" class="fa fa-fw fa-eye field-icon toggle-password"></span>
    			<p id="dummy1_text"></p>
                <label>
                <input type="hidden" value="' . $login . '" name="login">
                <input type="submit" value="Valider" id="chpwdValid">
                </label>
                </div>
                </form>';
        }
    } else {
        $html .= "<H1>Identifiants ENT et SambaÉdu</H1>";
        $ent_password = $_POST['ent_password'] ?? "";
        $password2sync = $_POST['password2sync'] ?? "";
        $html_form = "";
        /*
         * on vérifie rien en dessous en fait, ce sont toujours les mêmes valeurs
         * je laisse pour debug, en replaçant $login par $_SESSION['login_ent'] dans le test
         * ça peut donner des infos
         */
        if ($login == $_SESSION['login']) {
            if (empty($_SESSION['login_ent'])) {
                header("Location: /oauth2/login.php");
                $_SESSION['login_ent'] = $_SESSION['login'];
            }
            $html_form .= "<p>Votre identifiant utilisable <b>sur l'ENT et SambaÉdu</b> est  <b>" . $_SESSION['login'] . "</b></p>";
            if ($_SESSION['login'] != $_SESSION['login_ent']) {
                $html_form .= "<p>Votre identifiant initial (<b>" . $_SESSION['login_ent'] . "</b>) est toujours utilisable sur l'ENT uniquement.</p>";
            }
        } else {
            $html_form .= "<p>Votre identifiant ENT : <b>" . $_SESSION['login_ent'] . "</b></p>";
            $html_form .= "<p>Votre identifiant SambaÉdu : <b>" . $_SESSION['login'] . "</b></p>";
        }
        if (! empty($config['gsuite_sync'])) {
            $html_form .= "<p>Votre adresse email SambaÉdu : <b>" . $_SESSION['login'] . "@" . $config['domain'] . "</b></p>";
        }
        $html_form .= '<center>
                <form name="synchropwd" action="" method="post">
    			<label>Vérifiez votre mot de passe <b>ENT</b> :</label>
                <input type="password" name="ent_password" size="20" id="password">
                <input type="checkbox" onclick="showPasswd()"> Afficher le mot de passe
                <br>';
        if (! empty($config['gsuite_sync'])) {
            $html_form .= '<input type="submit" value="Valider et activer votre compte Gsuite">';
        } else {
            $html_form .= '<input type="submit" value="Valider">';
        }
        $html_form .= '</form>';
        $html_form .= '</center>';
        if (! empty($ent_password)) {
            /*
             * check du password ENT avec le ... login ENT qui n'est pas toujours le même que $login
             */
            $cookies = false;
            if (! check_ent_passwd($config, $cookies, "", $_SESSION['login_ent'], $ent_password)) {
                $html .= "<p class='error'>Votre mot de passe ENT est erroné. Recommencez ou suivez le lien de régénération de mot de passe sur l'ENT.<p>";
                $html .= $html_form;
            } elseif (user_valid_passwd($config, $login, $ent_password) == 1) {
                if (! empty($config['gsuite_sync'])) {
                    require_once "gsuite.inc.php";
                    $email = change_gsuite_password($config, $login, $ent_password);
                    $html .= "<p class='error'>Votre compte mail est : <p>
                 <pre> $email </pre>";
                }
                if (empty($config['no_cloud']) && configure_user_cloud($config, $login, $ent_password) && ! empty($config['cloud_uri'])) {
                    $html .= "<p> et le dossier cloud " . $config['cloud_uri'] . "<p>";
                }
                $html .= "<p>Vos mots de passe sont correctement synchronisés.<p>";
            } else {
                $html .= "<p>Pour utiliser le même mot de passe sur le réseau SambaÉdu cliquer sur le bouton ci-dessous.</p>";
                $html .= '<center>
                    <form name="chgpsswd" action="" method="post">
                    <input type="hidden" name="password2sync" value="' . $ent_password . '">
                    <input type="submit" value="Synchroniser mon mot de passe">
                    </form>
                    </center>';
            }
        } elseif (! empty($password2sync)) {
            if (usersetpassword($config, $login, $password2sync)) {
                $html .= "<p>Votre mot de passe a été synchronisé sur SambaÉdu. C'est à présent le mot de passe à utiliser pour ouvrir des sessions sur les ordinateurs de l'établissement.</p>";
                if (! empty($config['gsuite_sync'])) {
                    require_once "gsuite.inc.php";
                    $email = change_gsuite_password($config, $login, $ent_password);
                    $html .= "<p> et également pour votre compte mail <pre> $email </pre><p>";
                }
                if (empty($config['no_cloud']) && configure_user_cloud($config, $login, $ent_password) && ! empty($config['cloud_uri'])) {
                    $html .= "<p> et le dossier cloud " . $config['cloud_uri'] . "<p>";
                }
            }
        } else {
            $html .= $html_form;
        }
    }

    return $html;
}

function send_activation_message($config, $login, $mail)
{
    $user = search_user($config, $login);
    if (! isset($user['email'])) {
        trigger_error($login);
        return;
    }
    $listing = [];
    if (strcasecmp($mail, $user['email']) == 0) {
        $boundary = hash("sha256", time());
        $mime_boundary = "--{$boundary}";
        $headers = "MIME-Version: 1.0\n";
        $headers .= "Content-Type: multipart/mixed;";
        $headers .= "boundary=$boundary";
        $body = "$mime_boundary\n";
        $body .= "Content-Type: text/html; charset=\"UTF-8\"\n";
        $body .= "Content-Transfer-Encoding: 7bit\n\n";
        $body .= reinit_passwd($config, $user, $listing, true);
        $body .= "\n\n";
        if (is_array($listing) && count($listing) > 0) {
            $body .= "$mime_boundary\n";
            $body .= generate_listing_pdf($config, $listing, true);
            $body .= "\n\n";
        }
        $body = str_replace(chr(0), '\n', $body);
        mail($mail, "Code d'activation", $body, $headers);
    }
}

/**
 * Cracheur de html
 *
 * @param string $login
 * @return string
 */
function user_interface_entete($config, $user, $login, $page, $etabs, $etab_choix)
{
    $selected_applis = $selected_visio = $selected_connect = $selected_links = $selected_echanges = $selected_shares = $selected_reinit = $selected_devoirs = "";
    switch ($page) {
        case "reinit":
            $selected_reinit = 'class=selected';
            break;
        case "visio":
            $selected_visio = 'class="selected"';
            break;
        case "connect":
            $selected_connect = 'class="selected"';
            break;
        case "links":
            $selected_links = 'class="selected"';
            break;
        case "shares":
            $selected_shares = 'class="selected"';
            break;
        case "devoirs":
            $selected_devoirs = 'class="selected"';
            break;
        case "applis":
            $selected_applis = 'class="selected"';
            break;
        case "echanges":
            $selected_echanges = 'class="selected"';
            break;
    }
    /*
     *
     * Message de bienvenue
     */
    $WelcomeMessage = replace_element($config, "WelcomeMessage", "Bienvenue sur l&apos;interface des utilisateurs de SambaÉdu");
    /*
     * Logo dessus
     */
    $LogoDessus = replace_element($config, "LogoDessus", "../elements/images/logo-dessus.gif");
    /*
     * Titre de la page
     */
    $UserPageTitle = replace_element($config, "UserPageTitle", "SambaÉdu");
    /*
     * Pour les profs, un lien vers la gestion des partages
     * et la réinitialisation du mot de passe
     */
    $html_profs = "";
    // print_r($user);
    if (is_prof($config, $user) || have_right($config, SE_USER_PASSWORD_INIT)) {
        if (empty($config['no_echange_shares'])) {
            $html_profs .= '
            <li ' . $selected_echanges . '>
            <a href="?page=echanges">
            <svg>
            <use xlink:href="#echanges"></use>
            </svg>
            <span>Répertoires «&nbsp;échanges&nbsp;»</span>
            </a>
            </li>';
        }
        if (! empty($config['cloud_name']) && empty($config['no_matiere_shares'])) {
            $html_profs .= '
            <li ' . $selected_shares . '>
            <a href="?page=shares">
            <span class="fa fa-fw fa-list menu_icon"></span>
            <span>Partages « matières »</span>
            </a>
            </li>';
        }
        if (! empty($config['cloud_name']) && empty($config['no_devoir_shares'])) {
            $html_profs .= '
            <li ' . $selected_devoirs . '>
            <a href="?page=devoirs">
            <span class="fa fa-fw fa-file-text menu_icon"></span>
            <span>Gestion des devoirs</span>
            </a>
            </li>';
        }

        $html_profs .= '
        <li ' . $selected_reinit . '>
        <a href="?page=reinit">
        <span class="fa fa-users menu_icon"></span>
        <span>Gerer les utilisateurs</span>
        </a>
        </li>';
    }

    /*
     * Pour les se3_is_admin un lien vers l'interface d'admin
     */
    $html_admin = "";
    if (! is_eleve($config, $user)) {
        if (have_right($config, SE_ADMIN, $user)) {
            $html_admin .= '<li>
        <a href="../admin/">
        <svg>
        <use xlink:href="#admin"></use>
        </svg>
        <span>Administration du serveur</span>
        </a>
        </li>';
        } elseif (list_delegations($config, $user['cn']) || have_right($config, SE_WPKG_ASSIGN, $user['cn'])) {
            $html_admin .= '
        <li ' . $selected_applis . '>
            <a href="?page=applis">
            <span class="fa fa-fw fa-list menu_icon"></span>
            <span>Affectation des applications</span>
            </a>
        </li>';
            $html_admin .= '<li>
        <a href="../annu/people.php?cn=' . $user['cn'] . '">
        <svg>
        <use xlink:href="#admin"></use>
        </svg>
        <span>Administration des ordinateurs</span>
        </a>
        </li>';
        }
    }

    $html = '
<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8" />
        <link type="text/css" rel="stylesheet" href="../vendor/twbs/bootstrap/dist/css/bootstrap.min.css">
		<script src="../vendor/twbs/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
        <link rel="stylesheet" href="user.interface.css" />
        <link rel="stylesheet" href="../vendor/fortawesome/font-awesome/css/all.min.css" />
        <title>' . $UserPageTitle .
        '</title>
    </head>
    <body onload="collapsed()">
            
<svg style="display:none;">
    <symbol id="echanges" viewBox="0 0 20 20">
    <rect x="4.16" y="1.75" width="1" height="7.97"/><polygon points="7.15 8.99 4.66 13.31 2.16 8.99 7.15 8.99"/><rect x="12.84" y="11.03" width="1" height="4.97"/><polygon points="11.85 11.47 13.34 8.88 14.84 11.47 11.85 11.47"/>
    </symbol>
    <symbol id="shares" viewBox="0 0 20 20">
    <rect x="4.16" y="1.75" width="1" height="7.97"/><polygon points="7.15 8.99 4.66 13.31 2.16 8.99 7.15 8.99"/><rect x="12.84" y="11.03" width="1" height="4.97"/><polygon points="11.85 11.47 13.34 8.88 14.84 11.47 11.85 11.47"/>
    </symbol>
    <symbol id="admin" viewBox="0 0 20 20">
    <path d="M17.498,11.697c-0.453-0.453-0.704-1.055-0.704-1.697c0-0.642,0.251-1.244,0.704-1.697c0.069-0.071,0.15-0.141,0.257-0.22c0.127-0.097,0.181-0.262,0.137-0.417c-0.164-0.558-0.388-1.093-0.662-1.597c-0.075-0.141-0.231-0.22-0.391-0.199c-0.13,0.02-0.238,0.027-0.336,0.027c-1.325,0-2.401-1.076-2.401-2.4c0-0.099,0.008-0.207,0.027-0.336c0.021-0.158-0.059-0.316-0.199-0.391c-0.503-0.274-1.039-0.498-1.597-0.662c-0.154-0.044-0.32,0.01-0.416,0.137c-0.079,0.106-0.148,0.188-0.22,0.257C11.244,2.956,10.643,3.207,10,3.207c-0.642,0-1.244-0.25-1.697-0.704c-0.071-0.069-0.141-0.15-0.22-0.257C7.987,2.119,7.821,2.065,7.667,2.109C7.109,2.275,6.571,2.497,6.07,2.771C5.929,2.846,5.85,3.004,5.871,3.162c0.02,0.129,0.027,0.237,0.027,0.336c0,1.325-1.076,2.4-2.401,2.4c-0.098,0-0.206-0.007-0.335-0.027C3.001,5.851,2.845,5.929,2.77,6.07C2.496,6.572,2.274,7.109,2.108,7.667c-0.044,0.154,0.01,0.32,0.137,0.417c0.106,0.079,0.187,0.148,0.256,0.22c0.938,0.936,0.938,2.458,0,3.394c-0.069,0.072-0.15,0.141-0.256,0.221c-0.127,0.096-0.181,0.262-0.137,0.416c0.166,0.557,0.388,1.096,0.662,1.596c0.075,0.143,0.231,0.221,0.392,0.199c0.129-0.02,0.237-0.027,0.335-0.027c1.325,0,2.401,1.076,2.401,2.402c0,0.098-0.007,0.205-0.027,0.334C5.85,16.996,5.929,17.154,6.07,17.23c0.501,0.273,1.04,0.496,1.597,0.66c0.154,0.047,0.32-0.008,0.417-0.137c0.079-0.105,0.148-0.186,0.22-0.256c0.454-0.453,1.055-0.703,1.697-0.703c0.643,0,1.244,0.25,1.697,0.703c0.071,0.07,0.141,0.15,0.22,0.256c0.073,0.098,0.188,0.152,0.307,0.152c0.036,0,0.073-0.004,0.109-0.016c0.558-0.164,1.096-0.387,1.597-0.66c0.141-0.076,0.22-0.234,0.199-0.393c-0.02-0.129-0.027-0.236-0.027-0.334c0-1.326,1.076-2.402,2.401-2.402c0.098,0,0.206,0.008,0.336,0.027c0.159,0.021,0.315-0.057,0.391-0.199c0.274-0.5,0.496-1.039,0.662-1.596c0.044-0.154-0.01-0.32-0.137-0.416C17.648,11.838,17.567,11.77,17.498,11.697 M16.671,13.334c-0.059-0.002-0.114-0.002-0.168-0.002c-1.749,0-3.173,1.422-3.173,3.172c0,0.053,0.002,0.109,0.004,0.166c-0.312,0.158-0.64,0.295-0.976,0.406c-0.039-0.045-0.077-0.086-0.115-0.123c-0.601-0.6-1.396-0.93-2.243-0.93s-1.643,0.33-2.243,0.93c-0.039,0.037-0.077,0.078-0.116,0.123c-0.336-0.111-0.664-0.248-0.976-0.406c0.002-0.057,0.004-0.113,0.004-0.166c0-1.75-1.423-3.172-3.172-3.172c-0.054,0-0.11,0-0.168,0.002c-0.158-0.312-0.293-0.639-0.405-0.975c0.044-0.039,0.085-0.078,0.124-0.115c1.236-1.236,1.236-3.25,0-4.486C3.009,7.719,2.969,7.68,2.924,7.642c0.112-0.336,0.247-0.664,0.405-0.976C3.387,6.668,3.443,6.67,3.497,6.67c1.75,0,3.172-1.423,3.172-3.172c0-0.054-0.002-0.11-0.004-0.168c0.312-0.158,0.64-0.293,0.976-0.405C7.68,2.969,7.719,3.01,7.757,3.048c0.6,0.6,1.396,0.93,2.243,0.93s1.643-0.33,2.243-0.93c0.038-0.039,0.076-0.079,0.115-0.123c0.336,0.112,0.663,0.247,0.976,0.405c-0.002,0.058-0.004,0.114-0.004,0.168c0,1.749,1.424,3.172,3.173,3.172c0.054,0,0.109-0.002,0.168-0.004c0.158,0.312,0.293,0.64,0.405,0.976c-0.045,0.038-0.086,0.077-0.124,0.116c-0.6,0.6-0.93,1.396-0.93,2.242c0,0.847,0.33,1.645,0.93,2.244c0.038,0.037,0.079,0.076,0.124,0.115C16.964,12.695,16.829,13.021,16.671,13.334 M10,5.417c-2.528,0-4.584,2.056-4.584,4.583c0,2.529,2.056,4.584,4.584,4.584s4.584-2.055,4.584-4.584C14.584,7.472,12.528,5.417,10,5.417 M10,13.812c-2.102,0-3.812-1.709-3.812-3.812c0-2.102,1.71-3.812,3.812-3.812c2.102,0,3.812,1.71,3.812,3.812C13.812,12.104,12.102,13.812,10,13.812"/>
    </symbol>
    <symbol id="applis" viewBox="0 0 20 20">
    <path d="M17.498,11.697c-0.453-0.453-0.704-1.055-0.704-1.697c0-0.642,0.251-1.244,0.704-1.697c0.069-0.071,0.15-0.141,0.257-0.22c0.127-0.097,0.181-0.262,0.137-0.417c-0.164-0.558-0.388-1.093-0.662-1.597c-0.075-0.141-0.231-0.22-0.391-0.199c-0.13,0.02-0.238,0.027-0.336,0.027c-1.325,0-2.401-1.076-2.401-2.4c0-0.099,0.008-0.207,0.027-0.336c0.021-0.158-0.059-0.316-0.199-0.391c-0.503-0.274-1.039-0.498-1.597-0.662c-0.154-0.044-0.32,0.01-0.416,0.137c-0.079,0.106-0.148,0.188-0.22,0.257C11.244,2.956,10.643,3.207,10,3.207c-0.642,0-1.244-0.25-1.697-0.704c-0.071-0.069-0.141-0.15-0.22-0.257C7.987,2.119,7.821,2.065,7.667,2.109C7.109,2.275,6.571,2.497,6.07,2.771C5.929,2.846,5.85,3.004,5.871,3.162c0.02,0.129,0.027,0.237,0.027,0.336c0,1.325-1.076,2.4-2.401,2.4c-0.098,0-0.206-0.007-0.335-0.027C3.001,5.851,2.845,5.929,2.77,6.07C2.496,6.572,2.274,7.109,2.108,7.667c-0.044,0.154,0.01,0.32,0.137,0.417c0.106,0.079,0.187,0.148,0.256,0.22c0.938,0.936,0.938,2.458,0,3.394c-0.069,0.072-0.15,0.141-0.256,0.221c-0.127,0.096-0.181,0.262-0.137,0.416c0.166,0.557,0.388,1.096,0.662,1.596c0.075,0.143,0.231,0.221,0.392,0.199c0.129-0.02,0.237-0.027,0.335-0.027c1.325,0,2.401,1.076,2.401,2.402c0,0.098-0.007,0.205-0.027,0.334C5.85,16.996,5.929,17.154,6.07,17.23c0.501,0.273,1.04,0.496,1.597,0.66c0.154,0.047,0.32-0.008,0.417-0.137c0.079-0.105,0.148-0.186,0.22-0.256c0.454-0.453,1.055-0.703,1.697-0.703c0.643,0,1.244,0.25,1.697,0.703c0.071,0.07,0.141,0.15,0.22,0.256c0.073,0.098,0.188,0.152,0.307,0.152c0.036,0,0.073-0.004,0.109-0.016c0.558-0.164,1.096-0.387,1.597-0.66c0.141-0.076,0.22-0.234,0.199-0.393c-0.02-0.129-0.027-0.236-0.027-0.334c0-1.326,1.076-2.402,2.401-2.402c0.098,0,0.206,0.008,0.336,0.027c0.159,0.021,0.315-0.057,0.391-0.199c0.274-0.5,0.496-1.039,0.662-1.596c0.044-0.154-0.01-0.32-0.137-0.416C17.648,11.838,17.567,11.77,17.498,11.697 M16.671,13.334c-0.059-0.002-0.114-0.002-0.168-0.002c-1.749,0-3.173,1.422-3.173,3.172c0,0.053,0.002,0.109,0.004,0.166c-0.312,0.158-0.64,0.295-0.976,0.406c-0.039-0.045-0.077-0.086-0.115-0.123c-0.601-0.6-1.396-0.93-2.243-0.93s-1.643,0.33-2.243,0.93c-0.039,0.037-0.077,0.078-0.116,0.123c-0.336-0.111-0.664-0.248-0.976-0.406c0.002-0.057,0.004-0.113,0.004-0.166c0-1.75-1.423-3.172-3.172-3.172c-0.054,0-0.11,0-0.168,0.002c-0.158-0.312-0.293-0.639-0.405-0.975c0.044-0.039,0.085-0.078,0.124-0.115c1.236-1.236,1.236-3.25,0-4.486C3.009,7.719,2.969,7.68,2.924,7.642c0.112-0.336,0.247-0.664,0.405-0.976C3.387,6.668,3.443,6.67,3.497,6.67c1.75,0,3.172-1.423,3.172-3.172c0-0.054-0.002-0.11-0.004-0.168c0.312-0.158,0.64-0.293,0.976-0.405C7.68,2.969,7.719,3.01,7.757,3.048c0.6,0.6,1.396,0.93,2.243,0.93s1.643-0.33,2.243-0.93c0.038-0.039,0.076-0.079,0.115-0.123c0.336,0.112,0.663,0.247,0.976,0.405c-0.002,0.058-0.004,0.114-0.004,0.168c0,1.749,1.424,3.172,3.173,3.172c0.054,0,0.109-0.002,0.168-0.004c0.158,0.312,0.293,0.64,0.405,0.976c-0.045,0.038-0.086,0.077-0.124,0.116c-0.6,0.6-0.93,1.396-0.93,2.242c0,0.847,0.33,1.645,0.93,2.244c0.038,0.037,0.079,0.076,0.124,0.115C16.964,12.695,16.829,13.021,16.671,13.334 M10,5.417c-2.528,0-4.584,2.056-4.584,4.583c0,2.529,2.056,4.584,4.584,4.584s4.584-2.055,4.584-4.584C14.584,7.472,12.528,5.417,10,5.417 M10,13.812c-2.102,0-3.812-1.709-3.812-3.812c0-2.102,1.71-3.812,3.812-3.812c2.102,0,3.812,1.71,3.812,3.812C13.812,12.104,12.102,13.812,10,13.812"/>
    </symbol>
    <symbol id="visioconference" viewBox="0 0 20 20">
    <path d="M17.919,4.633l-3.833,2.48V6.371c0-1-0.815-1.815-1.816-1.815H3.191c-1.001,0-1.816,0.814-1.816,1.815v7.261c0,1.001,0.815,1.815,1.816,1.815h9.079c1.001,0,1.816-0.814,1.816-1.815v-0.739l3.833,2.478c0.428,0.226,0.706-0.157,0.706-0.377V5.01C18.625,4.787,18.374,4.378,17.919,4.633 M13.178,13.632c0,0.501-0.406,0.907-0.908,0.907H3.191c-0.501,0-0.908-0.406-0.908-0.907V6.371c0-0.501,0.407-0.907,0.908-0.907h9.079c0.502,0,0.908,0.406,0.908,0.907V13.632zM17.717,14.158l-3.631-2.348V8.193l3.631-2.348V14.158z">
    </path>
    </symbol>
    <symbol id="users" viewBox="0 0 16 16">
    <path d="M8,0a8,8,0,1,0,8,8A8,8,0,0,0,8,0ZM8,15a7,7,0,0,1-5.19-2.32,2.71,2.71,0,0,1,1.7-1,13.11,13.11,0,0,0,1.29-.28,2.32,2.32,0,0,0,.94-.34,1.17,1.17,0,0,0-.27-.7h0A3.61,3.61,0,0,1,5.15,7.49,3.18,3.18,0,0,1,8,4.07a3.18,3.18,0,0,1,2.86,3.42,3.6,3.6,0,0,1-1.32,2.88h0a1.13,1.13,0,0,0-.27.69,2.68,2.68,0,0,0,.93.31,10.81,10.81,0,0,0,1.28.23,2.63,2.63,0,0,1,1.78,1A7,7,0,0,1,8,15Z" />
    </symbol>
    <symbol id="connect" viewBox="0 0 16 16">
    <polygon points="0.64 11.85 -0.02 11.1 2.55 8.85 4.57 10.4 9.25 5.25 12.97 8.84 15.37 6.79 16.02 7.54 12.94 10.2 9.29 6.68 4.69 11.76 2.59 10.14 0.64 11.85"/>
    </symbol>
    <symbol id="links" viewBox="0 0 16 16">
    <rect x="9.78" y="5.34" width="1" height="7.97"/><polygon points="7.79 6.07 10.28 1.75 12.77 6.07 7.79 6.07"/><rect x="4.16" y="1.75" width="1" height="7.97"/><polygon points="7.15 8.99 4.66 13.31 2.16 8.99 7.15 8.99"/><rect x="1.28" width="1" height="4.97"/><polygon points="3.28 4.53 1.78 7.13 0.28 4.53 3.28 4.53"/><rect x="12.84" y="11.03" width="1" height="4.97"/><polygon points="11.85 11.47 13.34 8.88 14.84 11.47 11.85 11.47"/>
    </symbol>
    <symbol id="collapse" viewBox="0 0 16 16">
    <polygon points="11.62 3.81 7.43 8 11.62 12.19 10.09 13.71 4.38 8 10.09 2.29 11.62 3.81"/>
    </symbol>
    <symbol id="search" viewBox="0 0 16 16">
    <path d="M6.57,1A5.57,5.57,0,1,1,1,6.57,5.57,5.57,0,0,1,6.57,1m0-1a6.57,6.57,0,1,0,6.57,6.57A6.57,6.57,0,0,0,6.57,0Z"/><rect x="11.84" y="9.87" width="2" height="5.93" transform="translate(-5.32 12.84) rotate(-45)"/>
    </symbol>
    <symbol id="menu" viewBox="0 0 24 24">
    <path d="M4 22h-4v-4h4v4zm0-12h-4v4h4v-4zm0-8h-4v4h4v-4zm3 0v4h17v-4h-17zm0 12h17v-4h-17v4zm0 8h17v-4h-17v4z"/>
    </symbol>
    <symbol id="dx" viewBox="0 0 24 24">
    <path d="M8.416,3.943l1.12-1.12v9.031c0,0.257,0.208,0.464,0.464,0.464c0.256,0,0.464-0.207,0.464-0.464V2.823l1.12,1.12c0.182,0.182,0.476,0.182,0.656,0c0.182-0.181,0.182-0.475,0-0.656l-1.744-1.745c-0.018-0.081-0.048-0.16-0.112-0.224C10.279,1.214,10.137,1.177,10,1.194c-0.137-0.017-0.279,0.02-0.384,0.125C9.551,1.384,9.518,1.465,9.499,1.548L7.76,3.288c-0.182,0.181-0.182,0.475,0,0.656C7.941,4.125,8.234,4.125,8.416,3.943z M15.569,6.286h-2.32v0.928h2.32c0.512,0,0.928,0.416,0.928,0.928v8.817c0,0.513-0.416,0.929-0.928,0.929H4.432c-0.513,0-0.928-0.416-0.928-0.929V8.142c0-0.513,0.416-0.928,0.928-0.928h2.32V6.286h-2.32c-1.025,0-1.856,0.831-1.856,1.856v8.817c0,1.025,0.832,1.856,1.856,1.856h11.138c1.024,0,1.855-0.831,1.855-1.856V8.142C17.425,7.117,16.594,6.286,15.569,6.286z"/>
    </symbol>
</svg>
            
<header class="page-header">
  <nav>
    <a href="#0">
      <img class="logo" src="' . $LogoDessus . '" alt="SambaÉdu">
    </a>
    <button class="toggle-mob-menu" aria-expanded="false" aria-label="open menu">
      <svg width="20" height="20" aria-hidden="true">
        <use xlink:href="#menu"></use>
      </svg>
    </button>
    <ul class="admin-menu">
      <li class="menu-heading">
        <h3>Vos applications :</h3>
      </li>
      <li>
        <a href="?page=param">
          <svg>
            <use xlink:href="#users"></use>
          </svg>
          <span>Accueil</span>
        </a>
      </li>';
    $html .= '
      <li ' . $selected_links . '>
        <a href="?page=links">
          <span class="fa fa-key menu_icon"></span>
          <span>Gérer mon mot de passe</span>
        </a>
      </li>
          
        ' . $html_profs;

    if (! empty($config['bbb_server_base_url'])) {
        $html .= ' <li ' . $selected_visio . '>
        <a href="?page=visio">
          <svg>
            <use xlink:href="#visioconference"></use>
          </svg>
          <span>Visioconférence</span>
        </a>
      </li>';
    }
    if (! empty($config['guacamole_url'])) {
        $html .= '
      <li ' . $selected_connect . ' >
        <a href="?page=connect">
            <svg>
              <use xlink:href="#connect"></use>
            </svg>
            <span>Se connecter à un ordinateur</span>
          </a>
      </li>';
    }

    $html .= '  ' . $html_admin . '
          <li>
        <a href="?page=dx">
          <svg>
            <use xlink:href="#dx"></use>
          </svg>
          <span>Se déconnecter</span>
        </a>
      </li>
      <li>
        <button class="collapse-btn" aria-expanded="true" aria-label="collapse menu">
          <svg aria-hidden="true">
            <use xlink:href="#collapse"></use>
          </svg>
          <span>Réduire le menu</span>
        </button>
      </li>
    </ul>
  </nav>
</header>
<section class="page-content">
  <section class="search-and-user">
    <div class="admin-profile">' . $WelcomeMessage;
    if (count($etabs) > 1) {
        $html .= '<div class="admin-profile"><form name=etab action="" method="POST">Etablissement :
            <SELECT NAME=etab SIZE=1 onchange=this.form.submit()>';
        foreach ($etabs as $e) {
            $html .= "<option value=\"" . $e['uai'] . "\"";
            if ($etab_choix == $e['uai']) {
                $html .= " selected";
            }
            if ($e['uai'] == 0) {
                $html .= ">Domaine entier";
            } else {
                $html .= ">" . $e['uai'] . " " . etab_to_name($config, $e['uai']);
                if (! $e['activated']) {
                    $html .= " <b>virtuel</b>";
                }
                $html .= "\n";
            }
            $html .= "</option>";
        }
        $html .= '</SELECT></form></div>';
    }
    $html .= '</div><div class="admin-profile">
      <span class="greeting">Bonjour ' . @$user['prenom'] . '</span>
      <div class="notifications">
       <a href="?page=dx" title="Se déconnecter">
        <span class="badge"></span>
        <svg>
          <use xlink:href="#users"></use>
        </svg>
        </a>
      </div>
    </div>
  </section>
  <section class="grid">
';
    return $html;
}

function user_interface_footer()
{
    $html = '</section>
    <footer class="page-footer">
    <small> SambaÉdu</small>
    </footer>
    </section>
    <script id="rendered-js" src="user.interface.js"></script>
    </body>
    </html>
    ';
    return $html;
}

/**
 *
 * @return string
 */
function html_change_password_form($config, $login, $password)
{
    // @TODO basculer auto en mode de modificatio différée si la charge est trop importante
    // pour le moment changements de mdp appliqués en direct
    $stack = false;

    $html = '
        <!DOCTYPE html>
        <html>
            <head>
                <meta charset="utf-8" />
                <link rel="stylesheet" href="user.interface.login.css" />
                <link rel="stylesheet" href="../vendor/fortawesome/font-awesome/css/all.min.css" />
                <title>Changement de mot de passe pour $login</title>
            </head>
            <body>
            <div class="wrapper fadeInDown">
              <div id="formContent">
                <!-- Tabs Titles -->
        
                <h2 class="active">Vous devez changer votre mot de passe pour activer votre compte.</h2>' . change_pwd($config, $login, $password, $stack) . '
                <div id="formFooter">
                </div>
              </div>
            </div>
            <script id="rendered-js" src="user.interface.js"></script>
        	</body>
        </html>
    ';
    return $html;
}

/**
 *
 * @return string
 */
function html_user_forbidden($config)
{
    $html = '
        <!DOCTYPE html>
        <html>
            <head>
                <meta charset="utf-8" />
                <link rel="stylesheet" href="user.interface.login.css" />
                <link rel="stylesheet" href="../vendor/fortawesome/font-awesome/css/all.min.css" />
                <title>L\'accès aux élèves est désactivé jusqu\'a la rentrée.</title>
            </head>
            <body>
            <div class="wrapper fadeInDown">
              <div id="formContent">
                 <h2 class="active">L\'accès aux élèves est désactivé jusqu\'a la rentrée</h2>
              </div>
            </div>
            <script id="rendered-js" src="user.interface.js"></script>
        	</body>
        </html>
    ';
    return $html;
}

/**
 *
 * @return string
 */
function html_login_form($config, $message = "")
{
    $LogoLogin = replace_element($config, "LogoLogin", "/elements/images/LogoSambaEdu.png");
    $WelcomeLoginMesg = replace_element($config, "WelcomeLoginMesg", "Retrouvez toutes vos applications en ligne !");
    $LoginPageTitle = replace_element($config, "LoginPageTitle", "Se connecter aux services de SambaÉdu");
    $mail_login = $_POST['login'] ?? "";
    $html = '
        <!DOCTYPE html>
        <html>
            <head>
                <meta charset="utf-8" />
                <link rel="stylesheet" href="user.interface.login.css" />
                <link rel="stylesheet" href="../vendor/fortawesome/font-awesome/css/all.min.css" />
                <title>' . $LoginPageTitle . '</title>
            </head>
            <body>
            <div class="wrapper fadeInDown">
              <div id="formContent">
                <!-- Tabs Titles -->
                <h2 class="active">' . $WelcomeLoginMesg . '</h2>
                <!-- Icon -->
                <div class="fadeIn first">
                  <img src="' . $LogoLogin . '" id="icon" alt="Un service proposé par SambaÉdu" />
                </div>
                <!-- Login Form -->
                <form action="?page=login" method="post" >
                  <input type="text" id="login" class="fadeIn second" name="login" placeholder="Nom d\'utilisateur">
                  <input type="password" id="password" class="fadeIn third" name="password" placeholder="Mot de passe">
                 <i class="fadeIn fa fa-eye" id="togglePassword" style="margin-left: -30px; cursor: pointer;"></i>
                 <input type="submit" class="fadeIn fourth" value="C\'est parti !">
                </form>
                <div id="formFooter">';
    if (! empty($message)) {
        $html .= '              <div id="erreur">
                 <h2 class="error">' . $message . '</h2>
                <a class="underlineHover" href="?page=mail&mail_login=' . $mail_login . '">Mot de passe oublié ?</a>
              </div>';
    } else {
        $html .= '            <a class="underlineHover" href="#">Connectez vous avec vos identifiants de session habituels.</a>';
    }
    $html .= '
                  <p>
                    En France, une attaque par déni de service (DDoS) peut avoir de graves conséquences judiciaires.
                    <a href="https://www.legifrance.gouv.fr/affichCodeArticle.do;jsessionid=2FB1E87673A7871CE407E1CB862F780D.tplgfr30s_2?idArticle=LEGIARTI000030939443&cidTexte=LEGITEXT000006070719&categorieLien=id&dateTexte=">
Le Code pénal</a> prévoit jusqu’à 5 ans de prison et 150 000 euros d’amende.
        
Quand elle vise un service de l’État, les sanctions passent à 7 ans de prison et 300 000 euros d’amende.
        
Ces sanctions n’incluent évidemment pas les dommages et intérêts que les victimes de l’attaque pourraient réclamer, au titre du préjudice, notamment matériel.
</p><p><b>
Toute tentative de DDoS sera poursuivie.
</b></p>
        
                </div>
              </div>
            </div>
            <script>
            const togglePassword = document.querySelector("#togglePassword");
			const password = document.querySelector("#password");
			togglePassword.addEventListener("click", function (e) {
				if (password.getAttribute("type") === "password") {
					password.setAttribute("type", "text");
					this.classList.remove("fa-eye");
					this.classList.add("fa-eye-slash");
				 } else {
					password.setAttribute("type", "password");
					this.classList.remove("fa-eye-slash");
					this.classList.add("fa-eye");
				 }
			});
            </script>
        	</body>
        </html>
    ';
    return $html;
}

/**
 *
 * @return string
 */
function html_mail_form($config)
{
    $LogoLogin = replace_element($config, "LogoLogin", "/elements/images/LogoSambaEdu.png");
    $WelcomeLoginMesg = replace_element($config, "WelcomeLoginMesg", "Retrouvez toutes vos applications en ligne !");
    $LoginPageTitle = replace_element($config, "LoginPageTitle", "Se connecter aux services de SambaÉdu");
    $mail_login = $_GET['mail_login'] ?? "";
    // $user = search_user($config, $login);
    $html = '
        <!DOCTYPE html>
        <html>
            <head>
                <meta charset="utf-8" />
                <link rel="stylesheet" href="user.interface.login.css" />
                <link rel="stylesheet" href="../vendor/fortawesome/font-awesome/css/all.min.css" />
                <title>' . $LoginPageTitle . '</title>
            </head>
            <body>
            <div class="wrapper fadeInDown">
            <!-- Login Form -->
            <div id="formContent">
                <!-- Tabs Titles -->
                <h2 class="active">' . $WelcomeLoginMesg . '</h2>
                <!-- Icon -->
                <div class="fadeIn first">
                    <img src="' . $LogoLogin . '" id="icon" alt="Un service proposé par SambaÉdu" />
                </div>';
    if (is_eleve($config, $mail_login)) {
        $html .= '              <div id="fadeIn second">
                Demandez à un de vos professeurs de réinitialiser votre mot de passe.
              </div>';
    } elseif (! empty($_POST['mail']) && ! empty($_POST['login'])) {
        send_activation_message($config, $_POST['login'], $_POST['mail']);
        $html .= '              <div id="fadeIn second">
                Un message contenant un nouveau code d\'activation a été envoyé à l\'adresse
                indiquée. Veuillez consulter votre boite à lettre et vous reconnecter.
              </div>';
    } else {
        $html .= '
                <div class="fadeIn second">
                    Entrez l\'adresse email renseignée pour votre compte (mail académique)
                </div>
                <form action="?page=login" method="post" >
                  <input type="hidden" id="login"  name="login" value="' . $mail_login . '" placeholder="Nom d\'utilisateur">
                  <input type="text" id="mail" class="fadeIn third" name="mail" placeholder="Email">
                 <input type="submit" class="fadeIn fourth" value="Envoyer">
                </form>';
    }
    $html .= '
                    </div>
                 </div>
         	</body>
        </html>
    ';
    return $html;
}

?>