<?php

function update_xml_unattend($config, $file, $attrs, $specialize = false)
{
    $xml = new DOMDocument();
    $xml->formatOutput = true;
    $xml->preserveWhiteSpace = false;
    $xml->load($file);
    $xpath = new DOMXPath($xml);
    $xpath->registerNamespace('ns', "urn:schemas-microsoft-com:unattend");
    $xpath->registerNamespace('wcm', "urn:schemas-microsoft-com:unattend");
    // win11
    $w11 = '             <RunSynchronous>
                <RunSynchronousCommand wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
                    <Description>Switch to legacy Setup</Description>
                    <Order>1</Order>
                    <Path>reg add "HKLM\System\Setup" /v CmdLine /t REG_SZ /d "X:\sources\setup.exe" /f</Path>
                </RunSynchronousCommand>
                <RunSynchronousCommand wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
                    <Order>2</Order>
                    <Path>reg add HKLM\System\Setup\LabConfig /v BypassTPMCheck /t reg_dword /d 0x00000001 /f</Path>
                </RunSynchronousCommand>
                <RunSynchronousCommand wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
                    <Order>3</Order>
                    <Path>reg add HKLM\System\Setup\LabConfig /v BypassSecureBootCheck /t reg_dword /d 0x00000001 /f</Path>
                </RunSynchronousCommand>
                <RunSynchronousCommand wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
                    <Order>4</Order>
                    <Path>reg add HKLM\System\Setup\LabConfig /v BypassRAMCheck /t reg_dword /d 0x00000001 /f</Path>
                </RunSynchronousCommand>
                <RunSynchronousCommand wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
                    <Order>5</Order>
                    <Path>reg add HKLM\System\Setup\LabConfig /v BypassCPUCheck /t reg_dword /d 0x00000001 /f</Path>
                </RunSynchronousCommand>
                <RunSynchronousCommand wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
                    <Order>6</Order>
                    <Path>reg add HKLM\System\Setup\LabConfig /v BypassStorageCheck /t reg_dword /d 0x00000001 /f</Path>
                </RunSynchronousCommand>
            </RunSynchronous>';
    if (! empty($attrs['version']) && $attrs['version'] == "Win11") {
        $node = $xml->createDocumentFragment();
        $node->appendXML($w11);
        $key = $xpath->query("/ns:unattend/ns:settings[@pass='windowsPE']/ns:component[@name='Microsoft-Windows-Setup']");
        if (! is_null($key->item(0))) {
            $key->item(0)->appendChild($node);
        }
    }
    // fragments pour partitionnement
    $disk = [
        'legacy' => '<DiskConfiguration>
	<Disk wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
		<CreatePartitions>
			<CreatePartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
				<Order>1</Order>
				<Type>Primary</Type>
				<Extend>true</Extend>
			</CreatePartition>
		</CreatePartitions>
		<ModifyPartitions>
			<ModifyPartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
				<Active>true</Active>
				<Format>NTFS</Format>xml
				<Label>OS</Label>
				<Letter>C</Letter>
				<Order>1</Order>
				<PartitionID>1</PartitionID>
			</ModifyPartition>
		</ModifyPartitions>
		<DiskID>0</DiskID>
		<WillWipeDisk>true</WillWipeDisk>
	</Disk>
</DiskConfiguration>',
        'uefi' => '<DiskConfiguration>
	<Disk wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
		<CreatePartitions>
			<!-- System partition (ESP) -->
			<CreatePartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
				<Order>1</Order>
				<Type>EFI</Type>
				<Size>260</Size>
			</CreatePartition>
			<!-- Windows partition -->
			<CreatePartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
				<Order>2</Order>
				<Type>Primary</Type>
				<Extend>true</Extend>
			</CreatePartition>
		</CreatePartitions>
		<ModifyPartitions>
			<!-- System partition (ESP) -->
			<ModifyPartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
				<Order>1</Order>
				<PartitionID>1</PartitionID>
				<Label>System</Label>
				<Format>FAT32</Format>
			</ModifyPartition>
			<!-- Windows partition -->
			<ModifyPartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
				<Order>2</Order>
				<PartitionID>2</PartitionID>
				<Label>Windows</Label>
				<Letter>C</Letter>
				<Format>NTFS</Format>
			</ModifyPartition>
		</ModifyPartitions>
		<DiskID>0</DiskID>
		<WillWipeDisk>true</WillWipeDisk>
	</Disk>
</DiskConfiguration>',
        'legacy_dboot' => '<DiskConfiguration>
				<Disk wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
					<CreatePartitions>
						<CreatePartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
							<Order>1</Order>
							<Type>Primary</Type>
							<Size>100000</Size>
						</CreatePartition>
						<CreatePartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
							<Order>2</Order>
							<Type>Primary</Type>
							<Size>5000</Size>
						</CreatePartition>
					</CreatePartitions>
					<ModifyPartitions>
						<ModifyPartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
							<Order>1</Order>
							<PartitionID>1</PartitionID>
							<Format>NTFS</Format>
							<Label>OS</Label>
							<Letter>C</Letter>
						</ModifyPartition>
						<ModifyPartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
							<Order>2</Order>
							<PartitionID>2</PartitionID>
							<Format>NTFS</Format>
							<Label>DATA</Label>
							<Letter>E</Letter>
						</ModifyPartition>
					</ModifyPartitions>
					<DiskID>0</DiskID>
					<WillWipeDisk>true</WillWipeDisk>
				</Disk>
			</DiskConfiguration>',
        'uefi_dboot' => '<DiskConfiguration>
				<Disk wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
		<CreatePartitions>
			<!-- System partition (ESP) -->
			<CreatePartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
				<Order>1</Order>
				<Type>EFI</Type>
				<Size>260</Size>
			</CreatePartition>
					<CreatePartitions>
						<CreatePartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
							<Order>2</Order>
							<Type>Primary</Type>
							<Size>100000</Size>
						</CreatePartition>
						<CreatePartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
							<Order>3</Order>
							<Type>Primary</Type>
							<Size>5000</Size>
						</CreatePartition>
					</CreatePartitions>
					<ModifyPartitions>
			<!-- System partition (ESP) -->
			<ModifyPartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
				<Order>1</Order>
				<PartitionID>1</PartitionID>
				<Label>System</Label>
				<Format>FAT32</Format>
			</ModifyPartition>
						<ModifyPartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
							<Order>2</Order>
							<PartitionID>2</PartitionID>
							<Format>NTFS</Format>
							<Label>OS</Label>
							<Letter>C</Letter>
						</ModifyPartition>
						<ModifyPartition wcm:action="add" xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State">
							<Order>3</Order>
							<PartitionID>3</PartitionID>
							<Format>NTFS</Format>
							<Label>DATA</Label>
							<Letter>E</Letter>
						</ModifyPartition>
					</ModifyPartitions>
					<DiskID>0</DiskID>
					<WillWipeDisk>true</WillWipeDisk>
				</Disk>
			</DiskConfiguration>'
    ];
    if (! empty($attrs['bios'])) {
        $node = $xml->createDocumentFragment();
        $node->appendXML($disk[$attrs['bios']]);
        $key = $xpath->query("/ns:unattend/ns:settings[@pass='windowsPE']/ns:component[@name='Microsoft-Windows-Setup']");
        if (! is_null($key->item(0))) {
            $key->item(0)->appendChild($node);
            switch ($attrs['bios']) {
                case "legacy":
                    $disk = 0;
                    $part = 1;
                    break;
                case "uefi":
                    $disk = 0;
                    $part = 2;
                    break;
            }
            $image = $xml->createElement("ImageInstall");
            $node = $xml->createElement("OSImage");
            $node1 = $xml->createElement("InstallTo");
            $node2 = $xml->createElement("DiskID");
            $node2->textContent = $disk;
            $node1->appendChild($node2);
            $node2 = $xml->createElement("PartitionID");
            $node2->textContent = $part;
            $node1->appendChild($node2);
            $node->appendChild($node1);
            $node1 = $xml->createElement("InstallToAvailablePartition");
            $node1->textContent = "false";
            $node->appendChild($node1);
            $image->appendChild($node);
            $key[0]->appendChild($image);
        }
    }
    // password autologon
    if ($attrs['join']) {
        $user = $config['se4install_name'];
        $passwd = $config['se4install_passwd'];
    } else {
        $user = $config['win_user'] ?? $config['perso_user'] ?? $config['linux_user'];
        $passwd = $config['win_user_passwd'] ?? $config['perso_user_passwd'] ?? $config['linux_user_passwd'];
    }
    $key = $xpath->query("/ns:unattend/ns:settings/ns:component/ns:AutoLogon/ns:Username");
    if (! is_null($key[0]))
        $key[0]->nodeValue = $user;
    $key = $xpath->query("/ns:unattend/ns:settings/ns:component/ns:AutoLogon/ns:Password/ns:Value");
    if (! is_null($key[0]))
        $key[0]->nodeValue = $passwd;
    $key = $xpath->query("/ns:unattend/ns:settings[@pass='oobeSystem']/ns:component[@name='Microsoft-Windows-Shell-Setup']/ns:AutoLogon/ns:Domain");
    if (! is_null($key[0]))
        $key[0]->nodeValue = $config['domain'];

    // nom du poste
    if ($key = $xpath->query("/ns:unattend/ns:settings/ns:component/ns:ComputerName"))
        foreach ($key as $node) {
            $node->nodeValue = $attrs['name'] ?? "*";
        }
    $key = $xpath->query("/ns:unattend/ns:settings/ns:component/ns:RegisteredOrganization");
    if (! is_null($key[0]))
        $key[0]->nodeValue = $config['domain'];
    $key = $xpath->query("/ns:unattend/ns:settings/ns:component/ns:UserData/ns:Organization");
    if (! is_null($key[0]))
        $key[0]->nodeValue = $config['domain'];
    $key = $xpath->query("/ns:unattend/ns:settings[@pass='windowsPE']/ns:component/ns:UserData/ns:FullName");
    if (! is_null($key[0]))
        $key[0]->nodeValue = $config['se4install_name'];
    // if ($key = $xpath->query("/ns:unattend/ns:settings/ns:component/ns:RegisteredOwner"))
    // $key[0]->nodeValue = $config['se4install_name'];
    $key = $xpath->query("/ns:unattend/ns:settings[@pass='windowsPE']/ns:component/ns:UserData/ns:ProductKey/ns:Key");
    if (! is_null($key[0]))
        $key[0]->nodeValue = $config['win_key'] ?? "VK7JG-NPHTM-C97JM-9MPGT-3V66T";

    // mise au domaine
    if ($attrs['join']) {
        $join = '<component xmlns:wcm="http://schemas.microsoft.com/WMIConfig/2002/State" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" name="Microsoft-Windows-UnattendedJoin" processorArchitecture="amd64" publicKeyToken="31bf3856ad364e35" language="neutral" versionScope="nonSxS">
 <Identification>
  <Credentials>
   <Domain></Domain>
   <Password></Password>
   <Username></Username>
  </Credentials>
  <JoinDomain></JoinDomain>
  <TimeoutPeriodInMinutes>10</TimeoutPeriodInMinutes>
  <MachineObjectOU></MachineObjectOU>
 </Identification>
</component>';

        $node = $xml->createDocumentFragment();
        $node->appendXML($join);

        $key = $xpath->query("/ns:unattend/ns:settings[@pass='specialize']");
        if (! is_null($key->item(0))) {
            $key->item(0)->appendChild($node);
        }
        // mise au domaine
        if ($key = $xpath->query("/ns:unattend/ns:settings[@pass='specialize']/component/Identification/Credentials/Username"))
            $key[0]->nodeValue = $config['ldap_admin_name'];
        if ($key = $xpath->query("/ns:unattend/ns:settings[@pass='specialize']/component/Identification/Credentials/Password"))
            $key[0]->nodeValue = $config['ldap_admin_passwd'];
        if ($key = $xpath->query("/ns:unattend/ns:settings[@pass='specialize']/component/Identification/Credentials/Domain"))
            $key[0]->nodeValue = $config['domain'];
        if ($key = $xpath->query("/ns:unattend/ns:settings[@pass='specialize']/component/Identification/JoinDomain"))
            $key[0]->nodeValue = $config['domain'];
        if ($key = $xpath->query("/ns:unattend/ns:settings[@pass='specialize']/component/Identification/MachineObjectOU"))
            $key[0]->nodeValue = $attrs['ou'] ?? $config['dn']['computers'];
    }

    // compte local admin
    if ($attrs['join']) {
        $local_user = $config['adminse_name'];
        $local_passwd = $config['adminse_passwd'];
    } else {
        $local_user = $config['win_user'] ?? $config['perso_user'] ?? $config['linux_user'];
        $local_passwd = $config['win_user_passwd'] ?? $config['perso_user_passwd'] ?? $config['linux_user_passwd'];
    }
    $key = $xpath->query("/ns:unattend/ns:settings[@pass='oobeSystem']/ns:component[@name='Microsoft-Windows-Shell-Setup']/ns:UserAccounts/ns:LocalAccounts");
    $local = $xml->createElement("LocalAccount");
    $local->setAttribute('wcm:action', "add");
    $node = $xml->createElement("Name");
    $node->nodeValue = $local_user;
    $local->appendChild($node);
    $node = $xml->createElement("Password");
    $node1 = $xml->createElement("Value");
    $node1->nodeValue = $local_passwd;
    $node->appendChild($node1);
    $node1 = $xml->createElement("PlainText");
    $node1->nodeValue = "true";
    $node->appendChild($node1);
    $local->appendChild($node);
    $node = $xml->createElement("Group");
    $node->nodeValue = "Administrators";
    $local->appendChild($node);
    $node = $xml->createElement("Description");
    $node->nodeValue = "Administrateur local SambaEdu";
    $local->appendChild($node);
    $node = $xml->createElement("DisplayName");
    $node->nodeValue = $local_user;
    $local->appendChild($node);
    $key[0]->appendChild($local);

    $autologon = $config['win_autologon'] ?? $config['perso_autologon'] ?? 0;
    if (! $attrs['join'] && $autologon == 1) {
        if ($key = $xpath->query("/ns:unattend/ns:settings[@pass='oobeSystem']/ns:component[@name='Microsoft-Windows-Shell-Setup']/ns:AutoLogon/ns:LogonCount"))
            $key[0]->nodeValue = 4294967295;
    }

    // pw administrateur local

    if ($key = $xpath->query("/ns:unattend/ns:settings/ns:component/ns:UserAccounts/ns:AdministratorPassword/ns:Value"))
        $key[0]->nodeValue = $local_passwd;

    // lignes de commandes de finition de l'install

    $commandlines = $xml->documentElement->getElementsByTagName('CommandLine');
    foreach ($commandlines as $name) {
        $name->textContent = preg_replace("/###_ADMINSE_NAME_###/", $config['adminse_name'], $name->textContent);
        $name->textContent = preg_replace("/###_SE4FS_NAME_###/", $config['se4fs_name'], $name->textContent);
        $name->textContent = preg_replace("/###_NAME_###/", $attrs['name'], $name->textContent);
    }
    $commandlines = $xml->documentElement->getElementsByTagName('Path');
    foreach ($commandlines as $name) {
        $name->textContent = preg_replace("/###_ADMINSE_NAME_###/", $config['adminse_name'], $name->textContent);
        $name->textContent = preg_replace("/###_SE4FS_NAME_###/", $config['se4fs_name'], $name->textContent);
    }

    if ($specialize) {
        $key = $xpath->query("/ns:unattend/ns:settings[@pass='generalize']");
        $key[0]->setAttribute('wasPassProcessed', "true");
    }
    if (! empty($attrs['version']) && $attrs['version'] == "Win7") {
        $node = $xml->documentElement->getElementsByTagName('HideOEMRegistrationScreen')->item(0);
        $node->parentNode->removeChild($node);
        $node = $xml->documentElement->getElementsByTagName('HideOnlineAccountScreens')->item(0);
        $node->parentNode->removeChild($node);
    }
    return $xml->saveXML();
}

?>
