<?php

/**

 * Page d'accueil

 * @Projet SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL

 */

/**
 *
 * @Repertoire: /
 * file: index.php
 */
require_once 'config.inc.php';
$config = get_config();
$login = $config['login'];
require_once 'ldap.inc.php';
require_once 'debug.inc.php';
require_once 'samba.inc.php';
require_once 'actions.inc.php';
require_once 'partages.inc.php';
require_once 'ent.inc.php';
include_once 'admin_ui.inc.php';
require_once ("functions.inc.php");
include "fonc_outils.inc.php";

// hack en cas de changement de serveur ?
if (! empty($_SESSION['login'])) {
    $config['login'] = $_SESSION['login'];
}

$html = "";
admin_header_html($config, $html, true);

admin_topbar_html($config, $html);
if (empty($config['etab_ou'])) {
    if (empty($_SESSION['etab_ou'])) {
        $root_path = "/";
    } else {
        $root_path = "/" . $_SESSION['etab_ou'] . "/";
    }
} else {
    $root_path = "/" . $config['etab_ou'] . "/";
}

if (empty($login)) {
    header("Status: 301 Moved Permanently", false, 301);
    header("Location: " . $root_path . "auth.php");
    exit();
} else {
    admin_menu_html($config, $html);

    $html .= header_authorize($config);
    $login = $config['login'];

    if (have_right($config, SE_USER_READ) || have_right_or_delegation($config, SE_COMPUTER_VIEW) || get_local_admin_right($config, $login)) {
        if (isset($config['affiche_etat']) && $config['affiche_etat'] == 1) {
            // tests
            header("Status: 301 Moved Permanently", false, 301);
            header("Location: " . $root_path . "test.php");
            exit();
        } else {
            // blank
            header("Status: 301 Moved Permanently", false, 301);
            header("Location: " . $root_path . "blank.php");
            exit();
        }
    } else {
        // me
        header("Status: 301 Moved Permanently", false, 301);
        header("Location: " . $root_path . "annu/people.php?cn=" . $config['login']);
        exit();
    }
    admin_footer_html($html, false);
}

echo $html;
?>