<?php
/*
 * actions sur un parc executees en cron tous les quarts d'heure
 *
 * ce script est appelé via action_cron.sh.
 * si $_POST['mail] est passé, envoi d'un mail en cas d'action.
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
header_authorize_script($config);
require_once 'dhcpd.inc.php';
require_once ("fonc_outils.inc.php");
require_once ("fonc_parc.inc.php");
require_once ("logs.inc.php");
require_once ("pronote.inc.php");
require_once ("power.inc.php");

$day = array(
    'dimanche',
    'lundi',
    'mardi',
    'mercredi',
    'jeudi',
    'vendredi',
    'samedi'
);
$mois = array(
    'janvier',
    'février',
    'mars',
    'avril',
    'mai',
    'juin',
    'juillet',
    'août',
    'septembre',
    'octobre',
    'novembre',
    'décembre'
);
$message = ! empty($config['alert_parc']);
$ladate = $day[date("w")] . " " . date("d") . " " . $mois[date("n") - 1] . " " . date("Y");
$html = "<b>Action du " . $ladate . " à " . date("H:i:s") . " :</b><br>\n";
$mail = false;
if (get_ecowatt($config) > 1) {
    $html .= "EcoWatt : arrêt des postes non-utilisés du parc « base ».<br>\n";
    start_parc($config, "stop", "base", false);
    $mail = true;
} else {
    $authlink = db_connect($config);
    $jours = [
        'd',
        'l',
        'ma',
        'me',
        'j',
        'v',
        's'
    ];

    if (! empty($config['mode_programmation']) and $config['mode_programmation'] == 'auto') {
        $etat = max(get_vacances($config)['etat'], get_feries($config)['etat']);
        if ($etat != '0' and $etat != $config['vacances']) {
            set_config($config, 'vacances', $etat);
        }
    }

    $heure = explode(":", date("w:H:i:s"));
    $heure_fin = explode(":", date("w:H:i:s", time() + 900));
    $table = "actions";
    $requete = "SELECT * FROM $table WHERE jour='" . $jours[$heure[0]] . "' and heure > '" . $heure[1] . ":" . $heure[2] . ":" . $heure[3] . "' and heure < '" . $heure_fin[1] . ":" . $heure_fin[2] . ":" . $heure_fin[3] . "';";
    // print $requete;
    $res = mysqli_query($authlink, $requete);
    if (mysqli_num_rows($res) > 0) {
        $html .= "<ul>\n";
        while ($row = mysqli_fetch_assoc($res)) {
            if ($row['action'] == "stop" || $config['vacances'] != '2') {
                $html .= "<li>Action " . $row['action'] . " sur " . $row['parc'] . ".</li>\n";
                start_parc($config, $row['action'], $row['parc'], true);
                $mail = true;
            }
        }
        $html .= "</ul>\n";
        mysqli_close($authlink);
    }
    if (isset($config['pronote_api_passwd'])) {
        $parcs = search_parcs($config, "*", "salle");
        $html .= "<ul>\n";
        foreach ($parcs as $salle) {
            if ($action = get_salle_state($config, $salle['name'])) {
                $html .= "<li>Action EDT " . $action . " sur " . $salle['name'] . ".</li>\n";
                start_parc($config, $action, $salle['name'], false);
                $mail = true;
            }
        }
        $html .= "</ul>\n";
    }
}

if ($mail && $message) {
    echo $html;
}
// $html = "";
// admin_footer_html($html, false);
// echo $html;
?>
