<?php

/**

 * @Projet SambaEdu

 * @Auteurs Equipe Sambaedu

 * @Note: 

 * @Licence Distribue sous la licence GPL

 */

/**
 *
 * @Repertoire: parcs/
 * file: action_machine.php
 *
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
require_once "ldap.inc.php";
require_once "ihm.inc.php";
require_once "fonc_outils.inc.php";
require_once ('dhcpd.inc.php');
require_once ('fonc_parc.inc.php');

// ***************Definition des droits de lecture et aide en ligne
$login = $config['login'];
// Verifie les droits
if (! have_right_or_delegation($config, SE_COMPUTER_VIEW)) {
    exit();
}
$acces_restreint = false;
// *****************cas des parcs delegues***********************************
if (! have_right_or_delegation($config, SE_COMPUTER_ADMIN, $login)) {
    echo "<h3>Votre délégation a été prise en compte pour l'affichage de cette page.</h3>";
    $acces_restreint = true;

    $list_delegate = list_delegations($config);
    echo "<ul>";
    foreach ($list_delegate as $info_parc_delegate) {
        echo "<li>$info_parc_delegate</li>";
    }
    echo "</ul>";
}

/**
 * *********************** Declaration des variables ***********************************
 */
// action peut etre shutdown ou wol
$action = $_POST['action'] ?? $_GET['action'] ?? "";
$ip = $_POST['ip'] ?? $_GET['ip'] ?? "";
$machine = $_POST['machine'] ?? $_GET['machine'] ?? "";
$retour = $_POST['retour'] ?? $_GET['retour'] ?? "show_parc";
$parc = $_GET['parc'] ?? "";
$content = "";

if ($acces_restreint) {
    if (! have_delegation($config, $parc, SE_COMPUTER_VIEW)) {
        exit();
    }
}

switch ($action) {
    case "shutdown":
        if (! empty($machine)) {
            $content .= "<HEAD>";
            $content .= "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            $content .= "</HEAD>";

            $content .= "<h1>Arrêt de(s) machine(s)</h1>";
            $content .= "Commandes prises en compte !<br>";
            $content .= start_poste($config, "shutdown", $machine, true);
            $content .= "<h3>Arret lancé pour le poste" . $machine . "</h3>";
            $content .= "<font color=#FF0000>Un temps d'attente de plus une minute est nécéssaire pour voir le résultat dans l'interface</font><br>";
        } else {
            $content .= "Vous devez choisir un parc";
        }

        break;

    case "wol":
        if (! empty($machine)) {
            $content .= "<HEAD>";
            $content .= "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            $content .= "</HEAD>";

            $content .= "<h1>Démarrage de(s) machine(s)</h1>";

            $content .= "Commandes prises en compte !<br>";

            $content .= "<h3>Démarrage effectué pour le poste $machine. (Ne concerne que les machines equipées du syst&#232me 'wake on lan')</h3>";
            $content .= start_poste($config, "wol", $machine, true);
            $content .= "<font color=#FF0000>Un temps d'attente de plus une minute est nécéssaire pour voir le résultat dans l'interface</font><br>";
        } else {
            $content .= "Vous devez choisir une machine";
        }

        break;

    case "reboot":
        if (! empty($machine)) {
            $content .= "<HEAD>";
            $content .= "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            $content .= "</HEAD>";

            $content .= "<h1>Redémarrage de(s) machine(s)</h1>";

            $content .= "Commandes prises en compte !<br>";

            $content .= "<h3>Redémarrage effectué pour le poste $machine. (Ne concerne que les machines equipées du syst&#232me 'wake on lan')</h3>";
            $content .= start_poste($config, "reboot", $machine, true);
            $content .= "<font color=#FF0000>Un temps d'attente de plus une minute est nécéssaire pour voir le résultat dans l'interface</font><br>";
        } else {
            $content .= "Vous devez choisir une machine";
        }

        break;

    case "reservation":
        if (! empty($machine)) {
            $content .= "<HEAD>";
            $content .= "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            $content .= "</HEAD>";

            $content .= "<HEAD>";
            $content .= "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            $content .= "</HEAD>";
            $content .= start_poste($config, "wol", $machine, true);
            if (set_dhcp_reservation($config, $machine, $ip)) {
                $content .= "reservation pour " . $machine . "OK<br>\n";
                $content .= start_poste($config, "reboot", $machine);
            } else {
                $content .= "reservation pour" . $machine . "impossible<br>\n";
            }
        }
        break;
    case "dynamique":
        if (! empty($machine)) {
            $content .= "<HEAD>";
            $content .= "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            $content .= "</HEAD>";

            $content .= "<HEAD>";
            $content .= "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            $content .= "</HEAD>";
            $content .= start_poste($config, "wol", $machine);
            if (delete_dhcp_reservation($config, $machine)) {
                $content .= "suppression de la reservation pour " . $machine . "OK<br>\n";
                $content .= start_poste($config, "reboot", $machine);
            } else {
                $content .= "suppression de la reservation pour" . $machine . "impossible<br>\n";
            }
        }
        break;
}
echo $content . "<br>\n";
echo "<br><center>";
echo "<a href=\"$retour.php?parc=$parc&action_poste=check\">Retour</a>";
echo "</center>";

$html = "";
admin_footer_html($html);
echo $html;
?>