<?php

/**

 * permet d'attribuer la gestion d'un parc a un utilisateur
 * @Version $Id$

 * @Projet LCS / SambaEdu

 * @auteurs Equipe SambaEdu

 * @Licence Distribue selon les termes de la licence GPL

 * @note
 * @TODO Page a refaire completement

 */

/**
 *
 * @Repertoire: parcs/
 * file: delegate_parc.php
 *
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include_once "ldap.inc.php";
include "ihm.inc.php";

$right = have_right($config, SE_COMPUTER_ADMIN);
echo "Page obsolète, les délégations sont attribuées au niveau de la gestion des droits aux utilisateurs !";
$html = "";
admin_footer_html($html);
echo $html;
exit();

/**
 *
 * Affiche un bouton retour vers la page delegate_parc.php
 *
 * @Parametres
 * @return
 */
function retour_delegate()
{
    echo "<p><a href=\"delegate_parc.php?action=liste\">Voir la liste des délégations en cours</a></p>\n";
}

function form_choix_user($config, $action, $filtre, $choix)
{
    echo "Choix du de l'utilisateur ou du groupe";
    echo " <INPUT TYPE=\"text\" name=\"filtre\" VALUE=\"$filtre\" SIZE=\"14\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"$action\">\n";
    echo "<input type=\"hidden\" name=\"choix\" value=\"1\">\n";

    echo "<br>";
    if (empty($filtre))
        $filtre = "*";
    else
        $filtre = "*" . $filtre . "*";
    if ($choix == 1) {
        $list_user = search_ad($config, $filtre, "user");
        $list_user = array_merge(search_ad($config, $filtre, "group"), $list_user);
        if (count($list_user) > 15)
            $size = 15;
        else
            $size = count($list_user);

        if (count($list_user) > 0) {
            sort($list_user);
            echo "Nom : ";
            echo "<p><select size=\"" . $size . "\" name=\"users[]\" multiple>\n";
            foreach ($list_user as $user) {
                echo "<option value=\"" . $user['cn'] . "\">" . $user['cn'] . "</option>\n";
            }
        }
        echo "</select>\n";
        echo "<br>";
    }

    echo " <input type=\"submit\" value=\"Valider\">\n";
    echo "<u onmouseover=\"return escape('Donner le début du nom du groupe ou de l\'utilisateur que vous souhaitez trouver.')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"help\"></u> ";
}

if ($right) {

    // Titre
    echo "<h1>Délégation de parc</h1>";

    // On teste si il existe des parcs

    $list_parcs = search_parcs($config, "*");
    if (count($list_parcs) == 0) {
        echo "<br><br>";
        echo "Il n'existe aucun parc. Vous devez d'abord créer un parc";
        exit();
    }

    // @TODO FIX_RIGHT
    if (! ($right) and (! have_right($config, "parc_can_manage"))) {
        echo "Vous n'avez pas les droits nécessaires pour ouvrir cette page...";
        exit();
    }

    // ************************Definition des variables*******************
    $user = $_POST['nouveau'] ?? $_GET['nouveau'] ?? NULL;
    $salles = $_POST['salles'] ?? $_GET['salles'] ?? [];
    $action = $_POST['action'] ?? $_GET['action'] ?? "";
    $users = $_POST['users'] ?? $_GET['users'] ?? array();
    $filtre = $_POST['filtre'] ?? $_GET['filtre'] ?? NULL;
    $choix = $_POST['choix'] ?? $_GET['choix'] ?? 0;

    $parcs = array();
    switch ($action) {
        // ************Voir les delegations en cours***************************
        default:
            // @TODO FIX_RIGHT
            if ((! have_right($config, SE_COMPUTER_ADMIN)) and (! have_right($config, "parc_can_manage"))) {
                echo "Droits insuffisants pour accéder à cette fonction";
                exit();
            }

            echo "<h3>Délégations en cours </h3>";

            if ($right) {
                $delegations = list_delegations($config, "*");
            } else {
                // @TODO gérer les délégations pour l'affichage du tableau
                $delegations = list_delegations($config);
            }
            if (count($delegations) == 0) {
                echo "Aucune délégation en cours";
            } else {
                echo "<table class='table-bordered' align=center width=\"50%\">\n";
                echo "<tr><td align=center class=menuheader colspan=\"6\" height=\"30\" >Récapitulatif des délégations par parc</td>\n";
                echo "</tr>\n";
                echo "<tr><td class=menuheader height=\"30\" align=center>Utilisateur/groupe</td>\n";
                echo "<td class=menuheader align=center>Parc</td>\n";
                echo "<td class=menuheader colspan=3 align=center>Niveau de délégation</td></tr>\n";
                foreach ($delegations as $delegation) {
                    if (isset($delegation['member'])) {
                        foreach ($delegation['member'] as $member) {
                            $delegation['user'] = ldap_dn2cn($member);
                            echo "<tr><td align=center>" . $delegation['user'] . "</td>\n";
                            echo "<td align=center>" . $delegation['parc'] . "</td>\n";
                            echo "<td align=center>";
                            if ($delegation['level'] == "manage") {
                                echo "Délégation forte</td>";
                                if ($right) {
                                    echo "<td align=center><a href=\"delegate_parc.php?users[]=" . $delegation['user'] . "&salles[]=" . $delegation['samaccountname'] . "&action=view\">";
                                    echo "<img src=\"../elements/images/stock_bottom.png\" alt=\"Diminuer le niveau de délégation\" title=\"Diminuer le niveau de délégation\" width=\"16\" height=\"16\" border=\"0\" /></a></td>\n";
                                    echo "</td>\n";
                                }
                            }
                            if ($delegation['level'] == "view") {
                                echo "Délégation faible</td>\n";

                                if ($right) {
                                    echo "<td align=center><a href=\"delegate_parc.php?users[]=" . $delegation['user'] . "&salles[]=" . $delegation['samaccountname'] . "&action=manage\">";
                                    echo "<img src=\"../elements/images/stock_top.png\" alt=\"Augmenter le niveau de délégation\" title=\"Augmenter le niveau de délégation\" width=\"16\" height=\"16\" border=\"0\" /></a></td>\n";
                                    echo "</td>\n";
                                }
                            }
                            if ($delegation['level'] == "rdp") {
                                echo "Accès à distance rdp</td>\n";
                            }
                            if (($right) or ((type_delegation($config, $delegation['parc']) == "manage") and ($delegation['level'] == "view"))) {
                                echo "<td align=center><a href=\"delegate_parc.php?users[]=" . $delegation['user'] . "&salles[]=" . $delegation['samaccountname'] . "&action=nodelegate\">";
                                echo "<img src=\"../elements/images/edittrash.png\" alt=\"Supprimer cette délégation\" title=\"Supprimer cette délégation\" width=\"16\" height=\"16\" border=\"0\" /></a></td>\n";
                                echo "</td>\n";
                            } else {
                                echo "<td>&nbsp;</td>\n";
                            }

                            echo "</tr>";
                        }
                    }
                }
                echo "</table><br><br>\n";
            }
            // $html = "";
            // admin_footer_html($html);
            // echo $html;
            // break;

            // *******************Choix d'une salle********************************
            if (! $salles) {
                // choix du template
                echo "<h3>Choisir un nouveau parc à déléguer </h3>";

                $list_parcs = search_parcs($config, "*");
                sort($list_parcs);
                if ($size = count($list_parcs) > 10) {
                    $size = 10;
                }
                echo "<FORM method=\"post\" action=\"delegate_parc.php\">\n";
                echo "<input type=\"hidden\" name=\"action\" value=\"new\" />";
                echo "<SELECT NAME=\"salles[]\" SIZE=\"" . $size . "\" multiple>";
                echo "<option value=\"\">Sélectionner</option>";
                if (count($list_parcs) > 0) {
                    for ($loop = 0; $loop < count($list_parcs); $loop ++) {
                        if (($right) or (type_delegation($config, $list_parcs[$loop]["name"]) == "manage")) {
                            array_push($parcs, $list_parcs[$loop]["name"]);
                            echo "<option value=\"" . $list_parcs[$loop]["samaccountname"] . "\"";
                            if ((isset($parc)) && ($parc == $list_parcs[$loop]["samaccountname"])) {
                                echo " selected";
                            }
                            echo ">" . $list_parcs[$loop]["name"] . "\n";
                            echo "</option>";
                        }
                    }
                }

                echo "</SELECT>&nbsp;&nbsp;\n";
                echo " <input type=\"submit\" value=\"Valider\">\n";
                echo "<u onmouseover=\"return escape('Un parc correspond à un groupe de machines. <br>Il peut vous servir à regrouper vos machines (par salle par exemple).<br>Une machine peut appartenir à plusieurs parcs en fonction de vos besoins. Il peut àtre lié à un <font color=#FF0000>template</font> du même nom si vous avez créé un répertoire correspondant dans le répertoire Admhomes/templates. Vous pourrez alors agir sur les machines du parc en utilisant les possibilités des templates.')\"><img name=\"action_image3\"  src=\"../elements/images/system-help.png\" alt=\"help\"></u> ";
                echo "Choix d'une machine unique <input type=\"text\" name=\"machine\" value=\"\" />";
                echo "</form>\n";
            }
            break;

        // *********************Choix d'un utilisateur******************************
        case "new":
            echo "</h3><form action=\"delegate_parc.php\" name=\"visu\" method=\"get\">\n";

            foreach ($salles as $salle) {
                echo "<h3>Vous avez choisi de déléguer la gestion de " . $salle;
                if (count($users) == 0) { // choix du user
                    form_choix_user($config, $action, $filtre, $choix);
                } else {
                    if ($right) {
                        echo "<input type=\"radio\" name=\"action\" id=\"action_manage\" value=\"manage\"  >\n";
                        echo "<label for='action_manage'>Déléguer totalement (admin local) la gestion de <b> " . $salle . "  </b></label><br>\n";
                        echo "<input type=\"radio\" name=\"action\" id=\"action_rdp\" value=\"rdp\"  CHECKED  >\n";
                        echo "<label for='action_rdp'>Permettre l'accès à distance Guacamole <b>" . $salle . " </b></label><br>\n";
                    }

                    if (($right) || (type_delegation($config, $salle) == "manage")) {
                        echo "<br><input type=\"radio\" name=\"action\" id=\"action_nodelegate\" value=\"nodelegate\">\n";
                        echo "<label for='action_nodelegate'>Retirer la délégation de<b> " . $salle . "</b> pour cet utilisateur</label>";
                    }
                    foreach ($users as $user) {
                        echo "<input type=\"hidden\" name=\"users[]\" value=\"" . $user . "\">\n";
                    }
                    echo "<br><br><input type=\"submit\" name=\"submit\" value=\"Envoyer\" />\n";
                }
                echo "<input type=\"hidden\" name=\"salles[]\" value=\"" . $salle . "\">\n";
            }
            echo "</form>\n";
            break;

        // **********************************action manage***********************
        case "manage":
            // ********************************action commun a: manage, view, nodelegate
            if (count($users) == 0 || (! $salles)) {
                echo "Vouz devez choisir un parc ou une machine et un utilisateur";
                retour_delegate();
                exit();
            }
            foreach ($salles as $salle) {

                echo "<h2>Délégation de $salle </h2>\n";
                foreach ($users as $user) {
                    if (have_right($config, SE_COMPUTER_ADMIN, $user)) {
                        echo "<font color=#FF0000>Cet utilisateur bénéficie du  droit computer_is_admin , il a déjà tous les droits sur les parcs et les templates</font><br>";
                    }

                    if (! $right) {
                        exit();
                    }

                    // @TODO FIX_RIGHT
                    if (have_right($config, "parc_can_manage", $user)) {
                        echo "<p>Cet utilisateur bénéficie déjà d'une délégation forte</p>";
                    } else {
                        $right = "parc_can_manage";
                        add_right_profile($config, $user, $right);
                        echo "La délégation forte (parc_can_manage) est prise en compe: Plus d'éléments du menu sont accessibles à <b>$user </b> dans <b>$salle</b><br>\n";
                        echo "<ul><li>Clients Windows</li>\n";
                        echo "<li>Inventaire</li>\n";
                        echo "<li>.....</li></ul><br>";
                    }

                    // ajout dans la table delegation si necessaire
                    $result = type_delegation($config, $salle, $user);
                    if ($result) {
                        if ($result == $action) {

                            echo "<p><font color=#FF0000>L'utilisateur <b>$user</b> avait déjà une délégation sur ce parc</font></p>\n";
                            delete_delegation($config, $salle, $user, $result);
                        }

                        $result_verif = type_delegation($config, $salle, $user);

                        if ($result_verif != "view") {
                            $right = "parc_can_view";
                            remove_right_profile($config, $user, $right);
                        }
                    }
                    create_delegation($config, $salle, $user, "manage");
                }
            }
            retour_delegate();
            break;

        // **************************************action nodelegate********************************************
        case "nodelegate":

            // ********************************action commun a: manage, view, nodelegate
            if (count($users) == 0 or (! $salles)) {
                echo "Vouz devez choisir un parc et un utilisateur";
                retour_delegate();
                exit();
            }

            echo "<h2>Délégation de parcs</h2>\n";
            foreach ($users as $user) {

                if (have_right($config, SE_COMPUTER_ADMIN, $user)) {
                    echo "<font color=#FF0000>Cet utilisateur bénéficie du  droit computer_is_admin , il a déjà tous les droits sur les parcs et les templates</font><br>";
                }
                foreach ($salles as $salle) {
                    $result = type_delegation($config, $salle, $user);
                    $res = delete_delegation($config, $salle, $user, $result);
                    if ($res) {
                        echo "<p>La délégation est supprimé pour <b> $user </b>sur le parc <b> $salle</b></p>\n";
                    }
                }
            }
            retour_delegate();

            break;

        // *******************************action view*******************************
        case "view":
        case "rdp":
        case "vnc":
            // ********************************action commun a: manage, view, nodelegate
            if (count($users) == 0 or (! $salles)) {
                echo "Vouz devez choisir un parc et un utilisateur";
                retour_delegate();
                exit();
            }

            echo "<h2>" . "Délégation du parc : </h2>\n";
            foreach ($users as $user) {

                if (have_right($config, SE_COMPUTER_ADMIN, $user)) {
                    echo "<font color=#FF0000>Cet utilisateur bénéficie du  droit computer_is_admin , il a déjà tous les droits sur les parcs et les templates</font><br>";
                }

                // ajout dans ldap du droit parc_can_view si le droit n'est pas deja mis
                // @TODO FIX_RIGHT
                $right = "parc_can_view";
                if (have_right($config, $right, $user)) {
                    echo "Cet utilisateur bénéficie déjà d'une délégation faible<br>";
                } else {
                    add_right_profile($config, $user, $right);
                }

                echo "La délégation " . $action . " est prise en compte pour : <b> $user </b> <br>";
                foreach ($salles as $salle) {
                    $result = type_delegation($config, $salle, $user);

                    if ($result) {
                        echo "<p><font color=#FF0000>L'utilisateur<B> $user</B>avait déjà une délégation sur le parc <b>" . $salle . "</b></font></p>\n";
                        delete_delegation($config, $salle, $user, $result);
                        $result_verif = type_delegation($config, $salle, $user);

                        if ($result_verif != "manage") {
                            $right = "parc_can_manage";
                            remove_right_profile($config, $user, $right);
                        }
                    }

                    create_delegation($config, $salle, $user, $action);
                }
            }
            retour_delegate();

            break;
        // fin case "view":
    } // fin du switch($action)
}
$html = "";
admin_footer_html($html);
echo $html;
?>