<?php

/**

 * Supprime des machines d'un  parc ou de l'annuaire
 * @Version 10-2020 

 * @Projet SambaEdu 

 * @auteurs Equipe SambaEdu

 * @Licence Distribue selon les termes de la licence GPL

 * @note 

 */

/**
 *
 * @Repertoire: parcs/
 * file: delete_parc.php
 *
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
require_once "samba-tool.inc.php";
include "ihm.inc.php";

$parc = $_POST['parc'] ?? "";
$delparc = $_POST['delparc'] ?? 0;
$delete_parc = $_POST['delete_parc'] ?? 0;
$old_computers = $_POST['old_computers'] ?? array();
$supprime_all = $_POST['supprime_all'] ?? array();
$filtrecomp = $_POST['filtrecomp'] ?? "";
// debug_var();
$mp_en_cours = list_members_parc($config, $parc, true);
// var_dump($machines);
/**
 * ****************************************************************
 */

if (have_right($config, SE_COMPUTER_ADMIN)) {
    // Titre
    echo "<h1>Suppression de machine</h1>";

    // Affichage du formulaire de selection de parc
    if ((empty($parc)) && ($delparc != 2) && count($supprime_all) == 0) {
        // La variable parc est vide on affiche une selecion
        // On retourne de choix :
        // delparc = 0 on efface des machines du parc
        // delparc = 1 on efface tout le parc
        echo "<H3>Sélection du parc à modifier</H3>";
        $list_parcs = search_parcs($config, "*");
        if (count($list_parcs) > 0) {
            echo "<FORM method=\"post\" action=\"delete_parc.php\">\n";
            echo "<SELECT NAME=\"delparc\" SIZE=\"1\" \">\n";
            echo "<option value=\"0\">Supprimer des machines du parc\n";
            echo "<option value=\"1\">Supprimer le parc\n";
            echo "<option value=\"2\">Supprimer une machine sans parc\n";
            echo "</SELECT>\n";
            echo "<SELECT NAME=\"parc\" SIZE=\"1\">";
            echo "<option value=\"\">Sélectionner\n";
            for ($loop = 0; $loop < count($list_parcs); $loop ++) {
                if (($delparc == 0) || ($list_parcs[$loop]['samaccountname'] != "computers"))
                    echo "<option value=\"" . $list_parcs[$loop]["samaccountname"] . "\">" . $list_parcs[$loop]["name"] . "\n";
            }
            echo "</SELECT>&nbsp;&nbsp;\n";
            echo "<input type=\"submit\" value=\"Valider\">\n";
            echo "<u onmouseover=\"return escape('<b>Effacer les machines d\'un parc</b> Sélectionner un parc dans lequel vous souhaitez supprimer des machines.<br>La suppression de toutes les machines d\'un parc provoque la suppression du parc.<br><b>Effacer le parc</b> provoque la suppression du parc, mais pas la suppression des machines dans l\'annuaire.<br>Pour supprimer proprement les machines, vous devez aller dans Etat par nom de machine et sélectionner la machine à supprimer.<br><b>Supprimer une machine sans parc</b> permet de supprimer complétement une machine n\'appartenant à aucun parc.')\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"help\"></u> ";
            echo "</FORM>\n";
        }
    } else {
        // Suppression des machines sans parc
        // cas delparc = 2
        if ($delparc == "2") {
            // Filtrage des noms
            echo "<FORM action=\"delete_parc.php\" method=\"post\">\n";
            echo "<P>Lister les noms contenant: ";
            echo "<INPUT TYPE=\"text\" NAME=\"filtrecomp\"\n VALUE=\"$filtrecomp\" SIZE=\"8\">";
            echo "<input type=\"hidden\" name=\"delparc\" value=\"2\">\n";
            echo "<input type=\"submit\" value=\"Valider\">\n";
            echo "</FORM>\n";
            // On recherche les machines sans parc
            $list_computer = list_members_parc($config, "computers", true);
            if (count($list_computer) > 0) {
                $form = "<form action=\"delete_parc.php\" method=\"post\">\n";
                $form .= "<p>Sélectionnez les machines sans parc à supprimer : </p>\n";
                $form .= "<p><select size=\"" . $size . "\" name=\"supprime_all[]\" multiple=\"multiple\">\n";
                for ($loopa = 0; $loopa < count($list_computer); $loopa ++) {
                    $status = $list_computer[$loopa]["status"] ?? "dns";
                    if ($status == "dns") {
                        ;
                        // Si pas de parc on affiche
                        $mpenc = ldap_hostname($config, $list_computer[$loopa]);
                        // Filtrage selon critere
                        if ("$filtrecomp" == "") {
                            $form .= "<option value=" . ldap_hostname($config, $list_computer[$loopa]) . ">" . $mpenc;
                        } else {
                            // $lmloop=0;
                            $mpcount = count($mpenc);
                            $mach = $mpenc;
                            if (preg_match("/$filtrecomp/", $mach)) {
                                $form .= "<option value=" . $mpenc . ">" . $mpenc;
                            }
                        }
                    }
                }
                $form .= "</select></p>\n";
                $form .= "<input type=\"hidden\" name=\"delparc\" value=\"0\">\n";
                $form .= "<input type=\"hidden\" name=\"parc\" value=\"000001\">\n";
                $form .= "<input type=\"hidden\" name=\"delete_parc\" value=\"true\">\n";
                $form .= "<input type=\"submit\" value=\"Valider\">\n";
                $form .= "</form>\n";
                echo $form;
            }
            // On quitte
            $html = "";
            admin_footer_html($html);
            echo $html;
            exit();
        }
        // Affichage du formulaire de suppression des machines du parc
        // la variable parc n'est pas vide
        // delparc = 0
        // On propose les machines a supprimer qui existent dans ce parc
        if (($delete_parc == "0") && ($delparc != "1") && count($supprime_all) == 0) {
            // Filtrage des noms
            echo "<FORM action=\"delete_parc.php\" method=\"post\">\n";
            echo "<P>Lister les noms contenant: ";
            echo "<INPUT TYPE=\"text\" NAME=\"filtrecomp\"\n VALUE=\"$filtrecomp\" SIZE=\"8\">";
            echo "<input type=\"hidden\" name=\"parc\" value=\"$parc\">\n";
            echo "<input type=\"submit\" value=\"Valider\">\n";
            echo "</FORM>\n";
            // Lecture des membres du parc
            $mp_all = list_members_parc($config, $parc, true);
            $mp = $mp_all;
            if (count($mp) > 15)
                $size = 15;
            else
                $size = count($mp);
            if (count($mp) > 0) {
                $form = "<form action=\"delete_parc.php\" method=\"post\">\n";
                $form .= "<p>Sélectionnez les machines à enlever du parc : $parc</p>\n";
                $form .= "<p><select size=\"" . $size . "\" name=\"old_computers[]\" multiple=\"multiple\">\n";
                echo $form;
                for ($loop = 0; $loop < count($mp); $loop ++) {
                    echo "<option value=" . $mp[$loop]['cn'] . ">" . ldap_hostname($config, $mp[$loop]);
                }
                $form = "</select></p>\n";
                // Si il ne reste qu'une seule machine
                $form .= "<input type=\"hidden\" name=\"delete_parc\" value=\"1\">\n";
                $form .= "<input type=\"hidden\" name=\"parc\" value=\"$parc\">\n";
                $form .= "<input type=\"reset\" value=\"Réinitialiser la sélection\">\n";
                $form .= "<input type=\"submit\" value=\"Valider\" onclick= \"return getconfirm();\">\n";
                $form .= "</form>\n";
                echo $form;
            } else {
                $message = "Il n'y a pas de machines à supprimer !";
                echo "<br><br>";
                echo $message;
            }
        } else {
            // Si on veut supprimer tout le parc sans supprimer les machines de l'annuaire
            // Il faut delparc = 1 et parc non vide
            if ($delparc == "1") {
                if ($parc == "") {
                    echo "Vous devez sélectionner un parc !";
                    echo "<br><br><CENTER>";
                    echo "<a href=\"delete_parc.php\">Retour</A>";
                    echo "</CENTER>";
                    exit();
                } else {
                    // Suppression du parc
                    echo "<H3>Suppression du parc <U>$parc</U></H3>";
                    delete_parc($config, $parc);
                    echo "<br><br><CENTER>";
                    echo "<a href=\"delete_parc.php\">Retour</A>";
                    echo "</CENTER>";
                }
            } else {
                // Suppression des machines dans le parc
                if ($parc == "1") {
                    echo "<H3>Suppression de machine(s) sans parc</H3>";
                    echo "<P>Vous avez sélectionné " . count($supprime_all) . " machine(s)<BR>\n";
                } elseif (! empty($parc)) {
                    echo "<H3>Suppression de machines dans le parc <U>$parc</U></H3>";
                    echo "<P>Vous avez sélectionné " . count($old_computers) . " machine(s)<BR>\n";
                }
                if (! empty($parc)) {
                    // On compte si la demande ne porte pas sur toutes les machines
                    $mp_all = list_members_parc($config, $parc, true);
                    // on extrait les machines a virer
                    for ($loop = 0; $loop < count($old_computers); $loop ++) {
                        $computer = $old_computers[$loop];
                        if ($computer == $config['se4ad_name']) {
                            echo "<span style='color:red'>On ne supprime pas le serveur Sambaedu lui-même</span><br />\n";
                        } else {
                            // je suis un ordinateur
                            echo "Suppression de l'ordinateur $computer du parc <U>$parc</U><BR>\n";
                            // on supprime
                            remove_member_parc($config, $parc, $computer);
                            echo "<br />";
                        }
                    }
                }
                // si demande de suppression complete
                if (count($supprime_all) > 0) {
                    // On teste si la machine appartient a d'autres parcs
                    // Si oui il faut verifier que cela n'implique pas la suppression de l'autre parc.
                    for ($loopa = 0; $loopa < count($supprime_all); $loopa ++) {
                        if ($supprime_all[$loopa] == $config['se4ad_name']) {
                            echo "<span style='color:red'>On ne supprime pas le serveur Sambaedu lui-même</span><br />\n";
                        } else {
                            $computer = $supprime_all[$loopa];
                            $m = search_machine($config, $computer, true);
                            // on a bien une machine, on peut la supprimer

                            $res = delete_ad($config, $computer, "machine");
                            $res &= dns_delete($config, $m, true);

                            if ($res) {
                                echo "Suppression de l'ordinateur " . $computer . "<BR>\n";
                            } else {
                                echo "Erreur lors de la suppression de l'ordinateur " . $computer . "<BR>\n";
                            }
                        }
                    }
                }
                echo "<br><br><CENTER>";
                if (empty($parc)) {
                    echo "<A HREF=\"cherche_machine.php?mpenc=" . substr($computer, 0, - 4) . "\">Retour</A>";
                } else {
                    echo "<A HREF=\"show_parc.php?parc=$parc\">Retour</A>";
                    // echo "<a href=\"delete_parc.php\">Retour</A>";
                }
                echo "</CENTER>";
            }
        }
    }
}
$html = "";
admin_footer_html($html);
echo $html;
?>
