<?php
/**

 * affiche le statut des action à distance en cours

 * @Projet SambaEdu

 * @auteurs denis bonnenfant

 * @Licence Distribue selon les termes de la licence GPL

 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
include 'admin_ui.inc.php';
$html = "";
admin_header_html($config, $html);
admin_topbar_html($config, $html);
admin_menu_html($config, $html);
$html .= header_authorize($config);
echo $html;
include "ihm.inc.php";
require_once ("dhcpd.inc.php");
require "ipxe_functions.inc.php";
require_once ("fonc_outils.inc.php");
require_once ("fonc_parc.inc.php");
require "actions.inc.php";
require "windows.inc.php";
require_once "logs.inc.php";
require_once "ent.inc.php";

// Traduction
$type = $_POST['type'] ?? $_GET['type'] ?? "Rafraichir";
$id = $_POST['id'] ?? "";
$action = $_POST['action'] ?? $_GET['action'] ?? "";
$filtre = $_POST['filtre'] ?? "";
$choix = $_POST['choix'] ?? 0;
$modele = $_POST['modele'] ?? "";
$name = $_POST['name'] ?? "";
$role = $_POST['role'] ?? "";
$script = $_POST['script'] ?? "";
$parc = $_POST['parc'] ?? $_GET['parc'] ?? "";
$clone = $_GET['clone'] ?? $_POST['clone'] ?? "";
$partitions = $_POST['partitions'] ?? $_GET['partitions'] ?? [];
// debug_var();

if (! empty($clone))
    $clones = array(
        $clone
    );
else
    $clones = $_POST['clones'] ?? array();
if (! empty($name) && ! empty($role)) {
    if ($role == "modele") {
        $modele = $name;
        $action = "new";
        unset($name);
    } elseif ($role == "clone" || $role == "install") {
        $clones[0] = $name;
        $action = "add";
        unset($name);
    }
}

if (have_right_or_delegation($config, SE_COMPUTER_INSTALL)) {
    echo "<h1>Gestion des postes</h1>\n";
    $page = "lance_action.php";
    check_system_accounts($config);
    if (! empty($type))
        echo "<h2>Type d'actions : $type</h2>\n";
    echo "<FORM id=\"install\" name=\"install\" action=\"" . $page . "\" method=\"post\">\n";
    if ($type == "voir" && is_array($id)) {
        foreach ($id as $i) {
            if (fetch_action()[$i]['type'] == "clonage" || fetch_action()[$i]['type'] == "clonage2") {
                echo form_action_membres($config, $i);
                echo form_action_clonage();
                echo form_hidden("type", "clonage");
            }
        }
    } elseif ($type == "supprimer" && ! empty($id)) {
        foreach ($id as $i) {
            delete_action($i);
        }
        echo form_actions_statut();
        echo form_action_type($config);
    } elseif ($type == "clonage" || $type == "clonage2") {
        if (! file_exists("/var/www/sambaedu/ipxe/sysrescuecd/action.php") || ! file_exists("/var/sambaedu/unattended/install/os/sysresccd/")) {
            echo "Un outil nécessaire au bon fonctionnement du clonage semble manquant sur le serveur !";
            echo "<ul>\n";
            echo "<li>Vous devez installer le module sambaedu-clonage et lancer /usr/share/sambaedu/scripts/install-sysrescuecd-iso.sh</li>\n";
            echo "</ul>\n";
            $html = "";
            admin_footer_html($html);
            echo $html;
            die();
        }
        echo form_hidden("parc", $parc);
        if (empty($name)) {
            if (empty($action) || ($action == "submit")) {
                if (empty($id)) {
                    // pas d'action choisie, on affiche la liste complete
                    echo form_actions_statut($type);
                    echo form_action_clonage();
                } else {
                    echo form_action_membres($config, $id);
                    echo form_action_clonage("submit");
                }
            } elseif ($action == "new") {
                if (empty($modele)) {
                    echo form_choix_poste($config, $action, $filtre, $choix, "modele", $id, $parc);
                    echo form_hidden("action", $action);
                    echo form_hidden("id", $id);
                } else {
                    $machine = get_action($config, $modele);
                    if (@$machine['action']['keep']) {
                        $res = set_action($config, $modele, [
                            'role' => "modele",
                            'script' => "rescuecd",
                            'etape' => "init-modele",
                            'ret' => - 1
                        ]);
                    } elseif (! empty($id)) {
                        $res = set_action($config, $modele, [
                            'type' => $type,
                            'id' => $id,
                            'role' => "modele",
                            'script' => "default",
                            'etape' => "sysprep",
                            'ret' => - 1
                        ]);
                    } else {
                        $res = set_action($config, $modele, [
                            'type' => $type,
                            'id' => "new",
                            'role' => "modele",
                            'script' => "default",
                            'etape' => "sysprep",
                            'ret' => - 1
                        ]);
                        $id = $res['id'];
                    }
                    echo form_action_membres($config, $id);
                    echo form_action_clonage($action);
                }
            } elseif ($action == "keep") {
                toggle_action_keep($id);
                echo form_action_membres($config, $id);
                echo form_action_clonage($action);
            } elseif ($action == "add") {
                if (count($clones) == 0) {
                    echo form_choix_poste($config, $action, $filtre, $choix, "clone", $id, $parc);
                    echo form_hidden("id", $id);
                    echo form_hidden("action", $action);
                } else {
                    if (empty($id)) {
                        echo form_actions_statut($type);
                        echo form_hidden("action", $action);
                        echo form_hidden("clone", $clones[0]);
                    } else {
                        foreach ($clones as $clone) {
                            $script = "rescuecd";
                            $res = set_action($config, $clone, [
                                'id' => $id,
                                'role' => "clone",
                                'script' => "rescuecd",
                                'ret' => - 1,
                                'etape' => "init-clone"
                            ]);
                        }
                        echo form_action_membres($config, $id);
                        echo form_action_clonage($action);
                    }
                }
            } elseif ($action == "remove") {
                if (count($clones) > 0) {
                    foreach ($clones as $clone) {
                        // $token = get_action($config, $clone)['netbootguid'];
                        // $res = delete_action_members($token);
                        $res = delete_action_members($clone);
                    }
                    echo form_action_membres($config, $id);
                    echo form_action_clonage($action);
                }
            } elseif ($action == "del") {
                delete_action($id);
                echo form_actions_statut($type);
            } elseif ($action == "prepare") {
                $postes = get_action_member($config, $id, "modele");
                if (! empty($postes[0])) {
                    echo start_poste($config, "reboot", $postes[0]);
                }
                echo form_action_membres($config, $id);
                echo form_action_clonage($action);
            } elseif ($action == "prepare2") {
                $postes = get_action_member($config, $id, "modele");
                if (! empty($postes[0])) {
                    $res = set_action($config, $postes[0], [
                        'type' => $type,
                        'ret' => - 1,
                        'etape' => "sysprep"
                    ]);
                    echo start_poste($config, "reboot", $postes[0]);
                }
                echo form_action_membres($config, $id);
                echo form_action_clonage($action);
            } elseif ($action == "start") {
                $liste = get_action_member($config, $id, "clone");
                $postes = get_action_member($config, $id, "modele");
                if (! empty($postes[0]) && get_action($config, $postes[0])['action']['etape'] == "sysprep") {
                    $liste[] = $postes[0];
                }
                foreach ($liste as $poste) {
                    echo start_poste($config, "reboot", $poste);
                }
                echo form_action_membres($config, $id);
                echo form_action_clonage($action);
            } elseif ($action == "reset") {
                $liste = get_action_member($config, $id, "clone");
                $postes = get_action_member($config, $id, "modele");
                if (! empty($postes[0])) {
                    $res = set_action($config, $postes[0], [
                        'role' => "modele",
                        'script' => "rescuecd",
                        'ret' => - 1,
                        'etape' => "init-modele"
                    ]);
                }
                foreach ($liste as $poste) {
                    set_action($config, $poste, [
                        'id' => $id,
                        'script' => "rescuecd",
                        'ret' => - 1,
                        'etape' => "init-clone"
                    ]);
                    echo start_poste($config, "reboot", $poste);
                }
                echo form_action_membres($config, $id);
                echo form_action_clonage();
            } elseif ($action == "reinit") {
                $postes = get_action_member($config, $id, "modele");
                // $res = set_action($config, $postes[0], [
                // 'type' => "clonage2",
                // ]);
                if (! empty($postes[0])) {
                    $res = set_action($config, $postes[0], [
                        'role' => "modele",
                        // 'type' => "clonage2",
                        'script' => "rescuecd",
                        'ret' => 0, // on suppose que l'os est sur la partition 2 du premier disque.
                        'etape' => "change-hostname"
                    ]);
                }
                echo form_action_membres($config, $id);
                echo form_action_clonage();
            } elseif ($action == "disk") {
                if (count($partitions) > 0) {
                    set_disks($id, $partitions);
                }
                echo form_action_membres($config, $id);
                echo form_choix_partitions($id);
                echo form_action_clonage($action);
            }
        } else {
            // choix du rôle
            echo form_choix_role();
            echo form_hidden("name", $name);
        }
        echo form_hidden("type", $type);
    } elseif ($type == "install") {
        if (! file_exists("/var/sambaedu/unattended/install/os/Win10/sources/boot.wim") && ! file_exists("/var/sambaedu/unattended/install/os/Win11/sources/boot.wim") && ! file_exists("/var/sambaedu/unattended/install/os/debian-installer")) {
            echo "Un outil nécessaire au bon fonctionnement du module d'installation semble manquant sur le serveur !";
            echo "<ul>\n";
            echo "<li>Vous devez installer le module sambaedu-client-linux pour déployer des clients Linux</li>\n";
            echo "<li>Vous devez avoir mis en place l'iso Win10 ou Win11 - voir la documentation</li>\n";
            echo "</ul>\n";
            $html = "";
            admin_footer_html($html);
            echo $html;
            die();
        }
        echo form_hidden("parc", $parc);
        if (empty($action)) {
            echo form_choix_install();
            echo form_hidden("type", $type);
        } else {
            if (count($clones) == 0) {
                echo form_choix_poste($config, $action, $filtre, $choix, "install", $id, $parc);
                echo form_hidden("type", $type);
            } else {
                foreach ($clones as $name) {
                    echo form_hidden("clones[]", $name);
                    $res = set_action($config, $name, [
                        'type' => "install",
                        'script' => $action,
                        // 'id' => "new",
                        'etape' => "winpe",
                        'ret' => - 1
                    ]);
                    if (empty($res['networkaddress'])) {
                        echo "ERREUR, le poste n'a pas d'adresse MAC enregistrée, et donc ne peut pas être installé<br>Vous devez au minimum l'allumer, ou mieux reserver son IP\n";
                    } else {
                        echo "Le poste exécutera l'action \"" . $action . "\" sous l'id " . $res['id'] . " au prochain redémarrage. Vérifiez que le poste est bien configuré pour démarrer en PXE, ou appuyez sur F12\n";
                        echo start_poste($config, "reboot", $name, true);
                    }
                }
                echo form_hidden("type", "Rafraichir");
                $type = "Rafraichir";
            }
        }
    } elseif ($type == "wpkg") {
        echo form_hidden("id", $id);
        echo form_hidden("action", "wpkg");
        echo form_hidden("type", $type);
        echo form_hidden("parc", $parc);
        if (count($clones) == 0) {
            echo form_choix_poste($config, "wpkg", $filtre, $choix, "wpkg", $id, $parc);
        } else {
            foreach ($clones as $name) {
                if (! empty($name)) {
                    echo form_hidden("clones[]", $name);
                    $res = set_action($config, $name, [
                        'type' => "wpkg",
                        'script' => "default",
                        'etape' => "wpkg",
                        'ret' => - 1
                    ]);
                    set_statut($id, "reboot pour wpkg");
                    set_progress($id, "0%");
                    echo start_poste($config, "reboot", $name, true);
                }
            }
            echo form_hidden("type", "Rafraichir");
            $type = "Rafraichir";
        }
    } elseif ($type == "renomme") {
        echo form_hidden("type", $type);
        echo form_hidden("parc", $parc);

        if (count($clones) == 0) {
            echo form_choix_poste($config, "renomme", $filtre, $choix, "renomme", $id, $parc);
        } else {
            echo form_new_name($parc, $clones);
        }

        if (! empty($modele) && count($clones) > 0) {
            echo form_hidden("modele", $modele);
            $i = 1;
            foreach ($clones as $name) {
                echo form_hidden("clones[]", $name);
                if (count($clones) == 1) {
                    $new_name = $modele;
                } else {
                    $new_name = $modele . "-" . sprintf("%02d", $i ++);
                }
                $res = set_action($config, $name, [
                    'type' => "renomme",
                    'role' => $new_name,
                    'id' => "new",
                    'script' => "default",
                    'etape' => "renomme",
                    'ret' => - 1
                ]);
                set_statut($id, "reboot pour renommage au domaine");
                set_progress($id, "0%");
                echo start_poste($config, "reboot", $name, true);
            }
            echo form_hidden("type", "Rafraichir");
            $type = "Rafraichir";
        }
    } elseif ($type == "post") {
        if (empty($name)) {
            echo form_choix_poste($config, "post", $filtre, $choix, "install", $id);
            echo form_hidden("type", $type);
        } else {
            $res = set_action($config, $name, [
                'type' => "post",
                'script' => "default",
                'etape' => "post",
                'ret' => - 1
            ]);
            echo form_hidden("type", $type);
            echo form_hidden("name", $name);
            echo form_action_membres($config, $res['id']);
            echo start_poste($config, "reboot", $name, true);
        }
    } elseif ($type == "ltsp") {
        echo form_hidden("id", $id);
        echo form_hidden("action", "ltsp");
        echo form_hidden("type", $type);
        echo form_hidden("parc", $parc);
        echo form_choix_serveur_ltsp($config, $role) . "<p>";
        if (count($clones) == 0) {
            echo form_choix_poste($config, "ltsp", $filtre, $choix, $role, $id, $parc);
        } else {
            foreach ($clones as $name) {
                echo form_hidden("clones[]", $name);
                $res = set_action($config, $name, [
                    'type' => "ltsp",
                    'role' => $role,
                    'script' => "ltsp"
                ]);
                echo start_poste($config, "reboot", $name, true);
            }
        }
    } elseif ($type == "reboot") {
        echo form_hidden("id", $id);
        echo form_hidden("action", "default");
        echo form_hidden("type", $type);
        echo form_hidden("parc", $parc);
        if (count($clones) == 0) {
            echo form_choix_poste($config, "default", $filtre, $choix, "reboot", $id, $parc);
        } else {
            foreach ($clones as $name) {
                echo form_hidden("clones[]", $name);
                echo start_poste($config, "reboot", $name, true);
            }
        }
    } else {
        echo form_actions_statut();
        echo form_action_type($type);
        $type = "Rafraichir";
    }
    echo "</form>";
    if ($action == 'submit' || $type == "Rafraichir") {
        echo refresh_page("install");
    }
    echo "<FORM id=\"retour\" action=\"" . $page . "\" method=\"post\">\n";
    echo " <input type=\"submit\" value=\"Retour...\">\n";
    echo "</form>";
    // echo "<pre>" . print_r(fetch_action(), true) . "</pre>";
    // echo "<pre>" . print_r(get_action($config, "w11-efi-00"), true) . "</pre>";
}
$html = "";
admin_footer_html($html);
echo $html;
?>