<?php
/**

 * rafraichissement des partages 
 * 
 * @Projet SambaEdu

 * @auteurs denis bonnenfant

 * @Licence Distribue selon les termes de la licence GPL
 *
 * script appelé par cron toutes les minutes. Ne fait rien si une synchro manuelle a été lancée,
 * relance le traitement tant que c'est nécessaire (données non traitées) si il a été initié par cron.
 *
 * l'argument $_POST['action'] définit le type d'import à déclencher :
 * - cloud : sync des dossiers sur le nc
 * - samba : sync des dossiers samba (non implémenté)
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
header_authorize_script($config);
include "ihm.inc.php";
require_once ("ldap.inc.php");
require_once 'ent.inc.php';
require "cloud.inc.php";

// verrou global de la sync
$lock = apcu_fetch('partages_lock');
$html = "";

// cas d'un établissement virtuel : on impose l'uai
$uai = apcu_fetch('uai');
if (! empty($uai)) {
    $config = get_config($config, true, $uai);
}

// on active les comptes cloud des utilisateurs si besoin
// $n = apply_user_passwords($config, 30);
// if ($n > 0){
// $html .= "reste " . $n . " mots de passes à changer<br>";
// }
apply_user_cloud($config, 30, $html);

if (empty($lock)) {
    // Pas de sync cron en cours
    if (! empty($_POST['action'])) {
        // une action est demandée, on efface les caches au cas où
        apcu_delete('partages_html');
        apcu_delete('partages');
        apcu_delete('partages_lock');
        $action = $_POST['action'];
        if (! empty($config[$action . "_cron"])) {
            // stockage en cache
            $l = "cron_" . time();
            apcu_store('partages_lock', [
                'lock' => $l,
                'action' => $action,
                'running' => false
            ], $config['ent_timeout']);
            // verrou pour éviter les lancements concurrents par cron
            apcu_add($l . "_lock", true, 200);
            file_put_contents("/tmp/sync_" . $l . ".log", $html);
            unlock($l);
        }
    }
} elseif (isset($lock['lock']) && preg_match("/cron_/", $lock['lock']) && apcu_add($lock['lock'] . "_lock", true, 200)) {
    // des sync sont à faire
    $html = apcu_fetch('partages_html') ?? "";
    if (is_array($n = nc_users_ids($config, "", 20, $html))) {
        $end = update_nc_partages($config, $html);
    } else {
        $html .= $n . " utilisateurs restants à analyser<br>\n";
    }
    apcu_store('partages_html', $html);
    unlock($lock['lock']);
    file_put_contents("/tmp/sync_" . $lock['lock'] . ".log", apcu_fetch('partages_html'));
    if ($end) {
        echo $html;
        apcu_delete('partages_lock');
        apcu_delete('partages_html');
    }
}
?>