<?php
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
$config = get_config();
header_authorize_script($config);
include ("stats_libsql.php");

$success = false;
apcu_fetch('stats_lock', $success);
if ($success) {
    exit();
}
apcu_add('stats_lock', 1000);

$stats_link = connexion_db_stats($config);
if (! mysqli_error($stats_link)) {
    $test_sql = test_stats($stats_link);
    deconnexion_db_stats($stats_link);
}
if ($test_sql == 1) {
    $stats_link = connexion_db_stats($config);
    $query = mysqli_prepare($stats_link, "SELECT netbios_name, logintime, logouttime, id FROM connexions where username!='se4install' AND flag_stat=0 AND logouttime!='0000-00-00 00:00:00' ORDER BY id ASC LIMIT 0,800");
    mysqli_stmt_execute($query);
    mysqli_stmt_bind_result($query, $res_netbios_name, $res_logintime, $res_logouttime, $res_id);
    mysqli_stmt_store_result($query);
    $num_rows = mysqli_stmt_num_rows($query);

    $tab = array();
    if ($num_rows != 0) {
        while (mysqli_stmt_fetch($query)) {
            $tab[] = array(
                "netbios_name" => strtolower($res_netbios_name),
                "logintime" => $res_logintime,
                "logouttime" => $res_logouttime,
                "id" => $res_id
            );
        }
    }
    mysqli_stmt_close($query);
    deconnexion_db_stats($stats_link);

    foreach ($tab as $data) {
        $id_current = $data["id"];
        $datetime_start = strtotime($data["logintime"]);
        $date_start = date("Y-m-d", $datetime_start);
        $hour_start = date("H", $datetime_start) + 0;
        $min_start = date("i", $datetime_start) + 0;
        $quart_start = floor($min_start / 15);

        $datetime_end = strtotime($data["logouttime"]);
        $date_end = date("Y-m-d", $datetime_end);
        $hour_end = date("H", $datetime_end) + 0;
        $min_end = date("i", $datetime_end) + 0;
        $quart_end = ceil($min_end / 15);
        if ($quart_end == 4) {
            $quart_end = 0;
            $hour_end ++;
        }

        for ($i = strtotime($date_start); $i <= strtotime($date_end); $i = $i + 86400) {
            $stats_link = connexion_db_stats($config);
            $date_tmp = date("Y-m-d", $i);
            $query = mysqli_prepare($stats_link, "SELECT h00, h01, h02, h03, h04, h05, h06, h07, h08, h09, h10, h11, h12, h13, h14, h15, h16, h17, h18, h19, h20, h21, h22, h23 FROM connexions_stat WHERE netbios_name=? and date=?");
            mysqli_stmt_bind_param($query, "ss", $data["netbios_name"], $date_tmp);
            mysqli_stmt_execute($query);
            mysqli_stmt_bind_result($query, $res_h00, $res_h01, $res_h02, $res_h03, $res_h04, $res_h05, $res_h06, $res_h07, $res_h08, $res_h09, $res_h10, $res_h11, $res_h12, $res_h13, $res_h14, $res_h15, $res_h16, $res_h17, $res_h18, $res_h19, $res_h20, $res_h21, $res_h22, $res_h23);
            mysqli_stmt_store_result($query);
            $num_rows = mysqli_stmt_num_rows($query);
            $tab2 = array();
            if ($num_rows != 0) {
                while (mysqli_stmt_fetch($query)) {
                    $tab2 = array(
                        0 => $res_h00,
                        1 => $res_h01,
                        2 => $res_h02,
                        3 => $res_h03,
                        4 => $res_h04,
                        5 => $res_h05,
                        6 => $res_h06,
                        7 => $res_h07,
                        8 => $res_h08,
                        9 => $res_h09,
                        10 => $res_h10,
                        11 => $res_h11,
                        12 => $res_h12,
                        13 => $res_h13,
                        14 => $res_h14,
                        15 => $res_h15,
                        16 => $res_h16,
                        17 => $res_h17,
                        18 => $res_h18,
                        19 => $res_h19,
                        20 => $res_h20,
                        21 => $res_h21,
                        22 => $res_h22,
                        23 => $res_h23
                    );
                }
            }
            mysqli_stmt_close($query);
            deconnexion_db_stats($stats_link);

            $stat_return = array();
            for ($tmp_h = 0; $tmp_h < 24; $tmp_h ++) {
                if ($tab2 != array()) {
                    $stat_return[$tmp_h] = sprintf("%04d", decbin($tab2[$tmp_h]));
                } else {
                    $stat_return[$tmp_h] = "0000";
                }
                if ($i == strtotime($date_start) and $hour_start > $tmp_h) {
                    // nothing
                } elseif ($i == strtotime($date_end) and $hour_end < $tmp_h) {
                    // nothing
                } else {
                    for ($quart_tmp = 0; $quart_tmp < 4; $quart_tmp ++) {
                        if ($i == strtotime($date_start) and $hour_start == $tmp_h and $quart_start > $quart_tmp) {
                            // nothing
                        } elseif ($i == strtotime($date_end) and $hour_end == $tmp_h and $quart_end <= $quart_tmp) {
                            // nothing
                        } else {
                            $stat_return[$tmp_h][$quart_tmp] = "1";
                        }
                    }
                }
            }
            $stats_link = connexion_db_stats($config);
            $update_query = mysqli_prepare($stats_link, "REPLACE INTO `connexions_stat` (`netbios_name`, `date`, `h00`, `h01`, `h02`, `h03`, `h04`, `h05`, `h06`, `h07`, `h08`, `h09`, `h10`, `h11`, `h12`, `h13`, `h14`, `h15`, `h16`, `h17`, `h18`, `h19`, `h20`, `h21`, `h22`, `h23`) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
            $binstat0 = bindec($stat_return[0]);
            $binstat1 = bindec($stat_return[1]);
            $binstat2 = bindec($stat_return[2]);
            $binstat3 = bindec($stat_return[3]);
            $binstat4 = bindec($stat_return[4]);
            $binstat5 = bindec($stat_return[5]);
            $binstat6 = bindec($stat_return[6]);
            $binstat7 = bindec($stat_return[7]);
            $binstat8 = bindec($stat_return[8]);
            $binstat9 = bindec($stat_return[9]);
            $binstat10 = bindec($stat_return[10]);
            $binstat11 = bindec($stat_return[11]);
            $binstat12 = bindec($stat_return[12]);
            $binstat13 = bindec($stat_return[13]);
            $binstat14 = bindec($stat_return[14]);
            $binstat15 = bindec($stat_return[15]);
            $binstat16 = bindec($stat_return[16]);
            $binstat17 = bindec($stat_return[17]);
            $binstat18 = bindec($stat_return[18]);
            $binstat19 = bindec($stat_return[19]);
            $binstat20 = bindec($stat_return[20]);
            $binstat21 = bindec($stat_return[21]);
            $binstat22 = bindec($stat_return[22]);
            $binstat23 = bindec($stat_return[23]);
            mysqli_stmt_bind_param($update_query, "ssiiiiiiiiiiiiiiiiiiiiiiii", $data["netbios_name"], $date_tmp, $binstat0, $binstat1, $binstat2, $binstat3, $binstat4, $binstat5, $binstat6, $binstat7, $binstat8, $binstat9, $binstat10, $binstat11, $binstat12, $binstat13, $binstat14, $binstat15, $binstat16, $binstat17, $binstat18, $binstat19, $binstat20, $binstat21, $binstat22, $binstat23);
            mysqli_stmt_execute($update_query);
            // echo mysqli_stmt_error($update_query);
            mysqli_stmt_close($update_query);
            deconnexion_db_stats($stats_link);
            // echo "<br>";
        }
        $stats_link = connexion_db_stats($config);
        $update_query = mysqli_prepare($stats_link, "UPDATE `connexions` SET `flag_stat`=1 WHERE `id`=?");
        mysqli_stmt_bind_param($update_query, "i", $id_current);
        mysqli_stmt_execute($update_query);
        mysqli_stmt_close($update_query);
        deconnexion_db_stats($stats_link);
    }
} else {
    echo "Table sql non conforme";
}

apcu_delete('stats_lock');

?>
